/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
From rose@sst.ll.mit.edu Wed Feb 12 09:46:19 1992
Return-Path: <rose@sst.ll.mit.edu>
Received: from sst.ll.mit.edu by eve.speech-freya (4.1/SMI-4.1)
	id AA00240; Wed, 12 Feb 92 09:46:17 EST
Received: by sst.ll.mit.edu (5.61/3.3.sst)
	id AA04835; Wed, 12 Feb 92 09:11:05 -0500
Date: Wed, 12 Feb 92 09:11:05 -0500
From: rose@sst.ll.mit.edu (Richard Rose)
Message-Id: <9202121411.AA04835@sst.ll.mit.edu>
To: kukolich@sst.ll.mit.edu
Subject: smooooth
Status: R
*/

/* config.h must be first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <math.h>
/* *****************************************************************

        function: smooth()
	purpose:  assign lower limit to mixture weights.
	          if a mixture weight falls below eps, it is clamped
		  at eps. otherwise it is assigned:

		  c'[i][k] = (1 - n_eps*eps) c[i][k]/SUM_j c[i][j]

		  where: eps is the lower limit
		         n_eps is the number of weights falling below limit

                  The vector of LINEAR weights is passed to smooth,
		  and a vector of smoothed LOG weights is returned.

   ***************************************************************** */

smooth(eps,c,nmix)
float eps;
float *c;
int nmix;
{
    register int m;
    float n_eps;
    float leps;
    float scl; 
    float temp;

    leps = log10(eps);
    n_eps = 0;
    temp = 0.;
    for (m=0;m<nmix;m++)    /* clamp small weights */
        if (c[m] <= eps)
        {
	    c[m] = leps;
	    n_eps++;
	}
        else
            temp += c[m];

    scl = (1. - n_eps*eps) / temp;
    
    for (m=0;m<nmix;m++)    /* compute remaining weights */
        if (c[m] != leps)
	{
	    c[m] *= scl;
	    c[m] = log10(c[m]);
        }
}

