/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <math.h>
#include <nnlib.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
  
static int npatterns = 500;
static int seed = 0;
static int npercycle = 100;
static ARG argtab[] =
{
    { "npatterns", INT, &npatterns, "Number of pairs of points to generate"},
    { "seed", INT,&seed,"Random number seed"},
    { "npercycle", INT, &npercycle, "number of points per cycle"},
};
#define TABSIZE (sizeof(argtab)/sizeof(ARG))

double pi = 3.14159265358;

int
main(argc,argv)
     int argc;
     char **argv;
{
    float random_uniform();
    double x, xstep, y1, y2;
    int i;
    
    argc = nnargs(argc,argv,argtab,TABSIZE);
    
    srandom(seed);
    x = (double) random_uniform();
    xstep = 2*pi/(double)npercycle;
    
    for (i = 0; i < npatterns/2; i++, x += xstep) {
	y1 = sin(x);
	y2 = cos(x);
	printf("%.5g\n%.5g\n", y1, y2);
    } 
  return 0;
}
