/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* header files 
-----------------*/
/* config.h must be first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <math.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <nnlib.h>

/* definitions  
----------------*/
#define TABSIZE (sizeof(argtab)/sizeof(ARG))

/* Variables set from command line flags 
-----------------------------------------*/
static float starts[128] = {0};
static float yvalues[128] = {0};
static float xmin = -2.;
static float xmax = 5.;
static int npatterns = 500;
static int seed = 0;

/*** Argument Table ***/
static ARG argtab[]=
{
    {"seed", INT, &seed, "Random number seed"},
    {"starts", FLOAT_LIST, (int *)&starts[0], "starts of each section", 128},
    {"heights",FLOAT_LIST,(int *)&yvalues[0],"heights for section starts",128},
    {"xmin", FLOAT, (int *)&xmin, "lowest x value"},
    {"xmax", FLOAT, (int *)&xmax, "highest x value"},
    {"npatterns", INT, &npatterns, "number of vectors on each iteration"},
};

int
main(argc, argv)
    register int argc;
    register char **argv;
{
    int n, i;
    float x, y;

    argc = nnargs(argc, argv, argtab, TABSIZE);
    srandom(seed);

    if(starts[0] != yvalues[0])
      fatal_error("starts and heights must have the same number of entries");
    for(n = 0; n < npatterns; n++) {
	x = xmin + (random_uniform() * (xmax - xmin));
	if(starts[0] > 0){
	    if(x < starts[1]) y = yvalues[1];
	    else
	      for(i = 1; i <= starts[0]; i++){
		  if(x < starts[i]){
		      if(starts[i] != starts[i-1]){
			  y = (x - starts[i])/(starts[i] - starts[i-1]);
			  y *= yvalues[i] - yvalues[i-1];
			  y += yvalues[i];
		      } else y = yvalues[i];
		      break;
		  }
	      }
	}
	i = (int) starts[0];
	if(x > starts[i]) y = yvalues[i];
	printf("%g %g\n", x, y);
    }
  return 0;
}
