/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <math.h>
#include <nnlib.h>
  
static int npatterns = 500;
static int ninputs = 1;
static int noutputs = 1;
static int gap = 0;
static int skip = 1;

static ARG argtab[] =
{
    { "npatterns", INT, &npatterns, "Number of pairs of points to generate"},
    {"ninputs", INT, &ninputs, "number of inputs for map version"},
    {"noutputs", INT, &noutputs, "number of outputs for map version"},
    {"gap", INT, &gap, "number of points between inputs and outputs"},
    {"skip", INT, &skip, "npoints between start of two patterns"},
};
#define TABSIZE (sizeof(argtab)/sizeof(ARG))

int
main(argc,argv)
     int argc;
     char **argv;
{
    int i, stor_len, k;
    float *storage, tmp;

    argc = nnargs(argc,argv,argtab,TABSIZE);

    stor_len = ninputs + noutputs + gap;
    storage = allocate_vector(stor_len);

    /* read the first stor_len - skip patterns */
    if(skip < stor_len){
    for (i=0; i < stor_len - skip; i++) {
        if(scanf("%g", &storage[i]) == EOF) goto END;
    }
    }
    for(; i < npatterns; i++) {
    /* read the next skip patterns */
    if(skip <= stor_len){
        for(k = skip; k > 0; k--){
        if(scanf("%g", &storage[stor_len - k]) == EOF) goto END;
        }
    } else {
        for(k = 0; k < stor_len; k++) {
        if(scanf("%g", &storage[k]) == EOF) goto END;
        }
        for(; k < skip; k++){
        if(scanf("%g", &tmp) == EOF) goto END;
        }
    }
    /* print out the inputs */
    for(k = 0; k < ninputs; k++)
      printf("%5g ", storage[k]);

    /* print out the outputs */
    for(k = ninputs + gap; k < stor_len; k++)
      printf("%5g ", storage[k]);
    printf("\n");

    /* shift the storage array down for the next pattern */
    if(skip < stor_len)
      for(k = skip; k < stor_len; k++)
        storage[k-skip] = storage[k];
    }
    END:    exit(0);
}
