/***--------------------------------------------------------------------------
* NAME:        gcommittee.c
* PURPOSE:	committee classifier graphics controls
*
* DESCRIPTION: 
*
* BUGS AND LIMITATIONS:
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/gclass/committee/gcommittee.c,v 10.4 2001/08/23 20:13:14 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/gclass/committee/gcommittee.c,v $
* created 10-Aug-94 lck		MIT Lincoln Laboratory
-------------------------------------------------------------------------***/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */

static char rcsid[] = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/gclass/committee/gcommittee.c,v 10.4 2001/08/23 20:13:14 craig Exp $";



#define TRUE 1
#define FALSE 0

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <sys/ioctl.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/icon_load.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/cms.h>
#include <xview/notify.h>
#include <xview/notice.h>
#include <gcm.h>
#include <gdd.h>
#include <nnlib.h>
#include "gcommittee_ui.h"
#include <committee_args.h>	/* statics for committee args */
#include "../LNKnet_subs.h"
#include "../gnn/nn_params.h"

/* Needed window pointers */
extern gcommittee_param_pop_objects	*Gcommittee_param_pop;

/* statics for file name parts */
#define MAXSTR 256

/* routines found in this file */
void gcommittee_display_params();
void gcommittee_init ();
void gcommittee_store_plot_command();

void gcommittee_display_params()
{
    show_int_value(Gcommittee_param_pop->class_type, classifier_type);
}

void gcommittee_init ()
{
    gcommittee_display_params();
}

char * gcommittee_get_plot_label(string)
     char * string;
{
    /* add to existing label */
    sprintf (string, "%s %s", string,
	     (classifier_type == 0) ? "Average" :
	     (classifier_type == 1) ? "Median" : "Vote");

    return string;
}

/*
 * Notify callback function for selections.
 */
void
gcommittee_3_handler(item, value, event)
     Panel_item	item;
     int		value;
     Event		*event;/*ARGSUSED*/
{
    gcommittee_param_pop_objects *ip =
      (gcommittee_param_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);

    if(item == ip->class_type){
	classifier_type = value;
	set_plot_labels();
    } else {
	fprintf(stderr, "LNKnet: gcommittee_3_handler: unhandled: value: %u\n",
		value);
    }
}

char *
gcommittee_get_args()
{
    return (nnargs_get_part_flags(committee_tab, COMMITTEE_TABSIZE));
}

char *
gcommittee_get_important_args()
{
    return (nnargs_get_flags_one_line(committee_tab, COMMITTEE_TABSIZE));
}

void
write_committee_defaults(default_file)
     FILE *default_file;
{
    if(default_file != NULL){
	fprintf(default_file,"committee %s",
		nnargs_get_flags(committee_tab,COMMITTEE_TABSIZE));
    }
}

void
read_committee_defaults(argc, argv)
     int argc;
     char **argv;
{
    if(argc > 0){
	argc = nnargs(argc, argv, committee_tab, COMMITTEE_TABSIZE);
    } else {
	classifier_type = 0;
    }
}
