/***--------------------------------------------------------------------------
 * NAME:		gem_clus.c
 * PURPOSE:	parameter settting for em_clus
 *
 * SEE ALSO:	gem_clus_subs.c
 *
 * DESCRIPTION:
 *	gem_clus_display_params
 *	gem_clus_get_plot_label
 *	gem_clus_init
 *		
 * BUGS AND LIMITATIONS:
 *
 * $Header: /data/speech/kukolich/cvsroot/lnknet/src/gclass/em_clus/gem_clus.c,v 10.4 2001/08/23 20:13:15 craig Exp $
 * $Source: /data/speech/kukolich/cvsroot/lnknet/src/gclass/em_clus/gem_clus.c,v $
 ------------------------------------------------------------------------***/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */

static char rcsid[] = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/gclass/em_clus/gem_clus.c,v 10.4 2001/08/23 20:13:15 craig Exp $";



#define TRUE 1
#define FALSE 0
#define MAXSTR 256
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <unistd.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/cms.h>
#include <gdd.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <xview/notify.h>
#include <xview/notice.h>
#include <nnlib.h>
#include "gem_clus_ui.h"
#include <em_clus_args.h>		/* nnargs definitions */
#include "../LNKnet_subs.h"
#include "../gnn/nn_params.h"

static int specify_by_class;
static char tmp_str[MAXSTR];

extern gem_clus_popup1_objects	*Gem_clus_popup1;

void gem_clus_show_ncenters_choices();
void gem_clus_set_total_ncenters();
static int total_ncenters;

void
gem_clus_display_params()
{
    show_int_value (Gem_clus_popup1->cluster_by_class, cluster_by_class);
    show_int_value (Gem_clus_popup1->ncenters, ncenters);
    if(ncenters_list != NULL){
	show_string_text (Gem_clus_popup1->ncenters_list,
			  make_net_string(ncenters_list));
    }
    gem_clus_show_ncenters_choices();
    show_int_value(Gem_clus_popup1->equal_ncenters, specify_by_class);

    show_int_value (Gem_clus_popup1->reduce_step, reduce_step);
    show_float_text (Gem_clus_popup1->stop_percentage, stop_percentage);
    show_int_value (Gem_clus_popup1->max_iteration, max_iteration);
    show_float_text (Gem_clus_popup1->split_percentage, split_percentage);
    show_int_value (Gem_clus_popup1->add_random_offset, add_random_offset);
    show_float_text (Gem_clus_popup1->minvar, minimum_variance);
    show_float_text (Gem_clus_popup1->var_spread, variance_scale);

    show_int_value (Gem_clus_popup1->use_kmeans, use_kmeans);
    show_float_text (Gem_clus_popup1->kmeans_stop_percentage,
		     kmeans_stop_percentage);
    gem_clus_show_kmeans_fields();
}

char *
gem_clus_get_plot_label (string)
     char *string;
{
    sprintf (string, "%s Centers:%d", string, total_ncenters);
    
    return string;
}

void gem_clus_init ()
{
    gem_clus_display_params();
}

/*
 * Notify callback function for `max_iteration'.
 */
Panel_setting gem_clus_max_iteration_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    int	value = (int) xv_get(item, PANEL_VALUE);
    
    max_iteration = value;
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `split_percentage'.
 */
Panel_setting gem_clus_split_percentage_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    char *	value = (char *) xv_get(item, PANEL_VALUE);

    split_percentage =
      set_atof_low_value(value, "split_percentage",
			 Gem_clus_popup1->split_percentage, split_percentage, 0.);
    return panel_text_notify(item, event);
}


/*
 * Notify callback function for `stop_percentage'.
 */
Panel_setting gem_clus_stop_percentage_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    
    stop_percentage =
      set_atof_low_value(value, "stop_percentage",
			 Gem_clus_popup1->stop_percentage, stop_percentage, 0.);
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `ncenters'.
 */
Panel_setting gem_clus_ncenters_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    int	value = (int) xv_get(item, PANEL_VALUE);
    
    ncenters = value;
    gem_clus_set_total_ncenters();
    set_plot_labels();
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `class_centers'.
 */
void gem_clus_cluster_by_class_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    cluster_by_class = value;
    gem_clus_show_ncenters_choices();
    gem_clus_set_total_ncenters();
    set_plot_labels();
}

/*
 * Notify callback function for `equal_ncenters'.
 */
void gem_clus_equal_ncenters_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    specify_by_class = value;
    gem_clus_show_ncenters_choices();
    gem_clus_set_total_ncenters();
    set_plot_labels();
}


/*
 * Notify callback function for `ncenters_list'.
 */
Panel_setting gem_clus_ncenters_list_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    char *	value = (char *) xv_get(item, PANEL_VALUE);

    if(ncenters_list != NULL) deallocate_ivector(ncenters_list);
    ncenters_list = nnargs_get_int_alloc_list(strcpy(tmp_str, value));
    gem_clus_set_total_ncenters();
    set_plot_labels();
    return panel_text_notify(item, event);
}


void gem_clus_show_ncenters_choices()
{
    if(cluster_by_class){
	gray_out_item(Gem_clus_popup1->equal_ncenters, FALSE);
	if(specify_by_class){
	    gray_out_item(Gem_clus_popup1->ncenters_list, FALSE);
	    gray_out_item(Gem_clus_popup1->ncenters, TRUE);
	} else {
	    gray_out_item(Gem_clus_popup1->ncenters_list, TRUE);
	    gray_out_item(Gem_clus_popup1->ncenters, FALSE);
	}
    } else {
	gray_out_item(Gem_clus_popup1->equal_ncenters, TRUE);
	gray_out_item(Gem_clus_popup1->ncenters_list, TRUE);
	gray_out_item(Gem_clus_popup1->ncenters, FALSE);
    }
}


/*
 * Notify callback function for `reduce_step'.
 */
Panel_setting gem_clus_reduce_step_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    int	value = (int) xv_get(item, PANEL_VALUE);
    
    reduce_step = value;
    return panel_text_notify(item, event);
}


/*
 * Notify callback function for `add_random_offset'.
 */
void gem_clus_add_random_offset_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    add_random_offset = value;
}

/*
 * Notify callback function for `var_spread'.
 */
Panel_setting gem_clus_var_spread_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    char *	value = (char *) xv_get(item, PANEL_VALUE);

    variance_scale =
      set_atof_low_value(value, "var_spread",
			 Gem_clus_popup1->var_spread, variance_scale, 0.);
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `minvar'.
 */
Panel_setting gem_clus_minvar_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    char *	value = (char *) xv_get(item, PANEL_VALUE);

    minimum_variance =
      set_atof_low_value(value, "minvar", Gem_clus_popup1->minvar,
			 minimum_variance, 0.);
   return panel_text_notify(item, event);
}

/*
 * Notify callback function for `use_kmeans'.
 */
void gem_clus_use_kmeans_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    use_kmeans = value;
    gem_clus_show_kmeans_fields();
}

int
gem_clus_get_cost_func()
{
    if(use_kmeans) return CLUS_SQ_ERR;
    else return CLUS_LOG_LIKE;
}

gem_clus_show_kmeans_fields()
{
    if(use_kmeans)
      gray_out_item(Gem_clus_popup1->kmeans_stop_percentage, FALSE);
    else
      gray_out_item(Gem_clus_popup1->kmeans_stop_percentage, TRUE);
}

/*
 * Notify callback function for `kmeans_stop_percentage'.
 */
Panel_setting gem_clus_kmeans_stop_percentage_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    char *	value = (char *) xv_get(item, PANEL_VALUE);

    kmeans_stop_percentage =
      set_atof_low_value(value, "kmeans_stop_percentage",
			 Gem_clus_popup1->kmeans_stop_percentage,
			 kmeans_stop_percentage, 0.);
    return panel_text_notify(item, event);
}

void
gem_clus_set_total_ncenters()
{
    static char total_label[64];
    if(cluster_by_class){
	if(specify_by_class && ncenters_list != NULL){
	    int i;
	    for(i = 1, total_ncenters = 0; i <= ncenters_list[0]; i++){
		total_ncenters += ncenters_list[i];
	    }
	} else {
	    total_ncenters = nn_params.noutputs * ncenters;
	}
    } else {
	total_ncenters = ncenters;
    }
    sprintf(total_label, "This will create a total of %d centers.", total_ncenters);
    show_string_label(Gem_clus_popup1->total_ncenters_msg, total_label);
}

void gem_clus_show_menu()
{
    open_popup (Gem_clus_popup1->popup1);
}

char *
gem_clus_get_args ()
{
    char * ret_str;
    int tmp_ncenters;

    /* ncenters_list will take precedence if it is there.
       making it appear to be length 0 will prevent it from
       being written out as an argument when it is not needed */
    if(!specify_by_class && ncenters_list != NULL){
	tmp_ncenters = ncenters_list[0];
	ncenters_list[0] = 0;
    }
    ret_str = nnargs_get_part_flags(em_clus_tab, EM_CLUS_TABSIZE);

    if(!specify_by_class && ncenters_list != NULL){
	ncenters_list[0] = tmp_ncenters;
    }
    return (ret_str);
}

char *
gem_clus_get_important_args ()
{
    char * ret_str;
    int tmp_ncenters;

    /* ncenters_list will take precedence if it is there.
       making it appear to be length 0 will prevent it from
       being written out as an argument when it is not needed */
    if(!specify_by_class && ncenters_list != NULL){
	tmp_ncenters = ncenters_list[0];
	ncenters_list[0] = 0;
    }
    ret_str = nnargs_get_flags_one_line(em_clus_tab, EM_CLUS_TABSIZE);

    if(!specify_by_class && ncenters_list != NULL){
	ncenters_list[0] = tmp_ncenters;
    }
    return (ret_str);
}

static int specify_by_class_arg = 0;
static int cluster_by_class_arg = 0;
static int add_offset_arg = 0;
static int use_kmeans_arg = 0;
static int *ncenters_list_arg = NULL;
static ARG argtab2[]=
{
    {"specify_by_class", INT, &specify_by_class_arg,
       "specify centers by class"},
    {"cluster_by_class_flag", INT, &cluster_by_class_arg,
       "cluster by class"},
    {"add_offset_arg", INT, &add_offset_arg, "dummy for add_random_offset"},
    {"use_kmeans_arg", INT, &use_kmeans_arg, "dummy for use_kmeans"},
    {"ncenters_list_arg", INT_ALLOC_LIST, (int *)&ncenters_list_arg},
};
#define TABSIZE2 (sizeof(argtab2)/sizeof(ARG))

void write_em_clus_defaults(default_file)
     FILE *default_file;
{
    specify_by_class_arg = specify_by_class;
    cluster_by_class_arg = cluster_by_class;
    add_offset_arg = add_random_offset;
    use_kmeans_arg = use_kmeans;
    if(ncenters_list_arg != NULL) deallocate_ivector(ncenters_list_arg);
    strcpy(tmp_str,(char *)xv_get(Gem_clus_popup1->ncenters_list,
				  PANEL_VALUE));
    ncenters_list_arg = nnargs_get_int_alloc_list(tmp_str);
    if(default_file != NULL){
	fprintf (default_file, "em_clus %s",
		 nnargs_get_part_flags(em_clus_tab, EM_CLUS_TABSIZE));
	fprintf (default_file, "%s", nnargs_get_flags(argtab2, TABSIZE2));
    }
}

void
read_em_clus_defaults(argc, argv)
     int argc;
     char **argv;
{
    int i;

    if(argc > 0){
	argc = nnargs_part(argc, argv, em_clus_tab, EM_CLUS_TABSIZE);
	argc = nnargs(argc, argv, argtab2, TABSIZE2);
    } else {
	add_offset_arg = 1;
    }
    specify_by_class = specify_by_class_arg;
    cluster_by_class = cluster_by_class_arg;
    add_random_offset = add_offset_arg;
    use_kmeans = use_kmeans_arg;
    if(ncenters_list_arg != NULL){
	if(ncenters_list != NULL) deallocate_ivector(ncenters_list);
	ncenters_list = allocate_ivector(ncenters_list_arg[0]+1);
	for(i = 0; i <= ncenters_list_arg[0] && i < NNARGS_MAX_LABELS; i++)
	  ncenters_list[i] = ncenters_list_arg[i];
    }
}
