/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * ccode_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `ccode.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "ccode_ui.h"
#include <nnlib.h>
#include "nn_params.h"
#include "../LNKnet_subs.h"
#include <gen_2c_args.h>

int store_ccode_commands();
void ccode_check_file();

extern	ccode_ccode_pop_objects	*Ccode_ccode_pop;

static int ccode_pid = 0;

#define MAXSTR 256
static char ccode_shell_script[MAXSTR];
static char ccode_suffix[MAXSTR];
static char ccode_c_file[MAXSTR];

void
g_init_ccode()
{
}

void
g_display_ccode()
{
    param_fname = nn_params.param_fname;
    show_string_label(Ccode_ccode_pop->ccode_param_fname, param_fname);
    ccode_check_file();
    show_string_text(Ccode_ccode_pop->ccode_shell_script, ccode_shell_script);
    show_string_text(Ccode_ccode_pop->ccode_sub_suffix, ccode_suffix);
    show_string_text(Ccode_ccode_pop->ccode_c_file, ccode_c_file);
}

/*
 * Notify callback function for `ccode_generate'.
 */
void
ccode_btn_handler(item, event)
	Panel_item	item;
	Event		*event;/*ARGSUSED*/
{
    ccode_ccode_pop_objects *ip =
      (ccode_ccode_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *shell_path;
	
    if(item == ip->ccode_generate){
	shell_path = path_build(nn_params.exp_path, ccode_shell_script);
	if(overwrite_ok(shell_path)){
	    if(store_ccode_commands(shell_path)) return;
	    if(!nn_params.store_only)
	      ccode_pid = chdir_and_execute_command(ccode_shell_script);
	}
    } else if(item ==ip->ccode_cancel){
	stop_command_file(ccode_pid);
	ccode_pid = 0;
	close_popup(ip->ccode_pop);
    } else {
	fputs("LNKnet: ccode_btn_handler:unhandled\n", stderr);
    }
}

int
store_ccode_commands(shell_path)
     char *shell_path;
{
    extern char plot_command_line[];
    FILE *shell_file;
    void g_get_test_args();

    shell_file = command_file_open(shell_path, "for ccode shell file");
    if(shell_file == NULL) return -1;

    if(alg_is_clus()) return 0;
    adjust_test = nn_params.adjust_test;
    test_uniform_priors = nn_params.test_uniform_priors;
    test_priors_list = nn_params.test_priors_list;
    sprintf(plot_command_line, "%s2c %s", nn_params.classifier_name,
	    nnargs_get_flags(argtab2c, TABSIZE2C));
    *strrchr(plot_command_line, '\n') = ' ';	/* get rid of newline at end */
    fprintf(shell_file, "%s", plot_command_line);
    /* put in classifier dependent call if needed */
    g_get_test_args(shell_file);
    fprintf(shell_file, " >! %s\n", ccode_c_file);
    command_file_close(shell_file, shell_path, "for ccode shell file");
    return 0;
}

/*
 * Notify callback function for `ccode_shell_script'.
 */
Panel_setting
ccode_text_handler(item, event)
	Panel_item	item;
	Event		*event;
{
    ccode_ccode_pop_objects *ip =
      (ccode_ccode_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if(item == ip->ccode_shell_script){
	value = set_string_not_empty(value, "ccode shell script",
				     item, ccode_shell_script);
	strcpy(ccode_shell_script, value);
    } else if(item == ip->ccode_sub_suffix){
	class_suff = strcpy(ccode_suffix, value);
    } else if(item == ip->ccode_c_file){
	value = set_string_not_empty(value, "ccode file name",
				     item, ccode_c_file);
	strcpy(ccode_c_file, value);
    } else {
	fprintf(stderr, "LNKnet: ccode_text_handler: unhandled value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

void
create_ccode_file_names()
{
    param_fname = nn_params.param_fname;
    show_string_label(Ccode_ccode_pop->ccode_param_fname, param_fname);

    strcpy(ccode_c_file, nn_params.exp_name);
    strcat(ccode_c_file, ".c");
    show_string_text(Ccode_ccode_pop->ccode_c_file, ccode_c_file);

    strcpy(ccode_shell_script, nn_params.exp_name);
    strcat(ccode_shell_script, ".c.run");
    show_string_text(Ccode_ccode_pop->ccode_shell_script, ccode_shell_script);

    class_suff = strcpy(ccode_suffix, nn_params.exp_name);
    show_string_text(Ccode_ccode_pop->ccode_sub_suffix, ccode_suffix);

    ccode_check_file();
}

void
activate_ccode(flag)
     int flag;
{
    register int on_off;
    if(flag) on_off = FALSE;
    else on_off = TRUE;
    gray_out_item(Ccode_ccode_pop->ccode_param_fname, on_off);
    gray_out_item(Ccode_ccode_pop->ccode_shell_script, on_off);
    gray_out_item(Ccode_ccode_pop->ccode_sub_suffix, on_off);
    gray_out_item(Ccode_ccode_pop->ccode_c_file, on_off);
    gray_out_item(Ccode_ccode_pop->ccode_generate, on_off);
    gray_out_item(Ccode_ccode_pop->ccode_cancel, on_off);
}

void
ccode_check_file()
{
    if(file_exists(path_build(nn_params.exp_path, nn_params.param_fname))){
	show_string_label(Ccode_ccode_pop->ccode_err_msg, "");
    } else {
	show_string_label(Ccode_ccode_pop->ccode_err_msg, 
			  "Error: Classifier Parameter File does not exist");
    }
}

static char *ccode_shell_arg;
static char *ccode_suffix_arg;
static char *ccode_c_file_arg;
static ARG ccodetab[] =
{
    {"shell_script", STRING, (int *)&ccode_shell_arg, ""},
    {"suffix", STRING, (int *)&ccode_suffix_arg, ""},
    {"c_file", STRING, (int *)&ccode_c_file_arg, ""},
};
#define CCODE_TABSIZE (sizeof(ccodetab)/sizeof(ARG))

void
write_ccode_defaults(default_file)
     FILE *default_file;
{
    ccode_shell_arg = null_if_empty_string(ccode_shell_script);
    ccode_suffix_arg = null_if_empty_string(ccode_suffix);
    ccode_c_file_arg = null_if_empty_string(ccode_c_file);
    
    if(default_file != NULL){
	fprintf(default_file, "ccode %s",
		nnargs_get_flags(ccodetab, CCODE_TABSIZE));
    }
}

void
read_ccode_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* zero out flags that are not present when not set */
    ccode_shell_arg = ccode_suffix_arg = ccode_c_file_arg = NULL;

    if(argc > 0){
	argc = nnargs(argc, argv, ccodetab, CCODE_TABSIZE);
    }
    strcpy_empty_if_null(ccode_shell_script, ccode_shell_arg);
    class_suff = strcpy_empty_if_null(ccode_suffix, ccode_suffix_arg);
    strcpy_empty_if_null(ccode_c_file, ccode_c_file_arg);
}
