/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * committeeData_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `committeeData.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/notice.h>
#include "committeeData_ui.h"
#include <nnlib.h>
#include <err2data_args.h>
#include "../LNKnet_subs.h"
#include "nn_params.h"

extern	committeeData_committeeData_pop_objects	*CommitteeData_committeeData_pop;
void committeeData_set_status_strings();
void committeeData_run();
void committeeData_set_lists();
void set_committee_data_base();
char *committeeData_file_ok();
void store_committeeData_commands();
char **committeeData_get_input_labels();
void committeeData_set_ninputs_msg();

#define COMM_TRAIN 1
#define COMM_EVAL 2
#define COMM_TEST 4
int which_files;

#define MAXSTR 256
static char output_data_base[MAXSTR];
static char committeeData_shell_ftmp[MAXSTR];
static char train_status_string[MAXSTR];
static char eval_status_string[MAXSTR];
static char test_status_string[MAXSTR];
static char **experiment_list;
static char *experiment_list_string = NULL;
static char **train_list;
static char **eval_list;
static char **test_list;
static int nexperiments;

static int committeeData_pid = 0;

/* g_init_committeeData() should be called after g_init_data() */
void
g_init_committeeData()
{
    which_files = COMM_TRAIN+COMM_EVAL+COMM_TEST;
    noutputs = nn_params.noutputs;
}

void
g_display_committeeData()
{
    show_string_label(CommitteeData_committeeData_pop->exp_path,
		      nn_params.exp_path);
    if(experiment_list_string != NULL)
      nn_free(experiment_list_string, "for experiment_list_string");
    experiment_list_string = make_labels_string(experiment_list);
    show_string_text(CommitteeData_committeeData_pop->committeeData_list,
		     experiment_list_string);
    show_int_value(CommitteeData_committeeData_pop->committeeData_train_select,
		   which_files);
    committeeData_set_status_strings();
    
    show_string_text(CommitteeData_committeeData_pop->committeeData_data_base,
		     output_data_base);
    show_int_label(CommitteeData_committeeData_pop->committeeData_n_outputs,
		  noutputs);
    show_string_label(CommitteeData_committeeData_pop->committeeData_shell_script,
		     committeeData_shell_ftmp);
    show_string_label(CommitteeData_committeeData_pop->committeeData_err_message, "");
    committeeData_set_ninputs_msg();
}

/*
 * Notify callback function for `committeeData_generate_data'.
 */
void
committeeData_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    committeeData_committeeData_pop_objects *ip =
      (committeeData_committeeData_pop_objects *)
      xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->committeeData_generate_data) {
	committeeData_run();
    } else if(item == ip->committeeData_cancel) {
	stop_command_file(committeeData_pid);
	committeeData_pid = 0;
	close_popup(ip->committeeData_pop);
    } else {
	fputs("LNKnet: committeeData_btn_handler: unhandled\n", stderr);
    }
}

/*
 * Notify callback function for `committeeData_list'.
 */
Panel_setting
committeeData_2_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    char tmp[NNMAX_LINE];
    committeeData_committeeData_pop_objects *ip = (committeeData_committeeData_pop_objects *)
      xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if(item == ip->committeeData_list){
	/* build experiment_list */
	if(experiment_list != NULL)
	  deallocate_string_vector(experiment_list, atoi(experiment_list[0]));
	experiment_list = nnargs_get_string_alloc_list(strcpy(tmp, value));
	nexperiments = atoi(experiment_list[0]);
	committeeData_set_lists();
	committeeData_set_ninputs_msg();
    } else if(item == ip->committeeData_data_base){
	value = set_string_not_empty(value, "committeeData data base",
				     item, output_data_base);
	strcpy(output_data_base, value);
	strcpy(committeeData_shell_ftmp, output_data_base);
	strcat(committeeData_shell_ftmp, ".run");
	show_string_label(CommitteeData_committeeData_pop->committeeData_shell_script,
			  committeeData_shell_ftmp);
	committeeData_set_ninputs_msg();
    } else {
	fprintf(stderr, "LNKnet: committeeData_2_handler: unhandled value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `committeeData_train_select'.
 */
void
committeeData_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;
{
    committeeData_committeeData_pop_objects *ip =
      (committeeData_committeeData_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->committeeData_train_select){
	which_files = value;
    } else {
	fputs("LNKnet: committeeData_3_handler: unhandled\n", stderr);
    }
}

/*
 * Event callback function for `train_status'.
 */
void
committeeData_committeeData_pop_train_status_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    committeeData_committeeData_pop_objects *ip =
      (committeeData_committeeData_pop_objects *)
	xv_get(item, XV_KEY_DATA, INSTANCE);

    if (event_action(event) == ACTION_SELECT) {
	committeeData_set_status_strings();
    }
    panel_default_handle_event(item, event);
}

/*
 * Event callback function for `eval_status'.
 */
void
committeeData_committeeData_pop_eval_status_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    committeeData_committeeData_pop_objects *ip =
      (committeeData_committeeData_pop_objects *)
	xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if (event_action(event) == ACTION_SELECT) {
	committeeData_set_status_strings();
    }
    panel_default_handle_event(item, event);
}

/*
 * Event callback function for `test_status'.
 */
void
committeeData_committeeData_pop_test_status_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    committeeData_committeeData_pop_objects *ip =
      (committeeData_committeeData_pop_objects *)
	xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if (event_action(event) == ACTION_SELECT) {
	committeeData_set_status_strings();
    }
    panel_default_handle_event(item, event);
}

void
committeeData_update_exp_path()
{
    show_string_label(CommitteeData_committeeData_pop->exp_path,
		      nn_params.exp_path);
    committeeData_set_status_strings();
}

void
committeeData_set_status_strings()
{
    int nfiles, i;

    if(experiment_list == NULL) nfiles = 0;
    else nfiles = atoi(experiment_list[0]);

    strcpy(train_status_string, "");
    strcpy(eval_status_string, "");
    strcpy(test_status_string, "");
    for(i = 1; i <= nfiles; i++){
	/* check the training file */
	strcat(train_status_string, committeeData_file_ok(train_list[i]));
	if(i < nfiles) strcat(train_status_string, ",");

	/* check the evaluation file */
	strcat(eval_status_string, committeeData_file_ok(eval_list[i]));
	if(i < nfiles) strcat(eval_status_string, ",");

	/* check the testing file */
	strcat(test_status_string, committeeData_file_ok(test_list[i]));
	if(i < nfiles) strcat(test_status_string, ",");
    }
    show_string_label(CommitteeData_committeeData_pop->train_status,
		      train_status_string);
    show_string_label(CommitteeData_committeeData_pop->eval_status,
		      eval_status_string);
    show_string_label(CommitteeData_committeeData_pop->test_status,
		      test_status_string);
}

void
committeeData_set_lists()
{
    char tmp[MAXSTR];
    int nfiles, i;

    if(experiment_list == NULL) return;
    nfiles = atoi(experiment_list[0]);

    /* build train list */
    if(train_list != NULL)
      deallocate_string_vector(train_list, atoi(train_list[0]));
    train_list = (char **)allocate_pvector(nfiles+1);
    train_list[0] = strdup(experiment_list[0]);
    for(i = 1; i <= nfiles; i++){
	strcpy(tmp, experiment_list[i]);
	strcat(tmp, ".err");
	strcat(tmp, nn_params.ext_test_train);
	train_list[i] = strdup(tmp);
    }

    /* build test list */
    if(test_list != NULL)
      deallocate_string_vector(test_list, atoi(test_list[0]));
    test_list = (char **)allocate_pvector(nfiles+1);
    test_list[0] = strdup(experiment_list[0]);
    for(i = 1; i <= nfiles; i++){
	strcpy(tmp, experiment_list[i]);
	strcat(tmp, ".err");
	strcat(tmp, nn_params.ext_test);
	test_list[i] = strdup(tmp);
    }
    
    /* build eval list */
    if(eval_list != NULL)
      deallocate_string_vector(eval_list, atoi(eval_list[0]));
    eval_list = (char **)allocate_pvector(nfiles+1);
    eval_list[0] = strdup(experiment_list[0]);
    for(i = 1; i <= nfiles; i++){
	strcpy(tmp, experiment_list[i]);
	strcat(tmp, ".err");
	strcat(tmp, nn_params.ext_eval);
	eval_list[i] = strdup(tmp);
    }
    committeeData_set_status_strings();
}

char *
committeeData_file_ok(file_name)
     char *file_name;
{
    FILE *fp;
    int ntoken;
    
    if(file_exists(path_build(nn_params.exp_path, file_name))){
	/* check the number of tokens on each line, should be
	   5 + noutputs */
	if((fp = fopen(path_build(nn_params.exp_path, file_name),"r"))
	   != NULL){
	    ntoken = get_n_tokens(fp);
	    fclose(fp);
	    if(ntoken >= 5+noutputs)
	      return "1";
	    else return "*";
	}
    }
    /* if the file wasn't ok, we will drop through the ifs to here */
    return "0";
}

void
set_committee_data_base(value)
     char *value;
{
    strcpy(output_data_base, value);
    strcat(output_data_base, "_comm");
    strcpy(committeeData_shell_ftmp, output_data_base);
    strcat(committeeData_shell_ftmp, ".run");
    show_string_text(CommitteeData_committeeData_pop->committeeData_data_base,
		     output_data_base);
    show_string_label(CommitteeData_committeeData_pop->committeeData_shell_script,
		     committeeData_shell_ftmp);
    committeeData_set_ninputs_msg();
}

void
committeeData_update_noutputs()
{
    noutputs = nn_params.noutputs;
    show_int_label(CommitteeData_committeeData_pop->committeeData_n_outputs,
		   nn_params.noutputs);
    committeeData_set_ninputs_msg();
}

void
committeeData_set_ninputs_msg()
{
    static char ninputs_label[64];
    sprintf(ninputs_label, "%s will have %d input features.",
	    output_data_base, noutputs*nexperiments);
    show_string_label(CommitteeData_committeeData_pop->ninputs_msg,
		      ninputs_label);
}

void
committeeData_run()
{
    char *shell_path, *dbase;
    FILE *shell_file;
    DEFAULTS_FILE_STRUCT df_args;
    void update_data_base(), setup_shown_list();
    void set_temp_exp_path(), restore_exp_path();

    /* make sure status strings are up to date */
    committeeData_set_status_strings();
	
    if(experiment_list == NULL) return; /* no experiments to include! */

    shell_path = path_build(nn_params.exp_path, committeeData_shell_ftmp);
    if(overwrite_ok(shell_path)){
	shell_file = command_file_open(shell_path, "for committeeData shell file");
	if(shell_file == NULL) return;
	
	set_temp_exp_path(shell_file);
	exp_path = nn_params.exp_path;

	/* store for each of the file types selected */
	if(which_files & COMM_TRAIN){
	    fprintf(shell_file, "\n#create training file\n");
	    if(committeeData_store_specific_command(shell_file,
						train_status_string,
						train_list,
						nn_params.ext_train) != 0){
		restore_exp_path();
		return;
	    }
	}
	if(which_files & COMM_EVAL){
	    fprintf(shell_file, "\n#create evaluation file\n");
	    if(committeeData_store_specific_command(shell_file,
						eval_status_string,
						eval_list,
						nn_params.ext_eval) != 0){
		restore_exp_path();
		return;
	    }
	}
	if(which_files & COMM_TEST){
	    fprintf(shell_file, "\n#create testing file\n");
	    if(committeeData_store_specific_command(shell_file,
						test_status_string,
						test_list,
						nn_params.ext_test) != 0){
		restore_exp_path();
		return;
	    }
	}

	/* save the defaults file */
	dbase = path_build(nn_params.exp_path, output_data_base);
	strcat(dbase, nn_params.desc_suff);
	df_args.ninputs = noutputs * nexperiments;
	df_args.noutputs = noutputs;
	df_args.db_type = CLASS_DATA;
	df_args.input_labels =
	  committeeData_get_input_labels(nexperiments, noutputs);
	df_args.output_labels = nn_params.output_labels;
	fprintf(shell_file, "\n#create description file\n");
	fprintf(shell_file, "cat << EOF > %s\n", dbase);
	write_defaults_stream(shell_file, &df_args);
	fprintf(shell_file, "EOF\n");

	deallocate_string_vector(df_args.input_labels,
				 atoi(df_args.input_labels[0]));

	setup_shown_list();
	update_data_base();

	restore_exp_path();

	shell_path = path_build(nn_params.exp_path, committeeData_shell_ftmp);
	command_file_close(shell_file, shell_path, "for committeeData shell file");

	show_string_label(CommitteeData_committeeData_pop->committeeData_err_message, "");
	if(!nn_params.store_only)
	  committeeData_pid = chdir_and_execute_command(committeeData_shell_ftmp);
    }
}

/* build an input label list for the committeeData data base */
/* X1mlp0,X1mlp1,X1knn0,X1knn1 */
char **
committeeData_get_input_labels(nexperiments, noutputs)
     int nexperiments, noutputs;
{
    int i, j, total;
    char *input_labels_string, **input_labels, temp[16];

    /* find the length of a string with the list entries in it */
    /* first figure it out for 1 output N classifiers,
       then multiply for M outputs */
    /* the commas and numbers*/
    total = 1;
    sprintf(temp, "%d", noutputs);
    total += strlen(temp);
    total *= nexperiments;
    /* the experiment labels */
    for(i = 0; i < nexperiments; i++){
	total += strlen(experiment_list[i+1]);
    }
    total *= noutputs; /* multiply for the noutputs per experiment */
    /* allocate the string and start it as empty */
    input_labels_string = nn_malloc(total+1, "for input_labels_string");
    input_labels_string[0] = '\0';
    /* fill the string */
    for(i = 0; i < nexperiments; i++){
	for(j = 0; j < noutputs; j++){
	    sprintf(input_labels_string + strlen(input_labels_string),
		    "%s%d,", experiment_list[i+1], j);
	}
    }
    /* take off the final comma */
    input_labels_string[strlen(input_labels_string)] = '\0';

    /* translate the string into a label list */
    input_labels = nnargs_get_string_alloc_list(input_labels_string);
    /* free input_labels_string */
    nn_free(input_labels_string, "for input_labels_string");
    return input_labels;
}

int
committeeData_store_specific_command(shell_file, status_string,
				     train_list, ext)
     FILE *shell_file;
     char *status_string;
     char **train_list;
     char *ext;
{
    /* check if all the status string says the files are ok */
    if(strstr(status_string, "0") || strstr(status_string, "*")){
	notice_prompt(CommitteeData_committeeData_pop->committeeData_pop, NULL,
		      NOTICE_MESSAGE_STRINGS,
		      "Error: Missing or Short Error Files",
		      "CommitteeData Data Base Creation Aborted",
		      NULL,
		      NOTICE_BUTTON_YES, "OK",
		      NULL);
	show_string_label(CommitteeData_committeeData_pop->committeeData_err_message,
	       "Error: Missing or Short Error Files");
	command_file_close(shell_file, committeeData_shell_ftmp,
			   "for committeeData shell file");
	return -1;
    }
    store_committeeData_commands(shell_file, train_list, ext);
    return 0;
}
void
store_committeeData_commands(shell_file, comm_file_list, ext)
     FILE *shell_file;
     char **comm_file_list, *ext;
{
    /* check that all files exist */
    char output_tmp[MAXSTR];

    file_list = comm_file_list;
    strcpy(output_tmp, output_data_base);
    output_file = strcat(output_tmp, ext);
    
    /* I cannot redirect the output to a file for store_only mode, because
       there is no log file for the committeeData shell script */
    fprintf(shell_file, "err2data %s",
	    nnargs_get_flags(err2data_tab, ERR2DATA_TABSIZE));
}

/* defaults file arguments, table, and routines */
static char *committeeData_shell_arg = "";
static char *output_data_base_arg = "";

static ARG committeeData_deftab[] =
{
    {"exp_list", STRING_ALLOC_LIST, (int *)&experiment_list, ""},
    {"which_files", INT, &which_files, "sum of:1-train,2-eval,4-test"},
    {"shell_script", STRING, (int *)&committeeData_shell_arg, ""},
    {"data_base", STRING, (int *)&output_data_base_arg, ""},
};
#define COMMITTEEDATA_DEF_LEN (sizeof(committeeData_deftab)/sizeof(ARG))

/* experiment list, files to do, db_name, noutputs shell script */
void
write_committeeData_defaults(default_file)
     FILE *default_file;
{
    committeeData_shell_arg = null_if_empty_string(committeeData_shell_ftmp);
    output_data_base_arg = null_if_empty_string(output_data_base);
    if(default_file != NULL){
	fprintf(default_file, "committeeData %s",
		nnargs_get_flags(committeeData_deftab, COMMITTEEDATA_DEF_LEN));
    }
}

void
read_committeeData_defaults(argc, argv)
     int argc;
     char **argv;
{
    committeeData_shell_arg = NULL;
    output_data_base_arg = NULL;
    if(experiment_list != NULL){
	deallocate_string_vector(experiment_list, atoi(experiment_list[0]));
	experiment_list = NULL;
    }
    if(argc > 0){
	argc = nnargs(argc, argv, committeeData_deftab, COMMITTEEDATA_DEF_LEN);
    }
    strcpy_empty_if_null(committeeData_shell_ftmp, committeeData_shell_arg);
    strcpy_empty_if_null(output_data_base, output_data_base_arg);
    committeeData_set_lists();
}
