/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * data_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `data.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <dirent.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/notice.h>
#include <nnlib.h>
#include "data_ui.h"
#include "priors_ui.h"
#include "nn_params.h"
#include "../LNKnet_main_ui.h"
#include "../LNKnet_subs.h"

extern	data_data_pop_objects	*Data_data_pop;
extern	data_defaults_pop_objects	*Data_defaults_pop;
extern	priors_priors_pop_objects	*Priors_priors_pop;
extern lnknet_glyph_objects *LNKnet_glyphs;

#define MAXSTR 256
#define SAVING 1
#define NOT_SAVING 0

/* space for file names (allows them to be copied using restore screens) */
/* having two data paths allows user to create relative paths */
static char data_path_full[MAXSTR] = ""; /* doesn't initalize well */
static char data_path_val[MAXSTR] = "./";
static char data_base[MAXSTR] = "vowel";
static char desc_filename[MAXSTR] = "vowel.defaults";
static char ext_train[MAXSTR] = ".train";
static char ext_test[MAXSTR] = ".test";
static char ext_eval[MAXSTR] = ".eval";
static char defaults_suffix[MAXSTR] = ".defaults";

/* space for setting up class count messages here and on priors window */
static char priors_string[MAXSTR];
static float *priors_list = NULL; /* allocated to noutputs long whenever
				     data base is changed */

static int selected_row = -1; /* current row selected in data_base_list */
/* to read the .defaults file for a data base */
DEFAULTS_FILE_STRUCT df_args;

void set_npatterns_train();
void update_data_base();
void set_test_file(), set_eval_file(), set_train_file();
void display_data_base_msgs(), display_defaults_generate_msgs();
void setup_shown_list();
void data_set_data_base();
void set_train_priors_string(), set_eval_priors_string();
void set_test_priors_string(), set_priors_string();
FILE *open_data_base_file();
void close_data_base_file();
void g_set_cv_filename();

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init_data()
{
    nn_params.data_path = data_path_full;
    nn_params.data_base = data_base;
    nn_params.desc_fname = desc_filename;
    nn_params.desc_suff = defaults_suffix;
    nn_params.ext_train = ext_train;
    nn_params.ext_eval = ext_eval;
    nn_params.ext_test = ext_test;
    nn_params.output_labels = NULL;
    nn_params.input_labels = NULL;
}

void
g_display_data()
{
    /* data window */
    show_string_text(Data_data_pop->data_path, data_path_val);
    show_string_text(Data_data_pop->data_base, data_base);
    display_data_base_msgs();

    show_string_text(Data_data_pop->ext_eval, ext_eval);
    show_string_text(Data_data_pop->ext_test, ext_test);
    show_string_text(Data_data_pop->ext_train, ext_train);

    update_data_base();/* prints npatterns_train, etc and priors_strings */

    /* data generate window */
    display_defaults_generate_msgs();
    show_string_label(Data_defaults_pop->data_base_name, data_base);
}

/*
 * Notify callback function for data window buttons
 */
void
data_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->generate_defaults){
	open_popup(Data_defaults_pop->defaults_pop);
    } else {
	fprintf(stderr, "LNKnet: data_btn_handler: unhandled btn\n");
    }
}

/*
 * Notify callback function for data text items
 */
Panel_setting
data_text_handler(item, event)
	Panel_item	item;
	Event		*event;
{
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    void norm_check_file(), select_check_file(), committeeData_set_lists();
    FILE *fp;
	
    if(item == ip->data_path){
	strcpy(data_path_val, value);
	set_data_path_full();
	norm_check_file();
	select_check_file();
	setup_shown_list();
	update_data_base();
/*
    } else if(item == ip->defaults_suffix){
	nn_params.desc_suff = strcpy(defaults_suffix, value);
	setup_shown_list();
	update_data_base();
*/
    } else if(item == ip->data_base){
	if(selected_row >= 0)
	  xv_set(Data_data_pop->data_base_list, PANEL_LIST_SELECT,
		 selected_row, FALSE, NULL);
	strcpy(data_base, value);
	data_set_data_base();
    } else if(item == ip->ext_train){
	strcpy(ext_train, value);
	nn_params.ext_train = ext_train;
	set_train_file();
	g_set_cv_filename();
    } else if(item == ip->ext_eval){
	strcpy(ext_eval, value);
	nn_params.ext_eval = ext_eval;
	set_eval_file();
	committeeData_set_lists();
    } else if(item == ip->ext_test){
	strcpy(ext_test, value);
	nn_params.ext_test = ext_test;
	set_test_file();
	committeeData_set_lists();
    } else if (item == ip->npatterns_train){
	set_npatterns_train(set_atoi_value(value, "npatterns_train",
					   item, nn_params.npatterns_train));
	fp = open_data_base_file(ext_train);
	set_train_priors_string(fp);
	close_data_base_file(fp);
    } else if (item == ip->npatterns_eval){
	nn_params.npatterns_eval = set_atoi_value(value, "npatterns_eval",
					item, nn_params.npatterns_eval);
	fp = open_data_base_file(ext_eval);
	set_eval_priors_string(fp);
	close_data_base_file(fp);
    } else if (item == ip->npatterns_test){
	nn_params.npatterns_test = set_atoi_value(value, "npatterns_test",
					item, nn_params.npatterns_test);
	fp = open_data_base_file(ext_test);
	set_test_priors_string(fp);
	close_data_base_file(fp);
    } else {
	fprintf(stderr, "LNKnet: data_text_handler: unhandled text value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

#ifdef SGI
/* the list handler format was changed between ow2 and ow3 !!!  */
/*
 * Notify callback function for `data_base_list'.
 */
int
data_list_handler(item, string, client_data, op, event)
	Panel_item	item;/*ARGSUSED*/
	char		*string;
	Xv_opaque	client_data;
	Panel_list_op	op;
	Event		*event;
{
    int row, nrows;
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *strend;
	
    switch(op) {
      case PANEL_LIST_OP_DESELECT:
	selected_row = -1;
	break;
      case PANEL_LIST_OP_SELECT:
	nrows = xv_get(item, PANEL_LIST_NROWS, NULL);
	for(row = 0; row < nrows; row++){
	    if(xv_get(item, PANEL_LIST_SELECTED, row) == TRUE) break;
	}
	if(row >= nrows) return XV_ERROR;

	selected_row = row;
	/* set data file prefix and display it */
	strcpy(data_base, string);
	/* strip .defaults off it */
	strend = strstr(data_base, defaults_suffix);
	if(strend != NULL) strend[0] = '\0';
	data_set_data_base();
	break;
      case PANEL_LIST_OP_VALIDATE:
	break;
      case PANEL_LIST_OP_DELETE:
	break;
    }
    return XV_OK;
}
#else
/*
 * Notify callback function for `data_base_list'.
 */
int
data_list_handler(item, string, client_data, op, event, row)
	Panel_item	item;/*ARGSUSED*/
	char		*string;
	Xv_opaque	client_data;
	Panel_list_op	op;
	Event		*event;
	int		row;
{
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *strend;
	
    switch(op) {
      case PANEL_LIST_OP_DESELECT:
	selected_row = -1;
	break;
      case PANEL_LIST_OP_SELECT:
	selected_row = row;
	/* set data file prefix and display it */
	strcpy(data_base, string);
	/* strip .defaults off it */
	strend = strstr(data_base, defaults_suffix);
	if(strend != NULL) strend[0] = '\0';
	data_set_data_base();
	break;
      case PANEL_LIST_OP_VALIDATE:
	break;
      case PANEL_LIST_OP_DELETE:
	break;
    }
    return XV_OK;
}
#endif
/*
 * Event callback function for `data_warning'.
 */
void
data_data_pop_data_warning_event_callback(item, event)
	Panel_item	item;
	Event		*event;
{
    if (event_action(event) == ACTION_SELECT) {
	update_data_base();
    }
    panel_default_handle_event(item, event);
}

/*
 * Event callback function for `data_error_message'.
 */
void
data_data_pop_data_error_message_event_callback(item, event)
	Panel_item	item;
	Event		*event;
{
    if (event_action(event) == ACTION_SELECT) {
	update_data_base();
    }
    panel_default_handle_event(item, event);
}

/*
 * Notify callback function for data generate buttons
 */
void
data_defaults_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    data_defaults_pop_objects *ip =
      (data_defaults_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->data_cancel_button){
	close_popup(ip->defaults_pop);
    } else if(item == ip->data_generate_button){
	/* LNKnet can only deal with classification data */
	df_args.db_type = CLASS_DATA;

	/* check arguments, complain if there is a problem and don't
	   save the file */
	if (data_check_df_args(SAVING)) {
	    write_defaults_file(path_build(nn_params.data_path,
					   nn_params.desc_fname), &df_args);
	    setup_shown_list();
	    update_data_base();
	}
    } else {
	fputs("LNKnet: data_defaults_btn_handler: unhandled btn\n", stderr);
    }
}

/*
 * Notify callback function for data generate text items
 */
Panel_setting
data_defaults_text_handler(item, event)
	Panel_item	item;
	Event		*event;
{
    data_defaults_pop_objects *ip =
      (data_defaults_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    static char tmp[NNMAX_LINE];
	
    /* always check for consistency in the arguments */
    if(item == ip->data_n_inputs_set){
	df_args.ninputs = set_atoi_value(value, "data_ninputs_set",
					item, nn_params.nraw);
	data_check_df_args(NOT_SAVING);
    } else if(item == ip->data_n_outputs_set){
	df_args.noutputs = set_atoi_value(value, "data_noutputs_set",
					  item, nn_params.noutputs);
	data_check_df_args(NOT_SAVING);
    } else if(item == ip->data_input_labels_set){
	if(df_args.input_labels != NULL)
	  deallocate_string_vector(df_args.input_labels,
				   atoi(df_args.input_labels[0]));
	df_args.input_labels =
	  nnargs_get_string_alloc_list(strcpy(tmp, value));
	data_check_df_args(NOT_SAVING);
    } else if(item == ip->data_output_labels_set){
	if(df_args.output_labels != NULL)
	  deallocate_string_vector(df_args.output_labels,
				   atoi(df_args.output_labels[0]));
	df_args.output_labels =
	  nnargs_get_string_alloc_list(strcpy(tmp, value));
	data_check_df_args(NOT_SAVING);
    } else {
	fprintf(stderr,
		"LNKnet: data_defaults_text_handler: unhandled text: value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for data generate settings
 */
void
data_defaults_3_handler(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;/*ARGSUSED*/
{
    data_defaults_pop_objects *ip =
      (data_defaults_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
#ifdef notdef
    /* only classification data may be used by LNKnet */
    if(item == ip->db_type_set){
	df_args.db_type = value;
    } else {
#endif
	fprintf(stderr,
		"LNKnet: data_defaults_3_handler: unhandled: value: %u\n",
		value);
#ifdef notdef
    }
#endif
}

/* check that the number of inputs matches the input label list and
   the number of outputs matches the output label list */
int
data_check_df_args(saving)
     int saving;
{
    int length;
    int ok = 1;
    char error_string[128];

    strcpy(error_string, "");
    if(df_args.output_labels != NULL){
	length = atoi(df_args.output_labels[0]);
	if(length != 0 && length != df_args.noutputs){
	    strcat(error_string, "# Class Labels != # Classes    ");
	    ok = 0;
	}
    }
    if(df_args.input_labels != NULL){
	length = atoi(df_args.input_labels[0]);
	if(length != 0 && length != df_args.ninputs){
	    strcat(error_string, "# Input Labels != # Inputs");
	    ok = 0;
	}
    }
    if(saving){
	if(ok == 0)
	  notice_prompt(Data_defaults_pop->defaults_pop, NULL,
			NOTICE_MESSAGE_STRINGS,
			error_string,
			"LNKnet will not create description file",
			NULL,
			NOTICE_BUTTON_YES, "OK",
			NULL);
    } else {
	show_string_label(Data_defaults_pop->data_defaults_error_message,
			  error_string);
	if(ok == 0)
	  show_image_label(Data_defaults_pop->data_defaults_warning,
			   LNKnet_glyphs->LNKnet_warning_pic);
	else
	  show_image_label(Data_defaults_pop->data_defaults_warning,
			   LNKnet_glyphs->LNKnet_blank_pic);
	  
    }
    return ok;
}

void
data_gray_out_window(direction)
     int direction;
{
    gray_out_item(Data_data_pop->data_path, direction);
    gray_out_item(Data_data_pop->data_base_list, direction);
    gray_out_item(Data_data_pop->data_base, direction);
    gray_out_item(Data_data_pop->n_inputs_message1, direction);
    gray_out_item(Data_data_pop->n_inputs_message, direction);
    gray_out_item(Data_data_pop->n_outputs_message1, direction);
    gray_out_item(Data_data_pop->n_outputs_message, direction);
    gray_out_item(Data_data_pop->input_labels_message1, direction);
    gray_out_item(Data_data_pop->input_labels_message, direction);
    gray_out_item(Data_data_pop->class_labels_message1, direction);
    gray_out_item(Data_data_pop->class_labels_message, direction);
    gray_out_item(Data_data_pop->filename_msg1, direction);
    gray_out_item(Data_data_pop->filename_msg2, direction);
    gray_out_item(Data_data_pop->patterns_msg_header1, direction);
    gray_out_item(Data_data_pop->patterns_msg_header2, direction);
    gray_out_item(Data_data_pop->patterns_per_class_msg1, direction);
    gray_out_item(Data_data_pop->patterns_per_class_msg2, direction);
    gray_out_item(Data_data_pop->ext_train, direction);
    gray_out_item(Data_data_pop->ext_eval, direction);
    gray_out_item(Data_data_pop->ext_test, direction);
    gray_out_item(Data_data_pop->npatterns_train, direction);
    gray_out_item(Data_data_pop->npatterns_eval, direction);
    gray_out_item(Data_data_pop->npatterns_test, direction);
    gray_out_item(Data_data_pop->train_msg, direction);
    gray_out_item(Data_data_pop->eval_msg, direction);
    gray_out_item(Data_data_pop->test_msg, direction);
    gray_out_item(Data_data_pop->train_patterns_per_class, direction);
    gray_out_item(Data_data_pop->eval_patterns_per_class, direction);
    gray_out_item(Data_data_pop->test_patterns_per_class, direction);
    gray_out_item(Data_data_pop->generate_defaults, direction);
    gray_out_item(Data_defaults_pop->data_generate_button, direction);
}

void
update_data_base()
{
    void set_main_data_warning();
    /* gray out the data base list and data file text widget so no one
       does a selection until this is done. */
    show_string_label(Data_data_pop->data_error_message,
		      "Counting patterns per class in data files");
    data_gray_out_window(TRUE);

    /* update the data base info on defaults file */
    /* read the data base description when filename changes */
    if(priors_list != NULL) deallocate_vector(priors_list);

    if(set_description_values_data_base() < 0){
	/* set error message to say couldn't find data base */
	show_string_label(Data_data_pop->data_error_message,
			  "Error: Cannot read data base defaults file");
	show_image_label(Data_data_pop->data_warning,
			 LNKnet_glyphs->LNKnet_warning_pic);
	set_main_data_warning(LNKnet_glyphs->small_warning_pic);
	priors_list = NULL;
    } else {
	show_string_label(Data_data_pop->data_error_message, "");
	show_image_label(Data_data_pop->data_warning,
			 LNKnet_glyphs->LNKnet_blank_pic);
	set_main_data_warning(LNKnet_glyphs->small_blank_pic);
	priors_list = allocate_vector(nn_params.noutputs+1);
	priors_list[0] = (float)nn_params.noutputs;
    }
    set_test_file();
    set_eval_file();
    set_train_file();
    
    /* turn off the graying out and fix the cursor */
    data_gray_out_window(FALSE);
}

int
set_description_values_data_base ()
{
    char desc_fullname[MAXSTR];
    FILE *desc_file;
    int rv;
    void region_set_input_label(), profile_set_input_label();
    void prob_set_target_label(), detect_set_target_label();
    void committeeData_update_noutputs(), set_feature_labels_string();
    
    strcpy(desc_filename, data_base);
    strcat(desc_filename, defaults_suffix);
    nn_params.desc_fname = desc_filename;
    strcpy (desc_fullname, path_build(nn_params.data_path,
				      nn_params.desc_fname));
    /* reset flags */
    if(df_args.input_labels != NULL){
	deallocate_string_vector(df_args.input_labels,
 				 atoi(df_args.input_labels[0]));
	df_args.input_labels = NULL;
    }
    if(df_args.output_labels != NULL){
	deallocate_string_vector(df_args.output_labels,
				 atoi(df_args.output_labels[0]));
	df_args.output_labels = NULL;
    }
    nn_params.db_type = df_args.db_type = CLASS_DATA;
    df_args.ninputs = df_args.noutputs = 0;

    if ((desc_file = fopen(desc_fullname, "r")) == NULL) {
	rv = -1;
    } else {
	read_defaults_file(desc_fullname, &df_args);
	nn_fclose(desc_file, desc_fullname, "for reading data description");
	rv = 0;
    }
    nn_params.nraw = df_args.ninputs;
    nn_params.noutputs = df_args.noutputs;
    nn_params.output_labels = df_args.output_labels;
    nn_params.input_labels = df_args.input_labels;

    /* set defaults messages */
    display_data_base_msgs();
    
    /* set defaults values on generate window */
    display_defaults_generate_msgs();

    /* update ninputs setting */
    update_nraw_and_ninputs();
    committeeData_update_noutputs();
    set_feature_labels_string();
    region_set_input_label();
    profile_set_input_label();

    /* update class labels on plots */
    prob_set_target_label();
    detect_set_target_label();


    return rv;
}

static char data_base_tmp[MAXSTR];

FILE *
open_data_base_file(ext)
     char *ext;
{
    FILE *fp;

    strcpy(data_base_tmp, data_base);
    strcat(data_base_tmp, ext);
    fp = fopen(path_build(nn_params.data_path, data_base_tmp), "r");
    return fp;
}

void
close_data_base_file(fp)
     FILE *fp;
{
    if(fp != NULL)
      nn_fclose(fp, path_build(nn_params.data_path, data_base),
		"for reading class priors");
}

void
set_priors_string(fp, npatterns)
    FILE *fp;
    int npatterns;
{
    if(fp != NULL){
	if(df_args.db_type == CLASS_DATA){
	    if(priors_list != NULL){
		find_class_priors(fp, npatterns, nn_params.noutputs,
				  priors_list);
		sprintf(priors_string, "%s", make_float_string(priors_list));
	    } else {
		sprintf(priors_string, "noutputs unknown");
	    }
	} else {
	    sprintf(priors_string, "Not classification data");
	}
    } else {
	if(df_args.db_type == CLASS_DATA){
	    sprintf(priors_string, "No File");
	} else {
	    sprintf(priors_string, "Not classification data");
	}
    }
}

void
set_test_file()
{
    FILE *fp;

    fp = open_data_base_file(ext_test);
    if(fp != NULL) nn_params.npatterns_test = get_n_lines(fp);
    else nn_params.npatterns_test = 0;
    set_test_priors_string(fp);
    close_data_base_file(fp);
}

void
set_test_priors_string(fp)
     FILE *fp;
{
    set_priors_string(fp, nn_params.npatterns_test);
    show_int_text(Data_data_pop->npatterns_test, nn_params.npatterns_test);
    show_string_label(Data_data_pop->test_patterns_per_class, priors_string);
    show_string_label(Priors_priors_pop->test_file_priors_message,
		      priors_string);
}

void
set_eval_file()
{
    FILE *fp;

    fp = open_data_base_file(ext_eval);
    if(fp != NULL) nn_params.npatterns_eval = get_n_lines(fp);
    else nn_params.npatterns_eval = 0;
    set_eval_priors_string(fp);
    close_data_base_file(fp);
}

void
set_eval_priors_string(fp)
     FILE *fp;
{
    set_priors_string(fp, nn_params.npatterns_eval);
    show_int_text(Data_data_pop->npatterns_eval, nn_params.npatterns_eval);
    show_string_label(Data_data_pop->eval_patterns_per_class, priors_string);
    show_string_label(Priors_priors_pop->eval_file_priors_message,
		      priors_string);
    
}

void
set_train_file()
{
    FILE *fp;

    fp = open_data_base_file(ext_train);
    if(fp != NULL) set_npatterns_train(get_n_lines(fp));
    else set_npatterns_train(0);
    set_train_priors_string(fp);
    close_data_base_file(fp);
}

void
set_train_priors_string(fp)
     FILE *fp;
{
    set_priors_string(fp, nn_params.npatterns_train);
    show_string_label(Data_data_pop->train_patterns_per_class,
		      priors_string);
    show_string_label(Priors_priors_pop->train_file_priors_message,
		      priors_string);
}

void
set_npatterns_train(value)
     int value;
{
    void g_set_priors_npatterns();

    nn_params.npatterns_train = value;

    show_int_text(Data_data_pop->npatterns_train, nn_params.npatterns_train);
    
    g_set_priors_npatterns(nn_params.npatterns_train);
}

void
display_data_base_msgs()
{
    static char *input_labels_string = NULL;
    static char *output_labels_string = NULL;

    show_int_label(Data_data_pop->n_inputs_message, nn_params.nraw);
    show_int_label(Data_data_pop->n_outputs_message, nn_params.noutputs);
    if(input_labels_string != NULL)
      nn_free(input_labels_string, "for make_labels_string");
    input_labels_string = make_labels_string(df_args.input_labels);
    show_string_label(Data_data_pop->input_labels_message,
		      input_labels_string);
    if(output_labels_string != NULL)
      nn_free(output_labels_string, "for make_labels_string");
    output_labels_string = make_labels_string(df_args.output_labels);
    show_string_label(Data_data_pop->class_labels_message,
		      output_labels_string);
}

void
display_defaults_generate_msgs()
{
    static char *input_labels_string = NULL;
    static char *output_labels_string = NULL;

    show_string_label(Data_defaults_pop->data_base_name, data_base);
    show_int_text(Data_defaults_pop->data_n_inputs_set, nn_params.nraw);
    show_int_text(Data_defaults_pop->data_n_outputs_set, nn_params.noutputs);
    if(input_labels_string != NULL)
      nn_free(input_labels_string, "for make_labels_string");
    input_labels_string = make_labels_string(df_args.input_labels);
    show_string_text (Data_defaults_pop->data_input_labels_set,
		      input_labels_string);
    if(output_labels_string != NULL)
      nn_free(output_labels_string, "for make_labels_string");
    output_labels_string = make_labels_string(df_args.output_labels);
    show_string_text (Data_defaults_pop->data_output_labels_set,
		      output_labels_string);

    /* check the number of inputs and outputs */
    data_check_df_args(NOT_SAVING);
}

void
setup_shown_list()
{
    int nrows, i;
    DIR *dirp;
    struct dirent *dp;
    char *list_string;

    gray_out_item(Data_data_pop->data_base_list, TRUE);

    /* empty the current list */
    nrows = xv_get(Data_data_pop->data_base_list, PANEL_LIST_NROWS, NULL);
    for(; nrows > 0; nrows--){
	xv_set(Data_data_pop->data_base_list, PANEL_LIST_DELETE, 0, NULL);
    }
    
    dirp = opendir(nn_params.data_path);
    /* !!! what about failure to open directory? */
    if(dirp == NULL) return;

    for(dp = readdir(dirp); dp != NULL; dp = readdir(dirp)){
	if(strstr(dp->d_name, defaults_suffix) != NULL){
	    /* find the position for this string on the list */
	    for(i = 0; i < nrows; i++){
		list_string = (char *)
		  xv_get(Data_data_pop->data_base_list, PANEL_LIST_STRING,
			 i, NULL);
		if(strcasecmp(list_string, dp->d_name) > 0) break;
	    }
	    xv_set(Data_data_pop->data_base_list,
		   PANEL_LIST_INSERT, i,
		   PANEL_LIST_STRING, i, dp->d_name,
		   NULL);
	    nrows++;
	}
    }
    closedir(dirp);
    gray_out_item(Data_data_pop->data_base_list, FALSE);
    selected_row = -1;
}

void
data_set_data_base()
{
    void g_set_normalize_filename();
    void g_create_search_filename(), set_committee_data_base();

    nn_params.data_base = data_base;
    /* display data base as selection */
    show_string_text(Data_data_pop->data_base, data_base);
    show_string_label(Data_defaults_pop->data_base_name, data_base);
    g_set_normalize_filename();
    g_create_search_filename();
    g_set_cv_filename();
    set_committee_data_base(data_base);
    update_data_base();
    /* tell notebook that something important changed */
    nn_params.major_note = 1;
}


/* defaults file arguments, table, and routines */
static char *data_path_arg = "./";
static char *defaults_suffix_arg = ".defaults";
static char *data_base_arg = "";
static char *ext_eval_arg = ".eval";
static char *ext_test_arg = ".test";
static char *ext_train_arg = ".train";
static int npatterns_train_arg = 0;
static int npatterns_test_arg = 0;
static int npatterns_eval_arg = 0;
static int db_type = 0;
static int ninputs = 0;
static int noutputs = 0;
static char **input_labels = NULL;
static char **class_labels = NULL;

static ARG datatab[] =
{
    {"data_path", STRING, (int *)&data_path_arg, ""},
    {"default_suffix", STRING, (int *)&defaults_suffix_arg, ""},
    {"data_base", STRING, (int *)&data_base_arg, ""},
    {"ext_train", STRING, (int *)&ext_train_arg, ""},
    {"ext_eval", STRING, (int *)&ext_eval_arg, ""},
    {"ext_test", STRING, (int *)&ext_test_arg, ""},
    {"npatterns_train", INT, &npatterns_train_arg, ""},
    {"npatterns_eval", INT, &npatterns_eval_arg, ""},
    {"npatterns_test", INT, &npatterns_test_arg, ""},
    {"db_type", INT, &db_type, "0-class,1-map,2-seq"},
    {"ninputs", INT, &ninputs, ""},
    {"noutputs", INT, &noutputs, ""},
    {"input_labels", STRING_ALLOC_LIST, (int *)&input_labels, ""},
    {"class_labels", STRING_ALLOC_LIST, (int *)&class_labels, ""},
};
#define TABSIZE (sizeof(datatab)/sizeof(ARG))

void
read_data_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear input_labels and class_labels, which are not there if they
       were NULL before */
    input_labels = class_labels = NULL;
    data_path_arg = defaults_suffix_arg = data_base_arg = NULL;
    ext_train_arg = ext_eval_arg = ext_test_arg = NULL;

    if(argc > 0){
	argc = nnargs(argc, argv, datatab, TABSIZE);
    } else {
	data_path_arg = "./";
        defaults_suffix_arg = ".defaults";
	data_base_arg = "vowel";
	ext_train_arg = ".train";
	ext_eval_arg = ".eval";
	ext_test_arg = ".test";
    }
    nn_params.data_path = strcpy_empty_if_null(data_path_val, data_path_arg);
    nn_params.desc_suff =
      strcpy_empty_if_null(defaults_suffix, defaults_suffix_arg);
    nn_params.data_base = strcpy_empty_if_null(data_base, data_base_arg);
    nn_params.ext_eval = strcpy_empty_if_null(ext_eval, ext_eval_arg);
    nn_params.ext_test = strcpy_empty_if_null(ext_test, ext_test_arg);
    nn_params.ext_train = strcpy_empty_if_null(ext_train, ext_train_arg);
    nn_params.npatterns_train = npatterns_train_arg;
    nn_params.npatterns_test = npatterns_test_arg;
    nn_params.npatterns_eval = npatterns_eval_arg;
    df_args.db_type = nn_params.db_type = db_type;
    df_args.ninputs = nn_params.nraw = ninputs;
    df_args.noutputs = nn_params.noutputs = noutputs;
    if(df_args.input_labels != NULL){
	deallocate_string_vector(df_args.input_labels,
				 atoi(df_args.input_labels[0]));
	df_args.input_labels = NULL;
    }
    if(df_args.output_labels != NULL){
	deallocate_string_vector(df_args.output_labels,
				 atoi(df_args.output_labels[0]));
	df_args.output_labels = NULL;
    }
    /* string_alloc_list substrings are allocated, so this is ok */
    nn_params.input_labels = df_args.input_labels = input_labels;
    nn_params.output_labels = df_args.output_labels = class_labels;

    set_data_path_full();
    setup_shown_list();
    
    g_display_data();
}

void
write_data_defaults(default_file)
     FILE *default_file;
{
    data_path_arg = null_if_empty_string(data_path_val);
    data_path_arg = null_if_empty_string(data_path_val);
    defaults_suffix_arg = null_if_empty_string(defaults_suffix);
    data_base_arg = null_if_empty_string(data_base);
    ext_eval_arg = null_if_empty_string(ext_eval);
    ext_test_arg = null_if_empty_string(ext_test);
    ext_train_arg = null_if_empty_string(ext_train);
    npatterns_train_arg = nn_params.npatterns_train;
    npatterns_test_arg = nn_params.npatterns_test;
    npatterns_eval_arg = nn_params.npatterns_eval;
    db_type = df_args.db_type;
    ninputs = df_args.ninputs;
    noutputs = df_args.noutputs;
    input_labels = df_args.input_labels;
    class_labels = df_args.output_labels;
    if(default_file != NULL){
	fprintf(default_file, "%s %s", "data",
		nnargs_get_flags(datatab, TABSIZE));
    }
}

set_data_path_full()
{
    if(data_path_val[0] == '/')
      strcpy(data_path_full, data_path_val);
    else {
	chdir(data_path_val);
	getwd(data_path_full);
	chdir(nn_params.working_directory);
    }
    nn_params.data_path = data_path_full;
}
