/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <nnlib.h>
#include "galgs.h"
#include "nn_params.h"

#include "../LNKnet_subs.h"
#include "gnn_ui.h"
#include "menus_ui.h"
#include "../plots/struct_ui.h"
#include "../plots/region_ui.h"
#include "select_ui.h"
#include "../bintree/gbintree_ui.h"
#include "../cknn/gcknn_ui.h"
#include "../em_clus/gem_clus_ui.h"
#include "../gauss/ggauss_ui.h"
#include "../gmix/ggmix_ui.h"
#include "../hyper/ghyper_ui.h"
#include "../rbf/grbf_ui.h"
#include "../ran_clus/gran_clus_ui.h"
#include "../nc_class/gnc_class_ui.h"
#include "../mlp/gmlp_ui.h"
#include "../lvq/glvq_ui.h"
#include "../lead_clus/glead_clus_ui.h"
#include "../knn/gknn_ui.h"
#include "../kmeans/gkmeans_ui.h"
#include "../irbf/girbf_ui.h"
#include "../artmap/gartmap_ui.h"
#include "../committee/gcommittee_ui.h"
#include "../histogram/ghistogram_ui.h"
#include "../parzen/gparzen_ui.h"

extern	gnn_main_window_objects	*Gnn_main_window;
extern	struct_struct_pop_objects	*Struct_struct_pop;
extern	region_bound_pop_objects	*Region_bound_pop;
extern	select_select_pop_objects	*Select_select_pop;
extern	select_select_generate_pop_objects	*Select_select_generate_pop;
extern	gbintree_param_pop_objects	*Gbintree_param_pop;
extern	gcknn_param_pop_objects	*Gcknn_param_pop;
extern	gem_clus_popup1_objects	*Gem_clus_popup1;
extern	ggauss_popup1_objects	*Ggauss_popup1;
extern	ggmix_param_pop_objects	*Ggmix_param_pop;
extern	ghyper_param_pop_objects	*Ghyper_param_pop;
extern	grbf_popup1_objects	*Grbf_popup1;
extern	gran_clus_popup1_objects	*Gran_clus_popup1;
extern	gnc_class_popup1_objects	*Gnc_class_popup1;
extern	gmlp_popup1_objects	*Gmlp_popup1;
extern	gmlp_weight_popup_objects	*Gmlp_weight_popup;
extern	gmlp_cost_popup_objects	*Gmlp_cost_popup;
extern	gmlp_node_popup_objects	*Gmlp_node_popup;
extern	glvq_popup1_objects	*Glvq_popup1;
extern	glead_clus_popup1_objects	*Glead_clus_popup1;
extern	gknn_param_pop_objects	*Gknn_param_pop;
extern	gkmeans_popup1_objects	*Gkmeans_popup1;
extern	girbf_popup1_objects	*Girbf_popup1;
extern	gartmap_param_pop_objects	*Gartmap_param_pop;
extern	gcommittee_param_pop_objects	*Gcommittee_param_pop;
extern	ghistogram_param_pop_objects	*Ghistogram_param_pop;
extern	gparzen_popup1_objects	*Gparzen_popup1;

algorithm_number algorithm = KMEANS;

void set_short_algorithm(value)
     int	value;
{
    void activate_test_selects();
    void activate_test_priors();
    void activate_train_priors();
    void activate_cost_plot();
    void activate_perr_plot();
    void activate_prob_plot();
    void activate_detect_plot();
    void activate_reject_plot();
    void activate_epoch_plots();
    void activate_profile_plot();
    void activate_region_plot();
    void activate_struct_plot();
    void activate_algorithm_feat_sel();
    void activate_ccode();
    void g_set_param_plots();
    void g_set_norm_plot();
    void g_set_normalize();
    void g_set_train();
    void g_set_struct_show_weight();
    void g_set_struct_use_threshold();
    void prob_set_sum_to_one();
    void reject_set_sum_to_one();

    algorithm = (algorithm_number) value;
    nn_params.algorithm = value;

    if(alg_is_clus()){
	/* KMEANS EM_CLUS RAN_CLUS LEAD_CLUS */
	gray_out_item(Region_bound_pop->color_check_box, TRUE);
	activate_test_selects(FALSE);
    } else {
    	gray_out_item(Region_bound_pop->color_check_box, FALSE);
	activate_test_selects(TRUE);
    }
    if(alg_is_clus() || algorithm == ARTMAP || algorithm == COMMITTEE){
	activate_algorithm_feat_sel(FALSE);
	activate_ccode(FALSE);
    } else {
	activate_ccode(TRUE);
	activate_algorithm_feat_sel(TRUE);
    }
    if(alg_is_epoch_class()){
	/* CKNN HYPER MLP IRBF GMIX LVQ ARTMAP */
	activate_epoch_plots(TRUE);
	activate_perr_plot (TRUE);
	if(alg_is_continuous_outputs())
	  activate_cost_plot(TRUE);
	else 
	  activate_cost_plot(FALSE);
    } else {
	activate_epoch_plots(FALSE);
	activate_cost_plot(FALSE);
	activate_perr_plot(FALSE);
    }
    if(alg_is_continuous_outputs()){
	/* MLP GAUSS RBF IRBF GMIX COMMITTEE */
	activate_test_priors(TRUE);
	activate_profile_plot (TRUE);
	activate_prob_plot(TRUE);
	activate_detect_plot(TRUE);
	activate_reject_plot(TRUE);
    } else {
	activate_profile_plot (FALSE);
	activate_test_priors(FALSE);
	activate_prob_plot(FALSE);
	activate_detect_plot(FALSE);
	activate_reject_plot(FALSE);
    }
    if(alg_is_likelihood()){
	prob_set_sum_to_one();
	reject_set_sum_to_one();
    }
    if(algorithm == HISTOGRAM || algorithm == COMMITTEE)
      activate_train_priors(FALSE);
    else
      activate_train_priors(TRUE);

    if(algorithm == COMMITTEE)
      activate_region_plot(FALSE);
    else
      activate_region_plot(TRUE);

    if(alg_has_struct_plot()){
	/* BINTREE MLP GAUSS RBF IRBF GMIX */
	activate_struct_plot(TRUE);

	if(algorithm == BINTREE || algorithm == GAUSS){
	    /* no weights, so no threshold either */
	    gray_out_item(Struct_struct_pop->struct_max_line, TRUE);
	    gray_out_item(Struct_struct_pop->struct_threshold, TRUE);
	    gray_out_item(Struct_struct_pop->struct_show_weight, TRUE);
	    gray_out_item(Struct_struct_pop->struct_use_threshold, TRUE);
	} else {
	    gray_out_item(Struct_struct_pop->struct_show_weight, FALSE);
	    g_set_struct_show_weight();
	    gray_out_item(Struct_struct_pop->struct_use_threshold, FALSE);
	    g_set_struct_use_threshold();
	}

	if(algorithm == MLP){
	    /* turn on dispay bias */
	    gray_out_item(Struct_struct_pop->struct_display_bias, FALSE);
	} else {
	    gray_out_item(Struct_struct_pop->struct_display_bias, TRUE);
	}
    } else {
	activate_struct_plot(FALSE);
    }
    /* set up cost plot error functions */
    switch(algorithm){
      case ARTMAP:
	gnn_set_cost_func(ARTMAP_COST);
	break;
      case MLP:
	gnn_set_cost_func(gmlp_get_cost_func());
	break;
      case IRBF:
	gnn_set_cost_func(girbf_get_cost_func());
	break;
      case GMIX:
	gnn_set_cost_func(LOG_LIKE);
	break;
      case CKNN:
      case HYPER:
	gnn_set_cost_func(CENTERS);
	break;
      case BINTREE:
      case GAUSS:
      case KNN:
      case RBF:
      case COMMITTEE:
	gnn_set_cost_func(SQ_ERR);
	break;
      case LVQ:
      case NC_CLASS:
	gnn_set_cost_func(NO_COST);
	break;
      case KMEANS:
	gnn_set_cost_func(CLUS_SQ_ERR);
	break;
      case EM_CLUS:
	gnn_set_cost_func(gem_clus_get_cost_func());
	break;
    }

    nn_params.classifier_name = classifier_names[algorithm];
    show_string_label (Gnn_main_window->algorithm_sel,
		       classifier_strings[algorithm]);
    show_string_label(Select_select_generate_pop->select_alg_msg,
		      classifier_strings[algorithm]);
    /* tell notebook that something important happened */
    nn_params.major_note = 1;
}

int
alg_is_clus()
{
    switch(algorithm){
      case KMEANS:
      case EM_CLUS:
      case RAN_CLUS:
      case LEAD_CLUS:
	return 1;
    }
    return 0;
}

int
alg_is_epoch_class()
{
    switch(algorithm){
      case CKNN:
      case HYPER:
      case MLP:
      case IRBF:
      case GMIX:
      case LVQ:
      case ARTMAP:
	return 1;
    }
    return 0;
}

int
alg_is_continuous_outputs()
{
    switch(algorithm){
      case MLP:
      case GAUSS:
      case RBF:
      case IRBF:
      case GMIX:
      case HISTOGRAM:
      case PARZEN:
      case BINTREE:
	return 1;
      default:
	return 0;
    }
}

int
alg_is_likelihood()
{
    switch(algorithm){
      case GAUSS:
      case GMIX:
      case HISTOGRAM:
      case PARZEN:
	return 1;
      default:
	return 0;
    }
}

int
alg_is_bayesian()
{
    switch(algorithm){
      case MLP:
      case RBF:
      case IRBF:
      case BINTREE:
	return 1;
      default:
	return 0;
    }
}

int
alg_has_struct_plot()
{
    switch(algorithm){
      case MLP:
      case GAUSS:
      case RBF:
      case IRBF:
      case GMIX:
      case BINTREE:
	return 1;
      default:
	return 0;
    }
}

void
show_algorithm_popup()
{
    switch (algorithm) {
      case KNN:
	open_popup (Gknn_param_pop->param_pop);
	break;
      case CKNN:
	open_popup (Gcknn_param_pop->param_pop);
	break;
      case BINTREE:
	open_popup (Gbintree_param_pop->param_pop);
	break;
      case HYPER:
	open_popup(Ghyper_param_pop->param_pop);
	break;
      case MLP:
	open_popup(Gmlp_popup1->popup1);
	break;
      case GAUSS:
	open_popup(Ggauss_popup1->popup1);
	break;
      case RBF:
	open_popup(Grbf_popup1->popup1);
	break;
      case IRBF:
	open_popup(Girbf_popup1->popup1);
	break;
      case GMIX:
	open_popup(Ggmix_param_pop->param_pop);
	break;
      case NC_CLASS:
	open_popup(Gnc_class_popup1->popup1);
	break;
      case LVQ:
	open_popup(Glvq_popup1->popup1);
	break;
      case KMEANS:
	open_popup(Gkmeans_popup1->popup1);
	break;
      case EM_CLUS:
	open_popup(Gem_clus_popup1->popup1);
	break;
      case LEAD_CLUS:
	open_popup(Glead_clus_popup1->popup1);
	break;
      case RAN_CLUS:
	open_popup(Gran_clus_popup1->popup1);
	break;
      case ARTMAP:
	open_popup(Gartmap_param_pop->param_pop);
	break;
      case COMMITTEE:
	open_popup(Gcommittee_param_pop->param_pop);
	break;
      case HISTOGRAM:
	open_popup(Ghistogram_param_pop->param_pop);
	break;
      case PARZEN:
	open_popup(Gparzen_popup1->popup1);
	break;
      default:
	break;
	}
}

char * g_get_plot_label(string)
     char * string;
{
    
    sprintf(string, "Norm:%s", norm_description(nn_params.normalize));
    switch (algorithm) {
      case KNN:
	return gknn_get_plot_label(string);
      case CKNN:
	return gcknn_get_plot_label(string);
      case BINTREE:
	return gbintree_get_plot_label(string);
      case HYPER:
	return ghyper_get_plot_label(string);
      case MLP:
	return gmlp_get_plot_label(string);
      case GAUSS:
	return ggauss_get_plot_label(string);
      case RBF:
	return grbf_get_plot_label(string);
      case IRBF:
	return girbf_get_plot_label(string);
      case GMIX:
	return ggmix_get_plot_label(string);
      case NC_CLASS:
	return gnc_class_get_plot_label(string);
      case LVQ:
	return glvq_get_plot_label(string);
      case KMEANS:
	return gkmeans_get_plot_label(string);
      case EM_CLUS:
	return gem_clus_get_plot_label(string);
      case LEAD_CLUS:
	return glead_clus_get_plot_label(string);
      case RAN_CLUS:
	return gran_clus_get_plot_label(string);
      case ARTMAP:
	return gartmap_get_plot_label(string);
      case COMMITTEE:
	return gcommittee_get_plot_label(string);
      case HISTOGRAM:
	return ghistogram_get_plot_label(string);
      case PARZEN:
	return gparzen_get_plot_label(string);
      default:
	return "";
    }
}

void g_update_ninputs()
{
    void gmlp_set_description_values();
    void ghistogram_set_total_nbins();
    void gkmeans_set_total_ncenters();
    void gem_clus_set_total_ncenters();
    void gran_clus_set_total_ncenters();

    gmlp_set_description_values();
    ghistogram_set_total_nbins();
    gkmeans_set_total_ncenters();
    gem_clus_set_total_ncenters();
    gran_clus_set_total_ncenters();
}

void g_get_test_args(shell_file)
     FILE *shell_file;
{
    void gknn_store_plot_command(), grbf_store_plot_command();
    void girbf_store_plot_command(), gbintree_store_plot_command();
    void ghistogram_store_plot_command(), gparzen_store_plot_command();
    switch (algorithm) {
      case RBF:
	grbf_store_plot_command (shell_file);
	break;
      case IRBF:
	girbf_store_plot_command (shell_file);
	break;
      case KNN:
	gknn_store_plot_command (shell_file);
	break;
      case BINTREE:
	gbintree_store_plot_command(shell_file);
	break;
      case HISTOGRAM:
	ghistogram_store_plot_command(shell_file);
	break;
      case PARZEN:
	gparzen_store_plot_command(shell_file);
	break;
      default:
	break;
    }
}

char * g_get_alg_args()
{
    char * gknn_get_args(), *gcknn_get_args();
    char * ghyper_get_args(), *gmlp_get_args();
    char * ggauss_get_args(), *grbf_get_args();
    char * girbf_get_args(), *ggmix_get_args();
    char * gnc_class_get_args(), *glvq_get_args();
    char * gkmeans_get_args(), *glead_clus_get_args();
    char * gran_clus_get_args();
    char * gnorm_get_args(), *gartmap_get_args();
    char * gem_clus_get_args(), *gbintree_get_args();
    char * gcommittee_get_args(), *ghistogram_get_args();
    char * gparzen_get_args();

    switch (algorithm) {
      case KNN:
	return gknn_get_args ();
      case CKNN:
	return gcknn_get_args ();
      case BINTREE:
	return gbintree_get_args ();
      case HYPER:
	return ghyper_get_args ();
      case MLP:
	return gmlp_get_args ();
      case GAUSS:
	return ggauss_get_args ();
      case RBF:
	return grbf_get_args ();
      case IRBF:
	return girbf_get_args ();
      case GMIX:
	return ggmix_get_args ();
      case NC_CLASS:
	return gnc_class_get_args ();
      case LVQ:
	return glvq_get_args ();
      case KMEANS:
	return gkmeans_get_args ();
      case EM_CLUS:
	return gem_clus_get_args ();
      case LEAD_CLUS:
	return glead_clus_get_args ();
      case RAN_CLUS:
	return gran_clus_get_args ();
      case ARTMAP:
	return gartmap_get_args();
      case COMMITTEE:
	return gcommittee_get_args ();
      case HISTOGRAM:
	return ghistogram_get_args();
      case PARZEN:
	return gparzen_get_args();
      default:
	break;
    }
}

char * g_get_important_alg_args()
{
    char * gknn_get_important_args(), *gcknn_get_important_args();
    char * ghyper_get_important_args(), *gmlp_get_important_args();
    char * ggauss_get_important_args(), *grbf_get_important_args();
    char * girbf_get_important_args(), *ggmix_get_important_args();
    char * gnc_class_get_important_args(), *glvq_get_important_args();
    char * gkmeans_get_important_args(), *glead_clus_get_important_args();
    char * gran_clus_get_important_args();
    char * gnorm_get_important_args(), *gartmap_get_important_args();
    char * gem_clus_get_important_args(), *gbintree_get_important_args();
    char * gcommittee_get_important_args(), *ghistogram_get_important_args();
    char * gparzen_get_important_args();

    switch (algorithm) {
      case KNN:
	return gknn_get_important_args ();
      case CKNN:
	return gcknn_get_important_args ();
      case BINTREE:
	return gbintree_get_important_args ();
      case HYPER:
	return ghyper_get_important_args ();
      case MLP:
	return gmlp_get_important_args ();
      case GAUSS:
	return ggauss_get_important_args ();
      case RBF:
	return grbf_get_important_args ();
      case IRBF:
	return girbf_get_important_args ();
      case GMIX:
	return ggmix_get_important_args ();
      case NC_CLASS:
	return gnc_class_get_important_args ();
      case LVQ:
	return glvq_get_important_args ();
      case KMEANS:
	return gkmeans_get_important_args ();
      case EM_CLUS:
	return gem_clus_get_important_args ();
      case LEAD_CLUS:
	return glead_clus_get_important_args ();
      case RAN_CLUS:
	return gran_clus_get_important_args ();
      case ARTMAP:
	return gartmap_get_important_args();
      case COMMITTEE:
	return gcommittee_get_important_args ();
      case HISTOGRAM:
	return ghistogram_get_important_args();
      case PARZEN:
	return gparzen_get_important_args();
      default:
	break;
    }
}

int must_store_clustering(){
    switch(algorithm){
      case RBF:
	return grbf_must_store_clustering();
      case IRBF:
	return girbf_must_store_clustering();
      case GMIX:
	return ggmix_must_store_clustering();
      case NC_CLASS:
	return gnc_class_must_store_clustering();
      case LVQ:
	return glvq_must_store_clustering();
      default:
	return 0;
    }
}

char * g_get_cluster_fname(){
    char * grbf_get_cluster_fname(), *girbf_get_cluster_fname();
    char * ggmix_get_cluster_fname(), *gnc_class_get_cluster_fname();
    char * glvq_get_cluster_fname();
    switch(algorithm){
      case RBF:
	return grbf_get_cluster_fname();
      case IRBF:
	return girbf_get_cluster_fname();
      case GMIX:
	return ggmix_get_cluster_fname();
      case NC_CLASS:
	return gnc_class_get_cluster_fname();
      case LVQ:
	return glvq_get_cluster_fname();
      default:
	return 0;
    }
}

int g_get_cluster_alg(){
    int cluster_alg;
    switch(algorithm){
      case RBF:
	cluster_alg = grbf_get_cluster_alg();
	break;
      case IRBF:
	cluster_alg = girbf_get_cluster_alg();
	break;
      case GMIX:
	cluster_alg = ggmix_get_cluster_alg();
	break;
      case NC_CLASS:
	cluster_alg = gnc_class_get_cluster_alg();
	break;
      case LVQ:
	cluster_alg = glvq_get_cluster_alg();
	break;
      default:
	cluster_alg = 0;
	break;
    }
    return cluster_alg;
}

int alg_uses_clustering(){
    switch(algorithm){
      case RBF:
      case IRBF:
      case GMIX:
      case NC_CLASS:
      case LVQ:
	return 1;
      default:
	return 0;
    }
}

/* these are intended for use when gnn is storing cluster commands,
   gnn must temporarily change the algorithm to the appropriate clustering
   algorithm */
int g_get_alg(){
    return algorithm;
}

int g_set_alg(alg){
    algorithm = alg;
    nn_params.classifier_name = classifier_names[alg];
}

/*
 * get the number of epochs from the current algorithm
 */
int g_get_epochs()
{
    switch (algorithm) {
      case CKNN:
	return gcknn_get_epochs();
      case GMIX:
	return ggmix_get_epochs();
      case HYPER:
	return ghyper_get_epochs();
      case LVQ:
	return glvq_get_epochs();
      case MLP:
	return gmlp_get_epochs();
      case IRBF:
	return girbf_get_epochs();
      case KNN:
      case GAUSS:
      case RBF:
      case NC_CLASS:
      case KMEANS:
      case EM_CLUS:
      case LEAD_CLUS:
      case RAN_CLUS:
      case ARTMAP:
      default:
	return 1;
    }
}

/*
 * set the number of epochs from the current algorithm
 */
int g_set_epochs(e)
     int e;
{
    void gmlp_set_epochs(), gcknn_set_epochs(), ghyper_set_epochs();
    void ggmix_set_epochs(), glvq_set_epochs(), girbf_set_epochs();
    switch (algorithm) {
      case MLP:
	gmlp_set_epochs(e);
	break;
      case CKNN:
	gcknn_set_epochs(e);
	break;
      case HYPER:
	ghyper_set_epochs(e);
	break;
      case GMIX:
	ggmix_set_epochs(e);
	break;
      case LVQ:
	glvq_set_epochs(e);
	break;
      case IRBF:
	girbf_set_epochs(e);
	break;
      case KNN:
      case GAUSS:
      case RBF:
      case NC_CLASS:
      case KMEANS:
      case EM_CLUS:
      case LEAD_CLUS:
      case RAN_CLUS:
      case ARTMAP:
      default:
	break;
    }
}
#define SEQ(x,y) (0==strcmp(x,y))
void
read_defaults(dfp, dfname)
     FILE *dfp;
     char *dfname;
{
    char *argv[256];
    int argc;
    void read_main_defaults();
    void read_data_defaults(), read_norm_defaults();
    void read_select_defaults(), read_priors_defaults();
    void read_plot_defaults(), read_reports_defaults();
    void read_print_defaults(), read_committee_defaults();
    void read_ccode_defaults(), read_committeeData_defaults();
    void read_artmap_defaults(), read_bintree_defaults();
    void read_cknn_defaults(), read_em_clus_defaults();
    void read_gauss_defaults(), read_gmix_defaults();
    void read_hyper_defaults(), read_irbf_defaults();
    void read_kmeans_defaults(), read_knn_defaults();
    void read_lead_clus_defaults(), read_lvq_defaults();
    void read_mlp_defaults(), read_nc_class_defaults();
    void read_ran_clus_defaults(), read_rbf_defaults();
    void read_parzen_defaults(), read_histogram_defaults();
    void set_algorithm(), data_set_data_base();
    void read_bound_defaults(), read_cost_defaults(), read_profile_defaults();
    void read_perr_defaults(), read_struct_defaults(), read_prob_defaults();
    void read_detect_defaults();
    void read_reject_defaults();
    char *list_name;

    if(dfp != NULL){
	while(1){
	    argc = fill_argv(argv, dfp, dfname);
	    if(argc == EOF) break;
	    if(argc == 0) continue;
	    list_name = argv[0];
	    if(SEQ(list_name, "LNKnet")){
		read_main_defaults(argc, argv);
	    } else if(SEQ(list_name, "data")){
		read_data_defaults(argc, argv);
	    } else if(SEQ(list_name, "norm")){
		read_norm_defaults(argc, argv);
	    } else if(SEQ(list_name, "select")){
		read_select_defaults(argc, argv);
	    } else if(SEQ(list_name, "priors")){
		read_priors_defaults(argc, argv);
	    } else if(SEQ(list_name, "plot")){
		read_plot_defaults(argc, argv);
	    } else if(SEQ(list_name, "bound")){
		read_bound_defaults(argc, argv);
	    } else if(SEQ(list_name, "profile")){
		read_profile_defaults(argc, argv);
	    } else if(SEQ(list_name, "cost")){
		read_cost_defaults(argc, argv);
	    } else if(SEQ(list_name, "perr")){
		read_perr_defaults(argc, argv);
	    } else if(SEQ(list_name, "struct")){
		read_struct_defaults(argc, argv);
	    } else if(SEQ(list_name, "prob")){
		read_prob_defaults(argc, argv);
	    } else if(SEQ(list_name, "detect")){
		read_detect_defaults(argc, argv);
	    } else if(SEQ(list_name, "reject")){
		read_reject_defaults(argc, argv);
	    } else if(SEQ(list_name, "reports")){
		read_reports_defaults(argc, argv);
	    } else if(SEQ(list_name, "print")){
		read_print_defaults(argc, argv);
	    } else if(SEQ(list_name, "ccode")){
		read_ccode_defaults(argc, argv);
	    } else if(SEQ(list_name, "committeeData")){
		read_committeeData_defaults(argc, argv);
	    } else if(SEQ(list_name, "artmap")){
		read_artmap_defaults(argc, argv);
	    } else if(SEQ(list_name, "bintree")){
		read_bintree_defaults(argc, argv);
	    } else if(SEQ(list_name, "cknn")){
		read_cknn_defaults(argc,argv);
	    } else if(SEQ(list_name, "em_clus")){
		read_em_clus_defaults(argc,argv);
	    } else if(SEQ(list_name, "gauss")){
		read_gauss_defaults(argc,argv);
	    } else if(SEQ(list_name, "gmix")){
		read_gmix_defaults(argc,argv);
	    } else if(SEQ(list_name, "hyper")){
		read_hyper_defaults(argc, argv);
	    } else if(SEQ(list_name, "irbf")){
		read_irbf_defaults(argc,argv);
	    } else if(SEQ(list_name, "kmeans")){
		read_kmeans_defaults(argc,argv);
	    } else if(SEQ(list_name, "knn")){
		read_knn_defaults(argc,argv);
	    } else if(SEQ(list_name, "lead_clus")){
		read_lead_clus_defaults(argc,argv);
	    } else if(SEQ(list_name, "lvq")){
		read_lvq_defaults(argc,argv);
	    } else if(SEQ(list_name, "mlp")){
		read_mlp_defaults(argc, argv);
	    } else if(SEQ(list_name, "nc_class")){
		read_nc_class_defaults(argc,argv);
	    } else if(SEQ(list_name, "ran_clus")){
		read_ran_clus_defaults(argc,argv);
	    } else if(SEQ(list_name, "rbf")){
		read_rbf_defaults(argc,argv);
	    } else if(SEQ(list_name, "committee")){
		read_committee_defaults(argc, argv);
	    } else if(SEQ(list_name, "histogram")){
		read_histogram_defaults(argc, argv);
	    } else if(SEQ(list_name, "parzen")){
		read_parzen_defaults(argc, argv);
	    } else {
		warning("Unknown argument list: %s", list_name);
	    }
	}
    } else {/* need to read all of them, anyway, to set the defaults */
	argc = 0;
	read_main_defaults(argc, argv);
	read_data_defaults(argc, argv);
	read_norm_defaults(argc, argv);
	read_select_defaults(argc, argv);
	read_priors_defaults(argc, argv);
	read_plot_defaults(argc, argv);
	read_bound_defaults(argc, argv);
	read_profile_defaults(argc, argv);
	read_cost_defaults(argc, argv);
	read_perr_defaults(argc, argv);
	read_struct_defaults(argc, argv);
	read_prob_defaults(argc, argv);
	read_detect_defaults(argc, argv);
	read_reject_defaults(argc, argv);
	read_reports_defaults(argc, argv);
	read_print_defaults(argc, argv);
	read_ccode_defaults(argc, argv);
	read_committeeData_defaults(argc, argv);
	read_artmap_defaults(argc, argv);
	read_bintree_defaults(argc, argv);
	read_cknn_defaults(argc,argv);
	read_em_clus_defaults(argc,argv);
	read_gauss_defaults(argc,argv);
	read_gmix_defaults(argc,argv);
	read_hyper_defaults(argc, argv);
	read_irbf_defaults(argc,argv);
	read_kmeans_defaults(argc,argv);
	read_knn_defaults(argc,argv);
	read_lead_clus_defaults(argc,argv);
	read_lvq_defaults(argc,argv);
	read_mlp_defaults(argc, argv);
	read_nc_class_defaults(argc,argv);
	read_ran_clus_defaults(argc,argv);
	read_rbf_defaults(argc,argv);
	read_committee_defaults(argc, argv);
	read_histogram_defaults(argc, argv);
	read_parzen_defaults(argc, argv);
    }

    if(dfp == NULL){
	/* update algorithm derived file names */
	set_algorithm(nn_params.algorithm);
	/* update data base derived file names */
	data_set_data_base();
    } else {
	void g_set_cv_filename();
	/* some things are derived and note stored whole */
	g_set_cv_filename();
    }
    g_display();
    g_display_algs();
    /* write messages, like class priors for files, that are generated
       not stored */
/*
    set_description_values();
*/
}

write_defaults(dfp)
     FILE *dfp;
{
    void set_common_flags();
    void write_main_defaults();
    void write_data_defaults(), write_norm_defaults();
    void write_select_defaults(), write_priors_defaults();
    void write_plot_defaults(), write_reports_defaults();
    void write_print_defaults(), write_committee_defaults();
    void write_ccode_defaults(), write_committeeData_defaults();
    void write_artmap_defaults(), write_bintree_defaults();
    void write_cknn_defaults(), write_em_clus_defaults();
    void write_gauss_defaults(), write_gmix_defaults();
    void write_hyper_defaults(), write_irbf_defaults();
    void write_kmeans_defaults(), write_knn_defaults();
    void write_lead_clus_defaults(), write_lvq_defaults();
    void write_mlp_defaults(), write_nc_class_defaults();
    void write_ran_clus_defaults(), write_rbf_defaults();
    void write_parzen_defaults(), write_histogram_defaults();
    void write_bound_defaults(), write_cost_defaults();
    void write_perr_defaults(), write_struct_defaults();
    void write_profile_defaults(), write_prob_defaults();
    void write_detect_defaults();
    void write_reject_defaults();


    set_common_flags(gnn_get_which_data());

    write_main_defaults(dfp);
    write_data_defaults(dfp);
    write_norm_defaults(dfp);
    write_select_defaults(dfp);
    write_priors_defaults(dfp);
    write_plot_defaults(dfp);
    write_bound_defaults(dfp);
    write_profile_defaults(dfp);
    write_cost_defaults(dfp);
    write_perr_defaults(dfp);
    write_struct_defaults(dfp);
    write_prob_defaults(dfp);
    write_detect_defaults(dfp);
    write_reject_defaults(dfp);
    write_reports_defaults(dfp);
    write_print_defaults(dfp);
    write_ccode_defaults(dfp);
    write_committeeData_defaults(dfp);
    write_artmap_defaults(dfp);
    write_bintree_defaults(dfp);
    write_cknn_defaults(dfp);
    write_em_clus_defaults(dfp);
    write_gauss_defaults(dfp);
    write_gmix_defaults(dfp);
    write_hyper_defaults(dfp);
    write_irbf_defaults(dfp);
    write_kmeans_defaults(dfp);
    write_knn_defaults(dfp);
    write_lead_clus_defaults(dfp);
    write_lvq_defaults(dfp);
    write_mlp_defaults(dfp);
    write_nc_class_defaults(dfp);
    write_ran_clus_defaults(dfp);
    write_rbf_defaults(dfp);
    write_committee_defaults(dfp);
    write_histogram_defaults(dfp);
    write_parzen_defaults(dfp);
}

void
g_set_cluster_names()
{
    void grbf_set_cluster_param_fname(), girbf_set_cluster_param_fname();
    void ggmix_set_cluster_param_fname(), glvq_set_cluster_param_fname();
    void gnc_class_set_cluster_param_fname();
    
    grbf_set_cluster_param_fname();
    girbf_set_cluster_param_fname();
    ggmix_set_cluster_param_fname();
    glvq_set_cluster_param_fname();
    gnc_class_set_cluster_param_fname();
}

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
g_init_algs()
{
    void gmlp_init(), gknn_init(), gcknn_init(), gbintree_init();
    void grbf_init(), glvq_init(), gran_clus_init(), gnc_class_init();
    void gkmeans_init(), gem_clus_init(), gran_clus_init();
    void glead_clus_init(), ghyper_init(), ggauss_init(), girbf_init();
    void ggmix_init(), gartmap_init(), gcommittee_init();
    void ghistogram_init(), gparzen_init();

    gartmap_init();
    gmlp_init ();
    gknn_init ();
    gcknn_init ();
    gbintree_init ();
    grbf_init ();
    glvq_init ();
    gran_clus_init ();
    gnc_class_init ();
    gkmeans_init ();
    gem_clus_init ();
    glead_clus_init ();
    ghyper_init ();
    ggauss_init ();
    ggmix_init();
    girbf_init ();
    gcommittee_init ();
    ghistogram_init();
    gparzen_init();
}

g_display_algs()
{
    void gmlp_display_params(), gknn_display_params();
    void gcknn_display_params(), gbintree_display_params();
    void grbf_display_params(), glvq_display_params();
    void gran_clus_display_params(), gnc_class_display_params();
    void gkmeans_display_params(), gem_clus_display_params();
    void glead_clus_display_params(), ghyper_display_params();
    void ggauss_display_params(), ggmix_display_params();
    void girbf_display_params(), gartmap_display_params();
    void gcommittee_display_params(), ghistogram_display_params();
    void gparzen_display_params();

    gmlp_display_params ();
    gknn_display_params ();
    gcknn_display_params ();
    gbintree_display_params ();
    grbf_display_params ();
    glvq_display_params ();
    gran_clus_display_params ();
    gnc_class_display_params ();
    gkmeans_display_params ();
    gem_clus_display_params ();
    glead_clus_display_params ();
    ghyper_display_params ();
    ggauss_display_params ();
    ggmix_display_params();
    girbf_display_params ();
    gartmap_display_params();
    gcommittee_display_params();
    ghistogram_display_params();
    gparzen_display_params();
}

void
set_common_flags(which_data)
     int which_data;
{
    void gnn_set_common_flags(), gnorm_set_common_flags();
    void select_set_common_flags(), cost_set_common_flags();
    void bound_set_common_flags(), perr_set_common_flags();
    void struct_set_common_flags(), profile_set_common_flags();
    void prob_set_common_flags(), detect_set_common_flags();
    void reject_set_common_flags();

    gnn_set_common_flags(which_data);
    gnorm_set_common_flags();
    select_set_common_flags();
    cost_set_common_flags();
    perr_set_common_flags();
    bound_set_common_flags(which_data);
    profile_set_common_flags(which_data);
    struct_set_common_flags();
    prob_set_common_flags(which_data);
    detect_set_common_flags(which_data);
    reject_set_common_flags(which_data);
}
