/* designators for the algorithms in LNKnet */
#ifndef galgs_h
#define galgs_h

/* algorithm integer designator */
/*typedef enum{
    KNN = 0, CKNN, HYPER, MLP, GAUSS, RBF, GMIX, NC_CLASS, LVQ, IRBF, BINTREE,
    COMMITTEE, HISTOGRAM, PARZEN,
    KMEANS, EM_CLUS, LEAD_CLUS, RAN_CLUS, ARTMAP, extra}
algorithm_number;*/
typedef enum{
    MLP = 0, RBF, IRBF, HISTOGRAM, PARZEN, GAUSS, GMIX, KNN, CKNN, NC_CLASS,
    LVQ, HYPER, BINTREE, COMMITTEE,
    KMEANS, EM_CLUS, LEAD_CLUS, RAN_CLUS, ARTMAP, extra}
algorithm_number;
/* extra is to allow ARTMAP + 1 to be a real number */

static char *classifier_strings[] = {
    /* classification algorithms */
    "MLP (Multi-Layer Perceptron)",
    "RBF (Radial Basis Function)", 
    "IRBF (Incremental RBF)", 
    "HISTOGRAM",
    "PARZEN (Parzen Window)",
    "GAUSS (Gaussian)", 
    "GMIX (Gaussian Mixture)",
    "KNN (K-Nearest Neighbor)",
    "CKNN (Condensed KNN)",
    "NC_CLASS (Nearest Cluster)",
    "LVQ (Learning Vector Quantizer)", 
    "HYPER (Hypersphere)",
    "BINTREE (Binary Tree)",
    "COMMITTEE",
    /* clustering algorithms */
    "KMEANS (K Means Clustering)",
    "EM_CLUS (GMIX Clustering)",
    "LEAD_CLUS (Leader Clustering)",
    "RAN_CLUS (Random Clustering)", 
    /* contributed algorithms */
    "ARTMAP (Fuzzy ART Map)",
};
static char *classifier_names[] = {
    "mlp", "rbf", "irbf", "histogram", "parzen", "gauss", "gmix", "knn",
    "cknn", "nc_class", "lvq", "hyper", "bintree", "committee",
    "kmeans", "em_clus", "lead_clus", "ran_clus",
    "artmap"};
#endif
