/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * gnn_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `gnn.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <sys/param.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include <gen_class_args.h>
#include "../LNKnet_subs.h"
#include "galgs.h"
#include "nn_params.h"
#include "gnn_ui.h"
#include "menus_ui.h"
#include "../plots/plots_ui.h"
#include "reports_ui.h"
#include "data_ui.h"
#include "norm_ui.h"
#include "select_ui.h"
#include "priors_ui.h"
#include "print_ui.h"
#include "ccode_ui.h"
#include "committeeData_ui.h"

extern	gnn_main_window_objects	*Gnn_main_window;
extern	data_data_pop_objects	*Data_data_pop;
extern	norm_norm_pop_objects	*Norm_norm_pop;
extern	select_select_pop_objects	*Select_select_pop;
extern	priors_priors_pop_objects	*Priors_priors_pop;
extern	plots_plot_pop_objects	*Plots_plot_pop;
extern	reports_file_pop_objects	*Reports_file_pop;
extern	ccode_ccode_pop_objects	*Ccode_ccode_pop;
extern	committeeData_committeeData_pop_objects	*CommitteeData_committeeData_pop;
extern  print_print_pop_objects	*Print_print_pop;

static int store_only;
static int append_flag;/*needed for log append on train create after cluster*/
static int continue_flag; /* needed to set continue flag in notebook */
static int run_options;
static int test_select;
#define MAXSTR 256
static char exp_name[MAXSTR] = "";/* the part the user types */
static char full_exp_name[MAXSTR] = "";/* with algorithm added */
static char ext_test_train[] = ".test_on_train";
static char temp_filename[MAXSTR];
static char ext_cv[MAXSTR] = ".cv";
static char cv_filename[MAXSTR] = "";/* !!! update with data base */
static int screen_cv;

static int exper_pid = 0;

#define PLOT_ONLY 0
#define EXP_AND_PLOT 1

#define RUN_TRAIN 0
#define RUN_TEST 1
#define RUN_TRAIN_AND_TEST 2
#define RUN_CROSS_VALID 3

#define DEFAULTS_FILENAME ".lnknetrc"

#define SHOW_GRAPHICS 1
#define NO_GRAPHICS 0

/* for printint constant width versions of shell script names in the
   notebook file */
static char const_width_script_name[64];

/* set up "important" args list
   the actual arguments are declared in <gen_class_args.h> */
static ARG import_tab[] =
{
    {"train_uniform_priors", BOOLEAN, &train_uniform_priors,
      "if adjusting train priors, make class probabilities uniform"},
    {"train_priors_list", FLOAT_ALLOC_LIST, (int *)&train_priors_list,
       "class probabilities list for sampling in training"},
    {"test_uniform_priors", BOOLEAN, &test_uniform_priors,
       "if adjusting priors in testing, make class probabilities uniform"},
    {"test_priors_list", FLOAT_ALLOC_LIST, (int *)&test_priors_list,
       "class probabilities list for scaling in testing"},
    {"features", INT_ALLOC_LIST, (int *)&features,
       "features of normalized data to use"},
};
#define IMPORT_TABSIZE (sizeof(import_tab)/sizeof(ARG))

void g_run();
void set_short_algorithm();
void g_defaults_write();
void set_experiment_name();
void gnn_set_common_flags();
void g_set_cvtest_flag();
void g_set_cv_filename();
void read_defaults();
void store_plot_commands();

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init ()
{
    void g_init_data(), g_init_norm(), g_init_select(), g_init_priors();
    void g_init_plots(), g_init_reports(), g_init_ccode();
    void g_init_committeeData(), g_init_print();
    /* set gnn's variables */
    store_only = 0;
    run_options = 0;
    random_flag = 0;
    test_select = CLASS_EVAL;
    nn_params.exp_name = full_exp_name;
    nn_params.exp_prefix = exp_name;
    nn_params.ext_test_train = ext_test_train;

    /* set variables on gnn's popups */
    g_init_data();
    g_init_norm();
    g_init_select();
    g_init_priors();
    g_init_plots();
    g_init_reports();
    g_init_print();
    g_init_ccode();
    g_init_committeeData();
    g_set_cv_filename();
}

g_display()
{
    void g_display_data(), g_display_norm(), g_display_select();
    void g_display_priors(), g_display_plots(), g_display_reports();
    void g_display_ccode(), g_display_committeeData(), g_display_print();

    g_display_data();
    g_display_norm();
    g_display_select();
    g_display_priors();
    g_display_plots();
    g_display_reports();
    g_display_print();
    g_display_ccode();
    g_display_committeeData();

    show_int_value (Gnn_main_window->random_flag, random_flag);
    show_int_text(Gnn_main_window->seed, seed);
    show_int_value (Gnn_main_window->store_only, store_only);
    show_int_value (Gnn_main_window->action_select, run_options);
    show_int_value (Gnn_main_window->test_select, test_select);
    show_int_value (Gnn_main_window->cv_from_file, cross_valid_from_file);
    show_string_text (Gnn_main_window->ext_cv, ext_cv);
    show_string_label (Gnn_main_window->cv_filename, cv_filename);
    show_int_text(Gnn_main_window->cross_valid, screen_cv);
    show_int_value(Gnn_main_window->cv_random, cv_random);
    /* do graying out for cross valid */
    g_set_cvtest_flag(run_options == RUN_CROSS_VALID);
    show_string_text (Gnn_main_window->experiment_name, exp_name);
    set_short_algorithm(nn_params.algorithm);
}

/*
 * Notify callback function for main window buttons
 */
void
main_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    gnn_main_window_objects *ip =
      (gnn_main_window_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    void show_algorithm_popup();
	
    if(item == ip->Continue){
	create_flag = FALSE;
	append_flag = TRUE;
	continue_flag = TRUE;
	g_run (EXP_AND_PLOT);
    } else if(item == ip->plot_only) {
	continue_flag = FALSE;
	g_run(PLOT_ONLY);
    } else if(item == ip->start_run){
	create_flag = TRUE;
	append_flag = FALSE;
	continue_flag = FALSE;
	g_run(EXP_AND_PLOT);
    } else if(item == ip->stop_run){
	stop_command_file(exper_pid);
	exper_pid = 0;
    } else if(item == ip->save_defaults){
	strcpy (temp_filename, path_build(getenv("HOME"), DEFAULTS_FILENAME));
	if (overwrite_ok (temp_filename)) {
	    g_defaults_write (temp_filename);
	    printf ("\nLNKnet default values saved in %s\n", temp_filename);
	}
    } else if(item == ip->restore_defaults){
	void g_get_defaults();
	g_get_defaults("");/* use defaults file for getting data */
    }	/* buttons that call up other windows */
    else if (item == ip->data_button){
	open_popup(Data_data_pop->data_pop);
    } else if(item == ip->norm_button){
	open_popup(Norm_norm_pop->norm_pop);
    } else if(item == ip->feature_button){
	open_popup(Select_select_pop->select_pop);
    } else if(item == ip->priors_button){
	open_popup(Priors_priors_pop->priors_pop);
    } else if(item == ip->alg_button){
	show_algorithm_popup();
    } else if(item == ip->plot_button){
	open_popup(Plots_plot_pop->plot_pop);
    } else if(item == ip->report_button){
	open_popup(Reports_file_pop->file_pop);
    } else if(item == ip->print_button){
	open_popup(Print_print_pop->print_pop);
    } else if(item == ip->ccode_button){
	open_popup(Ccode_ccode_pop->ccode_pop);
    } else if(item == ip->committeeData_button){
	open_popup(CommitteeData_committeeData_pop->committeeData_pop);
    } else {
	fputs("LNKnet: main_btn_handler, unhandled button\n", stderr);
    }
}

/*
 * Notify callback function for main window text fields
 */
Panel_setting
main_2_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    gnn_main_window_objects *ip =
      (gnn_main_window_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if(item == ip->cross_valid){
	cross_valid = set_atoi_range_value(value, "cross_valid_nfolds",
					   item, cross_valid, 2, 255);
	screen_cv = cross_valid;
    } else if(item == ip->ext_cv){
	value = set_string_not_empty(value, "cross valid file extension",
				     item, ext_cv);
	strcpy (ext_cv, value);
	show_string_text (Gnn_main_window->ext_cv, ext_cv);
	g_set_cv_filename();
    } else if(item == ip->experiment_name){
	set_experiment_name(value);
    } else if (item == ip->seed){
	seed = set_atoi_value(value, "seed", item, seed);
    } else {
	fprintf(stderr, "LNKnet: main_2_handler: unhandled: value: %s\n",
		value);
    }    
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for main window settings
 */
void
main_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    gnn_main_window_objects *ip =
      (gnn_main_window_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
    void activate_features();
	
    if(item == ip->store_only){
	nn_params.store_only = store_only = value;
    } else if(item == ip->cv_from_file){
	if(value){
	    cross_valid_from_file = 1;
	    gray_out_item (ip->ext_cv, FALSE);
	    gray_out_item (ip->cv_filename1, FALSE);
	    gray_out_item (ip->cv_filename, FALSE);
	    gray_out_item (ip->cross_valid, TRUE);
	    gray_out_item (ip->cv_random, TRUE);
	    gray_out_item(ip->cv_random_msg, TRUE);
	} else {
	    cross_valid_from_file = 0;
	    gray_out_item (ip->ext_cv, TRUE);
	    gray_out_item (ip->cv_filename, TRUE);
	    gray_out_item (ip->cv_filename1, TRUE);
	    gray_out_item (ip->cross_valid, FALSE);
	    gray_out_item(ip->cv_random, FALSE);
	    gray_out_item(ip->cv_random_msg, FALSE);
	}
    } else if(item == ip->random_flag){
	random_flag = value;
    } else if(item == ip->action_select){
	run_options = value;
	if(run_options == RUN_TEST)
	  activate_features(FALSE);
	else 
	  activate_features(TRUE);
	g_set_cvtest_flag(run_options == RUN_CROSS_VALID);
	/* update the plot names on the print page */
	region_create_plot_fname(gnn_get_which_data());
	print_set_region_status();
	profile_create_plot_fname(gnn_get_which_data());
	print_set_profile_status();
    } else if(item == ip->test_select){
	test_select = value;
	/* update the plot names on the print page */
	region_create_plot_fname(gnn_get_which_data());
	print_set_region_status();
	profile_create_plot_fname(gnn_get_which_data());
	print_set_profile_status();
    } else if (item == ip->cv_random){
	cv_random = value;
    } else {
	fputs("LNKnet: main_3_handler: unhandled setting\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    
	    /* gxv_start_connections DO NOT EDIT THIS SECTION */
	    
	    /* gxv_end_connections */
	    
	    value >>= 1;
	}
    }
}
/*
 * Event callback function for `data_problem'.
 * saves a function call, not calling main_data_warning_handler()
 *
 * calls the routine that senses selections on the error picture on the
 * data base window
 */
void
gnn_main_window_data_problem_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    data_data_pop_data_warning_event_callback(item, event);
}

/*
 * Event callback function for `norm_problem'.
 * saves a function call, not calling main_norm_warning_handler
 * 
 * calls the routine that senses selections on the error picture on
 * the normalization window
 */
void
gnn_main_window_norm_problem_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    norm_norm_pop_norm_warning_event_callback(item, event);
}
/*
 * Event callback function for `select_problem'.
 * saves a function call, not calling main_select_warning_handler
 *
 * calls the routine that senses selections on the error picture on
 * the select window
 */
void
gnn_main_window_select_problem_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    select_select_pop_select_warning_event_callback(item, event);
}

void
g_run (run_flag)
     int run_flag;
{
    if (overwrite_ok(nn_params.shell_path)) {
	if(store_commands(nn_params.shell_path, run_flag)) return;
	if(!store_only)
	  exper_pid = chdir_and_execute_command(nn_params.shell_fname);
    }
}

void
g_set_cvtest_flag(value)
     int value;
{
    if(value){	    
	cross_valid = screen_cv;
	gray_out_item(Gnn_main_window->cv_from_file, FALSE);
	if(cross_valid_from_file){
	    gray_out_item(Gnn_main_window->ext_cv, FALSE);
	    gray_out_item(Gnn_main_window->cv_filename, FALSE);
	    gray_out_item(Gnn_main_window->cv_filename1, FALSE);
	} else {
	    gray_out_item (Gnn_main_window->cross_valid, FALSE);
	    gray_out_item(Gnn_main_window->cv_random, FALSE);
	    gray_out_item(Gnn_main_window->cv_random_msg, FALSE);
	}
	gray_out_item (Gnn_main_window->test_select, TRUE);
	show_int_value(Gnn_main_window->test_select, CLASS_TRAIN);
    } else {
	cross_valid = 0;
	gray_out_item (Gnn_main_window->cross_valid, TRUE);
	gray_out_item(Gnn_main_window->cv_random, TRUE);
	gray_out_item(Gnn_main_window->cv_random_msg, TRUE);
	gray_out_item (Gnn_main_window->cv_from_file, TRUE);
	gray_out_item (Gnn_main_window->ext_cv, TRUE);
	gray_out_item (Gnn_main_window->cv_filename1, TRUE);
	gray_out_item (Gnn_main_window->cv_filename, TRUE);
	show_int_value(Gnn_main_window->test_select, test_select);
	gray_out_item(Gnn_main_window->test_select, FALSE);
    }
}

/* set cross_valid without changing anything else.
   needed by feature selection window */
int
set_cv_nfolds(cv_val)
     int cv_val;
{
    int rv;
    rv = cross_valid;
    cross_valid = cv_val;
    return rv;
}

void
g_set_cv_filename()
{
    strcpy (cv_filename, nn_params.data_base);
    strcat (cv_filename, nn_params.ext_train);
    strcat (cv_filename, ext_cv);
    cross_valid_fname = cv_filename;
    show_string_label(Gnn_main_window->cv_filename, cv_filename);
}

void
activate_test_selects(activate_flag)
     int activate_flag;
{
    int dir;
    /* this used to change the run_options */
    if(activate_flag) dir = FALSE;
    else dir = TRUE;

    gray_out_item(Data_data_pop->ext_eval, dir);
    gray_out_item(Data_data_pop->npatterns_eval, dir);
    gray_out_item(Data_data_pop->ext_test, dir);
    gray_out_item(Data_data_pop->npatterns_test, dir);
}

void
set_algorithm(value)
     int	value;
{
    void set_plot_labels();
    void set_short_algorithm();

    set_short_algorithm(value);
    set_experiment_name(exp_name); /* adds in classifier name and
				      tells dependents */
    set_plot_labels();
}

void
g_defaults_write(default_fullname)
     char *default_fullname;
{
    FILE *default_file;
    
    default_file = fopen(default_fullname, "w", "defaults file");
    write_defaults(default_file);
    nn_fclose(default_file, default_fullname, 
	      "for reading data description");
}

/* defaults file arguments, table, and routines */
static int algorithm_arg = 0;
static char *exp_tmp = "";
static char *ext_cv_arg = ".cv";

static ARG maintab[] =
{
    {"store_only", INT, &store_only, ""},
    {"action", INT, &run_options, "1-TRAIN,2-TEST,3-TRAIN&TEST,4-CV"},
    {"test_file", INT, &test_select, "1-train,2-eval,2-test"},
    {"cv_nfolds", INT, &screen_cv, ""},
    {"cv_from_file", INT, &cross_valid_from_file, ""},
    {"cv_random", FLAG, &cv_random, ""},
    {"ext_cv", STRING, (int *)&ext_cv_arg, ""},
    {"random", INT, &random_flag, ""},
    {"algorithm", INT, &algorithm_arg, ""},
    {"exp_name", STRING, (int *)&exp_tmp, ""},
    {"seed", INT, &seed, ""},
};
#define TABSIZE (sizeof(maintab)/sizeof(ARG))

void
read_main_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* set variables that are not included if they are NULL or 0 */
    exp_tmp = NULL;
    ext_cv_arg = NULL;
    cv_random = 0;

    if(argc > 0){
	argc = nnargs(argc, argv, maintab, TABSIZE);
    } else {
	/* set some defaults for initial startup */
	random_flag = 1;	/* turn on randomization */
	algorithm_arg = 0;	/* MLP, usually */
	ext_cv_arg = ".cv";
	screen_cv = 4;
	exp_tmp = "X1";
	cv_random = 1;
    }
    cross_valid = (run_options == RUN_CROSS_VALID) ? screen_cv : 0;
    nn_params.algorithm = algorithm_arg;
    strcpy_empty_if_null(exp_name, exp_tmp);
    nn_params.exp_prefix = exp_name;
    strcpy_empty_if_null(ext_cv, ext_cv_arg);
    nn_params.store_only = store_only;
}

void
write_main_defaults (default_file)
     FILE *default_file;
{
    /* we need to save the cross valid setting from the screen */
    algorithm_arg = nn_params.algorithm;
    exp_tmp = null_if_empty_string(exp_name);
    ext_cv_arg = null_if_empty_string(ext_cv);
    if(default_file != NULL){
	fprintf (default_file, "LNKnet %s",
		 nnargs_get_flags(maintab, TABSIZE));
    }
}

void
g_get_defaults (screen_fname)
     char *screen_fname;
{
    /* get arguments from default file if present */
    FILE *default_file;

    if(screen_fname == NULL || strcmp(screen_fname, "") == 0){
	screen_fname = path_build(getenv("HOME"), DEFAULTS_FILENAME);
    }
    default_file = fopen(screen_fname, "r");
    read_defaults(default_file, screen_fname);
    if(default_file != NULL)
      nn_fclose(default_file, screen_fname,
		"for reading LNKnet defaults");
}

static char *exp_path_tmp;

void
set_temp_exp_path(shell_file)
     FILE *shell_file;
{
    exp_path_tmp = nn_params.exp_path;
    exp_path = nn_params.exp_path = "$loc";
    
    /* print out variable necessary for running remotely */
    fprintf(shell_file, "set loc=`pwd`\n");
}

void
restore_exp_path()
{
    nn_params.exp_path = exp_path = exp_path_tmp;
}

int
store_commands (filename, run_flag)
     char *filename;
     int run_flag;/* stores only plot command if run_flag == PLOT_ONLY */
{
    FILE *shell_file;
    void set_plot_flags(), set_common_flags();
    void store_commands_specific();
    void store_alg_plot_commands();
    void g_write_notebook_entry();

    shell_file = command_file_open (filename, "for run shell file");
    if(shell_file == NULL) return -1;
    
    set_temp_exp_path(shell_file);

    /* store train commands */
    if (run_options == RUN_TRAIN || run_options == RUN_TRAIN_AND_TEST) {
	set_common_flags(TRAIN_TRAIN);
	train_flag = TRUE;
	if(run_flag != PLOT_ONLY){
	    /* setup for notebook */
	    if(nn_params.epoch_plots){
		if(store_epochs_train(shell_file, run_flag)
		   == 0){
		    /* not enough epochs to do more than one training run */
		    store_commands_specific (shell_file, run_flag);
		    if(alg_is_epoch_class() && nn_params.notebook_on)
		      store_train_note_command(shell_file, nn_params.log_fname,
					       nn_params.shell_fname,
					       nn_params.notebook_path);
		}
	    } else {
		fprintf(shell_file, "\n#train\n");
		store_commands_specific (shell_file, run_flag);
		if(alg_is_epoch_class() && nn_params.notebook_on)
		  store_train_note_command(shell_file, nn_params.log_fname,
					   nn_params.shell_fname,
					   nn_params.notebook_path);
	    }
	}
	append_flag = TRUE;
	if(nn_params.train_plots){
	    if(store_only)
	      store_alg_plot_commands(shell_file, NO_GRAPHICS);
	    else 
	      store_alg_plot_commands(shell_file, SHOW_GRAPHICS);
	}
    }
    train_flag = FALSE;

    /* store test commands */
    if(run_options == RUN_TEST || run_options == RUN_TRAIN_AND_TEST) {
	create_flag = TRUE;
	set_common_flags(test_select);
	if(run_flag != PLOT_ONLY) fprintf(shell_file, "\n#test\n");
	store_commands_specific (shell_file, run_flag);
	append_flag = TRUE;
	/* store command to get result */
	if(run_flag != PLOT_ONLY){
	    if(nn_params.notebook_on)
	      store_test_note_command(shell_file, nn_params.log_fname,
				      nn_params.shell_fname,
				      nn_params.notebook_path);
	}
	/* 1 is for show_graphics, not shown with epoch plots */
	if(store_only)
	  store_alg_plot_commands(shell_file, NO_GRAPHICS);
	else
	  store_alg_plot_commands(shell_file, SHOW_GRAPHICS);
    }
    /* store cross valid commands */
    if(run_options == RUN_CROSS_VALID){
	create_flag = TRUE;
	if(run_flag != PLOT_ONLY) fprintf(shell_file, "\n#cross validation\n");
	set_common_flags(CV_TRAIN);
	if(cross_valid > 1){
	    store_commands_specific (shell_file, run_flag);
	    /* store command to get result */
	    if(run_flag != PLOT_ONLY){
		if(nn_params.notebook_on)
		  store_cv_note_command(shell_file, nn_params.log_fname,
					nn_params.shell_fname,
					nn_params.notebook_path);
	    }
	}
    }

    /* store plots */
    if(run_options != RUN_CROSS_VALID)
      store_plot_commands(shell_file);

    restore_exp_path();
    
    /* tell the log file where we are */
    /* telling sooner risks the log file being overwritten */
    fprintf(shell_file, "echo \"current directory:\" >> %s\n",
	    nn_params.log_fname);
    fprintf(shell_file, "echo $loc >> %s\n", nn_params.log_fname);
    
    command_file_close (shell_file, filename, "for run shell file");

    /* store screen file */
    g_defaults_write(nn_params.screen_path);
    g_write_notebook_entry(run_flag);

    return 0;
}

void
store_commands_specific (shell_file, run_flag)
     FILE *shell_file;
     int run_flag;	/* stores only plot command if run_flag == PLOT_ONLY */
{
    void g_store_run_command();
    char *g_get_cluster_fname(), *g_get_alg_args();
    char *temp_fname;
    int clus_alg, temp_alg;
    
    if(run_flag != PLOT_ONLY){
	/* store clustering commands */
	if(must_store_clustering() &&
	   ((train_flag && create_flag) || cross_valid > 1)){

	    /* set param_fname and algorithm */
	    temp_fname = param_fname;
	    param_fname = g_get_cluster_fname();
	    temp_alg = g_get_alg();
	    clus_alg = g_get_cluster_alg();
	    g_set_alg(clus_alg);
	    
	    store_command_head(shell_file);
	    fprintf(shell_file, "%s", g_get_alg_args());
	    store_command_end(shell_file);
	    
	    /* reset param_fname and algorithm */
	    param_fname = temp_fname;
	    g_set_alg(temp_alg);
	    append_flag = TRUE;
	}
	/* store train, test, or cv command */
	store_command_head(shell_file);
	fprintf(shell_file, "%s", g_get_alg_args());
	store_command_end(shell_file);
    }
}

char *
g_get_gen_class_args()
{
    return nnargs_get_part_flags(gen_tab, GEN_TABSIZE);
}

char *
g_get_important_args()
{
    return nnargs_get_flags_one_line(import_tab, IMPORT_TABSIZE);
}

store_command_head(shell_file)
    FILE *shell_file;
{
    if(nn_params.verbosity > 1)
      fprintf(shell_file, "(time ");
    fprintf(shell_file, "%s\\\n %s",
	    nn_params.classifier_name, g_get_gen_class_args());
}

store_command_end(shell_file)
     FILE *shell_file;
{
    if(nn_params.verbosity > 1)
      fprintf(shell_file, ")");
    if(store_only){
	fprintf(shell_file, ">");
	if(append_flag) fprintf(shell_file, ">");
	fprintf(shell_file, "& %s\n", nn_params.log_fname);
    } else {
	fprintf(shell_file, "|& nn_tee -h ");
	if(append_flag) fprintf(shell_file, "-a ");
	fprintf(shell_file, "%s\n", nn_params.log_fname);
    }
}

int
store_epochs_train(shell_file, run_flag)
     FILE *shell_file;
     int run_flag;
{
    int epochs;
    void setup_epoch_plot_calls();
    void finish_epoch_plot_calls();
    
    /* get the number of epochs we are supposed to do */
    epochs = g_get_epochs();
    /* if we can only do one pass, do it normally */
    if(epochs <= nn_params.e_per_plot) return 0;
    /* if e_per_plot set wrong, it causes a core dump */
    if(nn_params.e_per_plot <= 0) return 0;
    
    /* set up variables in the shell file */
    fprintf(shell_file, "\n#initialize plot file names and numbers\n");
    setup_epoch_plot_calls(shell_file);
    fprintf(shell_file, "\n#initialize total number of epochs\n");
    fprintf(shell_file, "set epochs_left = %d\n", epochs);
    
    /* set variables to do the first training run */
    g_set_epochs(nn_params.e_per_plot);
    
    fprintf(shell_file, "\n# training and plots for first movie frame\n");
    store_commands_specific(shell_file, run_flag);
    /* 0 is for show_graphics, not shown with epoch plots */
    if(nn_params.train_plots)
      store_alg_plot_commands(shell_file, NO_GRAPHICS);
    
    /* the rest of the training will be done in continue mode */
    create_flag = FALSE;
    append_flag = TRUE;
    
    /* create a call to display the set of plots */
    fprintf(shell_file, "\n# start list of plot numbers for movie\n");
    fprintf(shell_file, "set plotnum_list = $plotnum\n");
    fprintf(shell_file, "@ plotnum++\n");
    
    fprintf(shell_file, "\n# decrease epochs left \n");
    fprintf(shell_file, "@ epochs_left -= %d\n", nn_params.e_per_plot);
    
    /* loop through most of the training epochs */
    fprintf(shell_file, "\n######## start movie mode loop #############\n");
    fprintf(shell_file, "while($epochs_left > %d)\n", nn_params.e_per_plot);
    fprintf(shell_file, "set bpfname = \"$bplotfile$plotnum\"\n");
    fprintf(shell_file, "set ppfname = \"$pplotfile$plotnum\"\n");
    
    fprintf(shell_file, "\n# train\n");
    store_commands_specific(shell_file, run_flag);
    /* 0 is for show_graphics, not shown with epoch plots */
    if(nn_params.train_plots)
      store_alg_plot_commands(shell_file, NO_GRAPHICS);
    

    fprintf(shell_file, "\n# update list of plot numbers for movie\n");
    fprintf(shell_file, "set plotnum_list = $plotnum_list,$plotnum\n");
    fprintf(shell_file, "@ plotnum++\n");

    fprintf(shell_file, "\n# decrease epochs left\n");
    fprintf(shell_file, "@ epochs_left -= %d\n", nn_params.e_per_plot);
    fprintf(shell_file, "end\n");
    fprintf(shell_file, "\n######## end movie mode loop ################\n");
    
    /* do the last training call, which may want fewer epochs */
    fprintf(shell_file, "\n# do last %d epochs of training \n",
	    nn_params.e_per_plot);
    fprintf(shell_file, "set bpfname = \"$bplotfile$plotnum\"\n");
    fprintf(shell_file, "set ppfname = \"$pplotfile$plotnum\"\n");
    
    /* calculate the number of epochs remaining (e_per_plot or less) */
    /* e_per_plot must be > 0 or this dumps core */
    if(epochs%nn_params.e_per_plot != 0)
      g_set_epochs(epochs%nn_params.e_per_plot);
    fprintf(shell_file, "\n#train\n");
    store_commands_specific(shell_file, run_flag);

    /* store the command in the notebook file */
    if(alg_is_epoch_class() && nn_params.notebook_on){
	sprintf(const_width_script_name, "%s MOVIE EPOCH: %d",
		nn_params.shell_fname, epochs);
	store_train_note_command(shell_file, nn_params.log_fname,
				 const_width_script_name,
				 nn_params.notebook_path);
    }

    /* 0 is for show_graphics, not shown with epoch plots */
    if(nn_params.train_plots)
      store_alg_plot_commands(shell_file, NO_GRAPHICS);
    
    fprintf(shell_file, "\n#add last plot number to list\n");
    fprintf(shell_file, "set plotnum_list = $plotnum_list,$plotnum\n");
    
    /* display the plots */
    fprintf(shell_file, "# display movie frames in olxplot windows\n");
    finish_epoch_plot_calls(shell_file);
    g_set_epochs(epochs);
    
    return(1);
}

/* build the experiment name string and tell dependent windows */
void
set_experiment_name(value)
     char *value;
{
    void create_experiment_file_names();
    void create_ccode_file_names();
    void g_set_cluster_names();
    void create_plot_file_names();

    strcpy(exp_name, value);
    nn_params.exp_prefix = exp_name;
    strcpy(full_exp_name, value);
    strcat(full_exp_name, nn_params.classifier_name);
    nn_params.exp_name = full_exp_name;
    g_set_cluster_names();
    create_experiment_file_names();
    create_ccode_file_names();
    create_plot_file_names();
    nn_params.major_note = 1;
}

void
gnn_set_common_flags(which_data)
     int which_data;
{
    static char tmp_data_fname_space[MAXSTR];
    static char tmp_error_fname_space[MAXSTR];
    char *data_exten = NULL, *err_exten = NULL;

    /* build data_fname */
    switch(which_data){
      case CLASS_TRAIN:
      case TRAIN_TRAIN:
      case CV_TRAIN:
	data_exten = nn_params.ext_train;
	npatterns = nn_params.npatterns_train;
	break;
      case CLASS_EVAL:
	npatterns = nn_params.npatterns_eval;
	data_exten = nn_params.ext_eval;
	break;
      case CLASS_TEST:
	npatterns = nn_params.npatterns_test;
	data_exten = nn_params.ext_test;
	break;
    }
    strcpy(tmp_data_fname_space, nn_params.data_base);
    strcat(tmp_data_fname_space, data_exten);
    data_fname = tmp_data_fname_space;

    /* build error_fname */
    switch(which_data){
      case TRAIN_TRAIN:
	err_exten = nn_params.ext_train;
	break;
      case CLASS_TRAIN:
	err_exten = ext_test_train;
	break;
      case CLASS_EVAL:
	err_exten = nn_params.ext_eval;
	break;
      case CLASS_TEST:
	err_exten = nn_params.ext_test;
	break;
      case CV_TRAIN:
	err_exten = ext_cv;
	break;
    }
    strcpy(tmp_error_fname_space, nn_params.error_fname);
    strcat(tmp_error_fname_space, err_exten);
    error_fname = tmp_error_fname_space;
    
    /* train, create */
    /* exp_path */
    /* error_fname */
    param_fname = nn_params.param_fname;
    data_path = nn_params.data_path;
    desc_fname = nn_params.desc_fname;
    /* npatterns */
    ninputs = nn_params.ninputs;
    features = nn_params.features;
    normalize = nn_params.normalize;
    norm_fname = nn_params.norm_fname;
    /* cross_valid */
    /* random, seed */
    adjust_train = nn_params.adjust_train;
    priors_npatterns = nn_params.priors_npatterns;
    train_uniform_priors = nn_params.train_uniform_priors;
    train_priors_list = nn_params.train_priors_list;
    adjust_test = nn_params.adjust_test;
    test_uniform_priors = nn_params.test_uniform_priors;
    test_priors_list = nn_params.test_priors_list;
    verbosity = nn_params.verbosity;
    if(which_data == TRAIN_TRAIN)
	verror = nn_params.no_train_verror ? 0 : nn_params.verror;
    else
      verror = nn_params.verror;
    /* log_outputs */
}

int
gnn_get_which_data()
{
    if(run_options == RUN_TRAIN) return TRAIN_TRAIN;
    else if(run_options == RUN_TRAIN_AND_TEST || RUN_TEST)
      return test_select;
    else return CV_TRAIN;
}

/***---------------------------------------------------------------------------
* NAME:		diff_screen
* PURPOSE:	find differences between two screen files, printing them
*		to the FILE p;
* EXAMPLE:
*	FILE *p;
*	diff_screen(p, "X1mlp.screen", "LNKnet.note.log" );
* NOTE:
--------------------------------------------------------------------------***/
void
diff_screen(fp, fname1, fname2)
     FILE *fp;
     char *fname1;
     char *fname2;
{
    FILE *p1, *p2;
    char *argv1[256], *argv2[256];
    int argc1, argc2, i;

    p1 = nn_fopen(fname1, "r", "in diff screen");
    p2 = nn_fopen(fname2, "r", "in diff screen");

    while (1){
	/* while there are commands left in the files */
	argc1 = fill_argv(argv1, p1, fname1);
	if (argc1 == EOF) break;
	/* copy things in argv1 to make it safe to call fill_argv again */
	for(i = 0; i < argc1; i++){
	    if((argv1[i] = strdup(argv1[i])) == NULL)
	      fatal_error("%s: Cannot allocate space while copying argv1",
			  "diff_screen");
	}
	/* add a final argument to help the checking */
	if((argv1[argc1] = strdup("FINAL_MATCH")) == NULL)
	  fatal_error("%s: Cannot allocate space while copying argv1",
		      "diff_screen");
	argc1++;

	argc2 = fill_argv(argv2, p2, fname2);
	if (argc2 == EOF) break;
	/* copy things in argv2 out of habit */
	for(i = 0; i < argc2; i++){
	    if((argv2[i] = strdup(argv2[i])) == NULL)
	      fatal_error("%s: Cannot allocate space while copying argv1",
			  "diff_screen");
	}
	/* add a final argument to help the checking */
	if((argv2[argc2] = strdup("FINAL_MATCH")) == NULL)
	  fatal_error("%s: Cannot allocate space while copying argv2",
		      "diff_screen");
	argc2++;

	/* find the differences between the arglists */
	if(strcmp(argv1[0], argv2[0])){
	    /* the argument names don't match. there is a problem with
	       the log file */
	    fprintf(fp, "log file commands out of synch %s %s",
		    argv1[0], argv2[0]);
	    for (i = 0; i < argc1; i++) free(argv1[i]);
	    for (i = 0; i < argc2; i++) free(argv2[i]);
	    break;
	} else {
	    if (notebook_important_change(argv1[0]))
	      diff_argv(fp, argc1, argv1, argc2, argv2);
	    /* I'd like to put a check in here to see if this is one
	       of the arg tables we actally care about */
	    /* free argv strings that we dup'ed */
	    for (i = 0; i < argc1; i++) free(argv1[i]);
	    for (i = 0; i < argc2; i++) free(argv2[i]);
	}
    }
    nn_fclose(p1, "in diff_screen");
    nn_fclose(p2, "in diff_screen");
}

#define SEQ(x,y) (0==strcmp(x,y))
int
notebook_important_change(argv0)
     char *argv0;
{
    if(SEQ(argv0, "select") ||
       SEQ(argv0, nn_params.classifier_name) ||
       (alg_uses_clustering() &&
	SEQ(argv0, classifier_names[g_get_cluster_alg()]))) return 1;
    else return 0;
}

void
g_write_notebook_entry(run_flag)
     int run_flag;
{
    FILE *fp;
    char *g_get_important_alg_args();
    char command[MAXSTR];
    char note_screen_fname[MAXSTR];
    int note_screen_len = MAXSTR;
    int status;

    if(nn_params.notebook_on == 0) return;
    if(run_flag == PLOT_ONLY) return;
    /* add changes to the notebook file */
    fp = fopen(nn_params.notebook_path, "a");
    if(fp == NULL){
	warning("LNKnet: cannot open notebook file %s",
		nn_params.notebook_path);
	return;
    }
    /* setup for screen_fname. Let's be carefull not to overwrite things. */
    strncpy(note_screen_fname, nn_params.notebook_fname, note_screen_len-1);
    note_screen_fname[note_screen_len-1] = '\0';/* just to be sure */
    strncat(note_screen_fname, ".screen",
	    note_screen_len - strlen(note_screen_fname));

    /* write the shell script name as the start of any line */
    fprintf(fp, "\n%s ", nn_params.shell_fname);
    if(nn_params.major_note){
	char *g_get_alg_args();

	/* print out the important things:
	   experiment name (done)
	   data base selection
	   important args from current classifier */
	fprintf(fp, "%s ", nn_params.data_base );
	fprintf(fp, "%s ",
		(nn_params.normalize == NONE)? "none" :
		(nn_params.normalize == SIMPLE) ? "simple" :
		(nn_params.normalize == PCA) ? "pca" : "lda");
	fprintf(fp, "%s ", g_get_important_args());
	if(ninputs != nn_params.nraw)
	  fprintf(fp, "-ninputs %d ", ninputs);
	/* differences in these three flags will not be caught later */
	if(cross_valid > 1)
	  fprintf(fp, "-cross_valid %d ", cross_valid);
	if(nn_params.epoch_plots)
	  fprintf(fp, "-movie %d ", nn_params.e_per_plot);
	if(continue_flag) fprintf(fp, "-continue ");

	if(must_store_clustering()){
	    char *temp_fname,  *g_get_cluster_fname();
	    int clus_alg, temp_alg;
	    
	    /* temporarily set the algorithm */
	    temp_fname = param_fname;
	    param_fname = g_get_cluster_fname();
	    temp_alg = g_get_alg();
	    clus_alg = g_get_cluster_alg();
	    g_set_alg(clus_alg);
	    
	    fprintf(fp, " %s ", nn_params.classifier_name);
	    fprintf(fp, "%s", g_get_important_alg_args());

	    /* and set it back */
	    param_fname = temp_fname;
	    g_set_alg(temp_alg);
	}
	fprintf(fp, " %s ", nn_params.classifier_name);
	fprintf(fp, "%s", g_get_important_alg_args());
    } else { /* this is a change, not a new experiment */
	/* make sure there is a notebook log file */
	if (file_exists (note_screen_fname)){
	    void diff_screen();
	    if(continue_flag) fprintf(fp, "-continue ");
	    diff_screen(fp, nn_params.screen_path, note_screen_fname);
	}
    }
    fprintf(fp, "\n");
    nn_fclose(fp, nn_params.notebook_path,
	      "to append to the notebook file");
    /* copy the current screen file into the notebook screen file */
    sprintf(command, "cp %s %s", nn_params.screen_path, note_screen_fname);
    system(command);
    wait(&status);
    nn_params.major_note = 0;
}

void
set_main_data_warning(image)
     Xv_opaque image;
{
    show_image_label(Gnn_main_window->data_problem, image);
}

void
set_main_norm_warning(image)
     Xv_opaque image;
{
    show_image_label(Gnn_main_window->norm_problem, image);
}

void
set_main_select_warning(image)
     Xv_opaque image;
{
    show_image_label(Gnn_main_window->select_problem, image);
}
