/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * menus_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `menus.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include "menus_ui.h"
#include "galgs.h"

void set_algorithm();

/*
 * Menu handler for classifiers.
 */
Menu_item
alg_class_handler(item, op)
     Menu_item	item;
     Menu_generate	op;
{
    Xv_opaque ip = (Xv_opaque) xv_get(item, XV_KEY_DATA, INSTANCE);
    char * menu_choice = (char *)xv_get(item, MENU_STRING);
    algorithm_number alg;
	
    switch (op) {
      case MENU_DISPLAY:
	break;
	
      case MENU_DISPLAY_DONE:
	break;
	
      case MENU_NOTIFY:
	for(alg = MLP; alg <= COMMITTEE; alg++){
	    if(!strcmp(classifier_strings[alg], menu_choice)){
		set_algorithm(alg);
		break;
	    }
	}
/*
	if(alg > COMMITTEE){
	    fprintf(stderr, "classifier menu: unhandled: %s\n", menu_choice);
	}
*/
	break;

      case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for clusters
 */
Menu_item
alg_clus_handler(item, op)
     Menu_item	item;
     Menu_generate	op;
{
    Xv_opaque ip = (Xv_opaque) xv_get(item, XV_KEY_DATA, INSTANCE);
    char * menu_choice = (char *)xv_get(item, MENU_STRING);
    algorithm_number alg;
	
    switch (op) {
      case MENU_DISPLAY:
	break;
	
	case MENU_DISPLAY_DONE:
	break;
	
      case MENU_NOTIFY:
	for(alg = KMEANS; alg <= RAN_CLUS; alg++){
	    if(!strcmp(classifier_strings[alg], menu_choice)){
		set_algorithm(alg);
		break;
	    }
	}
/*
	if(alg > RAN_CLUS){
	    fprintf(stderr, "cluster menu: unhandled: %s\n", menu_choice);
	}
*/
	break;

      case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}

/*
 * Menu handler for contrib menu items
 */
Menu_item
alg_contrib_handler(item, op)
     Menu_item	item;
     Menu_generate	op;
{
    Xv_opaque ip = (Xv_opaque) xv_get(item, XV_KEY_DATA, INSTANCE);
    char * menu_choice = (char *)xv_get(item, MENU_STRING);
    algorithm_number alg;
	
    switch (op) {
      case MENU_DISPLAY:
	break;
	
      case MENU_DISPLAY_DONE:
	break;
	
      case MENU_NOTIFY:
	for(alg = ARTMAP; alg <= ARTMAP; alg++){
	    if(!strcmp(classifier_strings[alg], menu_choice)){
		set_algorithm(alg);
		break;
	    }
	}
/*
	if(alg > ARTMAP){
	    fprintf(stderr, "contrib menu: unhandled: %s\n", menu_choice);
	}
*/
	break;

      case MENU_NOTIFY_DONE:
	break;
    }
    return item;
}


/*
 * Menu handler for `quit (Quit )'.
 */
Menu_item
quit_handler(item, op)
     Menu_item	item;
     Menu_generate	op;
{
    Xv_opaque ip = (Xv_opaque) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    switch (op) {
      case MENU_DISPLAY:
      case MENU_DISPLAY_DONE:
      case MENU_NOTIFY_DONE:
	break;

      case MENU_NOTIFY:
	exit_nnsubs();
	exit(0);
	break;
    }
    return item;
}
