/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * print_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `print.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include "print_ui.h"
#include "nn_params.h"
#include "../LNKnet_subs.h"

#define LOG_NUM 1
#define REGION_NUM 2
#define PROFILE_NUM 4
#define COST_NUM 8
#define PERR_NUM 16
#define STRUCT_NUM 32
#define PROB_NUM 64
#define DETECT_NUM 128
#define REJECT_NUM 256
typedef enum{
    DO_PRINT, DO_PREVIEW, DO_PS, DO_MIF,
} do_process;

extern print_print_pop_objects *Print_print_pop;
extern print_review_pop_objects *Print_review_pop;

static int all_flags = 0;
static int log_flag = 0;
static int region_flag = 0;
static int profile_flag = 0;
static int cost_flag = 0;
static int perr_flag = 0;
static int struct_flag = 0;
static int prob_flag = 0;
static int detect_flag = 0;
static int reject_flag = 0;

static char printer_tmp[84] = "";
static char unique_name[32] = "";
static char *printer_name;
static char tmp_fname[256];

/* required interactions */
/* Change any of the file names:
   change the printed copy here, change the status message,
   if it was the log file, maybe clear the log file window and unpin it
   for the status messages, check for the existance of the three files
   and clear the print message. If we change back to something old, the
   print message goes away. Too bad.
 */
/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init_print()
{
    printer_name = printer_tmp;
}

/* display current settings for all panel widgets */
void
g_display_print()
{
    int value;
    /* display status of each file and the file names */
    print_set_log_status();
    print_set_region_status();
    print_set_profile_status();
    print_set_cost_status();
    print_set_perr_status();
    print_set_struct_status();
    print_set_prob_status();
    print_set_detect_status();
    print_set_reject_status();
    /* display the print/dont print flags */
    value = 0;
    value += (log_flag) ? LOG_NUM : 0;
    value += (region_flag) ? REGION_NUM : 0;
    value += (profile_flag) ? PROFILE_NUM : 0;
    value += (cost_flag) ? COST_NUM : 0;
    value += (perr_flag) ? PERR_NUM : 0;
    value += (struct_flag) ? STRUCT_NUM : 0;
    value += (prob_flag) ? PROB_NUM : 0;
    value += (detect_flag) ? DETECT_NUM : 0;
    value += (reject_flag) ? REJECT_NUM : 0;
    all_flags = value;
    show_int_value(Print_print_pop->fileSelection, value);
}

/*
 * Notify callback function for print buttons
 */
void
print_btn_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    print_print_pop_objects *ip =
      (print_print_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if (item == ip->previewButton){
	print_process_files(DO_PREVIEW);
    } else if (item == ip->printButton){
	print_process_files(DO_PRINT);
    } else if (item == ip->postscriptButton){
	print_process_files(DO_PS);
    } else if (item == ip->makerButton){
	print_process_files(DO_MIF);
    } else if (item == ip->updateButton){
	print_set_all_status();
    } else {
	fputs("LNKnet: print_btn_handler: unhandled btn\n", stderr);
    }
}

/*
p * Notify callback function for `fileSelection'.
 */
void
print_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;
{
    print_print_pop_objects *ip =
      (print_print_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->fileSelection){
	log_flag = (value & LOG_NUM) ? 1 : 0;
	region_flag = (value & REGION_NUM) ? 1 : 0;
	profile_flag = (value & PROFILE_NUM) ? 1 : 0;
	cost_flag = (value & COST_NUM) ? 1 : 0;
	perr_flag = (value & PERR_NUM) ? 1 : 0;
	struct_flag = (value & STRUCT_NUM) ? 1 : 0;
	prob_flag = (value & PROB_NUM) ? 1 : 0;
	detect_flag = (value & DETECT_NUM) ? 1 : 0;
	reject_flag = (value & REJECT_NUM) ? 1 : 0;
	all_flags=value;
    } else {
	fputs("LNKnet: print_3_handler: unhandled selector\n", stderr);
    }
}

/*
 * Notify callback function for `print_name'.
 */
Panel_setting
print_2_handler(item, event)
     Panel_item	item;
     Event		*event;
{
    print_print_pop_objects *ip =
      (print_print_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if(item == ip->print_name){
	if(strcmp(value, "") != 0){
	    sprintf(printer_tmp, "-P%s", value);
	} else {
	    sprintf(printer_tmp, "");
	}
	printer_name = printer_tmp;
    } else {
	fprintf(stderr, "LNKnet: print_2_handler: unhandled: value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for print buttons
 */
void
review_btn_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    print_review_pop_objects *ip =
      (print_review_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->reviewCancelButton){
	close_popup(Print_review_pop->review_pop);
    } else {
	fputs("LNKnet: print_btn_handler: unhandled btn\n", stderr);
    }
}

void
print_set_all_status()
{
    print_set_log_status();
    print_set_region_status();
    print_set_profile_status();
    print_set_cost_status();
    print_set_perr_status();
    print_set_struct_status();
    print_set_prob_status();
    print_set_detect_status();
    print_set_reject_status();
}

void
print_set_log_status()
{
    show_string_label(Print_print_pop->logName, nn_params.log_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.log_fname)))
      show_string_label(Print_print_pop->logExists, "Yes");
    else
      show_string_label(Print_print_pop->logExists, "No");
}

void
print_set_region_status()
{
    show_string_label(Print_print_pop->regionName, nn_params.region_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.region_fname)))
      show_string_label(Print_print_pop->regionExists, "Yes");
    else
      show_string_label(Print_print_pop->regionExists, "No");

    strcpy(tmp_fname, nn_params.region_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->regionPS, "Yes");
    else
      show_string_label(Print_print_pop->regionPS, "No");

    strcpy(tmp_fname, nn_params.region_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->regionMIF, "Yes");
    else
      show_string_label(Print_print_pop->regionMIF, "No");
}

void
print_set_profile_status()
{
    show_string_label(Print_print_pop->profileName, nn_params.profile_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.profile_fname)))
      show_string_label(Print_print_pop->profileExists, "Yes");
    else
      show_string_label(Print_print_pop->profileExists, "No");

    strcpy(tmp_fname, nn_params.profile_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->profilePS, "Yes");
    else
      show_string_label(Print_print_pop->profilePS, "No");

    strcpy(tmp_fname, nn_params.profile_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->profileMIF, "Yes");
    else
      show_string_label(Print_print_pop->profileMIF, "No");
}

void
print_set_cost_status()
{
    show_string_label(Print_print_pop->costName, nn_params.cost_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.cost_fname)))
      show_string_label(Print_print_pop->costExists, "Yes");
    else
      show_string_label(Print_print_pop->costExists, "No");

    strcpy(tmp_fname, nn_params.cost_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->costPS, "Yes");
    else
      show_string_label(Print_print_pop->costPS, "No");

    strcpy(tmp_fname, nn_params.cost_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->costMIF, "Yes");
    else
      show_string_label(Print_print_pop->costMIF, "No");
}

void
print_set_perr_status()
{
    show_string_label(Print_print_pop->perrName, nn_params.perr_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.perr_fname)))
      show_string_label(Print_print_pop->perrExists, "Yes");
    else
      show_string_label(Print_print_pop->perrExists, "No");

    strcpy(tmp_fname, nn_params.perr_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->perrPS, "Yes");
    else
      show_string_label(Print_print_pop->perrPS, "No");

    strcpy(tmp_fname, nn_params.perr_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->perrMIF, "Yes");
    else
      show_string_label(Print_print_pop->perrMIF, "No");
}

void
print_set_struct_status()
{
    show_string_label(Print_print_pop->structName, nn_params.struct_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.struct_fname)))
      show_string_label(Print_print_pop->structExists, "Yes");
    else
      show_string_label(Print_print_pop->structExists, "No");

    strcpy(tmp_fname, nn_params.struct_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->structPS, "Yes");
    else
      show_string_label(Print_print_pop->structPS, "No");

    strcpy(tmp_fname, nn_params.struct_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->structMIF, "Yes");
    else
      show_string_label(Print_print_pop->structMIF, "No");
}

void
print_set_prob_status()
{
    show_string_label(Print_print_pop->probName, nn_params.prob_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.prob_fname)))
      show_string_label(Print_print_pop->probExists, "Yes");
    else
      show_string_label(Print_print_pop->probExists, "No");

    strcpy(tmp_fname, nn_params.prob_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->probPS, "Yes");
    else
      show_string_label(Print_print_pop->probPS, "No");

    strcpy(tmp_fname, nn_params.prob_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->probMIF, "Yes");
    else
      show_string_label(Print_print_pop->probMIF, "No");
}

void
print_set_detect_status()
{
    show_string_label(Print_print_pop->detectName, nn_params.detect_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.detect_fname)))
      show_string_label(Print_print_pop->detectExists, "Yes");
    else
      show_string_label(Print_print_pop->detectExists, "No");

    strcpy(tmp_fname, nn_params.detect_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->detectPS, "Yes");
    else
      show_string_label(Print_print_pop->detectPS, "No");

    strcpy(tmp_fname, nn_params.detect_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->detectMIF, "Yes");
    else
      show_string_label(Print_print_pop->detectMIF, "No");
}

void
print_set_reject_status()
{
    show_string_label(Print_print_pop->rejectName, nn_params.reject_fname);
    if(file_exists(path_build(nn_params.exp_path, nn_params.reject_fname)))
      show_string_label(Print_print_pop->rejectExists, "Yes");
    else
      show_string_label(Print_print_pop->rejectExists, "No");

    strcpy(tmp_fname, nn_params.reject_fname);
    strcat(tmp_fname, ".ps");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->rejectPS, "Yes");
    else
      show_string_label(Print_print_pop->rejectPS, "No");

    strcpy(tmp_fname, nn_params.reject_fname);
    strcat(tmp_fname, ".mif");
    if(file_exists(path_build(nn_params.exp_path, tmp_fname)))
      show_string_label(Print_print_pop->rejectMIF, "Yes");
    else
      show_string_label(Print_print_pop->rejectMIF, "No");
}

print_process_files(which)
     do_process which;
{
    char *file_name, cmd[256], *geometry;
    int flags;

    /* if the log file is check and exists, lpr -Pprintername log_file
       for the plot files, if they are check and exist, make a postscript
       copy and lpr that. set the printed bit.
       update the status messages
       !!!need a routine for the lpr bit, so I can get the -P flag right
       when there is no special printer requested */
    flags = all_flags;
    while(flags != 0){
	if(flags & LOG_NUM){
	    if(which == DO_PRINT){
		file_name = path_build(nn_params.exp_path,nn_params.log_fname);
		if(file_exists(file_name)){
		    sprintf(cmd, "lpr %s %s", printer_name, file_name);
		    printf("%s\n", cmd);
		    nn_system(cmd);
		}
	    } else if (which == DO_PREVIEW){
		file_name = path_build(nn_params.exp_path,nn_params.log_fname);
		if(file_exists(file_name)){
		    open_popup(Print_review_pop->review_pop);
		    xv_set(Print_review_pop->review_pane,
			   TEXTSW_FILE, file_name, NULL);
		    show_string_label(Print_review_pop->reviewLogName, file_name);
		}
	    }
	    flags -= LOG_NUM;
	} else {
	    file_name = NULL;
	    if(flags & REGION_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.region_fname);
		geometry = "-geometry 510x450 -title decision_plot";
		flags -= REGION_NUM;
	    } else if(flags & PROFILE_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.profile_fname);
		geometry = "-geometry 510x450 -title profile_plot";
		flags -= PROFILE_NUM;
	    } else if(flags & COST_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.cost_fname);
		geometry = "-geometry 600x400 -title cost_plot";
		flags -= COST_NUM;
	    } else if(flags & PERR_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.perr_fname);
		geometry = "-geometry 600x400 -title %_err_plot";
		flags -= PERR_NUM;
	    } else if(flags & STRUCT_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.struct_fname);
		geometry = "-geometry 510x450 -title struct_plot";
		flags -= STRUCT_NUM;
	    } else if(flags & PROB_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.prob_fname);
		geometry = "-geometry 510x450 -title prob_plot";
		flags -= PROB_NUM;
	    } else if(flags & DETECT_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.detect_fname);
		geometry = "-geometry 510x450 -title detect_plot";
		flags -= DETECT_NUM;
	    } else if(flags & REJECT_NUM){
		file_name =
		  path_build(nn_params.exp_path, nn_params.reject_fname);
		geometry = "-geometry 510x450 -title reject_plot";
		flags -= REJECT_NUM;
	    }
	    if(file_name != NULL && file_exists(file_name)){
		if(which == DO_PRINT){
		    sprintf(unique_name, "/tmp/LNKplot%.5d.ps", random() % 100000);
		    /* make a .ps file and print it */
		    sprintf(cmd, "plot2ps < %s > %s; lpr %s %s; rm %s",
			    file_name, unique_name, printer_name, unique_name,
			    unique_name);
		    printf("%s\n", cmd);
		    nn_system(cmd);
		} else if (which == DO_PREVIEW){
		    sprintf(cmd, "olxplot %s %s&", geometry, file_name);
		    /* start olxplot for this file */
		    nn_system(cmd);
		} else if (which == DO_PS){
		    strcpy(tmp_fname, file_name);
		    strcat(tmp_fname, ".ps");
		    /* make a .ps file and print it */
		    sprintf(cmd, "plot2ps < %s > %s", file_name, tmp_fname);
		    printf("%s\n", cmd);
		    nn_system(cmd);
		} else if (which == DO_MIF){
		    strcpy(tmp_fname, file_name);
		    strcat(tmp_fname, ".mif");
		    /* make a .mif file and print it */
		    sprintf(cmd, "plot2mif < %s > %s", file_name, tmp_fname);
		    printf("%s\n", cmd);
		    nn_system(cmd);
		}
	    }
	}
    }
    print_set_all_status();
}

static ARG printtab[] =
{
    {"log_file", FLAG, &log_flag, ""},
    {"region_plot", FLAG, &region_flag, ""},
    {"profile_plot", FLAG, &profile_flag, ""},
    {"cost_plot", FLAG, &cost_flag, ""},
    {"perr_plot", FLAG, &perr_flag, ""},
    {"struct_plot", FLAG, &struct_flag, ""},
    {"prob_plot", FLAG, &prob_flag, ""},
    {"detect_plot", FLAG, &detect_flag, ""},
    {"reject_plot", FLAG, &reject_flag, ""},
    {"printer_name", STRING, (int *)&printer_name, ""},
};
#define TABSIZE (sizeof(printtab)/sizeof(ARG))

void
read_print_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* zero out arguments that are not there when they are not set */
    log_flag = region_flag = profile_flag = 
      cost_flag = perr_flag = struct_flag =
	prob_flag = detect_flag = reject_flag = 0;
    printer_name = NULL;
    if(argc > 0){
	argc = nnargs(argc, argv, printtab, TABSIZE);
    }
    printer_name = strcpy_empty_if_null(printer_tmp, printer_name);
    /* set all_flags */
    all_flags = 0;
    all_flags += (log_flag) ? LOG_NUM : 0;
    all_flags += (region_flag) ? REGION_NUM : 0;
    all_flags += (profile_flag) ? PROFILE_NUM : 0;
    all_flags += (cost_flag) ? COST_NUM : 0;
    all_flags += (perr_flag) ? PERR_NUM : 0;
    all_flags += (struct_flag) ? STRUCT_NUM : 0;
    all_flags += (prob_flag) ? PROB_NUM : 0;
    all_flags += (detect_flag) ? DETECT_NUM : 0;
    all_flags += (reject_flag) ? REJECT_NUM : 0;
}

void
write_print_defaults(default_file)
     FILE *default_file;
{
    printer_name = null_if_empty_string(printer_tmp);
    if(default_file != NULL){
	fprintf(default_file, "%s %s", "print",
		nnargs_get_flags(printtab, TABSIZE));
    }
}
