/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * priors_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `priors.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include "priors_ui.h"
#include "nn_params.h"
#include "../LNKnet_subs.h"

extern	priors_priors_pop_objects	*Priors_priors_pop;

/* defaults file arguments, table, and routines */
static int adjust_train_arg = 0;
static int train_uniform_priors_arg = 0;
static float * train_priors_list_arg = NULL;
static int priors_npatterns_arg = 0;
static int adjust_test_arg = 0;
static int test_uniform_priors_arg = 0;
static float * test_priors_list_arg = NULL;

void g_set_adjust_train_priors();
void g_set_adjust_test_priors();
void g_set_train_uniform_priors();
void g_set_test_uniform_priors();
void priors_update_nn_params();
void g_set_priors_npatterns();
void perr_set_trial_average();
void cost_set_trial_average();


/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init_priors()
{
    nn_params.adjust_train = adjust_train_arg;
    nn_params.train_uniform_priors = train_uniform_priors_arg;
    nn_params.train_priors_list = train_priors_list_arg;
    nn_params.adjust_test = adjust_test_arg;
    nn_params.test_uniform_priors = test_uniform_priors_arg;
    nn_params.test_priors_list = test_priors_list_arg;
    nn_params.priors_npatterns = priors_npatterns_arg;
}

/* display current settings for all panel widgets */
void
g_display_priors()
{
    /* priors window */
    show_int_value(Priors_priors_pop->adjust_train_priors, adjust_train_arg);
    show_string_text(Priors_priors_pop->train_priors_list,
		     make_float_string(train_priors_list_arg));
    show_int_value(Priors_priors_pop->train_uniform, train_uniform_priors_arg);
    g_set_priors_npatterns(priors_npatterns_arg);
    g_set_adjust_train_priors(adjust_train_arg);
    show_int_value(Priors_priors_pop->adjust_test_priors, adjust_test_arg);
    show_string_text(Priors_priors_pop->test_priors_list,
		     make_float_string(test_priors_list_arg));
    show_int_value(Priors_priors_pop->test_uniform, test_uniform_priors_arg);
    g_set_adjust_test_priors(adjust_test_arg);
}

/*
 * Notify callback function for priors settings
 */
void
priors_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    priors_priors_pop_objects *ip =
      (priors_priors_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    
    if(item == ip->adjust_train_priors){
	g_set_adjust_train_priors(value);
    } else if(item == ip->train_uniform){
	g_set_train_uniform_priors(value);
    } else if(item == ip->adjust_test_priors){
	g_set_adjust_test_priors(value);
    } else if(item == ip->test_uniform){
	g_set_test_uniform_priors(value);
    } else {
	fprintf(stderr, "LNKnet: priors_select_handler: unhandled setting\n");
	fprintf(stderr, "LNKnet: priors_select_handler: value: %u\n", value);
    }
}

/*
 * Notify callback function for priors text
 */
Panel_setting
priors_text_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    priors_priors_pop_objects *ip =
      (priors_priors_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    char tmp[512];

	
    if(item == ip->train_priors_list){
	if(train_priors_list_arg != NULL)
	  deallocate_vector(train_priors_list_arg);
	train_priors_list_arg =
	  nnargs_get_float_alloc_list(strcpy(tmp, value));
	priors_update_nn_params();
	/* tell notebook that something important changed */
	nn_params.major_note = 1;
    } else if (item == ip->priors_npatterns){
	priors_npatterns_arg =
	  set_atoi_value(value, "priors_npatterns", item,
			 priors_npatterns_arg);
	nn_params.priors_npatterns = priors_npatterns_arg;
	perr_set_trial_average(priors_npatterns_arg);
	cost_set_trial_average(priors_npatterns_arg);
    } else if (item == ip->test_priors_list){
	if(test_priors_list_arg != NULL)
	  deallocate_vector(test_priors_list_arg);
	test_priors_list_arg =
	  nnargs_get_float_alloc_list(strcpy(tmp, value));
	priors_update_nn_params();
	/* tell notebook that something important changed */
	nn_params.major_note = 1;
    } else {
	fprintf(stderr, "LNKnet: priors_text_handler: unhandled text item\n");
	fprintf(stderr, "LNKnet: priors_text_handler: value: %s\n", value);
    }
    
    /* gxv_start_connections DO NOT EDIT THIS SECTION */
    
    /* gxv_end_connections */
    
    return panel_text_notify(item, event);
}

/* set adjust_train flag with appropriate graying out */
void
g_set_adjust_train_priors(value)
     int value;
{
    adjust_train_arg = value;
    if(value == 0){
	gray_out_item(Priors_priors_pop->train_uniform, TRUE);
	gray_out_item(Priors_priors_pop->train_priors_list, TRUE);
	gray_out_item(Priors_priors_pop->priors_npatterns, TRUE);
	gray_out_item(Priors_priors_pop->sample_priors_message, TRUE);
    } else {
	gray_out_item(Priors_priors_pop->train_uniform, FALSE);
	g_set_train_uniform_priors(train_uniform_priors_arg);
	gray_out_item(Priors_priors_pop->priors_npatterns, FALSE);
	gray_out_item(Priors_priors_pop->sample_priors_message, FALSE);
    }
    priors_update_nn_params();
    /* tell notebook that something important changed */
    nn_params.major_note = 1;
}

/* set adjust_test flag with appropriate graying out */
void
g_set_adjust_test_priors(value)
     int value;
{
    adjust_test_arg = value;
    if(value == 0){
	gray_out_item(Priors_priors_pop->test_uniform, TRUE);
	gray_out_item(Priors_priors_pop->test_priors_list, TRUE);
	gray_out_item(Priors_priors_pop->scale_priors_message, TRUE);
    } else {
	gray_out_item(Priors_priors_pop->test_uniform, FALSE);
	g_set_test_uniform_priors(test_uniform_priors_arg);
	gray_out_item(Priors_priors_pop->scale_priors_message, FALSE);
    }
    priors_update_nn_params();
    /* tell notebook that something important changed */
    nn_params.major_note = 1;
}

/* set train_uniform_priors flag with appropriate graying out */
void
g_set_train_uniform_priors(value)
     int value;
{
    train_uniform_priors_arg = value;
    if(train_uniform_priors_arg){
	gray_out_item(Priors_priors_pop->train_priors_list, TRUE);
    } else {
	gray_out_item(Priors_priors_pop->train_priors_list, FALSE);
    }
    priors_update_nn_params();
    /* tell notebook that something important changed */
    nn_params.major_note = 1;
}

/* set test_uniform_priors flag with appropriate graying out */
void
g_set_test_uniform_priors(value)
     int value;
{
    test_uniform_priors_arg = value;
    if(test_uniform_priors_arg){
	gray_out_item(Priors_priors_pop->test_priors_list, TRUE);
    } else {
	gray_out_item(Priors_priors_pop->test_priors_list, FALSE);
    }
    priors_update_nn_params();
    /* tell notebook that something important changed */
    nn_params.major_note = 1;
}

void
priors_update_nn_params()
{
    nn_params.adjust_train = adjust_train_arg;
    if(adjust_train_arg){
	nn_params.train_uniform_priors = train_uniform_priors_arg;
	if(train_uniform_priors_arg){
	    nn_params.train_priors_list = NULL;
	} else {
	    nn_params.train_priors_list = train_priors_list_arg;
	}
    } else {
	nn_params.train_uniform_priors = 0;
	nn_params.train_priors_list = NULL;
    }

    nn_params.adjust_test = adjust_test_arg;
    if(adjust_test_arg){
	nn_params.test_uniform_priors = test_uniform_priors_arg;
	if(test_uniform_priors_arg){
	    nn_params.test_priors_list = NULL;
	} else {
	    nn_params.test_priors_list = test_priors_list_arg;
	}
    } else {
	nn_params.test_uniform_priors = 0;
	nn_params.test_priors_list = NULL;
    }
}

/* routines for setting priors adjusting in decision region plots */
int
g_get_adjust_test()
{
    return nn_params.adjust_test;
}

int
g_get_test_uniform_priors()
{
    return nn_params.test_uniform_priors;
}

/* assumes that priors list being sent is statically allocated
   and large enough */
float *
g_copy_test_priors_list(priors_list)
     float *priors_list;
{
    int i;
    if(nn_params.test_priors_list == NULL){
	priors_list[0] = 0.;
    } else {
	for(i = 0; i <= (int)nn_params.test_priors_list[0]; i++){
	    priors_list[i] = nn_params.test_priors_list[i];
	}
    }
    return priors_list;
}

/* turn on and off graying out of priors */
void
activate_train_priors(activate_flag)
     int activate_flag;
{
    if(activate_flag){
	gray_out_item(Priors_priors_pop->adjust_train_priors, FALSE);
	adjust_train_arg =
	  xv_get(Priors_priors_pop->adjust_train_priors, PANEL_VALUE);
	g_set_adjust_train_priors(adjust_train_arg);
    } else {
	adjust_train_arg = 0;
	priors_update_nn_params();
	gray_out_item(Priors_priors_pop->adjust_train_priors, TRUE);
	gray_out_item(Priors_priors_pop->train_uniform, TRUE);
	gray_out_item(Priors_priors_pop->train_priors_list, TRUE);
	gray_out_item(Priors_priors_pop->priors_npatterns, TRUE);
	gray_out_item(Priors_priors_pop->sample_priors_message, TRUE);
    }
}

/* turn on and off graying out of priors */
void
activate_test_priors(activate_flag)
     int activate_flag;
{
    if(activate_flag){
	gray_out_item(Priors_priors_pop->adjust_test_priors, FALSE);
	adjust_test_arg =
	  xv_get(Priors_priors_pop->adjust_test_priors, PANEL_VALUE);
	g_set_adjust_test_priors(adjust_test_arg);
    } else {
	adjust_test_arg = 0;
	priors_update_nn_params();
	gray_out_item(Priors_priors_pop->adjust_test_priors, TRUE);
	gray_out_item(Priors_priors_pop->test_uniform, TRUE);
	gray_out_item(Priors_priors_pop->test_priors_list, TRUE);
	gray_out_item(Priors_priors_pop->scale_priors_message, TRUE);
    }
}

void
g_set_priors_npatterns(npatterns)
  int npatterns;
{
    nn_params.priors_npatterns = npatterns;
    show_int_text(Priors_priors_pop->priors_npatterns,
		  nn_params.priors_npatterns);
    priors_npatterns_arg = npatterns;

    perr_set_trial_average(npatterns);
    cost_set_trial_average(npatterns);
}

/* arguments are at the top of the file now */

static ARG priorstab[] =
{
    {"adjust_train", FLAG, &adjust_train_arg, ""},
    {"train_uniform_priors", FLAG, &train_uniform_priors_arg, ""},
    {"train_priors_list", FLOAT_ALLOC_LIST, (int *)&train_priors_list_arg, ""},
    {"priors_npatterns", INT, &priors_npatterns_arg, ""},
    {"adjust_test", FLAG, &adjust_test_arg, ""},
    {"test_uniform_priors", FLAG, &test_uniform_priors_arg, ""},
    {"test_priors_list", FLOAT_ALLOC_LIST, (int *)&test_priors_list_arg, ""},
};
#define TABSIZE (sizeof(priorstab)/sizeof(ARG))

void
read_priors_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* zero out arguments that are not there when they are not set */
    test_priors_list_arg = NULL;
    train_priors_list_arg = NULL;
    adjust_train_arg = adjust_test_arg = train_uniform_priors_arg =
      test_uniform_priors_arg = 0;
    if(argc > 0){
	argc = nnargs(argc, argv, priorstab, TABSIZE);
    } else {
	train_uniform_priors_arg = 1;
    }
    nn_params.priors_npatterns = priors_npatterns_arg;
    priors_update_nn_params();
}

void
write_priors_defaults(default_file)
     FILE *default_file;
{
    if(default_file != NULL){
	fprintf(default_file, "%s %s", "priors",
		nnargs_get_flags(priorstab, TABSIZE));
    }
}
