/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * select_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `select.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include <feat_sel_args.h>
#include <gen_search_args.h>
#include "select_ui.h"
#include "nn_params.h"
#include "../LNKnet_subs.h"
#define SELECT_PROGRAM_NAME "feat_sel"
#define PLOT_SELECT "plot_select"
#include <plot_select_args.h>
#include "galgs.h"
#include "../LNKnet_main_ui.h"

#define MAXSTR 256
static char search_plot_lbl_tmp[MAXSTR];
static char search_ftmp[MAXSTR];
static char search_shell_ftmp[MAXSTR];
static char search_log_ftmp[MAXSTR];
static char search_plot_ftmp[MAXSTR];
static char data_ftmp[MAXSTR];	/* data file */

static int search_best; /* take best from file */
static int best_n;
static int select_n_II;
static int select_type; /* ALL vs FIRST_N, etc */
static int select_plot;
static int classifier; /* 0-nn 1-mlp */
static int cv_nfolds;
static int *search_features = NULL;

static int select_pid = 0;

#undef timers_on
static struct itimerval select_gen_cr_timer;
static int select_gen_changes = 0;
static struct {
    char select_n_folds[80];/* this length must match the guide value */
    int select_search_n;
    char select_xmin[80];
    char select_xmax[80];
    char select_xstep[80];
    char select_ymin[80];
    char select_ymax[80];
    char select_ystep[80];
} select_gen_state;

extern	select_select_pop_objects	*Select_select_pop;
extern  select_select_generate_pop_objects	*Select_select_generate_pop;
extern lnknet_glyph_objects *LNKnet_glyphs;

/* macros for select_type */
#define ALL 0
#define FIRST_N 1
#define MANUAL 2
#define READ_FILE 3

/* macros for normalization */
#define NONE 0
#define SIMPLE 1
#define PCA 2
#define LDA 3

#define FORWARD 0
#define BACKWARD 1
#define FOR_AND_BACK 2

#define EXP_AND_PLOT 0
#define PLOT_ONLY 1

void set_feature_list();
void set_select_type();
void set_select_n();
void g_set_select_autoscale();
void g_create_search_filename();
void g_set_select_plot_label();
void g_update_ninputs();
void select_set_plot_label();
void set_feature_labels_string();
char *get_feature_labels();
void select_create_generate_files();
void copy_search_feature_list();
void open_select_select_generate_pop();
Notify_value select_gen_cr_timer_handler();

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init_select()
{
    select_type = ALL;
    select_plot = 1;
    search_best = 1;
    best_n = 0;
    search_direction = FORWARD;
    stop_early = 0;
    select_auto_scale_flag = 1;
    nn_params.ninputs = 0;
    nn_params.features = allocate_ivector(1);
    nn_params.features[0] = 0;

#ifdef timers_on
    /* also initialize any extra args to the panel items */
    setup_character_watch(Select_select_generate_pop->select_n_folds);
    setup_character_watch(Select_select_generate_pop->select_search_n);
    setup_character_watch(Select_select_generate_pop->select_xmin);
    setup_character_watch(Select_select_generate_pop->select_xmax);
    setup_character_watch(Select_select_generate_pop->select_xstep);
    setup_character_watch(Select_select_generate_pop->select_ymin);
    setup_character_watch(Select_select_generate_pop->select_ymax);
    setup_character_watch(Select_select_generate_pop->select_ystep);
    /* start cr_msg as not there */
#endif
    show_item(Select_select_generate_pop->select_n_folds_cr_msg, FALSE);
    show_item(Select_select_generate_pop->select_search_n_cr_msg, FALSE);
    show_item(Select_select_generate_pop->select_xmin_cr_msg, FALSE);
    show_item(Select_select_generate_pop->select_xmax_cr_msg, FALSE);
    show_item(Select_select_generate_pop->select_xstep_cr_msg, FALSE);
    show_item(Select_select_generate_pop->select_ymin_cr_msg, FALSE);
    show_item(Select_select_generate_pop->select_ymax_cr_msg, FALSE);
    show_item(Select_select_generate_pop->select_ystep_cr_msg, FALSE);
}

void
g_display_select()
{
    /* feature selection window */
    show_int_value(Select_select_pop->select_type, select_type);
    show_int_value(Select_select_pop->select_n, nn_params.ninputs);
    show_string_text(Select_select_pop->select_feature_list,
		     make_net_string(nn_params.features));
    show_string_text(Select_select_pop->select_file, search_ftmp);
    show_int_value(Select_select_pop->select_n_II, select_n_II);
    show_int_value(Select_select_pop->select_search_limit, search_best);
    set_select_type(select_type);
    
    /* select generate window */
    show_string_label(Select_select_generate_pop->select_file_msg,
		      search_ftmp);
    show_string_label(Select_select_generate_pop->select_shell_script,
		      search_shell_ftmp);
    show_string_label(Select_select_generate_pop->select_log_file,
		      search_log_ftmp);
    /* Nearest-Neighbor or current classifier */
    show_int_value(Select_select_generate_pop->select_classifier, classifier);
    if(classifier == 1)
      gray_out_item(Select_select_generate_pop->select_n_folds, FALSE);
    else
      gray_out_item(Select_select_generate_pop->select_n_folds, TRUE);
    show_int_text(Select_select_generate_pop->select_n_folds, cv_nfolds);
    /* forward, back, or both */
    show_int_value(Select_select_generate_pop->select_direction,
		   search_direction);
    /* stop early and when to stop */
    show_int_value(Select_select_generate_pop->stop_early, stop_early);
    if(stop_early){
	gray_out_item(Select_select_generate_pop->select_search_n, FALSE);
    } else {
	gray_out_item(Select_select_generate_pop->select_search_n, TRUE);
    }
    show_int_value(Select_select_generate_pop->select_search_n, search_n);
    /* plotting */
    show_int_value(Select_select_generate_pop->select_do_plot, select_plot);
    show_string_label(Select_select_generate_pop->select_plot_file,
		      select_plot_fname);
    /* plot axis limits and autoscale */
    show_int_value (Select_select_generate_pop->select_autoscale,
		    select_auto_scale_flag);
    g_set_select_autoscale(select_auto_scale_flag);
    show_float_text(Select_select_generate_pop->select_xmin, select_xmin);
    show_float_text (Select_select_generate_pop->select_xmax, select_xmax);
    show_float_text (Select_select_generate_pop->select_ymin, select_ymin);
    show_float_text (Select_select_generate_pop->select_ymax, select_ymax);
    show_float_text (Select_select_generate_pop->select_xstep, select_xstep);
    show_float_text (Select_select_generate_pop->select_ystep, select_ystep);
    select_set_plot_label();
#ifdef timers_on
    /* initialize the strings for the timers */
    strcpy(select_gen_state.select_n_folds,
	   xv_get(Select_select_generate_pop->select_n_folds, PANEL_VALUE));
    select_gen_state.select_search_n =
      xv_get(Select_select_generate_pop->select_search_n, PANEL_VALUE);
    strcpy(select_gen_state.select_xmin,
	   xv_get(Select_select_generate_pop->select_xmin, PANEL_VALUE));
    strcpy(select_gen_state.select_xmax,
	   xv_get(Select_select_generate_pop->select_xmax, PANEL_VALUE));
    strcpy(select_gen_state.select_xstep,
	   xv_get(Select_select_generate_pop->select_xstep, PANEL_VALUE));
    strcpy(select_gen_state.select_ymin,
	   xv_get(Select_select_generate_pop->select_ymin, PANEL_VALUE));
    strcpy(select_gen_state.select_ymax,
	   xv_get(Select_select_generate_pop->select_ymax, PANEL_VALUE));
    strcpy(select_gen_state.select_ystep,
	   xv_get(Select_select_generate_pop->select_ystep, PANEL_VALUE));
#endif
}

/*
 * Notify callback function for select settings
 */
void
select_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    select_select_pop_objects *ip =
      (select_select_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->select_type){
	/* ALL, FIRST_N, MANUAL, READ_FILE */
	set_select_type(value);
    } else if (item == ip->select_search_limit){
	/* use the best from the feature search or use the first N */
	search_best = value;
	if(value){
	    gray_out_item(Select_select_pop->select_n_II, TRUE);
	    set_select_n(best_n);
	} else {
	    gray_out_item(Select_select_pop->select_n_II, FALSE);
	    set_select_n(xv_get(Select_select_pop->select_n_II, PANEL_VALUE));
	}
	/* re-copy the first ninputs entries in search file feature list */
	copy_search_feature_list();
    } else {
	fprintf(stderr,
		"LNKnet: select_select_handler: unhandled setting: value: %u\n",
		value);
    }
}

/*
 * Notify callback function for select text items 
 */
Panel_setting
select_text_handler(item, event)
	Panel_item	item;
	Event		*event;
{
    select_select_pop_objects *ip =
      (select_select_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *cvalue;
    int ivalue;
	
    if(item == ip->select_feature_list){
	/* enter hand selected features */
	cvalue = (char *) xv_get(item, PANEL_VALUE);
	set_feature_list(cvalue);
    } else if(item == ip->select_file){
	/* set search file name for READ_FILE */
	cvalue = (char *) xv_get(item, PANEL_VALUE);
	cvalue = set_string_not_empty(cvalue, "feature selection file",
				      item, search_ftmp);
	strcpy(search_ftmp, cvalue);
	select_create_generate_files();
	if(select_type == READ_FILE){
	    g_read_search_file();
	}
    } else if(item == ip->select_n){
	/* set N for first N or N from search file */
	ivalue = (int) xv_get(item, PANEL_VALUE);
	set_select_n(ivalue);
	if(select_type == READ_FILE){
	    copy_search_feature_list();
	} else set_feature_labels_string();
	show_int_value(Select_select_pop->select_n, nn_params.ninputs);
    } else if(item == ip->select_n_II){
	/* set N for first N or N from search file */
	ivalue = (int) xv_get(item, PANEL_VALUE);
	set_select_n(ivalue);
	if(select_type == READ_FILE){
	    copy_search_feature_list();
	} else set_feature_labels_string();
	select_n_II = nn_params.ninputs;
	show_int_value(Select_select_pop->select_n_II, nn_params.ninputs);
    } else {
	fprintf(stderr, "LNKnet: select_text_handler: unhandled text item:\n");
    }
	
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `select_generate'.
 */
void
select_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    select_select_pop_objects *ip =
      (select_select_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->select_generate){
	/* bring up the generate window */
	open_select_select_generate_pop();
    } else {
	fprintf(stderr, "LNKnet: select_btn_handler: unhandled button\n");
    }
}

/*
 * Event callback function for `select_error_message'.
 */
void
select_select_pop_select_error_message_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    /* gxv_start_connections DO NOT EDIT THIS SECTION */
    
    /* recheck the error on the search file */
    if (event_action(event) == ACTION_SELECT) {
	if(select_type == READ_FILE){
	    g_read_search_file();
	}
    }
    
    /* gxv_end_connections */

    panel_default_handle_event(item, event);
}

/*
 * Event callback function for `select_warning'.
 */
void
select_select_pop_select_warning_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    /* gxv_start_connections DO NOT EDIT THIS SECTION */

    /* recheck the error on the search file */
    if (event_action(event) == ACTION_SELECT) {
	if(select_type == READ_FILE){
	    g_read_search_file();
	}
    }
	
    /* gxv_end_connections */

    panel_default_handle_event(item, event);
}

/*
 * Done callback function for `select_generate_pop'.
 */
void
select_gen_close_handler(frame)
     Frame		frame;
{
#ifdef timers_on
    /* if there is anything that is marked needing a CR, don't leave */
    if (select_gen_changes){
	/* beep at them and don't let them leave */
	xv_set(Select_select_generate_pop->select_generate_controls,
	       WIN_ALARM, NULL);
	/*XBell(xv_get(frame, XV_DISPLAY), 50);*/
	xv_set(Select_select_generate_pop->select_generate_pop,
	       FRAME_CMD_PIN_STATE, FRAME_CMD_PIN_IN, NULL);
    } else {
	notify_set_itimer_func(&select_gen_cr_timer, NOTIFY_FUNC_NULL,
			       ITIMER_REAL, NULL, NULL);
	close_popup(frame);
    }
#else
  close_popup(frame);
#endif
}

/*
 * Open callback function for `select_generate_pop'.
 */
void
open_select_select_generate_pop()
{
#ifdef timers_on
    /* turn timer on to check that text widgets aren't changed */
    select_gen_cr_timer.it_value.tv_sec = 1;
    select_gen_cr_timer.it_value.tv_usec = 0;
    select_gen_cr_timer.it_interval.tv_sec = 1;
    select_gen_cr_timer.it_interval.tv_usec = 0;
    notify_set_itimer_func(&select_gen_cr_timer, select_gen_cr_timer_handler,
			   ITIMER_REAL, &select_gen_cr_timer, NULL);
    /* start with all CR's hidden and changes off */
    /*!!! initialize strings to match state on open */
    select_gen_changes = 0;
#endif
    open_popup(Select_select_generate_pop->select_generate_pop);
}

/*
 * Handler for the Carriage return timer for the select generation window
 */
Notify_value
select_gen_cr_timer_handler(client, twhich)
     Notify_client client;
     int twhich;
{
    select_gen_changes = 0;
    /* check if anything has changed and post the CR for it if it has */
    if(check_stringNwidget(select_gen_state.select_n_folds,
			   Select_select_generate_pop->select_n_folds,
			   Select_select_generate_pop->select_n_folds_cr_msg))
      select_gen_changes = 1;
    if (check_stringNwidget(select_gen_state.select_n_folds,
			    Select_select_generate_pop->select_n_folds,
			    Select_select_generate_pop->select_n_folds_cr_msg))
      select_gen_changes = 1;
    /* this one is an integer !! */
    if (check_intNwidget(select_gen_state.select_search_n,
			 Select_select_generate_pop->select_search_n,
			 Select_select_generate_pop->select_search_n_cr_msg))
      select_gen_changes = 1;
    if (check_stringNwidget(select_gen_state.select_xmin,
			    Select_select_generate_pop->select_xmin,
			    Select_select_generate_pop->select_xmin_cr_msg))
      select_gen_changes = 1;
    if (check_stringNwidget(select_gen_state.select_xmax,
			    Select_select_generate_pop->select_xmax,
			    Select_select_generate_pop->select_xmax_cr_msg))
      select_gen_changes = 1;
    if (check_stringNwidget(select_gen_state.select_xstep,
			    Select_select_generate_pop->select_xstep,
			    Select_select_generate_pop->select_xstep_cr_msg))
      select_gen_changes = 1;
    if (check_stringNwidget(select_gen_state.select_ymin,
			    Select_select_generate_pop->select_ymin,
			    Select_select_generate_pop->select_ymin_cr_msg))
      select_gen_changes = 1;
    if (check_stringNwidget(select_gen_state.select_ymax,
			    Select_select_generate_pop->select_ymax,
			    Select_select_generate_pop->select_ymax_cr_msg))
      select_gen_changes = 1;
    if (check_stringNwidget(select_gen_state.select_ystep,
			    Select_select_generate_pop->select_ystep,
			    Select_select_generate_pop->select_ystep_cr_msg))
      select_gen_changes = 1;
}

/*
 * Notify callback function for select generate buttons
 */
void
select_gen_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    select_select_generate_pop_objects *ip =
      (select_select_generate_pop_objects *)
	xv_get(item, XV_KEY_DATA, INSTANCE);
    void show_algorithm_popup();
	
    if(item == ip->select_cancel){
	stop_command_file(select_pid);
	select_pid = 0;
	close_popup(ip->select_generate_pop);
    } else if(item == ip->select_run){
	select_run(EXP_AND_PLOT);
    } else if(item == ip->select_plot_only){
	select_run(PLOT_ONLY);
    } else if(item == ip->select_alg_params){
	show_algorithm_popup();
    } else {
	fputs("LNKnet: select_gen_btn_handler: unhandled button\n", stderr);
    }
}

/*
 * Notify callback function for select generate text items
 */
Panel_setting
select_gen_text_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    select_select_generate_pop_objects *ip =
      (select_select_generate_pop_objects *)
	xv_get(item, XV_KEY_DATA, INSTANCE);
    char * cvalue;
    

    if(item == ip->select_search_n){
	if (EVENT_IS_RTN(event) || event_button_is_down(event)){
	    search_n = (int) xv_get(item, PANEL_VALUE);
	    select_gen_state.select_search_n = search_n;
	    show_item(ip->select_search_n_cr_msg, FALSE);
	} else {
	    select_gen_changes = 1;
	    show_item(ip->select_search_n_cr_msg, TRUE);
	}
    } else {
	cvalue = (char *)xv_get(item, PANEL_VALUE);
	if(item == ip->select_n_folds){
	    if(!set_string2intNcheck(item, ip->select_n_folds_cr_msg,
				     &cv_nfolds, "cv_nfolds",
				     event, select_gen_state.select_n_folds))
	      select_gen_changes = 1;
	    else select_set_plot_label();

	} else if(item == ip->select_xmax){
	    if(!set_string2floatNcheck(item, ip->select_xmax_cr_msg,
				      &select_xmax, "select_xmax",
				      event, select_gen_state.select_xmax))
	      select_gen_changes = 1;
	} else if(item == ip->select_xmin){
	    if(!set_string2floatNcheck(item, ip->select_xmin_cr_msg,
				       &select_xmin, "select_xmin",
				       event, select_gen_state.select_xmin))
	      select_gen_changes = 1;
	} else if(item == ip->select_xstep){
	    if(!set_string2floatNcheck(item, ip->select_xstep_cr_msg,
				       &select_xstep, "select_xstep",
				       event, select_gen_state.select_xstep))
	      select_gen_changes = 1;
	} else if(item == ip->select_ymax){
	    if(!set_string2floatNcheck(item, ip->select_ymax_cr_msg,
				      &select_ymax, "select_ymax",
				      event, select_gen_state.select_ymax))
	      select_gen_changes = 1;
	} else if(item == ip->select_ymin){
	    if(!set_string2floatNcheck(item, ip->select_ymin_cr_msg,
				       &select_ymin, "select_ymin",
				       event, select_gen_state.select_ymin))
	      select_gen_changes = 1;
	} else if(item == ip->select_ystep){
	    if(!set_string2floatNcheck(item, ip->select_ystep_cr_msg,
				       &select_ystep, "select_ystep",
				       event, select_gen_state.select_ystep))
	      select_gen_changes = 1;
	} else {
	    fprintf(stderr, "LNKnet: select_gen_text_handler: unhandled text:\n");
	}
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for select generate settings
 */
void
select_gen_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    select_select_generate_pop_objects *ip =
      (select_select_generate_pop_objects *)
	xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->select_classifier){
	classifier = value;
	if(classifier == 1){
	    gray_out_item(Select_select_generate_pop->select_n_folds, FALSE);
	} else {
	    gray_out_item(Select_select_generate_pop->select_n_folds, TRUE);
	}
	select_set_plot_label();
    } else if (item == ip->select_direction){
	search_direction = value;
	g_create_search_filename();
	select_set_plot_label();
    } else if (item == ip->stop_early){
	stop_early = value;
	if(stop_early){
	    gray_out_item(Select_select_generate_pop->select_search_n, FALSE);
	} else {
	    gray_out_item(Select_select_generate_pop->select_search_n, TRUE);
	}
    } else if(item == ip->select_do_plot){
	select_plot = value;
    } else if(item == ip->select_autoscale){
	g_set_select_autoscale(value);
    } else {
	fprintf(stderr,
		"LNKnet: select_gen_select_handler: unhandled setting: value: %u\n",
		value);
    }
}

void
activate_features(activate_flag)
     int activate_flag;
{
    if(activate_flag){
	gray_out_item(Select_select_pop->select_type, FALSE);
    } else {
	gray_out_item(Select_select_pop->select_type, TRUE);
    }
}

void
set_select_type(value)
     int value;
{
    select_type = value;

    gray_out_item(Select_select_pop->select_feature_list, TRUE);
    gray_out_item(Select_select_pop->select_n, TRUE);
    gray_out_item(Select_select_pop->select_n_II, TRUE);
    gray_out_item(Select_select_pop->select_file, TRUE);
    gray_out_item(Select_select_pop->select_search_limit, TRUE);
    
    select_clear_error();
    switch(value){
      case ALL: /* all */
	set_select_n(nn_params.nraw);
	if(nn_params.features != NULL){
	    deallocate_ivector(nn_params.features);
	    nn_params.features = NULL;
	}
	set_feature_labels_string();
	break;
      case FIRST_N: /* first n */
	/* set ninputs to the value of what is stored in select_n */
	gray_out_item(Select_select_pop->select_n, FALSE);
	set_select_n(xv_get(Select_select_pop->select_n, PANEL_VALUE));
	if(nn_params.features != NULL){
	    deallocate_ivector(nn_params.features);
	    nn_params.features = NULL;
	}
	set_feature_labels_string();
	break;
      case MANUAL: /* fill in */
	gray_out_item(Select_select_pop->select_feature_list, FALSE);
	nn_params.ninputs = 0;
	set_feature_list((char *)xv_get(Select_select_pop->select_feature_list,
					PANEL_VALUE));
	break;
      case READ_FILE: /* get from file */
	gray_out_item(Select_select_pop->select_search_limit, FALSE);
	if(search_best == 0){
	    gray_out_item(Select_select_pop->select_n_II, FALSE);
	    set_select_n(xv_get (Select_select_pop->select_n_II,
				 PANEL_VALUE, NULL));
	}
	gray_out_item(Select_select_pop->select_file, FALSE);
	g_read_search_file();
	break;
      default: break;
    }
}

void
set_select_n(value)
     int value;
{
    nn_params.ninputs = value;
    if(nn_params.normalize == LDA)
      if(nn_params.ninputs > nn_params.noutputs-1){
	  nn_params.ninputs = nn_params.noutputs-1;
      }
    if(nn_params.ninputs > nn_params.nraw){
	nn_params.ninputs = nn_params.nraw;
    }
    g_update_ninputs();
}

/* called when nn_params.nraw is changed */
update_nraw_and_ninputs()
{
    if(select_type == ALL)
      set_select_n(nn_params.nraw);
    else
      set_select_n(nn_params.ninputs);
    /* display new value */
    show_int_value(Select_select_pop->select_n, nn_params.ninputs);
    show_int_value(Select_select_pop->select_n_II, nn_params.ninputs);
    set_feature_labels_string();
}

void
set_feature_list(value)
     char *value;
{
    static char tmp[NNMAX_LINE];
    int n;

    select_clear_error();
    if(nn_params.features != NULL) deallocate_ivector(nn_params.features);
    nn_params.features = nnargs_get_int_alloc_list(strcpy(tmp,value));
    set_select_n(nn_params.features[0]);
    if(nn_params.features[0] > nn_params.ninputs){
	/* take off the extra entries in feature list */
	nn_params.features[0] = nn_params.ninputs;
	show_string_text(Select_select_pop->select_feature_list,
			 make_net_string(nn_params.features));
    }
    /* check all the features */
    for(n = 1; n <= nn_params.ninputs; n++){
	if(nn_params.features[n] < 0 ||
	   nn_params.features[n] >= nn_params.nraw ||
	   (nn_params.normalize == LDA &&
	    nn_params.features[n] >= nn_params.noutputs)){
	    select_error("Error: Bad feature in feature list");
	    nn_params.features[0] = 0;
	    set_select_n(0);
	    break;
	}
    }
    set_feature_labels_string();
}

void
g_create_search_filename()
{
    static char *search_string[3] = {".for",".back",".for_bk"};
    static char *norm_char[4] = {".N",".S",".P",".D"};

    strcpy (search_ftmp, nn_params.data_base);
    /* I will want to include the algorithm for cv versions */
    /* I decided not to... */
    strcat (search_ftmp, search_string[search_direction]);
    strcat (search_ftmp, norm_char[nn_params.normalize]);

    search_param_fname = strcat (search_ftmp, ".param");
    show_string_text (Select_select_pop->select_file, search_ftmp);

    select_create_generate_files();

    /* check for parameter file and update message */
    if(select_type == READ_FILE){
	g_read_search_file();
    }
}

void
select_create_generate_files()
{
    char *temp_string, *strend;
    /* build generate window file names */
    /* first take the .param off the name, if it is there */
    if((temp_string = strdup(search_ftmp)) == NULL) return;
    if((strend = strstr(temp_string, ".param")) != NULL)
      strend[0] = '\0';

    /* now build the names and display them */
    show_string_label(Select_select_generate_pop->select_file_msg,
		      search_ftmp);
    strcpy (search_shell_ftmp, temp_string);
    strcat(search_shell_ftmp, ".run");
    show_string_label(Select_select_generate_pop->select_shell_script,
		      search_shell_ftmp);
    strcpy(search_log_ftmp, temp_string);
    strcat(search_log_ftmp, ".log");
    show_string_label(Select_select_generate_pop->select_log_file,
		      search_log_ftmp);
    strcpy(search_plot_ftmp, temp_string);
    strcat(search_plot_ftmp, ".plot");
    select_plot_fname = search_plot_ftmp;
    show_string_label(Select_select_generate_pop->select_plot_file,
		      search_plot_ftmp);

    free(temp_string);
}

void
select_check_file()
/* for data window */
{
    if(select_type == READ_FILE){
	g_read_search_file();
    }
}

int
g_read_search_file()
{
    int rv, i;
    FILE *param_file;
    int nraw, *selected;
    float *errors;

    select_clear_error();

    /* check if the file is there, warn if not, returning -1 */
    param_file = fopen(path_build(nn_params.data_path, search_ftmp), "r");
    if(param_file == NULL){
	select_error("Error: Feature list file does not exist");
	if(nn_params.features != NULL) nn_params.features[0] = 0;
	set_select_n(0);
	set_feature_labels_string();
	return -1;
    }
    rv = feat_sel_read_model(param_file, &nraw, &best_n, &selected, &errors);
    if(rv < 0){
	select_error("Error: Cannot read feature list file");
	if(nn_params.features != NULL) nn_params.features[0] = 0;
	set_select_n(0);
	set_feature_labels_string();
	return -1;
    }

    /* set ninputs */
    if(search_best){
	set_select_n(best_n);
    } else {
	set_select_n(select_n_II);
    }

    /* copy all of the features */
    if(search_features != NULL) deallocate_ivector(search_features);
    search_features = allocate_ivector(nraw+1);
    search_features[0] = nraw;
    for(i = 0; i < nraw; i++){
	search_features[i+1] = selected[i];
    }
    copy_search_feature_list();
    
    /* free allocated space */
    nn_fclose(param_file, path_build(nn_params.data_path, search_ftmp),
	      "for feature selection parameter file");
    /* free space allocated in feat_sel_read_model */
    nn_free((char *)selected, "for features");
    nn_free((char *)errors, "for errors");
    return(0);
}

void
copy_search_feature_list()
{
    int i;

    if(nn_params.features != NULL) deallocate_ivector(nn_params.features);
    nn_params.features = allocate_ivector(nn_params.ninputs+1);
    nn_params.features[0] = nn_params.ninputs;
    if(search_features != NULL){
	for(i = 0; i < nn_params.ninputs && i < search_features[0]; i++){
	    nn_params.features[i+1] = search_features[i+1];
	}
    } else {
	nn_params.features[0] = 0;
    }
    /* !!! */
    show_string_text(Select_select_pop->select_feature_list,
		     make_net_string(nn_params.features));
    set_feature_labels_string();
}

void
set_feature_labels_string()
{
    static char *feature_labels_string = NULL;
    void region_set_input_label(), profile_set_input_label();

    if(feature_labels_string != NULL)
      nn_free(feature_labels_string, "for feature_labels_string");
    feature_labels_string = get_feature_labels();
    show_string_label(Select_select_pop->feature_labels,
		      feature_labels_string);
    region_set_input_label();
    profile_set_input_label();
}

char *
get_feature_labels()
/* build a list of selected feature labels */
{
    int labels_len, total_length, i;
    char small_string[8];
    char *labels_string;

    /* we cannot use the original labels for PCA and LDA,
       let's fake the system out by pretending there are no labels */
    if(nn_params.normalize == LDA || nn_params.normalize == PCA ||
       nn_params.input_labels == NULL) labels_len = 0;
    else labels_len = atoi(nn_params.input_labels[0]);

    switch(select_type){
	/* put together a list of the selected features */
      case ALL:
      case FIRST_N:
	if(labels_len == 0){
	    /* just use 0,1,2 */
	    /* 5 chars per number, with the commas and the NIL at the end */
	    total_length = 6*nn_params.ninputs + 1;

	    labels_string = nn_malloc(total_length, "for make_labels_string");
	    labels_string[0] = '\0';
	    for(i = 0; i < nn_params.ninputs; i++){
		sprintf(small_string, "%d", i);
		strcat(labels_string, small_string);
		strcat(labels_string, ",");
	    }
	    /* take off the comma at the end */
	    total_length = strlen(labels_string);
	    if(total_length > 1) labels_string[total_length-1] = '\0';
	    return labels_string;
	}
	/* use the first ninputs entries in the existing list, if it is
	   long enough */
	if(labels_len < nn_params.ninputs){
	    /* labels length isn't long enough */
	    labels_string =
	      strdup("Not enough feature labels for this data base");
	    if(labels_string == NULL)
	      fatal_error("get_feature_labels: cannot allocate string");
	    return labels_string;
	} else if(labels_len == nn_params.ninputs){
	    labels_string = make_labels_string(nn_params.input_labels);
	} else {
	    /* change the list length to only ninputs */
	    /* we know that ninputs will fit because it is less than
	       labels_len */
	    sprintf(nn_params.input_labels[0], "%d", nn_params.ninputs);
	    labels_string = make_labels_string(nn_params.input_labels);
	    sprintf(nn_params.input_labels[0], "%d", labels_len);
	}
	return labels_string;
      case MANUAL:
      case READ_FILE:
	if(nn_params.features == NULL) return strdup("");
	total_length = 0;

	/* add up the length of the string to be created */
	for(i = 0; i < nn_params.ninputs; i++){
	    /* check for bad feature numbers */
	    if(nn_params.features[i+1] >= labels_len){
		if(labels_len == 0) total_length += 5; /* no more than 99999 */
		else {
		    labels_string =
		      strdup("Bad feature list or not enough labels");
		    if(labels_string == NULL)
		      fatal_error("get_feature_labels: cannot allocate string");
		    return labels_string;
		}
	    } else 
	      total_length +=
		strlen(nn_params.input_labels[nn_params.features[i+1]+1]);
	}
	/* remember the commas and the NIL at the end */
	total_length += nn_params.ninputs + 1;

	labels_string = nn_malloc(total_length, "for make_labels_string");
	labels_string[0] = '\0';
	if(labels_len > 0){
	    for(i = 0; i < nn_params.ninputs; i++){
		strcat(labels_string,
		       nn_params.input_labels[nn_params.features[i+1]+1]);
		strcat(labels_string, ",");
	    }
	} else {
	    for(i = 0; i < nn_params.ninputs && i < nn_params.features[0];
		i++){
		sprintf(small_string, "%d", nn_params.features[i+1]);
		strcat(labels_string, small_string);
		strcat(labels_string, ",");
	    }
	}

	/* take off the comma at the end */
	total_length = strlen(labels_string);
	if(total_length > 1) labels_string[total_length-1] = '\0';
	return labels_string;
    }
}

void
g_set_select_autoscale (value)
     int value;
{
    int on_off;
    if(value) on_off = TRUE;
    else on_off = FALSE;

    select_auto_scale_flag = on_off;
    gray_out_item(Select_select_generate_pop->select_axes_limits, on_off);
    gray_out_item(Select_select_generate_pop->select_xmin, on_off);
    gray_out_item(Select_select_generate_pop->select_ymin, on_off);
    gray_out_item(Select_select_generate_pop->select_xmax, on_off);
    gray_out_item(Select_select_generate_pop->select_ymax, on_off);
    gray_out_item(Select_select_generate_pop->select_xstep, on_off);
    gray_out_item(Select_select_generate_pop->select_ystep, on_off);
}

void
g_set_select_plot_label (value)
     char *value;
{
    sprintf (search_plot_lbl_tmp,"\"%s\"",value);
    select_plot_label = search_plot_lbl_tmp;
}

void
store_select_plot_command(shell_file)
     FILE *shell_file;
{
    extern char plot_command_line[];
    void select_set_common_flags();

    select_set_common_flags();
    plot_exp_path = nn_params.exp_path;

    if(nn_params.store_only) no_graphics = 1;
    else no_graphics = 0;

    if(nn_params.store_only) fprintf(shell_file, "(time ");
    sprintf(plot_command_line, "%s %s", PLOT_SELECT,
	    nnargs_get_flags(select_argtab, SELECT_TABSIZE));
    *strrchr(plot_command_line, '\n')  = ' ';
    fprintf(shell_file, "%s", plot_command_line);
    if(nn_params.store_only)
      fprintf(shell_file, "\\\n) >>& %s\n", search_log_ftmp);
    else fprintf(shell_file, "\n");
}

void
select_set_common_flags()
{
    exp_path = nn_params.exp_path;
    data_path = nn_params.data_path;
    strcpy(data_ftmp, nn_params.data_base);
    strcat(data_ftmp, nn_params.ext_train);
    data_fname = data_ftmp;
    desc_fname = nn_params.desc_fname;
    npatterns = nn_params.npatterns_train;
    normalize = nn_params.normalize;
    norm_fname = nn_params.norm_fname;
    search_verbosity = nn_params.verbosity;
    search_param_fname = search_ftmp;

    plot_exp_path = exp_path;
    plot_error_fname = search_param_fname;
    mac_searchlines_fname = "search.mac";
}

void
select_store_run_command(shell_file)
     FILE *shell_file;
{
    char *g_get_gen_class_args(), *g_get_alg_args();
    char *gmlp_get_args();
    int old_cv;
    void set_common_flags();

    if(classifier == 0){
	select_set_common_flags();
	fprintf(shell_file, "%s %s", SELECT_PROGRAM_NAME,
		nnargs_get_part_flags(argtab, TABSIZE));
	fprintf(shell_file, "%s",
		nnargs_get_part_flags(search_tab, SEARCH_TABSIZE));
    } else {
#define CV_TRAIN 4
	set_common_flags(CV_TRAIN);
	old_cv = set_cv_nfolds(cv_nfolds);
	/* print out general args */
	fprintf(shell_file, "%s_%s %s", nn_params.classifier_name,
		SELECT_PROGRAM_NAME, g_get_gen_class_args());
	/* print out classifier args */
	fprintf(shell_file, "%s", g_get_alg_args());
	/* if this algorithm uses clustering, store KMEANS arguments */
	if(alg_uses_clustering()){
	    algorithm_number temp_alg;
	    temp_alg = g_get_alg();
	    g_set_alg(KMEANS);
	    fprintf(shell_file, "%s", g_get_alg_args());
	    g_set_alg(temp_alg);
	}
	/* print out feat_search args */
	fprintf(shell_file, "%s",
		nnargs_get_part_flags(search_tab, SEARCH_TABSIZE));
	set_cv_nfolds(old_cv);
    }
}

int
store_select_commands(run_flag)
     int run_flag;
{
    FILE *shell_file;
    void set_temp_exp_path(), restore_exp_path();

    shell_file =
      command_file_open(path_build(nn_params.exp_path, search_shell_ftmp),
			"for norm shell file");
    if(shell_file == NULL) return -1;

    /* print out experiment path stuff */
    set_temp_exp_path(shell_file);

    if(run_flag != PLOT_ONLY){
	char *full_param_path;
	fprintf(shell_file, "\n#feature selection\n");
	select_store_run_command(shell_file);
	if(nn_params.store_only)
	  fprintf(shell_file, " >& %s\n", search_log_ftmp);
	else
	  fprintf(shell_file, " |& nn_tee -h %s\n", search_log_ftmp);
	/* copy param file to data directory */
	/* I used to ask first, before doing the copy */
	/* this is done in two parts because path_build returns a static */
	/* if the data path is the same as the real experiment path,
	   this will not work */
	full_param_path=path_build(nn_params.data_path, search_ftmp);
	fprintf(shell_file, "#check that the experiment directory is not\n");
	fprintf(shell_file, "#the same as the data directory,\n");
	fprintf(shell_file, "#then copy the search file to the data directory\n");
	fprintf(shell_file, "if (-e %s ) then \n", full_param_path);
	fprintf(shell_file, "  set src_i=`ls -i %s`\n", search_ftmp);
	fprintf(shell_file, "  set dest_i=`ls -i %s`\n", full_param_path);
	fprintf(shell_file, "  if ($src_i[1] != $dest_i[1]) cp %s %s\n",
		search_ftmp, full_param_path);
	fprintf(shell_file, "else\n");
	fprintf(shell_file, "  cp %s %s\n", search_ftmp, full_param_path);
	fprintf(shell_file, "endif\n");
    }
    if(select_plot || run_flag == PLOT_ONLY){
	fprintf(shell_file, "\n#feature selection plot\n");
	store_select_plot_command(shell_file);
    }
    restore_exp_path();

    command_file_close(shell_file,
		       path_build(nn_params.exp_path, search_shell_ftmp),
		       "for select shell file");

    return 0;
}

void
select_set_plot_label()
{
    switch(search_direction){
      case FORWARD:
	sprintf(search_plot_lbl_tmp, "\" Forward Search: Norm:%s",
		norm_description(nn_params.normalize));
	break;
      case BACKWARD:
	sprintf(search_plot_lbl_tmp, "\"Backward Search: Norm:%s",
		norm_description(nn_params.normalize));
	break;
      case FOR_AND_BACK:
	sprintf(search_plot_lbl_tmp, "\"Forward and Back Search: Norm:%s",
		norm_description(nn_params.normalize));
	break;
    }
    if(classifier == 0)
      sprintf(search_plot_lbl_tmp, "%s NN leave-1-out\"", search_plot_lbl_tmp);
    else
      sprintf(search_plot_lbl_tmp, "%s %s %d-Fold CV\"", search_plot_lbl_tmp,
	      nn_params.classifier_name, cv_nfolds);
    select_plot_label = search_plot_lbl_tmp;
    show_string_label(Select_select_generate_pop->select_plot_label,
		      select_plot_label);
}

select_run(run_flag)
     int run_flag;
{
    if(overwrite_ok(path_build(nn_params.exp_path, search_shell_ftmp))){
	if(store_select_commands(run_flag)) return;
	if(!nn_params.store_only)
	  select_pid = chdir_and_execute_command(search_shell_ftmp);
    }
}

/* defaults file arguments, table, and routines */
static int ninputs_arg = 0;
static char *search_fname = "";
static char *search_shell = "";
static char *search_log = "";
static int *features;
static ARG selecttab[] =
{
    {"select_type", INT, &select_type, "0-ALL,1-FIRST_N,2-MANUAL,3-READ_FILE"},
    {"ninputs", INT, &ninputs_arg, ""},
    {"use_best", FLAG, &search_best, ""},
    {"n_from_list", INT, &select_n_II, ""},
    {"search_fname", STRING, (int *)&search_fname, ""},
    {"search_n", INT, &search_n, "n for stop early"},
    {"search_shell", STRING, (int *)&search_shell, ""},
    {"search_log", STRING, (int *)&search_log, ""},
    {"search_direction", INT, &search_direction, "0-FOR,1-BACK,2-FOR_BACK"},
    {"stop_early", FLAG, &stop_early, ""},
    {"select_plot", FLAG, &select_plot, ""},
    {"select_autoscale", FLAG, &select_auto_scale_flag, ""},
    {"features", INT_ALLOC_LIST, (int *)&features, ""},
    {"classifier", FLAG, &classifier, ""},
    {"cv_nfolds", INT, &cv_nfolds, ""},
};
#define SELECT_DEF_LEN (sizeof(selecttab)/sizeof(ARG))

void
read_select_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    search_best = stop_early = select_plot = select_auto_scale_flag =
      classifier = 0;
    features = NULL;
    search_fname = search_shell = search_log = NULL;
    select_plot_fname = select_plot_label = NULL;

    /* these flags are reset each time they are used */
    plot_exp_path = plot_error_fname = mac_searchlines_fname = NULL;

    if(argc > 0){
	argc = nnargs_part (argc, argv, selecttab, SELECT_DEF_LEN);
	argc = nnargs(argc, argv, select_argtab, SELECT_TABSIZE);
    } else {
	select_auto_scale_flag = 1;
	classifier = 0;
	cv_nfolds = 4;
    }
    strcpy_empty_if_null(search_ftmp, search_fname);
    strcpy_empty_if_null(search_shell_ftmp, search_shell);
    strcpy_empty_if_null(search_log_ftmp, search_log);

    select_plot_fname =
      strcpy_empty_if_null(search_plot_ftmp, select_plot_fname);
    nn_params.features = features;
    nn_params.ninputs = ninputs_arg;
    select_plot_label =
      strcpy_empty_if_null(search_plot_lbl_tmp, select_plot_label);
}

void
write_select_defaults(default_file)
     FILE *default_file;
{
    search_fname = null_if_empty_string(search_ftmp);
    search_shell = null_if_empty_string(search_shell_ftmp);
    search_log = null_if_empty_string(search_log_ftmp);
    select_plot_fname = null_if_empty_string(select_plot_fname);
    select_plot_label = null_if_empty_string(select_plot_label);

    /* strings set in gnorm_set_common_flags */
    plot_exp_path = null_if_empty_string(plot_exp_path);
    plot_error_fname = null_if_empty_string(plot_error_fname);
    mac_searchlines_fname = null_if_empty_string(mac_searchlines_fname);
    
    features = nn_params.features;
    ninputs_arg = nn_params.ninputs;

    if(default_file != NULL){
	/* regular flags */
	fprintf (default_file, "select %s",
		 nnargs_get_part_flags(selecttab, SELECT_DEF_LEN));
	/* plot flags */
	fprintf (default_file, "%s",
		 nnargs_get_flags(select_argtab, SELECT_TABSIZE));
    }
}

void
activate_algorithm_feat_sel(activate_flag)
     int activate_flag;
{
    if(activate_flag){
	gray_out_item(Select_select_generate_pop->select_classifier, FALSE);
	classifier = xv_get(Select_select_generate_pop->select_classifier,
			    PANEL_VALUE, NULL);
	if(classifier)
	  gray_out_item(Select_select_generate_pop->select_n_folds, FALSE);
	else
	  gray_out_item(Select_select_generate_pop->select_n_folds, TRUE);
	gray_out_item(Select_select_generate_pop->select_alg_msg, FALSE);
	gray_out_item(Select_select_generate_pop->select_alg_params, FALSE);
    } else {
	gray_out_item(Select_select_generate_pop->select_classifier, TRUE);
	classifier = 0;
	gray_out_item(Select_select_generate_pop->select_n_folds, TRUE);
	gray_out_item(Select_select_generate_pop->select_alg_msg, TRUE);
	gray_out_item(Select_select_generate_pop->select_alg_params, TRUE);
    }
}
select_error(string)
     char *string;
{
    void set_main_select_warning();
    show_string_label(Select_select_pop->select_error_message, string);
    show_image_label(Select_select_pop->select_warning,
		     LNKnet_glyphs->LNKnet_warning_pic);
    set_main_select_warning(LNKnet_glyphs->small_warning_pic);
}

select_clear_error()
{
    void set_main_select_warning();
    /* clear error message if we have made it this far */
    show_string_label(Select_select_pop->select_error_message, "");
    show_image_label(Select_select_pop->select_warning,
		     LNKnet_glyphs->LNKnet_blank_pic);
    set_main_select_warning(LNKnet_glyphs->small_blank_pic);
}
