/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * cost_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `cost.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "cost_ui.h"
#include "../LNKnet_subs.h"
#include "../gnn/nn_params.h"
#include <nnlib.h>

#define PLOT_COST "plot_cost"
#include <plot_cost_args.h>
#include "../LNKnet_subs.h"
extern cost_cost_pop_objects	*Cost_cost_pop;
#define MAXSTR 256
void cost_set_cost_autoscale();
void cost_set_common_flags();
void g_set_cost_plot_label();
static char cost_plot_lbl_tmp[MAXSTR];
static char cost_plot_ftmp[MAXSTR];

void
g_init_cost()
{
    cost_autoscale = 1;
    nn_params.cost_fname = cost_plot_ftmp;
}

void
g_display_cost()
{
    show_string_label(Cost_cost_pop->cost_func, cost_string(cost_func));
    show_string_label(Cost_cost_pop->cost_plot_file, cost_plot_fname);
    show_int_value (Cost_cost_pop->cost_autoscale, cost_autoscale);
    /* to get the graying out */
    cost_set_cost_autoscale(cost_autoscale);
    show_float_text(Cost_cost_pop->cost_xmin, cost_xmin);
    show_float_text(Cost_cost_pop->cost_xmax, cost_xmax);
    show_float_text(Cost_cost_pop->cost_ymin, cost_ymin);
    show_float_text(Cost_cost_pop->cost_ymax, cost_ymax);
    show_float_text(Cost_cost_pop->cost_xstep, cost_xstep);
    show_float_text(Cost_cost_pop->cost_ystep, cost_ystep);
    show_string_label(Cost_cost_pop->cost_plot_label, cost_plot_label);
    show_int_text(Cost_cost_pop->cost_trial_average, plot_trial_average);
}

/*
 * Notify callback function for text_fields
 */
Panel_setting
cost_2_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    cost_cost_pop_objects *ip =
      (cost_cost_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    
    if(item == ip->cost_xmax){
	cost_xmax = set_atof_value(value, "cost_xmax", item, cost_xmax);
    } else if(item == ip->cost_xmin){
	cost_xmin = set_atof_value(value, "cost_xmin", item, cost_xmin);
    } else if(item == ip->cost_xstep){
	cost_xstep = set_atof_value(value, "cost_xstep", item, cost_xstep);
    } else if(item == ip->cost_ymax){
	cost_ymax = set_atof_value(value, "cost_ymax", item, cost_ymax);
    } else if(item == ip->cost_ymin){
	cost_ymin = set_atof_value(value, "cost_ymin", item, cost_ymin);
    } else if(item == ip->cost_ystep){
	cost_ystep = set_atof_value(value, "cost_ystep", item, cost_ystep);
    } else if(item == ip->cost_trial_average){
	plot_trial_average = set_atoi_value(value, "cost_trial_average",
					    item, plot_trial_average);
    } else {
	printf("cost_2_handler: unhandled\n");
	fprintf(stderr, "LNKnet: cost_2_handler: value: %s\n", value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `cost_autoscale'.
 */
void
cost_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    cost_cost_pop_objects *ip = (cost_cost_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->cost_autoscale){
	cost_set_cost_autoscale(value);
    } else {
	fputs("LNKnet: cost_3_handler, unhandled\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

void
create_cost_plot_fname()
{
    strcpy(cost_plot_ftmp, nn_params.exp_name);
    cost_plot_fname=strcat(cost_plot_ftmp, ".cost.plot");
    show_string_label(Cost_cost_pop->cost_plot_file, cost_plot_fname);
    nn_params.cost_fname = cost_plot_fname;
    print_set_cost_status();
}

/* for when npatterns_train changes on the data window */
void
cost_set_trial_average(value)
     int value;
{
    plot_trial_average = value;
    show_int_text(Cost_cost_pop->cost_trial_average, plot_trial_average);
}

void
cost_set_cost_autoscale(value)
     int value;
{
    int on_off;
    if(value) on_off = TRUE;
    else on_off = FALSE;
    cost_autoscale = on_off;
    gray_out_item(Cost_cost_pop->cost_axes_limits, on_off);
    gray_out_item(Cost_cost_pop->cost_xmin, on_off);
    gray_out_item(Cost_cost_pop->cost_ymin, on_off);
    gray_out_item(Cost_cost_pop->cost_xmax, on_off);
    gray_out_item(Cost_cost_pop->cost_ymax, on_off);
    gray_out_item(Cost_cost_pop->cost_xstep, on_off);
    gray_out_item(Cost_cost_pop->cost_ystep, on_off);
}

void
g_set_cost_plot_label(value)
  char *value;
{
    show_string_label (Cost_cost_pop->cost_plot_label, value);
    if(value[0] != '"'){
	strcpy(cost_plot_lbl_tmp, "\"");
	strncat(cost_plot_lbl_tmp ,value, MAXSTR-3);
	strcat(cost_plot_lbl_tmp, "\"");
    } else
      strncpy(cost_plot_lbl_tmp, value, MAXSTR);
    cost_plot_label = cost_plot_lbl_tmp;
}

/* for use by classifiers that change the cost function */
gnn_set_cost_func(cost_funcp)
     int cost_funcp;
{
    cost_func = cost_funcp;
    show_string_label(Cost_cost_pop->cost_func, cost_string(cost_func));
}

void
store_cost_plot_command(shell_file)
     FILE *shell_file;
{
    extern char plot_command_line[];

    cost_set_common_flags();
    if(nn_params.store_only) no_graphics = 1;
    else no_graphics = 0;
    class_data = 1;
    map_data = seq_data = 0;
    
    store_plot_start(shell_file);
    sprintf(plot_command_line, "%s",
	    nnargs_get_flags(cost_argtab, COST_TABSIZE));
    *strrchr(plot_command_line, '\n') = ' ';	/* get rid of newline at end */
    fprintf(shell_file, "%s %s", PLOT_COST, plot_command_line);
    store_plot_end(shell_file);
}

static char tmp_error_fname_space[MAXSTR];

void
cost_set_common_flags()
{
    strcpy(tmp_error_fname_space, nn_params.error_fname);
    strcat(tmp_error_fname_space, nn_params.ext_train);
    plot_error_fname = tmp_error_fname_space;
    plot_exp_path = nn_params.exp_path;
    mac_costlines_fname = "cost.mac";
}

/* defaults file arguments, table, and routines */
static int cost_autoscale_arg;

static ARG costtab[] =
{
    {"cost_autoscale_arg", INT, &cost_autoscale_arg, ""},
};
#define TABSIZE (sizeof(costtab)/sizeof(ARG))

void
read_cost_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    cost_plot_fname = cost_plot_label = NULL;
    /* these flags are reset each time they are used */
    plot_exp_path = plot_error_fname = mac_costlines_fname = NULL;

    if(argc > 0){
	argc = nnargs_part(argc, argv, costtab, TABSIZE);
	argc = nnargs(argc, argv, cost_argtab, COST_TABSIZE);
    } else {
	cost_autoscale_arg = 1;
    }
    cost_autoscale = cost_autoscale_arg;
    cost_plot_fname = strcpy_empty_if_null(cost_plot_ftmp, cost_plot_fname);
    cost_plot_label = strcpy_empty_if_null(cost_plot_lbl_tmp, cost_plot_label);
}

void
write_cost_defaults(default_file)
     FILE *default_file;
{
    cost_autoscale_arg = cost_autoscale;
    cost_plot_fname = null_if_empty_string(cost_plot_fname);
    cost_plot_label = null_if_empty_string(cost_plot_label);
    plot_exp_path = null_if_empty_string(plot_exp_path);
    plot_error_fname = null_if_empty_string(plot_error_fname);
    mac_costlines_fname = null_if_empty_string(mac_costlines_fname);

    if(default_file != NULL){
	fprintf(default_file, "%s %s", "cost",
		nnargs_get_part_flags(costtab, TABSIZE));
	fprintf(default_file, "%s",
		nnargs_get_flags(cost_argtab, COST_TABSIZE));
    }
}
