/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * detect_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `detect.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "detect_ui.h"
#include "../LNKnet_subs.h"
#include "../gnn/nn_params.h"
#include <nnlib.h>

#define PLOT_DETECT "plot_detect"
#include <plot_detect_args.h>
#include "../LNKnet_subs.h"
extern detect_detect_pop_objects	*Detect_detect_pop;
#define MAXSTR 256
void detect_set_common_flags();
void g_set_detect_plot_label();
static char detect_plot_lbl_tmp[MAXSTR];
static char detect_plot_ftmp[MAXSTR];
void detect_show_table_values();
void detect_set_target_label();

void
g_init_detect()
{
    nn_params.detect_fname = detect_plot_ftmp;
}

void
g_display_detect()
{
    show_int_text(Detect_detect_pop->target, target);
    detect_set_target_label();
    show_int_value(Detect_detect_pop->verbose, verbose);
    detect_show_table_values();
    show_float_text(Detect_detect_pop->detect_xmin, detect_xmin);
    show_float_text(Detect_detect_pop->detect_xmax, detect_xmax);
    show_float_text(Detect_detect_pop->detect_ymin, detect_ymin);
    show_float_text(Detect_detect_pop->detect_ymax, detect_ymax);
    show_float_text(Detect_detect_pop->detect_xstep, detect_xstep);
    show_float_text(Detect_detect_pop->detect_ystep, detect_ystep);
    show_string_label(Detect_detect_pop->detect_plot_file, plot_detect_fname);
    show_string_label(Detect_detect_pop->detect_plot_label, detect_plot_label);
    show_float_text(Detect_detect_pop->detect_table_begin, table_begin);
    show_float_text(Detect_detect_pop->detect_table_end, table_end);
    show_float_text(Detect_detect_pop->detect_table_step, table_step);
    show_float_text(Detect_detect_pop->detect_reject, reject_rate);
}

/*
 * Notify callback function for text_fields
 */
Panel_setting
detect_text_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    detect_detect_pop_objects *ip =
      (detect_detect_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    
    if(item == ip->target){
	target = set_atoi_low_value(value, "target", item, target, 0);
	detect_set_target_label();
    } else if(item == ip->detect_xmax){
	detect_xmax = set_atof_value(value, "detect_xmax", item, detect_xmax);
    } else if(item == ip->detect_xmin){
	detect_xmin = set_atof_value(value, "detect_xmin", item, detect_xmin);
    } else if(item == ip->detect_xstep){
	detect_xstep = set_atof_value(value, "detect_xstep", item,
				      detect_xstep);
    } else if(item == ip->detect_ymax){
	detect_ymax = set_atof_value(value, "detect_ymax", item, detect_ymax);
    } else if(item == ip->detect_ymin){
	detect_ymin = set_atof_value(value, "detect_ymin", item, detect_ymin);
    } else if(item == ip->detect_ystep){
	detect_ystep = set_atof_value(value, "detect_ystep", item,
				      detect_ystep);
    } else if(item == ip->detect_table_begin){
	table_begin = set_atof_range_value(value, "table_begin", item,
					   table_begin, 0., 100.);
    } else if(item == ip->detect_table_end){
	table_end = set_atof_range_value(value, "table_end", item,
					 table_end, 0., 100.);
    } else if(item == ip->detect_table_step){
	table_step = set_atof_range_value(value, "table_step", item,
					  table_step, 0., 100.);
    } else if(item == ip->detect_reject){
	reject_rate = set_atof_range_value(value, "reject", item,
					   reject_rate, 0., 1.);
    } else {
	printf("detect_text_handler: unhandled\n");
	fprintf(stderr, "LNKnet: detect_text_handler: value: %s\n", value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `detect_autoscale'.
 */
void
detect_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    detect_detect_pop_objects *ip =
      (detect_detect_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->verbose){
	verbose = value;
	detect_show_table_values();
    } else {
	fputs("LNKnet: detect_select_handler, unhandled\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

void
detect_show_table_values()
{
    if(verbose == 2){
	gray_out_item(Detect_detect_pop->detect_table_begin, FALSE);
	gray_out_item(Detect_detect_pop->detect_table_end, FALSE);
	gray_out_item(Detect_detect_pop->detect_table_step, FALSE);
    } else {
	gray_out_item(Detect_detect_pop->detect_table_begin, TRUE);
	gray_out_item(Detect_detect_pop->detect_table_end, TRUE);
	gray_out_item(Detect_detect_pop->detect_table_step, TRUE);
    }
}

void
create_detect_plot_fname()
{
    strcpy(detect_plot_ftmp, nn_params.exp_name);
    plot_detect_fname=strcat(detect_plot_ftmp, ".detect.plot");
    show_string_label(Detect_detect_pop->detect_plot_file, plot_detect_fname);
    nn_params.detect_fname = plot_detect_fname;
    print_set_detect_status();
}

void
detect_set_target_label()
{
    char * label;
    
    if(0 <= target && target < nn_params.noutputs){
	label = get_class_label(target, nn_params.output_labels); 
    } else {
	label = "Error: Bad Target Class";
    }
    show_string_label(Detect_detect_pop->target_label, label);
}

void
g_set_detect_plot_label(value)
  char *value;
{
    show_string_label(Detect_detect_pop->detect_plot_label, value);
    if(value[0] != '"'){
	strcpy(detect_plot_lbl_tmp, "\"");
	strncat(detect_plot_lbl_tmp ,value, MAXSTR-3);
	strcat(detect_plot_lbl_tmp, "\"");
    } else {
	strncpy(detect_plot_lbl_tmp, value, MAXSTR);
    }
    detect_plot_label = detect_plot_lbl_tmp;
}

void
store_detect_plot_command(shell_file)
     FILE *shell_file;
{
    extern char plot_command_line[];

    /* this plot has outputs that must go to the log file and stdout using
       a call to nn_tee. This means a pipe that would hang until olxplot
       exited unless no_detect_graphics is set */
    no_detect_graphics = 1;
    
    store_plot_start(shell_file);
    sprintf(plot_command_line, "%s",
	    nnargs_get_flags(detect_argtab, DETECT_TABSIZE));
    *strrchr(plot_command_line, '\n') = ' ';	/* get rid of newline at end */
    fprintf(shell_file, "%s %s", PLOT_DETECT, plot_command_line);
    store_plot_end_outputs(shell_file, "detect_plot", nn_params.detect_fname);
}

static char tmp_error_fname_space[MAXSTR];

void
detect_set_common_flags(which_data)
{
    strcpy(tmp_error_fname_space, nn_params.error_fname);
    switch(which_data){
      case TRAIN_TRAIN:
      case CV_TRAIN:
	strcat(tmp_error_fname_space, nn_params.ext_train);
	break;
      case CLASS_TRAIN:
	strcat(tmp_error_fname_space, nn_params.ext_test_train);
	break;
      case CLASS_EVAL:
	strcat(tmp_error_fname_space, nn_params.ext_eval);
	break;
      case CLASS_TEST:
	strcat(tmp_error_fname_space, nn_params.ext_test);
	break;
    }
    error_fname = tmp_error_fname_space;
    plot_exp_path = nn_params.exp_path;
    mac_detectlines_fname = "detect.mac";
    noutputs = nn_params.noutputs;
}

void
read_detect_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    plot_detect_fname  = detect_plot_label = NULL;
    /* these flags are reset each time they are used */
    plot_exp_path = error_fname = mac_detectlines_fname = NULL;
    no_detect_graphics = 0;
    mac_detect_flag = 0;
    if(argc > 0){
	argc = nnargs(argc, argv, detect_argtab, DETECT_TABSIZE);
    } else {
	verbose = 2;
    }
    plot_detect_fname = strcpy_empty_if_null(detect_plot_ftmp, plot_detect_fname);
    detect_plot_label = strcpy_empty_if_null(detect_plot_lbl_tmp, detect_plot_label);
}

void
write_detect_defaults(default_file)
     FILE *default_file;
{
    plot_detect_fname = null_if_empty_string(plot_detect_fname);
    detect_plot_label = null_if_empty_string(detect_plot_label);
    plot_exp_path = null_if_empty_string(plot_exp_path);
    error_fname = null_if_empty_string(error_fname);
    mac_detectlines_fname = null_if_empty_string(mac_detectlines_fname);

    if(default_file != NULL){
	fprintf(default_file, "%s %s", "detect",
		nnargs_get_flags(detect_argtab, DETECT_TABSIZE));
    }
}
