/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * perr_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `perr.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "perr_ui.h"
#include <nnlib.h>
#define PLOT_PERR "plot_perr"
#include <plot_perr_args.h>
#include "../LNKnet_subs.h"
#include "../gnn/nn_params.h"

extern	perr_perr_pop_objects	*Perr_perr_pop;

void g_set_perr_autoscale();
void perr_set_common_flags();
void g_set_perr_plot_label();

#define MAXSTR 256
static char perr_plot_lbl_tmp[MAXSTR];
static char perr_plot_ftmp[MAXSTR];

void
g_init_perr()
{
    perr_auto_scale_flag = 1;
    nn_params.perr_fname = perr_plot_ftmp;
}

void
g_display_perr()
{
    show_string_label(Perr_perr_pop->perr_plot_file, perr_plot_fname);
    show_int_value (Perr_perr_pop->perr_autoscale, perr_auto_scale_flag);
    g_set_perr_autoscale(perr_auto_scale_flag);
    show_float_text (Perr_perr_pop->perr_xmin, perr_xmin);
    show_float_text (Perr_perr_pop->perr_xmax, perr_xmax);
    show_float_text (Perr_perr_pop->perr_ymin, perr_ymin);
    show_float_text (Perr_perr_pop->perr_ymax, perr_ymax);
    show_float_text (Perr_perr_pop->perr_xstep, perr_xstep);
    show_float_text (Perr_perr_pop->perr_ystep, perr_ystep);
    show_string_label(Perr_perr_pop->perr_plot_label, perr_plot_label);
    show_int_text(Perr_perr_pop->perr_trial_average, plot_trial_average);
}

/*
 * Notify callback function for perr text items
 */
Panel_setting
perr_2_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    perr_perr_pop_objects *ip =
      (perr_perr_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    
    if(item == ip->perr_trial_average){
	plot_trial_average = set_atoi_value(value, "perr_trial_average", item,
					    plot_trial_average);
    } else if (item == ip->perr_xmax){
	perr_xmax = set_atof_value(value, "perr_xmax", item, perr_xmax);
    } else if (item == ip->perr_xmin){
	perr_xmin = set_atof_value(value, "perr_xmin", item, perr_xmin);
    } else if (item == ip->perr_xstep){
	perr_xstep = set_atof_value(value, "perr_xstep", item, perr_xstep);
    } else if (item == ip->perr_ymax){
	perr_ymax = set_atof_value(value, "perr_ymax", item, perr_ymax);
    } else if (item == ip->perr_ymin){
	perr_ymin = set_atof_value(value, "perr_ymin", item, perr_ymin);
    } else if (item == ip->perr_ystep){
	perr_ystep = set_atof_value(value, "perr_ystep", item, perr_ystep);
    } else {
	fprintf(stderr,
		"LNKnet: perr_2_handler: unhandled text: value: %s\n", value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `perr_autoscale'.
 */
void
perr_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    perr_perr_pop_objects *ip =
      (perr_perr_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->perr_autoscale){
	g_set_perr_autoscale(value);
    } else {
	fputs("LNKnet: perr_3_handler: unhandled\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

void
create_perr_plot_fname()
{
    strcpy(perr_plot_ftmp, nn_params.exp_name);
    perr_plot_fname=strcat(perr_plot_ftmp, ".perr.plot");
    show_string_label(Perr_perr_pop->perr_plot_file, perr_plot_fname);
    nn_params.perr_fname = perr_plot_fname;
    print_set_perr_status();
}

void
perr_set_trial_average(value)
     int value;
{
    plot_trial_average = value;
    show_int_text(Perr_perr_pop->perr_trial_average, plot_trial_average);
}

void
g_set_perr_autoscale (value)
     int value;
{
    int on_off;
    if (value) on_off = TRUE;
    else on_off = FALSE;
    perr_auto_scale_flag = on_off;
    gray_out_item(Perr_perr_pop->perr_axes_limits, on_off);
    gray_out_item(Perr_perr_pop->perr_xmin, on_off);
    gray_out_item(Perr_perr_pop->perr_ymin, on_off);
    gray_out_item(Perr_perr_pop->perr_xmax, on_off);
    gray_out_item(Perr_perr_pop->perr_ymax, on_off);
    gray_out_item(Perr_perr_pop->perr_xstep, on_off);
    gray_out_item(Perr_perr_pop->perr_ystep, on_off);
}

void
g_set_perr_plot_label (value)
     char *value;
{
    show_string_label(Perr_perr_pop->perr_plot_label, value);
    if(value[0] != '"'){
	strcpy(perr_plot_lbl_tmp, "\"");
	strncat(perr_plot_lbl_tmp ,value, MAXSTR-3);
	strcat(perr_plot_lbl_tmp, "\"");
    } else
      strncpy(perr_plot_lbl_tmp, value, MAXSTR);
    perr_plot_label = perr_plot_lbl_tmp;
}

void
store_perr_plot_command(shell_file)
     FILE *shell_file;
{
    extern char plot_command_line[];

    perr_set_common_flags();
    if(nn_params.store_only) no_graphics = 1;
    else no_graphics = 0;
    class_data = 1;
    map_data = seq_data = 0;

    store_plot_start(shell_file);
    sprintf(plot_command_line, "%s",
	    nnargs_get_flags(perr_argtab, PERR_TABSIZE));
    *strrchr(plot_command_line, '\n') = ' ';	/* get rid of newline at end */
    fprintf(shell_file, "%s %s", PLOT_PERR, plot_command_line);
    store_plot_end(shell_file);
}

static char tmp_error_fname_space[MAXSTR];
void
perr_set_common_flags()
{
    strcpy(tmp_error_fname_space, nn_params.error_fname);
    strcat(tmp_error_fname_space, nn_params.ext_train);
    plot_error_fname = tmp_error_fname_space;
    plot_exp_path = nn_params.exp_path;
    mac_perrlines_fname = "perr.mac";
}

/* defaults file arguments, table, and routines */
static int perr_autoscale_arg;

static ARG perrtab[] =
{
    {"perr_autoscale_arg", INT, &perr_autoscale_arg, ""},
};
#define TABSIZE (sizeof(perrtab)/sizeof(ARG))

void
read_perr_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    perr_plot_fname = perr_plot_label = NULL;
    /* these flags are reset each time they are used */
    plot_exp_path = plot_error_fname = mac_perrlines_fname = NULL;

    if(argc > 0){
	argc = nnargs_part(argc, argv, perrtab, TABSIZE);
	argc = nnargs(argc, argv, perr_argtab, PERR_TABSIZE);
    } else {
	perr_autoscale_arg = 1;
    }
    perr_auto_scale_flag = perr_autoscale_arg;
    perr_plot_fname = strcpy_empty_if_null(perr_plot_ftmp, perr_plot_fname);
    perr_plot_label = strcpy_empty_if_null(perr_plot_lbl_tmp, perr_plot_label);
}

void
write_perr_defaults(default_file)
     FILE *default_file;
{
    perr_autoscale_arg = perr_auto_scale_flag;
    perr_plot_fname = null_if_empty_string(perr_plot_fname);
    perr_plot_label = null_if_empty_string(perr_plot_label);
    plot_exp_path = null_if_empty_string(plot_exp_path);
    plot_error_fname = null_if_empty_string(plot_error_fname);
    mac_perrlines_fname = null_if_empty_string(mac_perrlines_fname);

    if(default_file != NULL){
	fprintf(default_file, "%s %s", "perr",
		nnargs_get_part_flags(perrtab, TABSIZE));
	fprintf(default_file, "%s",
		nnargs_get_flags(perr_argtab, PERR_TABSIZE));
    }
}
