/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * plots_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `plots.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include "../gnn/nn_params.h"
#include "../LNKnet_subs.h"
#include "plots_ui.h"
#include "region_ui.h"
#include "profile_ui.h"
#include "cost_ui.h"
#include "perr_ui.h"
#include "struct_ui.h"
#include "prob_ui.h"
#include "detect_ui.h"
#include "reject_ui.h"
extern	perr_perr_pop_objects	*Perr_perr_pop;
extern	struct_struct_pop_objects	*Struct_struct_pop;
extern	cost_cost_pop_objects	*Cost_cost_pop;
extern	prob_prob_pop_objects	*Prob_prob_pop;
extern	detect_detect_pop_objects	*Detect_detect_pop;
extern	reject_reject_pop_objects	*Reject_reject_pop;
extern	region_bound_pop_objects	*Region_bound_pop;
extern	profile_bound_pop_objects	*Profile_bound_pop;
extern	plots_plot_pop_objects	*Plots_plot_pop;

/* I am setting up the toggles for the plots here, but how do I tell
   the individual plot files where the arguments are actually set?
*/
int region_plot = 0;
int scatter_plot = 0;
int internals_plot = 0;
int profile_plot = 0;
int histogram_plot = 0;
int cost_plot_flag = 0;
int prob_plot_flag = 0;
int detect_plot_flag = 0;
int reject_plot_flag = 0;
int perr_plot_flag = 0;
int struct_plot_flag = 0;
int epoch_plots = 0;
int e_per_plot = 1;
#define MAXSTR 256

char plot_command_line[1024]; /* for use by all plot programs for
				 printing out arguments without final \n */

void g_profile_select_test();
void g_bound_select_test();
void profile_set_plot_flags(), region_set_plot_flags();
void plots_set_verror();

/* for printint constant width versions of shell script names in the
   notebook file */
static char const_width_script_name[64];

void
g_init_plots()
{
    void g_init_cost(), g_init_perr(), g_init_struct(), g_init_bound();
    void g_init_profile(), g_init_prob(), g_init_detect(), g_init_reject();

    nn_params.epoch_plots = 0;
    nn_params.train_plots = 0;
    g_init_cost();
    g_init_perr();
    g_init_struct();
    g_init_bound();
    g_init_profile();
    g_init_prob();
    g_init_detect();
    g_init_reject();
}

void
g_display_plots()
{
    void g_display_cost(), g_display_perr(), g_display_prob();
    void g_display_detect(), g_display_reject();
    void g_display_bound(), g_display_struct(), g_display_profile();
    int val;

    show_int_value (Plots_plot_pop->cost_plot_select, cost_plot_flag);
    show_int_value (Plots_plot_pop->prob_plot_select, prob_plot_flag);
    show_int_value (Plots_plot_pop->detect_plot_select, detect_plot_flag);
    show_int_value (Plots_plot_pop->reject_plot_select, reject_plot_flag);
    show_int_value (Plots_plot_pop->perr_plot_select, perr_plot_flag);
    val = region_plot + scatter_plot * 2 + internals_plot * 4;
    show_int_value (Plots_plot_pop->bound_select_test, val);
    val = profile_plot + histogram_plot*2;
    show_int_value (Plots_plot_pop->profile_select_test, val);
    show_int_value (Plots_plot_pop->struct_plot_select, struct_plot_flag);
    show_int_value (Plots_plot_pop->epoch_plots, epoch_plots);
    show_int_value (Plots_plot_pop->e_per_plot, e_per_plot);
    if(epoch_plots)
      gray_out_item(Plots_plot_pop->e_per_plot, FALSE);
    else
      gray_out_item(Plots_plot_pop->e_per_plot, TRUE);
    show_int_value (Plots_plot_pop->do_train_plots, nn_params.train_plots);

    g_display_cost();
    g_display_prob();
    g_display_detect();
    g_display_reject();
    g_display_perr();
    g_display_struct();
    g_display_bound();
    g_display_profile();
}

/*
 * Notify callback function for `plot_bound_params'.
 */
void
plots_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    plots_plot_pop_objects *ip =
      (plots_plot_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->plot_bound_params){
	open_popup(Region_bound_pop->bound_pop);
    } else if(item == ip->plot_profile_params){
	open_popup(Profile_bound_pop->bound_pop);
    } else if (item == ip->plot_cost_params){
	open_popup(Cost_cost_pop->cost_pop);
    } else if (item == ip->plot_prob_params){
	open_popup(Prob_prob_pop->prob_pop);
    } else if (item == ip->plot_detect_params){
	open_popup(Detect_detect_pop->detect_pop);
    } else if (item == ip->plot_reject_params){
	open_popup(Reject_reject_pop->reject_pop);
    } else if (item == ip->percent_error_parameters){
	open_popup(Perr_perr_pop->perr_pop);
    } else if (item == ip->struct_plot_parameters){
	open_popup(Struct_struct_pop->struct_pop);
    } else {
	fputs("LNKnet: plots_btn_handler: unhandled button\n", stderr);
    }
}

/*
 * Notify callback function for `bound_select_test'.
 */
void
plots_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    plots_plot_pop_objects *ip =
      (plots_plot_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
    void display_verror();
	
    if(item == ip->bound_select_test){
	g_bound_select_test(value);
    } else if(item == ip->profile_select_test){
	g_profile_select_test(value);
    } else if(item == ip->prob_plot_select){
	prob_plot_flag = value;
	plots_set_verror();
    } else if(item == ip->detect_plot_select){
	detect_plot_flag = value;
	plots_set_verror();
    } else if(item == ip->reject_plot_select){
	reject_plot_flag = value;
	plots_set_verror();
    } else if(item == ip->cost_plot_select){
	cost_plot_flag = value;
	plots_set_verror();
    } else if(item == ip->perr_plot_select){
	perr_plot_flag = value;
	plots_set_verror();
    } else if(item == ip->struct_plot_select){
	struct_plot_flag = value;
    } else if(item == ip->do_train_plots){
	nn_params.train_plots = value;
    } else if (item == ip->epoch_plots){
	nn_params.epoch_plots = epoch_plots = value;
	if(value)
	  gray_out_item(Plots_plot_pop->e_per_plot, FALSE);
	else
	  gray_out_item(Plots_plot_pop->e_per_plot, TRUE);
    } else {
	fputs("LNKnet: plots_select_handler: unhandled setting\n", stderr);
	for (i = 0; i < 0; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

/*
 * Notify callback function for `e_per_plot'.
 */
Panel_setting
plots_text_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    plots_plot_pop_objects *ip =
      (plots_plot_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    int	value = (int) xv_get(item, PANEL_VALUE);
    
    if(item == ip->e_per_plot){
	nn_params.e_per_plot = e_per_plot = value;
    } else {
	fprintf(stderr, "LNKnet: plots_text_handler: unhandled: value: %d\n", value);
    }
    
    /* gxv_start_connections DO NOT EDIT THIS SECTION */
    
    /* gxv_end_connections */
    
    return panel_text_notify(item, event);
}

void
activate_cost_plot (activate_flag)
     int activate_flag;
{
    int on_off;
    on_off = (activate_flag) ? FALSE : TRUE;
    gray_out_item(Plots_plot_pop->cost_plot_select, on_off);
    gray_out_item(Plots_plot_pop->plot_cost_params, on_off);
    if(activate_flag){
	cost_plot_flag =
	  xv_get(Plots_plot_pop->cost_plot_select, PANEL_VALUE);
	plots_set_verror();
    } else {
	cost_plot_flag = 0;
    }
}

void
activate_perr_plot (activate_flag)
     int activate_flag;
{
    int on_off;
    on_off = (activate_flag) ? FALSE : TRUE;
    gray_out_item (Plots_plot_pop->perr_plot_select, on_off);
    gray_out_item (Plots_plot_pop->percent_error_parameters, on_off);
    if(activate_flag){
	perr_plot_flag =
	  xv_get(Plots_plot_pop->perr_plot_select, PANEL_VALUE);
	plots_set_verror();
    } else {
	perr_plot_flag = 0;
    }
}

void
activate_prob_plot (activate_flag)
     int activate_flag;
{
    int on_off;
    on_off = (activate_flag) ? FALSE : TRUE;
    gray_out_item (Plots_plot_pop->prob_plot_select, on_off);
    gray_out_item (Plots_plot_pop->plot_prob_params, on_off);
    if(activate_flag){
	prob_plot_flag =
	  xv_get(Plots_plot_pop->prob_plot_select, PANEL_VALUE);
	plots_set_verror();
    } else {
	prob_plot_flag = 0;
    }
}

void
activate_detect_plot (activate_flag)
     int activate_flag;
{
    int on_off;
    on_off = (activate_flag) ? FALSE : TRUE;
    gray_out_item (Plots_plot_pop->detect_plot_select, on_off);
    gray_out_item (Plots_plot_pop->plot_detect_params, on_off);
    if(activate_flag){
	detect_plot_flag =
	  xv_get(Plots_plot_pop->detect_plot_select, PANEL_VALUE);
	plots_set_verror();
    } else {
	detect_plot_flag = 0;
    }
}

void
activate_reject_plot (activate_flag)
     int activate_flag;
{
    int on_off;
    on_off = (activate_flag) ? FALSE : TRUE;
    gray_out_item (Plots_plot_pop->reject_plot_select, on_off);
    gray_out_item (Plots_plot_pop->plot_reject_params, on_off);
    if(activate_flag){
	reject_plot_flag =
	  xv_get(Plots_plot_pop->reject_plot_select, PANEL_VALUE);
	plots_set_verror();
    } else {
	reject_plot_flag = 0;
    }
}

void
plots_set_verror()
{
    int change = 0;

    if((detect_plot_flag || reject_plot_flag || prob_plot_flag)
       && nn_params.verror < 2){
	nn_params.verror = 2;
	change = 1;
    }
    if((cost_plot_flag || perr_plot_flag) && nn_params.verror < 1){
	nn_params.verror = 1;
	change = 1;
    }
    if((cost_plot_flag || perr_plot_flag) && nn_params.no_train_verror){
	nn_params.no_train_verror = 0;
	change = 1;
    }
    if (change) display_verror();
}

int
plots_verror_value_ok(value)
     int value;
{
    if ((detect_plot_flag || reject_plot_flag || prob_plot_flag) && value < 2)
      return 0;
    else if ((cost_plot_flag || perr_plot_flag) && value < 1) return 0;
    else return 1;
}

int
plots_train_verror_value_ok(value)
     int value;
{
    if ((cost_plot_flag || perr_plot_flag) && value < 1) return 0;
    else return 1;
}

void
activate_profile_plot (activate_flag)
    int activate_flag;
{
    if (activate_flag) {
	gray_out_item (Plots_plot_pop->profile_select_test, FALSE);
	gray_out_item (Plots_plot_pop->plot_profile_params, FALSE);
	g_profile_select_test(xv_get(Plots_plot_pop->profile_select_test, 
		PANEL_VALUE));
    } else {
	gray_out_item (Plots_plot_pop->profile_select_test, TRUE);
	gray_out_item (Plots_plot_pop->plot_profile_params, TRUE);
	g_profile_select_test (0);
    }
}

void
g_bound_select_test(value)
     int value;
{
    region_plot = ((value & 1) != 0);
    scatter_plot = ((value & 2) != 0);
    internals_plot = ((value & 4) != 0);
    region_set_plot_flags(value);
}

void
g_profile_select_test(value)
{
    profile_plot = ((value & 1) != 0);
    histogram_plot = ((value & 2) != 0);
    profile_set_plot_flags(value);
}

void
activate_region_plot (activate_flag)
    int activate_flag;
{
    if (activate_flag) {
	gray_out_item (Plots_plot_pop->bound_select_test, FALSE);
	g_bound_select_test(xv_get(Plots_plot_pop->bound_select_test, 
		PANEL_VALUE));
	gray_out_item (Plots_plot_pop->plot_bound_params, FALSE);
    } else {
	gray_out_item (Plots_plot_pop->bound_select_test, TRUE);
	g_bound_select_test (0);
	gray_out_item (Plots_plot_pop->plot_bound_params, TRUE);
    }
}

void
activate_struct_plot (activate_flag)
    int activate_flag;
{
    if (activate_flag) {
	gray_out_item (Plots_plot_pop->struct_plot_select, FALSE);
	struct_plot_flag = xv_get(Plots_plot_pop->struct_plot_select,
				  PANEL_VALUE, NULL);
	gray_out_item (Plots_plot_pop->struct_plot_parameters, FALSE);
    } else {
	gray_out_item (Plots_plot_pop->struct_plot_select, TRUE);
	struct_plot_flag = 0;
	gray_out_item (Plots_plot_pop->struct_plot_parameters, TRUE);
    }
}

void
activate_epoch_plots(activate_flag)
{
    if(activate_flag){
	gray_out_item (Plots_plot_pop->epoch_plots, FALSE);
	if(xv_get(Plots_plot_pop->epoch_plots, PANEL_VALUE, NULL))
	  gray_out_item(Plots_plot_pop->e_per_plot, FALSE);
    } else {
	gray_out_item(Plots_plot_pop->epoch_plots, TRUE);
	gray_out_item(Plots_plot_pop->e_per_plot, TRUE);
   }
}

void
set_plot_labels()
{
    char string[MAXSTR];
    char *desc_text;
    char *g_get_plot_label();
    void g_set_bound_plot_label(), g_set_profile_plot_label();
    void g_set_cost_plot_label(), g_set_perr_plot_label();
    void g_set_prob_plot_label(), g_set_detect_plot_label();
    void g_set_reject_plot_label();
    
    desc_text = g_get_plot_label(string);
    g_set_bound_plot_label(desc_text);
    g_set_profile_plot_label(desc_text);
    g_set_perr_plot_label(desc_text);
    g_set_cost_plot_label(desc_text);
    g_set_prob_plot_label(desc_text);
    g_set_detect_plot_label(desc_text);
    g_set_reject_plot_label(desc_text);
}

void
store_alg_plot_commands(shell_file, show_plot)
     FILE *shell_file;
     int show_plot;
{
    void store_bound_plot_command(), store_profile_plot_command();
    
    /* do boundary plot, then profile plot */
    if(region_plot || scatter_plot || internals_plot) {
	fprintf(shell_file, "\n#decision region plot\n");
	store_bound_plot_command(shell_file, show_plot);
    }
    if(profile_plot || histogram_plot) {
	fprintf(shell_file, "\n#profile plot\n");
	store_profile_plot_command(shell_file, show_plot);
    }
}

/* print the opening of a plot command */
void
store_plot_start(shell_file)
     FILE *shell_file;
{
    if((nn_params.verbosity > 1) && nn_params.store_only)
      fprintf(shell_file, "(time ");
}

/* finish up a plot command */
void
store_plot_end(shell_file)
     FILE *shell_file;
{
    if((nn_params.verbosity > 1) && nn_params.store_only){
	fprintf(shell_file, "\\\n) >>& %s\n", nn_params.log_fname);
    } else {
	fprintf(shell_file, "\n");
    }
}

/* finish up a plot command where we are making sure that the outputs
   end up in the log file */
/* the problem here is that the olxplot that is started when a plot is
   run interactively prevents the pipe from closing for the tee so
   we need to do the tee on the plot without the interactive graphics
   and then display the plot in the background at the end */
void
store_plot_end_outputs(shell_file, plot_title, plot_fname)
     FILE *shell_file;
     char *plot_title, *plot_fname;
{
    if((nn_params.verbosity > 1) && nn_params.store_only){
	fprintf(shell_file, "\\\n) >>& %s\n", nn_params.log_fname);
    } else {
	fprintf(shell_file, "\\\n |& nn_tee -h -a %s\n",
		nn_params.log_fname);
	fprintf(shell_file, "olxplot -geometry 500x480 -title %s %s&\n",
		plot_title, plot_fname);
    }
}

void
create_plot_file_names()
{
    void create_cost_plot_fname(), create_perr_plot_fname();
    void create_profile_plot_fname(), create_prob_plot_fname();
    void create_bound_plot_fname(), create_struct_plot_fname();
    void create_detect_plot_fname(), create_reject_plot_fname();

    create_cost_plot_fname();
    create_perr_plot_fname();
    create_bound_plot_fname();
    create_profile_plot_fname();
    create_struct_plot_fname();
    create_prob_plot_fname();
    create_detect_plot_fname();
    create_reject_plot_fname();
}

/* defaults file arguments, table, and routines */
static int plot_train = 0;

/* plot_train, epoch plots, e_per_plot */

static ARG plottab[] =
{
    {"region", INT, &region_plot, ""},
    {"scatter", INT, &scatter_plot, ""},
    {"internals", INT, &internals_plot, ""},
    {"profile", INT, &profile_plot, ""},
    {"histogram", INT, &histogram_plot, ""},
    {"cost", INT, &cost_plot_flag, ""},
    {"prob", INT, &prob_plot_flag, ""},
    {"detect", INT, &detect_plot_flag, ""},
    {"reject", INT, &reject_plot_flag, ""},
    {"perr", INT, &perr_plot_flag, ""},
    {"struct_plot", INT, &struct_plot_flag, ""},
    {"plot_train", INT, &plot_train, ""},
    {"epoch_plots", INT, &epoch_plots, ""},
    {"e_per_plot", INT, &e_per_plot, ""},
};
#define TABSIZE (sizeof(plottab)/sizeof(ARG))

void
read_plot_defaults(argc, argv)
     int argc;
     char **argv;
{

    if(argc > 0){
	argc = nnargs(argc, argv, plottab, TABSIZE);
    } else {
	plot_train = 0;
	e_per_plot = 1;
    }
    nn_params.train_plots = plot_train;
    nn_params.epoch_plots = epoch_plots;
    nn_params.e_per_plot = e_per_plot;

}

void
write_plot_defaults(default_file)
     FILE *default_file;
{
    plot_train = nn_params.train_plots;

    if(default_file != NULL){
	fprintf(default_file, "plot %s",
		nnargs_get_flags(plottab, TABSIZE));
    }
}

/* store non-algorithm plots */
void
store_plot_commands(shell_file)
     FILE *shell_file;
{
    void store_cost_plot_command();
    void store_perr_plot_command();
    void store_struct_plot_command();
    void store_prob_plot_command();
    void store_detect_plot_command();
    void store_reject_plot_command();

    if(cost_plot_flag) {
	fprintf(shell_file, "\n#cost plot\n");
	store_cost_plot_command(shell_file);
    }
    if(perr_plot_flag) {
	fprintf(shell_file, "\n#percent error plot\n");
	store_perr_plot_command(shell_file);
    }
    if(struct_plot_flag){
	fprintf(shell_file, "\n#structure plot\n");
	store_struct_plot_command(shell_file);
    }
    if(prob_plot_flag) {
	fprintf(shell_file, "\n#prob plot\n");
	store_prob_plot_command(shell_file);
	sprintf(const_width_script_name, CONSTWIDTH_FORMAT,
		nn_params.shell_fname);
	if(nn_params.notebook_on)
	  store_chi_note_command(shell_file, nn_params.log_fname,
				 const_width_script_name,
				 nn_params.notebook_path);
    }
    if(detect_plot_flag) {
	fprintf(shell_file, "\n#detect plot\n");
	store_detect_plot_command(shell_file);
	sprintf(const_width_script_name, CONSTWIDTH_FORMAT,
		nn_params.shell_fname);
	if(nn_params.notebook_on)
	  store_roc_note_command(shell_file, nn_params.log_fname,
				 const_width_script_name,
				 nn_params.notebook_path);
    }
    if(reject_plot_flag) {
	fprintf(shell_file, "\n#reject plot\n");
	store_reject_plot_command(shell_file);
    }
}

static    char *bound_temp, *profile_temp;

void
setup_epoch_plot_calls(shell_file)
     FILE *shell_file;
{
    char *get_bound_plot_fname(), *get_profile_plot_fname();

    fprintf(shell_file, "set bplotfile = %s\n", get_bound_plot_fname());
    fprintf(shell_file, "set pplotfile = %s\n", get_profile_plot_fname());
    fprintf(shell_file, "set plotnum = 0\n");
    fprintf(shell_file, "set bpfname = $bplotfile$plotnum\n");
    fprintf(shell_file, "set ppfname = $pplotfile$plotnum\n");
    bound_temp = get_bound_plot_fname();
    set_bound_plot_fname("$bpfname");
    profile_temp = get_profile_plot_fname();
    set_profile_plot_fname ("$ppfname");
}

void
finish_epoch_plot_calls(shell_file)
     FILE *shell_file;
{
    if(nn_params.train_plots){
	if(scatter_plot || region_plot || internals_plot){
	    if(nn_params.store_only) fprintf(shell_file, "#");
	    fprintf(shell_file, "olxplot $bplotfile{$plotnum_list} &\n");
	}
	if(profile_plot || histogram_plot){
	    if(nn_params.store_only) fprintf(shell_file, "#");
	    fprintf(shell_file, "olxplot $pplotfile{$plotnum_list} &\n");
	}
    }

    set_bound_plot_fname(bound_temp);
    set_profile_plot_fname(profile_temp);
}
