/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * prob_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `prob.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "prob_ui.h"
#include "../LNKnet_subs.h"
#include "../gnn/nn_params.h"
#include <nnlib.h>

#define PLOT_PROB "plot_prob"
#include <plot_prob_args.h>
#include "../LNKnet_subs.h"
extern prob_prob_pop_objects	*Prob_prob_pop;
#define MAXSTR 256
void prob_set_common_flags();
void g_set_prob_plot_label();
static char prob_plot_lbl_tmp[MAXSTR];
static char prob_plot_ftmp[MAXSTR];
void gprob_show_var_bin_choices();
void prob_set_target_label();

void
g_init_prob()
{
    nn_params.prob_fname = prob_plot_ftmp;
}

void
g_display_prob()
{
    show_int_value(Prob_prob_pop->bin_plot, bin_plot);
    show_int_text(Prob_prob_pop->target, target);
    prob_set_target_label();
    show_int_value(Prob_prob_pop->var_bin, var_bin_flag);
    gprob_show_var_bin_choices();
    show_int_text(Prob_prob_pop->nbins, nbins);
    if(var_bin_ends != NULL)
      show_string_text(Prob_prob_pop->bin_ends,
		       make_float_string(var_bin_ends));
    show_int_text(Prob_prob_pop->min_bin_count, min_bin_count);
    show_int_value(Prob_prob_pop->chi_square, chi_square_flag);
    show_int_value(Prob_prob_pop->no_text, no_text);
    show_int_value(Prob_prob_pop->sum_to_one, sum_to_one);
    show_int_value(Prob_prob_pop->verbose, verbose);
    show_float_text(Prob_prob_pop->prob_xmin, prob_xmin);
    show_float_text(Prob_prob_pop->prob_xmax, prob_xmax);
    show_float_text(Prob_prob_pop->prob_ymin, prob_ymin);
    show_float_text(Prob_prob_pop->prob_ymax, prob_ymax);
    show_float_text(Prob_prob_pop->prob_xstep, prob_xstep);
    show_float_text(Prob_prob_pop->prob_ystep, prob_ystep);
    show_string_label(Prob_prob_pop->prob_plot_label, prob_plot_label);
    show_string_label(Prob_prob_pop->prob_plot_file, plot_prob_fname);
}

/*
 * Notify callback function for text_fields
 */
Panel_setting
prob_text_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    prob_prob_pop_objects *ip =
      (prob_prob_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    
    if(item == ip->target){
	target = set_atoi_low_value(value, "target", item, target, 0);
	prob_set_target_label();
    } else if(item == ip->nbins){
	nbins = set_atoi_low_value(value, "nbins", item, nbins, 0);
    } else if(item == ip->bin_ends){
	if(var_bin_ends != NULL) deallocate_vector(var_bin_ends);
	var_bin_ends = nnargs_get_float_alloc_list(value);
    } else if(item == ip->min_bin_count){
	min_bin_count = set_atoi_low_value(value, "min_bin_count", item,
					   min_bin_count, 0);
    } else if(item == ip->prob_xmax){
	prob_xmax = set_atof_value(value, "prob_xmax", item, prob_xmax);
    } else if(item == ip->prob_xmin){
	prob_xmin = set_atof_value(value, "prob_xmin", item, prob_xmin);
    } else if(item == ip->prob_xstep){
	prob_xstep = set_atof_value(value, "prob_xstep", item, prob_xstep);
    } else if(item == ip->prob_ymax){
	prob_ymax = set_atof_value(value, "prob_ymax", item, prob_ymax);
    } else if(item == ip->prob_ymin){
	prob_ymin = set_atof_value(value, "prob_ymin", item, prob_ymin);
    } else if(item == ip->prob_ystep){
	prob_ystep = set_atof_value(value, "prob_ystep", item, prob_ystep);
    } else {
	printf("prob_text_handler: unhandled\n");
	fprintf(stderr, "LNKnet: prob_text_handler: value: %s\n", value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `prob_autoscale'.
 */
void
prob_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    prob_prob_pop_objects *ip =
      (prob_prob_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->bin_plot){
	bin_plot = value;
    } else if(item == ip->var_bin){
	var_bin_flag = value;
	gprob_show_var_bin_choices();
    } else if(item == ip->chi_square){
	chi_square_flag = value;
    } else if(item == ip->no_text){
	no_text = value;
    } else if(item == ip->verbose){
	verbose = value;
    } else if(item == ip->sum_to_one){
	sum_to_one = value;
    } else {
	fputs("LNKnet: prob_select_handler, unhandled\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

void
gprob_show_var_bin_choices()
{
    if(var_bin_flag){
	gray_out_item(Prob_prob_pop->nbins, TRUE);
	gray_out_item(Prob_prob_pop->bin_ends, FALSE);
    } else {
	gray_out_item(Prob_prob_pop->nbins, FALSE);
	gray_out_item(Prob_prob_pop->bin_ends, TRUE);
    }
}

void
create_prob_plot_fname()
{
    strcpy(prob_plot_ftmp, nn_params.exp_name);
    plot_prob_fname=strcat(prob_plot_ftmp, ".prob.plot");
    show_string_label(Prob_prob_pop->prob_plot_file, plot_prob_fname);
    nn_params.prob_fname = plot_prob_fname;
    print_set_prob_status();
}

void
g_set_prob_plot_label(value)
  char *value;
{
    show_string_label(Prob_prob_pop->prob_plot_label, value);
    if(value[0] != '"'){
	strcpy(prob_plot_lbl_tmp, "\"");
	strncat(prob_plot_lbl_tmp ,value, MAXSTR-3);
	strcat(prob_plot_lbl_tmp, "\"");
    } else {
	strncpy(prob_plot_lbl_tmp, value, MAXSTR);
    }
    prob_plot_label = prob_plot_lbl_tmp;
}

void
prob_set_target_label()
{
    char * label;
    
    if(0 <= target && target < nn_params.noutputs){
	label = get_class_label(target, nn_params.output_labels); 
    } else {
	label = "Error: Bad Target Class";
    }
    show_string_label(Prob_prob_pop->target_label, label);
}

void
prob_set_sum_to_one()
{
    if(sum_to_one) return;
    sum_to_one = 1;
    show_int_value(Prob_prob_pop->sum_to_one, sum_to_one);
}

void
store_prob_plot_command(shell_file)
     FILE *shell_file;
{
    extern char plot_command_line[];

    /* this plot has outputs that must go to the log file and stdout using
       a call to nn_tee. This means a pipe that would hang until olxplot
       exited unless no_prob_graphics is set */
    no_prob_graphics = 1;
    
    store_plot_start(shell_file);
    sprintf(plot_command_line, "%s",
	    nnargs_get_flags(prob_argtab, PROB_TABSIZE));
    *strrchr(plot_command_line, '\n') = ' ';	/* get rid of newline at end */
    fprintf(shell_file, "%s %s", PLOT_PROB, plot_command_line);
    store_plot_end_outputs(shell_file, "prob_plot", nn_params.prob_fname);
}

static char tmp_error_fname_space[MAXSTR];

void
prob_set_common_flags(which_data)
{
    strcpy(tmp_error_fname_space, nn_params.error_fname);
    switch(which_data){
      case TRAIN_TRAIN:
      case CV_TRAIN:
	strcat(tmp_error_fname_space, nn_params.ext_train);
	npatterns = nn_params.npatterns_train;
	break;
      case CLASS_TRAIN:
	strcat(tmp_error_fname_space, nn_params.ext_test_train);
	npatterns = nn_params.npatterns_train;
	break;
      case CLASS_EVAL:
	strcat(tmp_error_fname_space, nn_params.ext_eval);
	npatterns = nn_params.npatterns_eval;
	break;
      case CLASS_TEST:
	strcat(tmp_error_fname_space, nn_params.ext_test);
	npatterns = nn_params.npatterns_test;
	break;
    }
    error_fname = tmp_error_fname_space;
    plot_exp_path = nn_params.exp_path;
    mac_problines_fname = "prob.mac";
    noutputs = nn_params.noutputs;
}

/* defaults file arguments, table, and routines */

static ARG probtab[] =
{
    {"no_graphics", BOOLEAN, &no_prob_graphics, ""},
};
#define TABSIZE (sizeof(probtab)/sizeof(ARG))

void
read_prob_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    plot_prob_fname = prob_plot_label = NULL;
    /* these flags are reset each time they are used */
    plot_exp_path = error_fname = mac_problines_fname = NULL;
    bin_plot = 0;
    var_bin_flag = 0;
    chi_square_flag = 0;
    no_prob_graphics = 0;
    no_text = 0;
    sum_to_one = 0;
    mac_prob_flag = 0;
    if(argc > 0){
	argc = nnargs_part(argc, argv, probtab, TABSIZE);
	argc = nnargs(argc, argv, prob_argtab, PROB_TABSIZE);
    } else {
	chi_square_flag = 1;
	verbose = 1;
    }
    plot_prob_fname = strcpy_empty_if_null(prob_plot_ftmp, plot_prob_fname);
    prob_plot_label = strcpy_empty_if_null(prob_plot_lbl_tmp, prob_plot_label);
}

void
write_prob_defaults(default_file)
     FILE *default_file;
{
    plot_prob_fname = null_if_empty_string(plot_prob_fname);
    prob_plot_label = null_if_empty_string(prob_plot_label);
    plot_exp_path = null_if_empty_string(plot_exp_path);
    error_fname = null_if_empty_string(error_fname);
    mac_problines_fname = null_if_empty_string(mac_problines_fname);

    if(default_file != NULL){
	fprintf(default_file, "%s %s", "prob",
		nnargs_get_part_flags(probtab, TABSIZE));
	fprintf(default_file, "%s",
		nnargs_get_flags(prob_argtab, PROB_TABSIZE));
    }
}
