/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * profile_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `profile.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "profile_ui.h"
#include "../gnn/nn_params.h"
#include <nnlib.h>
#define PLOT_BOUND "_plot_bound"
#include "../LNKnet_subs.h"
#include <plot_bound_args.h>

extern	profile_bound_pop_objects	*Profile_bound_pop;
#define MAXSTR 256
static char profile_plot_lbl_tmp[MAXSTR]; 
static char profile_plot_prefix_tmp[MAXSTR];
static char profile_plot_ftmp[MAXSTR];
static char data_ftmp[MAXSTR];
static char desc_ftmp[MAXSTR];

void g_set_profile_autoscale();
void g_profile_set_show_all();
void profile_set_common_flags();
void g_set_profile_plot_label();
void profile_set_input_label();

void
g_init_profile()
{
    show_color = 1;
    bound_autoscale = 1;
    nn_params.profile_fname = profile_plot_ftmp;
}

void
g_display_profile()
{
    /* set defaults for graph scales */
    show_string_label(Profile_bound_pop->profile_plot_file,
		      profile_plot_prefix_tmp);
    profile_create_plot_fname(gnn_get_which_data());
    show_int_text(Profile_bound_pop->bound_dim_1, bound_dim_1);
    profile_set_input_label();
    show_int_text(Profile_bound_pop->bound_npoints, bound_npoints);
    show_int_value(Profile_bound_pop->bound_autoscale, bound_autoscale);
    g_set_profile_autoscale(bound_autoscale);
    show_float_text(Profile_bound_pop->bound_xmin, bound_xmin);
    show_float_text(Profile_bound_pop->bound_xmax, bound_xmax);
    show_float_text(Profile_bound_pop->bound_xstep, bound_xstep);
    show_float_text(Profile_bound_pop->profile_ymin, profile_ymin);
    show_float_text(Profile_bound_pop->profile_ymax, profile_ymax);
    show_float_text(Profile_bound_pop->profile_ystep, profile_ystep);
    show_int_value(Profile_bound_pop->show_all_check_box, show_all);
    g_profile_set_show_all(show_all);
    show_float_text(Profile_bound_pop->distance_limit, distance_limit);
    show_string_label(Profile_bound_pop->profile_plot_label,
		      profile_plot_label);
    show_string_text(Profile_bound_pop->other_vars,
		     make_float_string(other_vars));
    show_int_value(Profile_bound_pop->plot_region_no_norm, no_norm);
}

/*
 * Notify callback function for profile popup text items
 */
Panel_setting
profile_2_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    profile_bound_pop_objects *ip =
      (profile_bound_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);

    char tmp[32];
	
    if(item == ip->bound_dim_1){
	bound_dim_1 =
	  set_atoi_value(value, "bound_dim_1", item, bound_dim_1);
	profile_set_input_label();
    } else if(item == ip->other_vars) {
	nnargs_get_float_list(strcpy(tmp, value), other_vars,
			      NNARGS_MAX_LABELS);
    } else if(item == ip->bound_npoints) {/* n_intervals per dim */
	bound_npoints = set_atoi_value(value, "bound_npoints", item,
				       bound_npoints);
    } else if(item == ip->bound_xmax){
	bound_xmax = set_atof_value(value, "bound_xmax", item, bound_xmax);
    } else if(item == ip->bound_xmin){
	bound_xmin = set_atof_value(value, "bound_xmin", item, bound_xmin);
    } else if(item == ip->bound_xstep){
	bound_xstep = set_atof_value(value, "bound_xstep", item, bound_xstep);
    } else if(item == ip->profile_ymax){
	profile_ymax = set_atof_value(value, "profile_ymax",
				      item, profile_ymax);
    } else if(item == ip->profile_ymin){
	profile_ymin = set_atof_value(value, "profile_ymin",
				      item, profile_ymin);
    } else if(item == ip->profile_ystep){
	profile_ystep = set_atof_value(value, "profile_ystep",
				       item, profile_ystep);
    } else if(item == ip->distance_limit){
	distance_limit =
	  set_atof_low_value(value, "distance_limit", item,
			     distance_limit, 0.);
    } else {
	fprintf(stderr,
		"LNKnet: profile_2_handler: unhandled text: value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for profile and profile settings
 */
void
profile_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    profile_bound_pop_objects *ip =
      (profile_bound_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->plot_region_no_norm){
	no_norm = value;
	profile_set_input_label();
    } else if(item == ip->bound_autoscale){
	g_set_profile_autoscale(value);
    } else if(item == ip->show_all_check_box){
	g_profile_set_show_all(value);
    } else {
	fputs("LNKnet: profile_3_handler: unhandled setting\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

void
create_profile_plot_fname()
{
    strcpy(profile_plot_prefix_tmp, nn_params.exp_name);
    strcat(profile_plot_prefix_tmp, ".profile.plot");
    show_string_label(Profile_bound_pop->profile_plot_file,
		      profile_plot_prefix_tmp);
    profile_create_plot_fname(gnn_get_which_data());
    print_set_profile_status();
}

void
g_set_profile_autoscale (value)
     int value;
{
    int on_off;
    if(value) on_off = TRUE;
    else on_off = FALSE;
    bound_autoscale = on_off; 
    gray_out_item(Profile_bound_pop->bound_axes_limits, on_off);
    gray_out_item(Profile_bound_pop->bound_xmin, on_off);
    gray_out_item(Profile_bound_pop->bound_xmax, on_off);
    gray_out_item(Profile_bound_pop->bound_xstep, on_off);
    gray_out_item(Profile_bound_pop->profile_ymin, on_off);
    gray_out_item(Profile_bound_pop->profile_ymax, on_off);
    gray_out_item(Profile_bound_pop->profile_ystep, on_off);
}

void
g_set_profile_plot_label (value)
     char *value;
{
    show_string_label(Profile_bound_pop->profile_plot_label, value);
    if(value[0] != '"'){
	strcpy(profile_plot_lbl_tmp, "\"");
	strncat(profile_plot_lbl_tmp ,value, MAXSTR-3);
	strcat(profile_plot_lbl_tmp, "\"");
    } else
      strncpy(profile_plot_lbl_tmp, value, MAXSTR);
    profile_plot_label = profile_plot_lbl_tmp;
}

void
g_profile_set_show_all (value)
     int value;
{
    if(value & 1){
	gray_out_item (Profile_bound_pop->distance_limit, TRUE);
    } else { 
	gray_out_item (Profile_bound_pop->distance_limit, FALSE);
    }
    show_all = value;
}

void
store_profile_plot_command(shell_file, show_plot)
     FILE *shell_file;
     int show_plot;
{
    extern char plot_command_line[];
    void g_get_test_args();

    if(show_plot) no_graphics = 0;
    else no_graphics = 1;

    store_plot_start(shell_file);
    sprintf (plot_command_line, "%s",
	     nnargs_get_flags(bound_argtab, BOUND_TABSIZE));
    *strrchr(plot_command_line, '\n') = ' ';	/* get rid of newline at end */
    fprintf(shell_file, "%s%s\\\n %s",
	    nn_params.classifier_name, PLOT_BOUND, plot_command_line);
    /* put in classifier dependent call if needed */
    g_get_test_args (shell_file);
    store_plot_end(shell_file);
}

void
profile_set_common_flags(which_data)
     int which_data;
{
    plot_exp_path = nn_params.exp_path;
    plot_error_fname = nn_params.param_fname;
    plot_n_inputs = nn_params.nraw;
    plot_n_outputs = nn_params.noutputs;
    /* labels */
    strcpy(desc_ftmp, path_build(nn_params.data_path, nn_params.desc_fname));
    scatter_desc_fullname = desc_ftmp;

    strcpy(data_ftmp, path_build(nn_params.data_path, nn_params.data_base));
    switch(which_data){
      case CLASS_TRAIN:
      case TRAIN_TRAIN:
      case CV_TRAIN:
	strcat(data_ftmp, nn_params.ext_train);
	scatter_n_patterns = nn_params.npatterns_train;
	break;
      case CLASS_EVAL:
	strcat(data_ftmp, nn_params.ext_eval);
	scatter_n_patterns = nn_params.npatterns_eval;
	break;
      case CLASS_TEST:
	strcat(data_ftmp, nn_params.ext_test);
	scatter_n_patterns = nn_params.npatterns_test;
	break;
    }
    scatter_data_fullname = data_ftmp;

    profile_create_plot_fname(which_data);

    plot_adjust_priors = nn_params.adjust_test;
    plot_uniform_priors = nn_params.test_uniform_priors;
    g_copy_test_priors_list(plot_priors_list);
    plot_map = nn_params.db_type;

    macdots_fname = "boundary_dots.mac";
    macscatter_fname = "scatter.mac";
    maclines_fname = "profile_lines.mac";
    machisto_fname = "profile_histo.mac";
    macwireframe_fname = "boundary_wire.mac";
    
}

void
profile_create_plot_fname(which_data)
     int which_data;
{
    strcpy(profile_plot_ftmp, profile_plot_prefix_tmp);
    switch(which_data){
      case TRAIN_TRAIN:
      case CV_TRAIN:
	strcat(profile_plot_ftmp, nn_params.ext_train);
	break;
      case CLASS_TRAIN:
	strcat(profile_plot_ftmp, nn_params.ext_test_train);
	break;
      case CLASS_EVAL:
	strcat(profile_plot_ftmp, nn_params.ext_eval);
	break;
      case CLASS_TEST:
	strcat(profile_plot_ftmp, nn_params.ext_test);
	break;
    }
    profile_plot_fname = profile_plot_ftmp;
    nn_params.profile_fname = profile_plot_fname;
}

void
profile_set_plot_flags(value)
{
    profile_plot = ((value & 1) != 0);
    histogram_plot = ((value & 2) != 0);
}

/* defaults file arguments, table, and routines */
static int all_data_arg = 0;/* show all data in scatter/histogram plots */
static float distance_limit_arg = .5;
static int show_misses_arg = 0;
static char *profile_plot_prefix_arg = NULL;

static ARG boundtab[] =
{
    {"all_data", INT, &all_data_arg,
       "Show all data in scatter/histogram plots"},
    {"distance", FLOAT, (int *) &distance_limit_arg,
       "Distance limit if all_data is off"},
    {"misses", INT, &show_misses_arg, "Highlight missclassified points"},
    {"plot_prefix", STRING, (int *)&profile_plot_prefix_arg, ""},
};
#define TABSIZE (sizeof(boundtab)/sizeof(ARG))

void
read_profile_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    profile_plot_prefix_arg = NULL;
    profile_plot_label = NULL;
    other_vars[0] = 0.;
    plot_priors_list[0] = 0.;
    bound_autoscale = 0;
    show_color = 0;

    /* strings set in profile_set_common_flags */
    profile_plot_fname = NULL;
    plot_exp_path = plot_error_fname = NULL;
    macdots_fname = macscatter_fname = maclines_fname = NULL;
    scatter_data_fullname = NULL;
    scatter_desc_fullname = NULL;
    no_norm = 0;

    /* clear bound plot strings */
    bound_plot_label = NULL;
    bound_plot_fname = NULL;

    if(argc > 0){
	argc = nnargs_part(argc, argv, boundtab, TABSIZE);
	argc = nnargs(argc, argv, bound_argtab, BOUND_TABSIZE);
    } else {
	show_color = 1;
	all_data_arg = 1;
	bound_autoscale = 1;
    }
    show_misses = show_misses_arg;
    show_all = all_data_arg;
    distance_limit = distance_limit_arg;

    strcpy_empty_if_null(profile_plot_prefix_tmp, profile_plot_prefix_arg);
    profile_plot_label =
      strcpy_empty_if_null(profile_plot_lbl_tmp, profile_plot_label);
}

void
write_profile_defaults(default_file)
     FILE *default_file;
{
    show_misses_arg = show_misses;
    all_data_arg = show_all;
    distance_limit_arg = distance_limit;

    profile_plot_prefix_arg = null_if_empty_string(profile_plot_prefix_tmp);
    profile_plot_label = null_if_empty_string(profile_plot_lbl_tmp);

    /* strings set in profile_set_common_flags */
    plot_exp_path = null_if_empty_string(plot_exp_path);
    plot_error_fname = null_if_empty_string(plot_error_fname);
    profile_plot_fname = null_if_empty_string(profile_plot_ftmp);
    scatter_data_fullname = null_if_empty_string(scatter_data_fullname);
    scatter_desc_fullname = null_if_empty_string(scatter_desc_fullname);

    /* clear plot strings that are not set by LNKnet */
    bound_plot_label = NULL;
    bound_plot_fname = NULL;
    macdots_fname = NULL;
    machisto_fname = NULL;
    maclines_fname = NULL;
    macwireframe_fname = NULL;

    if(default_file != NULL){
	fprintf(default_file, "profile %s",
		nnargs_get_part_flags(boundtab, TABSIZE));
	fprintf(default_file, "%s",
		nnargs_get_flags(bound_argtab, BOUND_TABSIZE));
    }
}
set_profile_plot_fname(value)
     char *value;
{
    profile_plot_fname = strcpy(profile_plot_ftmp, value);
    nn_params.profile_fname = profile_plot_fname;
    print_set_profile_status();
}

char *
get_profile_plot_fname()
{
    return profile_plot_fname;
}

void
profile_set_input_label()
{
    char *label;
    int upper_limit;
    if(no_norm) upper_limit = nn_params.nraw;
    else upper_limit = nn_params.ninputs;

    if(0 <= bound_dim_1 && bound_dim_1 < upper_limit){
	if(no_norm)
	  label = get_input_label(bound_dim_1, nn_params.input_labels,
				  NULL, 0);
	else
	  label = get_input_label(bound_dim_1, nn_params.input_labels,
				  nn_params.features, nn_params.normalize);
    } else {
	label = "Error: Bad Plot Feature";
    }
    show_string_label(Profile_bound_pop->bound_1_label, label);
}
