/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * reject_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `reject.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "reject_ui.h"
#include "../LNKnet_subs.h"
#include "../gnn/nn_params.h"
#include <nnlib.h>

#define PLOT_REJECT "plot_reject"
#include <plot_reject_args.h>
#include "../LNKnet_subs.h"
extern reject_reject_pop_objects	*Reject_reject_pop;
#define MAXSTR 256
void reject_set_common_flags();
void g_set_reject_plot_label();
static char reject_plot_lbl_tmp[MAXSTR];
static char reject_plot_ftmp[MAXSTR];
void reject_show_table_values();

void
g_init_reject()
{
    nn_params.reject_fname = reject_plot_ftmp;
}

void
g_display_reject()
{
    show_int_value (Reject_reject_pop->verbose, verbose);
    show_int_value (Reject_reject_pop->sum_to_one, sum_to_one);
    show_float_text(Reject_reject_pop->reject_xmin, reject_xmin);
    show_float_text(Reject_reject_pop->reject_xmax, reject_xmax);
    show_float_text(Reject_reject_pop->reject_ymin, reject_ymin);
    show_float_text(Reject_reject_pop->reject_ymax, reject_ymax);
    show_float_text(Reject_reject_pop->reject_xstep, reject_xstep);
    show_float_text(Reject_reject_pop->reject_ystep, reject_ystep);
    show_string_label(Reject_reject_pop->reject_plot_label, reject_plot_label);
    show_string_label(Reject_reject_pop->reject_plot_file, plot_reject_fname);
    reject_show_table_values();
    show_float_text(Reject_reject_pop->reject_table_begin, table_begin);
    show_float_text(Reject_reject_pop->reject_table_end, table_end);
    show_float_text(Reject_reject_pop->reject_table_step, table_step);
}

/*
 * Notify callback function for text_fields
 */
Panel_setting
reject_text_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    reject_reject_pop_objects *ip =
      (reject_reject_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    
    if(item == ip->reject_xmax){
	reject_xmax = set_atof_value(value, "reject_xmax", item, reject_xmax);
    } else if(item == ip->reject_xmin){
	reject_xmin = set_atof_value(value, "reject_xmin", item, reject_xmin);
    } else if(item == ip->reject_xstep){
	reject_xstep = set_atof_value(value, "reject_xstep", item, reject_xstep);
    } else if(item == ip->reject_ymax){
	reject_ymax = set_atof_value(value, "reject_ymax", item, reject_ymax);
    } else if(item == ip->reject_ymin){
	reject_ymin = set_atof_value(value, "reject_ymin", item, reject_ymin);
    } else if(item == ip->reject_ystep){
	reject_ystep = set_atof_value(value, "reject_ystep", item, reject_ystep);
    } else if(item == ip->reject_plot_label){
	g_set_reject_plot_label(value);
    } else if(item == ip->reject_table_begin){
	table_begin = set_atof_range_value(value, "table_begin", item,
					   table_begin, 0., 100.);
    } else if(item == ip->reject_table_end){
	table_end = set_atof_range_value(value, "table_end", item,
					 table_end, 0., 100.);
    } else if(item == ip->reject_table_step){
	table_step = set_atof_range_value(value, "table_step", item,
					  table_step, 0., 100.);
    } else {
	printf("reject_text_handler: unhandled\n");
	fprintf(stderr, "LNKnet: reject_text_handler: value: %s\n", value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `reject_autoscale'.
 */
void
reject_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    reject_reject_pop_objects *ip =
      (reject_reject_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->verbose){
	verbose = value;
	reject_show_table_values();
    } else if (item == ip->sum_to_one){
	sum_to_one = value;
    } else {
	fputs("LNKnet: reject_select_handler, unhandled\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

void
reject_show_table_values()
{
    if(verbose == 1){
	gray_out_item(Reject_reject_pop->reject_table_begin, FALSE);
	gray_out_item(Reject_reject_pop->reject_table_end, FALSE);
	gray_out_item(Reject_reject_pop->reject_table_step, FALSE);
    } else {
	gray_out_item(Reject_reject_pop->reject_table_begin, TRUE);
	gray_out_item(Reject_reject_pop->reject_table_end, TRUE);
	gray_out_item(Reject_reject_pop->reject_table_step, TRUE);
    }
}

void
create_reject_plot_fname()
{
    strcpy(reject_plot_ftmp, nn_params.exp_name);
    plot_reject_fname=strcat(reject_plot_ftmp, ".reject.plot");
    show_string_label(Reject_reject_pop->reject_plot_file, plot_reject_fname);
    nn_params.reject_fname = plot_reject_fname;
    print_set_reject_status();
}

void
g_set_reject_plot_label(value)
  char *value;
{
    show_string_label(Reject_reject_pop->reject_plot_label, value);
    if(value[0] != '"'){
	strcpy(reject_plot_lbl_tmp, "\"");
	strncat(reject_plot_lbl_tmp ,value, MAXSTR-3);
	strcat(reject_plot_lbl_tmp, "\"");
    } else {
	strncpy(reject_plot_lbl_tmp, value, MAXSTR);
    }
    reject_plot_label = reject_plot_lbl_tmp;
}

void
reject_set_sum_to_one()
{
    if(sum_to_one) return;
    sum_to_one = 1;
    show_int_value(Reject_reject_pop->sum_to_one, sum_to_one);
}

void
store_reject_plot_command(shell_file)
     FILE *shell_file;
{
    extern char plot_command_line[];

    /* this plot has outputs that must go to the log file and stdout using
       a call to nn_tee. This means a pipe that would hang until olxplot
       exited unless no_reject_graphics is set */
    no_graphics = 1;
    
    store_plot_start(shell_file);
    sprintf(plot_command_line, "%s",
	    nnargs_get_flags(reject_argtab, REJECT_TABSIZE));
    *strrchr(plot_command_line, '\n') = ' ';	/* get rid of newline at end */
    fprintf(shell_file, "%s %s", PLOT_REJECT, plot_command_line);
    store_plot_end_outputs(shell_file, "reject_plot", nn_params.reject_fname);
}

static char tmp_error_fname_space[MAXSTR];

void
reject_set_common_flags(which_data)
{
    strcpy(tmp_error_fname_space, nn_params.error_fname);
    switch(which_data){
      case TRAIN_TRAIN:
      case CV_TRAIN:
	strcat(tmp_error_fname_space, nn_params.ext_train);
	break;
      case CLASS_TRAIN:
	strcat(tmp_error_fname_space, nn_params.ext_test_train);
	break;
      case CLASS_EVAL:
	strcat(tmp_error_fname_space, nn_params.ext_eval);
	break;
      case CLASS_TEST:
	strcat(tmp_error_fname_space, nn_params.ext_test);
	break;
    }
    error_fname = tmp_error_fname_space;
    plot_exp_path = nn_params.exp_path;
    mac_rejectlines_fname = "reject.mac";
    noutputs = nn_params.noutputs;
}

void
read_reject_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    plot_reject_fname  = reject_plot_label = NULL;
    /* these flags are reset each time they are used */
    plot_exp_path = error_fname = mac_rejectlines_fname = NULL;
    no_graphics = 0;
    mac_reject_flag = 0;
    sum_to_one = 0;

    if(argc > 0){
	argc = nnargs(argc, argv, reject_argtab, REJECT_TABSIZE);
    } else {
	verbose = 1;
    }
    plot_reject_fname = strcpy_empty_if_null(reject_plot_ftmp, plot_reject_fname);
    reject_plot_label = strcpy_empty_if_null(reject_plot_lbl_tmp, reject_plot_label);
}

void
write_reject_defaults(default_file)
     FILE *default_file;
{
    plot_reject_fname = null_if_empty_string(plot_reject_fname);
    reject_plot_label = null_if_empty_string(reject_plot_label);
    plot_exp_path = null_if_empty_string(plot_exp_path);
    error_fname = null_if_empty_string(error_fname);
    mac_rejectlines_fname = null_if_empty_string(mac_rejectlines_fname);

    if(default_file != NULL){
	fprintf(default_file, "%s %s", "reject",
		nnargs_get_flags(reject_argtab, REJECT_TABSIZE));
    }
}
