/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * struct_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `struct.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "struct_ui.h"
#include "../gnn/nn_params.h"
#include "../gnn/galgs.h"
#include "../LNKnet_subs.h"
#include <nnlib.h>
#include <plot_struct.h>

extern	struct_struct_pop_objects	*Struct_struct_pop;

#define MAXSTR 256
static char struct_plot_ftmp[MAXSTR];

/* definitions for extra arguments */
static float struct_threshold = 0.;
static int struct_max_line_width = 10;
static int struct_scale_by_weight = 0;
static int struct_show_bias = 0;
static int struct_use_threshold = 0;
static int black_and_white = 0;

void struct_set_common_flags();
void g_set_struct_use_threshold();
void g_set_struct_threshold();
void g_set_struct_show_weight();

void
g_init_struct()
{
    nn_params.struct_fname = struct_plot_ftmp;
}

void
g_display_struct()
{
    show_string_label (Struct_struct_pop->struct_plot_file, struct_plot_fname);
    show_int_value (Struct_struct_pop->struct_autoscale, struct_autoscale);
    show_int_value (Struct_struct_pop->struct_no_text, struct_no_text);
    show_int_value (Struct_struct_pop->struct_show_weight,
		   struct_scale_by_weight);
    g_set_struct_show_weight();
    show_int_text(Struct_struct_pop->struct_max_line, struct_max_line_width);
    show_float_text(Struct_struct_pop->struct_threshold, struct_threshold);
    show_int_value (Struct_struct_pop->struct_use_threshold,
		    struct_use_threshold);
    g_set_struct_use_threshold();
    show_int_value(Struct_struct_pop->struct_display_bias, struct_show_bias);
    show_int_value(Struct_struct_pop->black_and_white, black_and_white);
}

/*
 * Notify callback function for struct plot text
 */
Panel_setting
struct_text_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    struct_struct_pop_objects *ip =
      (struct_struct_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if (item == ip->struct_threshold){
	g_set_struct_threshold(value);
    } else if (item == ip->struct_max_line){
	struct_max_line_width = set_atoi_value(value, "max_line_width",
					       item, struct_max_line_width);
    } else {
	fprintf(stderr,
		"LNKnet: struct_text_handler: unhandled text: value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for struct settings
 */
void
struct_select_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    struct_struct_pop_objects *ip =
      (struct_struct_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->struct_no_text){
	struct_no_text = value;
    } else if(item == ip->struct_use_threshold){
	struct_use_threshold = value;
	g_set_struct_use_threshold();
    } else if(item == ip->struct_autoscale){
	struct_autoscale = value;
    } else if(item == ip->struct_show_weight){
	struct_scale_by_weight = value;
	g_set_struct_show_weight();
    } else if(item == ip->struct_display_bias){
	struct_show_bias = value;
    } else if (item == ip->black_and_white){
	black_and_white = value;
    } else {
	fputs("LNKnet: struct_select_handler: unhandled setting\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    value >>= 1;
	}
    }
}

void
create_struct_plot_fname()
{
    strcpy(struct_plot_ftmp, nn_params.exp_name);
    struct_plot_fname=strcat(struct_plot_ftmp, ".struct.plot");
    show_string_label(Struct_struct_pop->struct_plot_file, struct_plot_fname);
    nn_params.struct_fname = struct_plot_fname;
    print_set_struct_status();
}

void
g_set_struct_use_threshold()
{
    if(struct_use_threshold){
	gray_out_item(Struct_struct_pop->struct_threshold, FALSE);
	g_set_struct_threshold((char *)xv_get(Struct_struct_pop->struct_threshold,
				      PANEL_VALUE));
    } else {
	struct_threshold = 0;
	gray_out_item(Struct_struct_pop->struct_threshold, TRUE);
    }
}

void    
g_set_struct_threshold(value)
     char *value;
{
    struct_threshold =
      set_atof_value(value, "struct_threshold",
		     Struct_struct_pop->struct_threshold,
		     struct_threshold);
}

void
g_set_struct_show_weight()
{
    if(struct_scale_by_weight){
	gray_out_item(Struct_struct_pop->struct_max_line, FALSE);
	gray_out_item(Struct_struct_pop->black_and_white, FALSE);
    } else {
	gray_out_item(Struct_struct_pop->struct_max_line, TRUE);
	gray_out_item(Struct_struct_pop->black_and_white, TRUE);
    }
}

void
store_struct_plot_command(shell_file)
     FILE *shell_file;
{
    extern char plot_command_line[];
    int algorithm;
    void g_store_plot_command();
    void g_get_test_args();

    struct_set_common_flags();
    if(nn_params.store_only) no_graphics = 1;
    else no_graphics = 0;
    algorithm = g_get_alg();

    store_plot_start(shell_file);
    sprintf(plot_command_line, "plot_%s %s", nn_params.classifier_name,
	    nnargs_get_flags(struct_plot_argtab, STRUCT_PLOT_TABSIZE));
    *strrchr(plot_command_line, '\n') = ' ';

    if(algorithm == GAUSS){
	fprintf(shell_file, "%s", plot_command_line);
    } else {
	if(algorithm == BINTREE){
	    fprintf(shell_file, "%s", plot_command_line);
	    g_get_test_args(shell_file); /* get extra arguments */
	} else {
	    sprintf(plot_command_line, "%s \\\n -threshold %f ",
		    plot_command_line, struct_threshold);
	    if(struct_scale_by_weight)
	      sprintf(plot_command_line,
		      "%s -show_weight_magnitude -max_line_width %d ",
		      plot_command_line, struct_max_line_width);
	    if(algorithm == MLP)
	      if(struct_show_bias)
		sprintf(plot_command_line, "%s -show_bias ",
			plot_command_line);
	    if(black_and_white)
	      sprintf(plot_command_line, "%s -bw", plot_command_line);
	    fprintf(shell_file, "%s", plot_command_line);
	}
    }
    store_plot_end(shell_file);
}

void
struct_set_common_flags()
{
    struct_param_fname = nn_params.param_fname;
    struct_defaults_fname =
      path_build(nn_params.data_path, nn_params.desc_fname);
}

/* defaults file arguments, table, and routines */
static int struct_no_text_arg = 0;
/* other arguments are defined above */

static ARG structtab[] =
{
    {"struct_no_text", INT, &struct_no_text_arg, ""},
    {"struct_threshold", FLOAT, (int *)&struct_threshold, ""},
    {"struct_use_threshold", INT, &struct_use_threshold, ""},
    {"struct_show_bias", INT, &struct_show_bias, ""},
    {"struct_scale_by_weight", INT, &struct_scale_by_weight, ""},
    {"struct_max_line_width", INT, &struct_max_line_width, ""},
    {"black_and_white", FLAG, &black_and_white, ""},
};
#define TABSIZE (sizeof(structtab)/sizeof(ARG))

void
read_struct_defaults(argc, argv)
     int argc;
     char **argv;
{
    /* clear flags that are not present in the defaults file if they
       are not "set" */
    struct_plot_fname = struct_defaults_fname = struct_param_fname = NULL;
    struct_autoscale = 0;
    black_and_white = 0;

    if(argc > 0){
	argc = nnargs_part(argc, argv, structtab, TABSIZE);
	argc = nnargs(argc, argv, struct_plot_argtab, STRUCT_PLOT_TABSIZE);
    } else {
	struct_no_text_arg = 0;
	struct_autoscale = 1;
    }
    struct_no_text = struct_no_text_arg;
    struct_plot_fname =
      strcpy_empty_if_null(struct_plot_ftmp, struct_plot_fname);
}

void
write_struct_defaults(default_file)
     FILE *default_file;
{
    struct_no_text_arg = struct_no_text;
    struct_defaults_fname =
      path_build(nn_params.data_path, nn_params.desc_fname);
    struct_plot_fname = null_if_empty_string(struct_plot_ftmp);

    /* set in struct_set_common_flags */
    struct_param_fname = null_if_empty_string(struct_param_fname);

    if(default_file != NULL){
	fprintf(default_file, "%s %s", "struct",
		nnargs_get_part_flags(structtab, TABSIZE));
	fprintf(default_file, "%s",
		nnargs_get_flags(struct_plot_argtab, STRUCT_PLOT_TABSIZE));
    }
}
