/*
 * gmap_ui.c - User interface object initialization functions.
 * This file was generated by `gxv' from `gmap.G'.
 * DO NOT EDIT BY HAND.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include <gcm.h>
#include "gmap_ui.h"

/*
 * Create object `quit_menu' in the specified instance.
 */
Xv_opaque
gmap_quit_menu_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern Menu_item	confirm_handler();
	Xv_opaque	obj;
	
	obj = xv_create(XV_NULL, MENU_COMMAND_MENU,
		XV_KEY_DATA, INSTANCE, ip,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "CANCEL",
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "CONFIRM",
			MENU_GEN_PROC, confirm_handler,
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `mappers' in the specified instance.
 */
Xv_opaque
gmap_mappers_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern Menu_item	alg_mlpm_handler();
	extern Menu_item	alg_rbfm_handler();
	extern Menu_item	alg_irbfm_handler();
	Xv_opaque	obj;
	
	obj = xv_create(XV_NULL, MENU_CHOICE_MENU,
		XV_KEY_DATA, INSTANCE, ip,
		MENU_TITLE_ITEM, "Mapping",
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "MLPM (Multi-Layer Perceptron)",
			MENU_GEN_PROC, alg_mlpm_handler,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "RBFM (Radial Basis Function)",
			MENU_GEN_PROC, alg_rbfm_handler,
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "IRBFM (Incremental RBF)",
			MENU_GEN_PROC, alg_irbfm_handler,
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `clusters' in the specified instance.
 */
Xv_opaque
gmap_clusters_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	extern Menu_item	alg_kmeansm_handler();
	Xv_opaque	obj;
	
	obj = xv_create(XV_NULL, MENU_COMMAND_MENU,
		XV_KEY_DATA, INSTANCE, ip,
		MENU_TITLE_ITEM, "Clusters",
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "KMEANSM (K Means Clustering)",
			MENU_GEN_PROC, alg_kmeansm_handler,
			NULL,
		MENU_GEN_PIN_WINDOW, owner, "Clusters",
		NULL);
	return obj;
}

/*
 * Create object `alg_groups' in the specified instance.
 */
Xv_opaque
gmap_alg_groups_create(ip, owner)
	caddr_t		ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(XV_NULL, MENU_COMMAND_MENU,
		XV_KEY_DATA, INSTANCE, ip,
		MENU_TITLE_ITEM, "Algorithm Groups",
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Mapping",
			MENU_PULLRIGHT, gmap_mappers_create(ip, owner),
			NULL,
		MENU_ITEM,
			XV_KEY_DATA, INSTANCE, ip,
			MENU_STRING, "Clustering",
			MENU_PULLRIGHT, gmap_clusters_create(ip, owner),
			NULL,
		MENU_GEN_PIN_WINDOW, owner, "Algorithm Groups",
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `window1'.
 */
gmap_window1_objects *
gmap_window1_objects_initialize(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_window1_objects *) calloc(1, sizeof (gmap_window1_objects))))
		return (gmap_window1_objects *) NULL;
	if (!ip->window1)
		ip->window1 = gmap_window1_window1_create(ip, owner);
	if (!ip->base_controls)
		ip->base_controls = gmap_window1_base_controls_create(ip, ip->window1);
	if (!ip->quit)
		ip->quit = gmap_window1_quit_create(ip, ip->base_controls);
	if (!ip->save_defaults)
		ip->save_defaults = gmap_window1_save_defaults_create(ip, ip->base_controls);
	if (!ip->algorithms)
		ip->algorithms = gmap_window1_algorithms_create(ip, ip->base_controls);
	if (!ip->algorithm_sel)
		ip->algorithm_sel = gmap_window1_algorithm_sel_create(ip, ip->base_controls);
	if (!ip->control_experiment_header)
		ip->control_experiment_header = gmap_window1_control_experiment_header_create(ip, ip->base_controls);
	if (!ip->algorithm_parameters)
		ip->algorithm_parameters = gmap_window1_algorithm_parameters_create(ip, ip->base_controls);
	if (!ip->start_run)
		ip->start_run = gmap_window1_start_run_create(ip, ip->base_controls);
	if (!ip->stop_run)
		ip->stop_run = gmap_window1_stop_run_create(ip, ip->base_controls);
	if (!ip->feature_select)
		ip->feature_select = gmap_window1_feature_select_create(ip, ip->base_controls);
	if (!ip->Continue)
		ip->Continue = gmap_window1_Continue_create(ip, ip->base_controls);
	if (!ip->plot_only)
		ip->plot_only = gmap_window1_plot_only_create(ip, ip->base_controls);
	if (!ip->file_button)
		ip->file_button = gmap_window1_file_button_create(ip, ip->base_controls);
	if (!ip->store_only)
		ip->store_only = gmap_window1_store_only_create(ip, ip->base_controls);
	if (!ip->normalize)
		ip->normalize = gmap_window1_normalize_create(ip, ip->base_controls);
	if (!ip->exper_msg1)
		ip->exper_msg1 = gmap_window1_exper_msg1_create(ip, ip->base_controls);
	if (!ip->norm_file)
		ip->norm_file = gmap_window1_norm_file_create(ip, ip->base_controls);
	if (!ip->train_select1)
		ip->train_select1 = gmap_window1_train_select1_create(ip, ip->base_controls);
	if (!ip->train_select2)
		ip->train_select2 = gmap_window1_train_select2_create(ip, ip->base_controls);
	if (!ip->experiment_name)
		ip->experiment_name = gmap_window1_experiment_name_create(ip, ip->base_controls);
	if (!ip->experiment_number)
		ip->experiment_number = gmap_window1_experiment_number_create(ip, ip->base_controls);
	if (!ip->auto_inc)
		ip->auto_inc = gmap_window1_auto_inc_create(ip, ip->base_controls);
	if (!ip->train_select3)
		ip->train_select3 = gmap_window1_train_select3_create(ip, ip->base_controls);
	if (!ip->restore_defaults)
		ip->restore_defaults = gmap_window1_restore_defaults_create(ip, ip->base_controls);
	if (!ip->random_flag)
		ip->random_flag = gmap_window1_random_flag_create(ip, ip->base_controls);
	if (!ip->enable_plotting)
		ip->enable_plotting = gmap_window1_enable_plotting_create(ip, ip->base_controls);
	if (!ip->plots)
		ip->plots = gmap_window1_plots_create(ip, ip->base_controls);
	if (!ip->seed)
		ip->seed = gmap_window1_seed_create(ip, ip->base_controls);
	if (!ip->cvtest_flag)
		ip->cvtest_flag = gmap_window1_cvtest_flag_create(ip, ip->base_controls);
	if (!ip->cv_from_file)
		ip->cv_from_file = gmap_window1_cv_from_file_create(ip, ip->base_controls);
	if (!ip->cross_valid)
		ip->cross_valid = gmap_window1_cross_valid_create(ip, ip->base_controls);
	if (!ip->ext_cv)
		ip->ext_cv = gmap_window1_ext_cv_create(ip, ip->base_controls);
	if (!ip->epoch_plots)
		ip->epoch_plots = gmap_window1_epoch_plots_create(ip, ip->base_controls);
	if (!ip->e_per_plot)
		ip->e_per_plot = gmap_window1_e_per_plot_create(ip, ip->base_controls);
	if (!ip->warning_message)
		ip->warning_message = gmap_window1_warning_message_create(ip, ip->base_controls);
	return ip;
}

/*
 * Create object `window1' in the specified instance.
 */
Xv_opaque
gmap_window1_window1_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	Xv_opaque		window1_image;
	static unsigned short	window1_bits[] = {
#include "lnkmap.icon"
	};
	
	window1_image = xv_create(XV_NULL, SERVER_IMAGE,
		SERVER_IMAGE_DEPTH, 1,
		SERVER_IMAGE_BITS, window1_bits,
		XV_WIDTH, 64,
		XV_HEIGHT, 64,
		NULL);
	obj = xv_create(owner, FRAME,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 577,
		XV_HEIGHT, 451,
		XV_LABEL, "LNKmap v1 10/92",
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_ICON, xv_create(XV_NULL, ICON,
			ICON_IMAGE, window1_image,
			NULL),
		NULL);
	return obj;
}

/*
 * Create object `base_controls' in the specified instance.
 */
Xv_opaque
gmap_window1_base_controls_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "White", NULL);
	return obj;
}

/*
 * Create object `quit' in the specified instance.
 */
Xv_opaque
gmap_window1_quit_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 12,
		PANEL_ITEM_COLOR, gcm_color_index("red"),
		PANEL_LABEL_STRING, "QUIT  ",
		PANEL_ITEM_MENU, gmap_quit_menu_create((caddr_t) ip, ip->window1),
		NULL);
	return obj;
}

/*
 * Create object `save_defaults' in the specified instance.
 */
Xv_opaque
gmap_window1_save_defaults_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		save_defaults_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 96,
		XV_Y, 12,
		PANEL_LABEL_STRING, "SAVE DEFAULTS",
		PANEL_NOTIFY_PROC, save_defaults_handler,
		NULL);
	return obj;
}

/*
 * Create object `algorithms' in the specified instance.
 */
Xv_opaque
gmap_window1_algorithms_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 252,
		XV_Y, 12,
		PANEL_LABEL_STRING, "ALGORITHM",
		PANEL_ITEM_MENU, gmap_alg_groups_create((caddr_t) ip, ip->window1),
		NULL);
	return obj;
}

/*
 * Create object `algorithm_sel' in the specified instance.
 */
Xv_opaque
gmap_window1_algorithm_sel_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_HELP_DATA, "gmap:algorithm_sel",
		XV_X, 364,
		XV_Y, 18,
		PANEL_LABEL_STRING, "Selected Algorithm",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `control_experiment_header' in the specified instance.
 */
Xv_opaque
gmap_window1_control_experiment_header_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 40,
		PANEL_LABEL_STRING, "CONTROL EXPERIMENT:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `algorithm_parameters' in the specified instance.
 */
Xv_opaque
gmap_window1_algorithm_parameters_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		algorithm_parameters_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_HELP_DATA, "gmap:algorithm_parameters",
		XV_X, 252,
		XV_Y, 40,
		PANEL_LABEL_STRING, "Algorithm Params . . .",
		PANEL_NOTIFY_PROC, algorithm_parameters_handler,
		NULL);
	return obj;
}

/*
 * Create object `start_run' in the specified instance.
 */
Xv_opaque
gmap_window1_start_run_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		start_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 4,
		XV_Y, 56,
		PANEL_LABEL_STRING, "START New Exper.",
		PANEL_NOTIFY_PROC, start_handler,
		NULL);
	return obj;
}

/*
 * Create object `stop_run' in the specified instance.
 */
Xv_opaque
gmap_window1_stop_run_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		stop_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 136,
		XV_Y, 56,
		PANEL_LABEL_STRING, "STOP Exper.",
		PANEL_NOTIFY_PROC, stop_handler,
		NULL);
	return obj;
}

/*
 * Create object `feature_select' in the specified instance.
 */
Xv_opaque
gmap_window1_feature_select_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		gmap_window1_feature_select_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 252,
		XV_Y, 76,
		PANEL_LABEL_STRING, "Feature Params . . .",
		PANEL_NOTIFY_PROC, gmap_window1_feature_select_notify_callback,
		NULL);
	return obj;
}

/*
 * Create object `Continue' in the specified instance.
 */
Xv_opaque
gmap_window1_Continue_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		continue_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_HELP_DATA, "gmap:Continue",
		XV_X, 24,
		XV_Y, 80,
		PANEL_LABEL_STRING, "CONTINUE Current Exper.",
		PANEL_NOTIFY_PROC, continue_handler,
		NULL);
	return obj;
}

/*
 * Create object `plot_only' in the specified instance.
 */
Xv_opaque
gmap_window1_plot_only_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		plot_only_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 60,
		XV_Y, 104,
		PANEL_LABEL_STRING, "PLOT ONLY",
		PANEL_NOTIFY_PROC, plot_only_handler,
		NULL);
	return obj;
}

/*
 * Create object `file_button' in the specified instance.
 */
Xv_opaque
gmap_window1_file_button_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		gmap_window1_file_button_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 252,
		XV_Y, 112,
		PANEL_LABEL_STRING, "Files . . .",
		PANEL_NOTIFY_PROC, gmap_window1_file_button_notify_callback,
		NULL);
	return obj;
}

/*
 * Create object `store_only' in the specified instance.
 */
Xv_opaque
gmap_window1_store_only_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		store_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 128,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, store_handler,
		PANEL_CHOICE_STRING, 0, "Only store shell script, do not run",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `normalize' in the specified instance.
 */
Xv_opaque
gmap_window1_normalize_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		normalize_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE, PANEL_DISPLAY_LEVEL, PANEL_CURRENT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 252,
		XV_Y, 144,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_LABEL_STRING, "Normalization:",
		PANEL_NOTIFY_PROC, normalize_handler,
		PANEL_CHOICE_STRINGS,
			"None",
			"Simple (mean=0, variance=1)",
			"Principal Components (PC)",
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `exper_msg1' in the specified instance.
 */
Xv_opaque
gmap_window1_exper_msg1_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 152,
		PANEL_LABEL_STRING, "EXPERIMENT",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `norm_file' in the specified instance.
 */
Xv_opaque
gmap_window1_norm_file_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_fname_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 252,
		XV_Y, 168,
		PANEL_VALUE_DISPLAY_LENGTH, 24,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Norm. File:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_fname_handler,
		NULL);
	return obj;
}

/*
 * Create object `train_select1' in the specified instance.
 */
Xv_opaque
gmap_window1_train_select1_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		train1_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 176,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, train1_handler,
		PANEL_CHOICE_STRING, 0, "Train",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `train_select2' in the specified instance.
 */
Xv_opaque
gmap_window1_train_select2_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		train2_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 200,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, train2_handler,
		PANEL_CHOICE_STRING, 0, "Test on Training Data",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `experiment_name' in the specified instance.
 */
Xv_opaque
gmap_window1_experiment_name_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	experiment_name_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 252,
		XV_Y, 200,
		PANEL_VALUE_DISPLAY_LENGTH, 7,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Exper. Name:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, experiment_name_handler,
		NULL);
	return obj;
}

/*
 * Create object `experiment_number' in the specified instance.
 */
Xv_opaque
gmap_window1_experiment_number_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	experiment_number_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 416,
		XV_Y, 200,
		PANEL_VALUE_DISPLAY_LENGTH, 5,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Number:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 100000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, experiment_number_handler,
		NULL);
	return obj;
}

/*
 * Create object `auto_inc' in the specified instance.
 */
Xv_opaque
gmap_window1_auto_inc_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		auto_inc_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 288,
		XV_Y, 216,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_NOTIFY_PROC, auto_inc_handler,
		PANEL_CHOICE_STRING, 0, "Auto-increment experiment number",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `train_select3' in the specified instance.
 */
Xv_opaque
gmap_window1_train_select3_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		train3_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 224,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, train3_handler,
		PANEL_CHOICE_STRINGS,
			"Eval",
			"Test",
			NULL,
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `restore_defaults' in the specified instance.
 */
Xv_opaque
gmap_window1_restore_defaults_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		restore_defaults_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 256,
		XV_Y, 248,
		PANEL_LABEL_STRING, "Restore Experiment Screens",
		PANEL_NOTIFY_PROC, restore_defaults_handler,
		NULL);
	return obj;
}

/*
 * Create object `random_flag' in the specified instance.
 */
Xv_opaque
gmap_window1_random_flag_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		random_flag_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 248,
		XV_Y, 272,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, random_flag_handler,
		PANEL_CHOICE_STRING, 0, "Random presentation order",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `enable_plotting' in the specified instance.
 */
Xv_opaque
gmap_window1_enable_plotting_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		enable_plotting_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 280,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, enable_plotting_handler,
		PANEL_CHOICE_STRING, 0, "Enable Plotting",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `plots' in the specified instance.
 */
Xv_opaque
gmap_window1_plots_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		gmap_window1_plots_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 152,
		XV_Y, 280,
		PANEL_LABEL_STRING, "Plots . . .",
		PANEL_NOTIFY_PROC, gmap_window1_plots_notify_callback,
		NULL);
	return obj;
}

/*
 * Create object `seed' in the specified instance.
 */
Xv_opaque
gmap_window1_seed_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	seed_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 248,
		XV_Y, 296,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Seed:  ",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 10000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, seed_handler,
		NULL);
	return obj;
}

/*
 * Create object `cvtest_flag' in the specified instance.
 */
Xv_opaque
gmap_window1_cvtest_flag_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		cvtest_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 304,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, cvtest_handler,
		PANEL_CHOICE_STRING, 0, "N-fold Cross-Validation",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `cv_from_file' in the specified instance.
 */
Xv_opaque
gmap_window1_cv_from_file_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		cv_from_file_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 328,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_CHOOSE_NONE, FALSE,
		PANEL_NOTIFY_PROC, cv_from_file_handler,
		PANEL_CHOICE_STRINGS,
			"Autosplit",
			"From file",
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `cross_valid' in the specified instance.
 */
Xv_opaque
gmap_window1_cross_valid_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cross_valid_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 108,
		XV_Y, 332,
		PANEL_VALUE_DISPLAY_LENGTH, 3,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Folds:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 10000,
		PANEL_MIN_VALUE, 2,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cross_valid_handler,
		NULL);
	return obj;
}

/*
 * Create object `ext_cv' in the specified instance.
 */
Xv_opaque
gmap_window1_ext_cv_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	ext_cv_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 108,
		XV_Y, 352,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "File Extens.:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, ext_cv_handler,
		NULL);
	return obj;
}

/*
 * Create object `epoch_plots' in the specified instance.
 */
Xv_opaque
gmap_window1_epoch_plots_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern void		epoch_plots_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 384,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, epoch_plots_handler,
		PANEL_CHOICE_STRING, 0, "Store periodic training plots",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `e_per_plot' in the specified instance.
 */
Xv_opaque
gmap_window1_e_per_plot_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	e_per_plot_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 56,
		XV_Y, 408,
		PANEL_VALUE_DISPLAY_LENGTH, 3,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Epochs per Plot:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 100,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, e_per_plot_handler,
		NULL);
	return obj;
}

/*
 * Create object `warning_message' in the specified instance.
 */
Xv_opaque
gmap_window1_warning_message_create(ip, owner)
	gmap_window1_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 432,
		PANEL_LABEL_STRING, "NOTE: Entries in text fields MUST be followed by <Return> or <Tab>",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `clus_plot'.
 */
gmap_clus_plot_objects *
gmap_clus_plot_objects_initialize(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_clus_plot_objects *) calloc(1, sizeof (gmap_clus_plot_objects))))
		return (gmap_clus_plot_objects *) NULL;
	if (!ip->clus_plot)
		ip->clus_plot = gmap_clus_plot_clus_plot_create(ip, owner);
	if (!ip->clus_plot_controls)
		ip->clus_plot_controls = gmap_clus_plot_clus_plot_controls_create(ip, ip->clus_plot);
	if (!ip->clus_plot_file)
		ip->clus_plot_file = gmap_clus_plot_clus_plot_file_create(ip, ip->clus_plot_controls);
	if (!ip->clus_dim_range)
		ip->clus_dim_range = gmap_clus_plot_clus_dim_range_create(ip, ip->clus_plot_controls);
	if (!ip->clus_dim_1)
		ip->clus_dim_1 = gmap_clus_plot_clus_dim_1_create(ip, ip->clus_plot_controls);
	if (!ip->clus_dim_2)
		ip->clus_dim_2 = gmap_clus_plot_clus_dim_2_create(ip, ip->clus_plot_controls);
	if (!ip->clus_other_vars)
		ip->clus_other_vars = gmap_clus_plot_clus_other_vars_create(ip, ip->clus_plot_controls);
	if (!ip->clus_npoints)
		ip->clus_npoints = gmap_clus_plot_clus_npoints_create(ip, ip->clus_plot_controls);
	if (!ip->clus_autoscale)
		ip->clus_autoscale = gmap_clus_plot_clus_autoscale_create(ip, ip->clus_plot_controls);
	if (!ip->clus_axes_limits)
		ip->clus_axes_limits = gmap_clus_plot_clus_axes_limits_create(ip, ip->clus_plot_controls);
	if (!ip->clus_xmin)
		ip->clus_xmin = gmap_clus_plot_clus_xmin_create(ip, ip->clus_plot_controls);
	if (!ip->clus_ymin)
		ip->clus_ymin = gmap_clus_plot_clus_ymin_create(ip, ip->clus_plot_controls);
	if (!ip->clus_xmax)
		ip->clus_xmax = gmap_clus_plot_clus_xmax_create(ip, ip->clus_plot_controls);
	if (!ip->clus_ymax)
		ip->clus_ymax = gmap_clus_plot_clus_ymax_create(ip, ip->clus_plot_controls);
	if (!ip->clus_xstep)
		ip->clus_xstep = gmap_clus_plot_clus_xstep_create(ip, ip->clus_plot_controls);
	if (!ip->clus_ystep)
		ip->clus_ystep = gmap_clus_plot_clus_ystep_create(ip, ip->clus_plot_controls);
	if (!ip->clus_no_norm)
		ip->clus_no_norm = gmap_clus_plot_clus_no_norm_create(ip, ip->clus_plot_controls);
	if (!ip->show_all_check_box)
		ip->show_all_check_box = gmap_clus_plot_show_all_check_box_create(ip, ip->clus_plot_controls);
	if (!ip->distance_limit)
		ip->distance_limit = gmap_clus_plot_distance_limit_create(ip, ip->clus_plot_controls);
	if (!ip->internals)
		ip->internals = gmap_clus_plot_internals_create(ip, ip->clus_plot_controls);
	if (!ip->internals_level)
		ip->internals_level = gmap_clus_plot_internals_level_create(ip, ip->clus_plot_controls);
	if (!ip->internals_scale)
		ip->internals_scale = gmap_clus_plot_internals_scale_create(ip, ip->clus_plot_controls);
	if (!ip->clus_plot_label)
		ip->clus_plot_label = gmap_clus_plot_clus_plot_label_create(ip, ip->clus_plot_controls);
	return ip;
}

/*
 * Create object `clus_plot' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_plot_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 414,
		XV_HEIGHT, 583,
		XV_LABEL, "Cluster Plot Parameters",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `clus_plot_controls' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_plot_controls_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "Light Gray", NULL);
	return obj;
}

/*
 * Create object `clus_plot_file' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_plot_file_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_plot_file_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 8,
		PANEL_VALUE_DISPLAY_LENGTH, 30,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Plot file name:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_plot_file_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_dim_range' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_dim_range_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 32,
		PANEL_LABEL_STRING, "Input Dimensions to Plot:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `clus_dim_1' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_dim_1_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 36,
		XV_Y, 56,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Horizontal (X) Dimension:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 100,
		PANEL_MIN_VALUE, 1,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `clus_dim_2' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_dim_2_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_dim_2_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 36,
		XV_Y, 80,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Vertical (Y) Dimension;",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 100,
		PANEL_MIN_VALUE, 1,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_dim_2_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_other_vars' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_other_vars_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_other_vars_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 104,
		PANEL_VALUE_DISPLAY_LENGTH, 41,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Settings for Other Dimensions (include X and Y)",
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_other_vars_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_npoints' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_npoints_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_npoints_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 20,
		XV_Y, 160,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Number of Points per Dimension:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 1000,
		PANEL_MIN_VALUE, 1,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_npoints_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_autoscale' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_autoscale_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern void		clus_autoscale_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 184,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, clus_autoscale_handler,
		PANEL_CHOICE_STRING, 0, "Autoscale Plot",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `clus_axes_limits' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_axes_limits_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 212,
		PANEL_LABEL_STRING, "Axes Limits:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `clus_xmin' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_xmin_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_xmin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 236,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_xmin_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_ymin' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_ymin_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_ymin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 160,
		XV_Y, 236,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_ymin_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_xmax' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_xmax_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_xmax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 260,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_xmax_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_ymax' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_ymax_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_ymax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 160,
		XV_Y, 260,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_ymax_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_xstep' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_xstep_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_xstep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 284,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_xstep_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_ystep' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_ystep_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_ystep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 160,
		XV_Y, 284,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_ystep_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_no_norm' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_no_norm_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern void		clus_no_norm_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 312,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, clus_no_norm_handler,
		PANEL_CHOICE_STRING, 0, "Do Not Normalize Data for Plot",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `show_all_check_box' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_show_all_check_box_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern void		show_all_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 344,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, show_all_handler,
		PANEL_CHOICE_STRING, 0, "Show All Data Points",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `distance_limit' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_distance_limit_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	distance_limit_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 52,
		XV_Y, 372,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Show points at this distance limit:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, distance_limit_handler,
		NULL);
	return obj;
}

/*
 * Create object `internals' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_internals_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 400,
		PANEL_LABEL_STRING, "Internals:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `internals_level' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_internals_level_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	internals_level_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 424,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Level of Detail:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 10,
		PANEL_MIN_VALUE, 1,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, internals_level_handler,
		NULL);
	return obj;
}

/*
 * Create object `internals_scale' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_internals_scale_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	internals_scale_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 440,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Global Scale Factor:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, internals_scale_handler,
		NULL);
	return obj;
}

/*
 * Create object `clus_plot_label' in the specified instance.
 */
Xv_opaque
gmap_clus_plot_clus_plot_label_create(ip, owner)
	gmap_clus_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	clus_plot_label_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 472,
		PANEL_VALUE_DISPLAY_LENGTH, 45,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Region Plot Label:",
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, clus_plot_label_handler,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `feature_pop'.
 */
gmap_feature_pop_objects *
gmap_feature_pop_objects_initialize(ip, owner)
	gmap_feature_pop_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_feature_pop_objects *) calloc(1, sizeof (gmap_feature_pop_objects))))
		return (gmap_feature_pop_objects *) NULL;
	if (!ip->feature_pop)
		ip->feature_pop = gmap_feature_pop_feature_pop_create(ip, owner);
	if (!ip->feat_search_controls)
		ip->feat_search_controls = gmap_feature_pop_feat_search_controls_create(ip, ip->feature_pop);
	if (!ip->select_type)
		ip->select_type = gmap_feature_pop_select_type_create(ip, ip->feat_search_controls);
	if (!ip->select_n)
		ip->select_n = gmap_feature_pop_select_n_create(ip, ip->feat_search_controls);
	if (!ip->feature_list)
		ip->feature_list = gmap_feature_pop_feature_list_create(ip, ip->feat_search_controls);
	return ip;
}

/*
 * Create object `feature_pop' in the specified instance.
 */
Xv_opaque
gmap_feature_pop_feature_pop_create(ip, owner)
	gmap_feature_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 577,
		XV_HEIGHT, 107,
		XV_LABEL, "Feature Selection",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `feat_search_controls' in the specified instance.
 */
Xv_opaque
gmap_feature_pop_feat_search_controls_create(ip, owner)
	gmap_feature_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "white", NULL);
	return obj;
}

/*
 * Create object `select_type' in the specified instance.
 */
Xv_opaque
gmap_feature_pop_select_type_create(ip, owner)
	gmap_feature_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		select_type_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_CHOICE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 20,
		XV_Y, 12,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_CHOOSE_NONE, FALSE,
		PANEL_LABEL_STRING, "Selection Method",
		PANEL_NOTIFY_PROC, select_type_handler,
		PANEL_CHOICE_STRINGS,
			"All Features",
			"First N               ",
			"Check by Hand",
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `select_n' in the specified instance.
 */
Xv_opaque
gmap_feature_pop_select_n_create(ip, owner)
	gmap_feature_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 144,
		XV_Y, 56,
		PANEL_VALUE_DISPLAY_LENGTH, 5,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "N:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 100,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		NULL);
	return obj;
}

/*
 * Create object `feature_list' in the specified instance.
 */
Xv_opaque
gmap_feature_pop_feature_list_create(ip, owner)
	gmap_feature_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	feature_list_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 144,
		XV_Y, 80,
		PANEL_VALUE_DISPLAY_LENGTH, 38,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Features: (0,1,2)",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, feature_list_handler,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `norm_plot'.
 */
gmap_norm_plot_objects *
gmap_norm_plot_objects_initialize(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_norm_plot_objects *) calloc(1, sizeof (gmap_norm_plot_objects))))
		return (gmap_norm_plot_objects *) NULL;
	if (!ip->norm_plot)
		ip->norm_plot = gmap_norm_plot_norm_plot_create(ip, owner);
	if (!ip->norm_plot_controls)
		ip->norm_plot_controls = gmap_norm_plot_norm_plot_controls_create(ip, ip->norm_plot);
	if (!ip->norm_plot_file)
		ip->norm_plot_file = gmap_norm_plot_norm_plot_file_create(ip, ip->norm_plot_controls);
	if (!ip->norm_autoscale)
		ip->norm_autoscale = gmap_norm_plot_norm_autoscale_create(ip, ip->norm_plot_controls);
	if (!ip->norm_axes_limits)
		ip->norm_axes_limits = gmap_norm_plot_norm_axes_limits_create(ip, ip->norm_plot_controls);
	if (!ip->norm_xmin)
		ip->norm_xmin = gmap_norm_plot_norm_xmin_create(ip, ip->norm_plot_controls);
	if (!ip->norm_ymin)
		ip->norm_ymin = gmap_norm_plot_norm_ymin_create(ip, ip->norm_plot_controls);
	if (!ip->norm_xmax)
		ip->norm_xmax = gmap_norm_plot_norm_xmax_create(ip, ip->norm_plot_controls);
	if (!ip->norm_ymax)
		ip->norm_ymax = gmap_norm_plot_norm_ymax_create(ip, ip->norm_plot_controls);
	if (!ip->norm_xstep)
		ip->norm_xstep = gmap_norm_plot_norm_xstep_create(ip, ip->norm_plot_controls);
	if (!ip->norm_ystep)
		ip->norm_ystep = gmap_norm_plot_norm_ystep_create(ip, ip->norm_plot_controls);
	if (!ip->norm_plot_label)
		ip->norm_plot_label = gmap_norm_plot_norm_plot_label_create(ip, ip->norm_plot_controls);
	return ip;
}

/*
 * Create object `norm_plot' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_plot_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 384,
		XV_HEIGHT, 227,
		XV_LABEL, "PC Eigenvalue Plot Parameters",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `norm_plot_controls' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_plot_controls_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "Light Gray", NULL);
	return obj;
}

/*
 * Create object `norm_plot_file' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_plot_file_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_plot_file_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 12,
		PANEL_VALUE_DISPLAY_LENGTH, 30,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Plot file name:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_plot_file_handler,
		NULL);
	return obj;
}

/*
 * Create object `norm_autoscale' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_autoscale_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern void		norm_autoscale_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 40,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, norm_autoscale_handler,
		PANEL_CHOICE_STRING, 0, "Autoscale Plot",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `norm_axes_limits' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_axes_limits_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 72,
		PANEL_LABEL_STRING, "Axes Numeric Limits:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `norm_xmin' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_xmin_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_xmin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 104,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_xmin_handler,
		NULL);
	return obj;
}

/*
 * Create object `norm_ymin' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_ymin_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_ymin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 172,
		XV_Y, 104,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_ymin_handler,
		NULL);
	return obj;
}

/*
 * Create object `norm_xmax' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_xmax_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_xmax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 128,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_xmax_handler,
		NULL);
	return obj;
}

/*
 * Create object `norm_ymax' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_ymax_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_ymax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 172,
		XV_Y, 128,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_ymax_handler,
		NULL);
	return obj;
}

/*
 * Create object `norm_xstep' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_xstep_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_xstep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 154,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_xstep_handler,
		NULL);
	return obj;
}

/*
 * Create object `norm_ystep' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_ystep_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_ystep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 172,
		XV_Y, 154,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_ystep_handler,
		NULL);
	return obj;
}

/*
 * Create object `norm_plot_label' in the specified instance.
 */
Xv_opaque
gmap_norm_plot_norm_plot_label_create(ip, owner)
	gmap_norm_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	norm_plot_label_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 180,
		PANEL_VALUE_DISPLAY_LENGTH, 45,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Plot Label:",
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, norm_plot_label_handler,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `file_pop'.
 */
gmap_file_pop_objects *
gmap_file_pop_objects_initialize(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_file_pop_objects *) calloc(1, sizeof (gmap_file_pop_objects))))
		return (gmap_file_pop_objects *) NULL;
	if (!ip->file_pop)
		ip->file_pop = gmap_file_pop_file_pop_create(ip, owner);
	if (!ip->data_controls)
		ip->data_controls = gmap_file_pop_data_controls_create(ip, ip->file_pop);
	if (!ip->wdir_name)
		ip->wdir_name = gmap_file_pop_wdir_name_create(ip, ip->data_controls);
	if (!ip->exper_msg)
		ip->exper_msg = gmap_file_pop_exper_msg_create(ip, ip->data_controls);
	if (!ip->experiment_path)
		ip->experiment_path = gmap_file_pop_experiment_path_create(ip, ip->data_controls);
	if (!ip->report_verbosity)
		ip->report_verbosity = gmap_file_pop_report_verbosity_create(ip, ip->data_controls);
	if (!ip->model_file)
		ip->model_file = gmap_file_pop_model_file_create(ip, ip->data_controls);
	if (!ip->verror)
		ip->verror = gmap_file_pop_verror_create(ip, ip->data_controls);
	if (!ip->error_file)
		ip->error_file = gmap_file_pop_error_file_create(ip, ip->data_controls);
	if (!ip->debug_verbosity)
		ip->debug_verbosity = gmap_file_pop_debug_verbosity_create(ip, ip->data_controls);
	if (!ip->shell_file)
		ip->shell_file = gmap_file_pop_shell_file_create(ip, ip->data_controls);
	if (!ip->log_file)
		ip->log_file = gmap_file_pop_log_file_create(ip, ip->data_controls);
	if (!ip->screen_file)
		ip->screen_file = gmap_file_pop_screen_file_create(ip, ip->data_controls);
	if (!ip->run_time_system)
		ip->run_time_system = gmap_file_pop_run_time_system_create(ip, ip->data_controls);
	if (!ip->controls1)
		ip->controls1 = gmap_file_pop_controls1_create(ip, ip->file_pop);
	if (!ip->data_msg)
		ip->data_msg = gmap_file_pop_data_msg_create(ip, ip->controls1);
	if (!ip->data_path)
		ip->data_path = gmap_file_pop_data_path_create(ip, ip->controls1);
	if (!ip->standard_data_list)
		ip->standard_data_list = gmap_file_pop_standard_data_list_create(ip, ip->controls1);
	if (!ip->add_data)
		ip->add_data = gmap_file_pop_add_data_create(ip, ip->controls1);
	if (!ip->delete_data)
		ip->delete_data = gmap_file_pop_delete_data_create(ip, ip->controls1);
	if (!ip->data_file)
		ip->data_file = gmap_file_pop_data_file_create(ip, ip->controls1);
	if (!ip->filename_msg2)
		ip->filename_msg2 = gmap_file_pop_filename_msg2_create(ip, ip->controls1);
	if (!ip->patterns_msg_header2)
		ip->patterns_msg_header2 = gmap_file_pop_patterns_msg_header2_create(ip, ip->controls1);
	if (!ip->ext_train)
		ip->ext_train = gmap_file_pop_ext_train_create(ip, ip->controls1);
	if (!ip->npatterns_train)
		ip->npatterns_train = gmap_file_pop_npatterns_train_create(ip, ip->controls1);
	if (!ip->ext_eval)
		ip->ext_eval = gmap_file_pop_ext_eval_create(ip, ip->controls1);
	if (!ip->npatterns_eval)
		ip->npatterns_eval = gmap_file_pop_npatterns_eval_create(ip, ip->controls1);
	if (!ip->ext_test)
		ip->ext_test = gmap_file_pop_ext_test_create(ip, ip->controls1);
	if (!ip->npatterns_test)
		ip->npatterns_test = gmap_file_pop_npatterns_test_create(ip, ip->controls1);
	if (!ip->n_inputs)
		ip->n_inputs = gmap_file_pop_n_inputs_create(ip, ip->controls1);
	if (!ip->n_outputs)
		ip->n_outputs = gmap_file_pop_n_outputs_create(ip, ip->controls1);
	if (!ip->labels)
		ip->labels = gmap_file_pop_labels_create(ip, ip->controls1);
	return ip;
}

/*
 * Create object `file_pop' in the specified instance.
 */
Xv_opaque
gmap_file_pop_file_pop_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 601,
		XV_HEIGHT, 493,
		XV_LABEL, "Data Files",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `data_controls' in the specified instance.
 */
Xv_opaque
gmap_file_pop_data_controls_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, 175,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "Thistle", NULL);
	return obj;
}

/*
 * Create object `wdir_name' in the specified instance.
 */
Xv_opaque
gmap_file_pop_wdir_name_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	gmap_wdir_name_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 8,
		PANEL_VALUE_DISPLAY_LENGTH, 35,
		PANEL_VALUE_STORED_LENGTH, 256,
		PANEL_LABEL_STRING, "Current Directory:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_VALUE_UNDERLINED, FALSE,
		PANEL_VALUE, "/u/demo/lnknet",
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, gmap_wdir_name_handler,
		NULL);
	return obj;
}

/*
 * Create object `exper_msg' in the specified instance.
 */
Xv_opaque
gmap_file_pop_exper_msg_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 32,
		PANEL_LABEL_STRING, "Experiment Files:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `experiment_path' in the specified instance.
 */
Xv_opaque
gmap_file_pop_experiment_path_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	experiment_path_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 48,
		PANEL_VALUE_DISPLAY_LENGTH, 25,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Exper. Path:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, experiment_path_handler,
		NULL);
	return obj;
}

/*
 * Create object `report_verbosity' in the specified instance.
 */
Xv_opaque
gmap_file_pop_report_verbosity_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	report_verbosity_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 344,
		XV_Y, 48,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Report Verbosity:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 10,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, report_verbosity_handler,
		NULL);
	return obj;
}

/*
 * Create object `model_file' in the specified instance.
 */
Xv_opaque
gmap_file_pop_model_file_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	param_fname_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 64,
		PANEL_VALUE_DISPLAY_LENGTH, 20,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Parameter file:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, param_fname_handler,
		NULL);
	return obj;
}

/*
 * Create object `verror' in the specified instance.
 */
Xv_opaque
gmap_file_pop_verror_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	verror_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 344,
		XV_Y, 71,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Error File Verbosity:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 10,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, verror_handler,
		NULL);
	return obj;
}

/*
 * Create object `error_file' in the specified instance.
 */
Xv_opaque
gmap_file_pop_error_file_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	ename_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 80,
		PANEL_VALUE_DISPLAY_LENGTH, 19,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Error file prefix:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, ename_handler,
		NULL);
	return obj;
}

/*
 * Create object `debug_verbosity' in the specified instance.
 */
Xv_opaque
gmap_file_pop_debug_verbosity_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	debug_verbosity_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 344,
		XV_Y, 94,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Debug Verbosity:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 10,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, debug_verbosity_handler,
		NULL);
	return obj;
}

/*
 * Create object `shell_file' in the specified instance.
 */
Xv_opaque
gmap_file_pop_shell_file_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	shell_fname_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 96,
		PANEL_VALUE_DISPLAY_LENGTH, 24,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Shell file:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, shell_fname_handler,
		NULL);
	return obj;
}

/*
 * Create object `log_file' in the specified instance.
 */
Xv_opaque
gmap_file_pop_log_file_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	log_file_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 112,
		PANEL_VALUE_DISPLAY_LENGTH, 26,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Log file:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, log_file_handler,
		NULL);
	return obj;
}

/*
 * Create object `screen_file' in the specified instance.
 */
Xv_opaque
gmap_file_pop_screen_file_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	screen_file_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 128,
		PANEL_VALUE_DISPLAY_LENGTH, 26,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Screen file",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, screen_file_handler,
		NULL);
	return obj;
}

/*
 * Create object `run_time_system' in the specified instance.
 */
Xv_opaque
gmap_file_pop_run_time_system_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	run_time_system_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 152,
		PANEL_VALUE_DISPLAY_LENGTH, 12,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Optional Remote Server Name:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, run_time_system_handler,
		NULL);
	return obj;
}

/*
 * Create object `controls1' in the specified instance.
 */
Xv_opaque
gmap_file_pop_controls1_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, (int)xv_get(ip->data_controls, XV_Y) +
		      (int)xv_get(ip->data_controls, XV_HEIGHT),
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "Wheat", NULL);
	return obj;
}

/*
 * Create object `data_msg' in the specified instance.
 */
Xv_opaque
gmap_file_pop_data_msg_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 16,
		PANEL_LABEL_STRING, "Data Files:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `data_path' in the specified instance.
 */
Xv_opaque
gmap_file_pop_data_path_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	dpath_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 40,
		PANEL_VALUE_DISPLAY_LENGTH, 26,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Data Path:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, dpath_handler,
		NULL);
	return obj;
}

/*
 * Create object `standard_data_list' in the specified instance.
 */
Xv_opaque
gmap_file_pop_standard_data_list_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern int		standard_data_list_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_LIST,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 56,
		PANEL_LIST_WIDTH, 200,
		PANEL_LIST_DISPLAY_ROWS, 3,
		PANEL_LABEL_STRING, "STANDARD DATA SETS:",
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_CHOOSE_ONE, TRUE,
		PANEL_CHOOSE_NONE, TRUE,
		PANEL_NOTIFY_PROC, standard_data_list_handler,
		PANEL_LIST_STRINGS,
			"gauss_map",
			"trap_map",
			"step_map",
			"2pulse_map",
			"piston",
			"SineMap",
			"SineNMap",
			"ChaosMap",
			"sunspot",
			NULL,
		NULL);
	return obj;
}

/*
 * Create object `add_data' in the specified instance.
 */
Xv_opaque
gmap_file_pop_add_data_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		add_data_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 280,
		XV_Y, 80,
		PANEL_LABEL_STRING, "Add",
		PANEL_NOTIFY_PROC, add_data_handler,
		NULL);
	return obj;
}

/*
 * Create object `delete_data' in the specified instance.
 */
Xv_opaque
gmap_file_pop_delete_data_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		delete_data_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 280,
		XV_Y, 112,
		PANEL_LABEL_STRING, "Delete",
		PANEL_NOTIFY_PROC, delete_data_handler,
		NULL);
	return obj;
}

/*
 * Create object `data_file' in the specified instance.
 */
Xv_opaque
gmap_file_pop_data_file_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	dname_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 152,
		PANEL_VALUE_DISPLAY_LENGTH, 20,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Data File Prefix:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, dname_handler,
		NULL);
	return obj;
}

/*
 * Create object `filename_msg2' in the specified instance.
 */
Xv_opaque
gmap_file_pop_filename_msg2_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 168,
		PANEL_LABEL_STRING, "Data File Extension:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `patterns_msg_header2' in the specified instance.
 */
Xv_opaque
gmap_file_pop_patterns_msg_header2_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 184,
		XV_Y, 168,
		PANEL_LABEL_STRING, "Number of Patterns:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `ext_train' in the specified instance.
 */
Xv_opaque
gmap_file_pop_ext_train_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	ext_train_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 184,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Train",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, ext_train_handler,
		NULL);
	return obj;
}

/*
 * Create object `npatterns_train' in the specified instance.
 */
Xv_opaque
gmap_file_pop_npatterns_train_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	npatterns_train_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 200,
		XV_Y, 184,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Train",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 1000000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, npatterns_train_handler,
		NULL);
	return obj;
}

/*
 * Create object `ext_eval' in the specified instance.
 */
Xv_opaque
gmap_file_pop_ext_eval_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	ext_eval_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 200,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Eval",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, ext_eval_handler,
		NULL);
	return obj;
}

/*
 * Create object `npatterns_eval' in the specified instance.
 */
Xv_opaque
gmap_file_pop_npatterns_eval_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	npatterns_eval_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 200,
		XV_Y, 200,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Eval",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 1000000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, npatterns_eval_handler,
		NULL);
	return obj;
}

/*
 * Create object `ext_test' in the specified instance.
 */
Xv_opaque
gmap_file_pop_ext_test_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	ext_test_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 48,
		XV_Y, 216,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Test",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, ext_test_handler,
		NULL);
	return obj;
}

/*
 * Create object `npatterns_test' in the specified instance.
 */
Xv_opaque
gmap_file_pop_npatterns_test_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	npatterns_test_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 200,
		XV_Y, 216,
		PANEL_VALUE_DISPLAY_LENGTH, 6,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Test",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 1000000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, npatterns_test_handler,
		NULL);
	return obj;
}

/*
 * Create object `n_inputs' in the specified instance.
 */
Xv_opaque
gmap_file_pop_n_inputs_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	n_inputs_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 256,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Input Features:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 1000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, n_inputs_handler,
		NULL);
	return obj;
}

/*
 * Create object `n_outputs' in the specified instance.
 */
Xv_opaque
gmap_file_pop_n_outputs_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	n_outputs_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 272,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Outputs:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 1000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, n_outputs_handler,
		NULL);
	return obj;
}

/*
 * Create object `labels' in the specified instance.
 */
Xv_opaque
gmap_file_pop_labels_create(ip, owner)
	gmap_file_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	labels_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 296,
		PANEL_VALUE_DISPLAY_LENGTH, 55,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Output Labels:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, labels_handler,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `map_plot'.
 */
gmap_map_plot_objects *
gmap_map_plot_objects_initialize(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_map_plot_objects *) calloc(1, sizeof (gmap_map_plot_objects))))
		return (gmap_map_plot_objects *) NULL;
	if (!ip->map_plot)
		ip->map_plot = gmap_map_plot_map_plot_create(ip, owner);
	if (!ip->plot_controls)
		ip->plot_controls = gmap_map_plot_plot_controls_create(ip, ip->map_plot);
	if (!ip->map_plot_file)
		ip->map_plot_file = gmap_map_plot_map_plot_file_create(ip, ip->plot_controls);
	if (!ip->map_in_dim)
		ip->map_in_dim = gmap_map_plot_map_in_dim_create(ip, ip->plot_controls);
	if (!ip->map_out_dim)
		ip->map_out_dim = gmap_map_plot_map_out_dim_create(ip, ip->plot_controls);
	if (!ip->other_vars)
		ip->other_vars = gmap_map_plot_other_vars_create(ip, ip->plot_controls);
	if (!ip->map_npoints)
		ip->map_npoints = gmap_map_plot_map_npoints_create(ip, ip->plot_controls);
	if (!ip->map_autoscale)
		ip->map_autoscale = gmap_map_plot_map_autoscale_create(ip, ip->plot_controls);
	if (!ip->map_dim_range)
		ip->map_dim_range = gmap_map_plot_map_dim_range_create(ip, ip->plot_controls);
	if (!ip->map_axes_limits)
		ip->map_axes_limits = gmap_map_plot_map_axes_limits_create(ip, ip->plot_controls);
	if (!ip->map_xmin)
		ip->map_xmin = gmap_map_plot_map_xmin_create(ip, ip->plot_controls);
	if (!ip->map_ymin)
		ip->map_ymin = gmap_map_plot_map_ymin_create(ip, ip->plot_controls);
	if (!ip->map_xmax)
		ip->map_xmax = gmap_map_plot_map_xmax_create(ip, ip->plot_controls);
	if (!ip->map_ymax)
		ip->map_ymax = gmap_map_plot_map_ymax_create(ip, ip->plot_controls);
	if (!ip->map_xstep)
		ip->map_xstep = gmap_map_plot_map_xstep_create(ip, ip->plot_controls);
	if (!ip->map_ystep)
		ip->map_ystep = gmap_map_plot_map_ystep_create(ip, ip->plot_controls);
	if (!ip->no_norm)
		ip->no_norm = gmap_map_plot_no_norm_create(ip, ip->plot_controls);
	if (!ip->map_plot_label)
		ip->map_plot_label = gmap_map_plot_map_plot_label_create(ip, ip->plot_controls);
	return ip;
}

/*
 * Create object `map_plot' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_plot_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 412,
		XV_HEIGHT, 361,
		XV_LABEL, "Mapping Plot Parameters",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `plot_controls' in the specified instance.
 */
Xv_opaque
gmap_map_plot_plot_controls_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "Light Gray", NULL);
	return obj;
}

/*
 * Create object `map_plot_file' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_plot_file_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_plot_file_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 8,
		PANEL_VALUE_DISPLAY_LENGTH, 30,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Map Plot file name:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_plot_file_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_in_dim' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_in_dim_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_in_dim_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 40,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Horizontal (X) Dimension:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 100,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_in_dim_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_out_dim' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_out_dim_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_out_dim_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 64,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Vertical (Y) Dimension;",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 100,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_out_dim_handler,
		NULL);
	return obj;
}

/*
 * Create object `other_vars' in the specified instance.
 */
Xv_opaque
gmap_map_plot_other_vars_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	other_vars_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 88,
		PANEL_VALUE_DISPLAY_LENGTH, 41,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Settings for Other Dimensions (include X and Y)",
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, other_vars_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_npoints' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_npoints_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_npoints_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 128,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Number of Points along X:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 1000,
		PANEL_MIN_VALUE, 1,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_npoints_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_autoscale' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_autoscale_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern void		map_autoscale_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 144,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, map_autoscale_handler,
		PANEL_CHOICE_STRING, 0, "Autoscale Plot",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `map_dim_range' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_dim_range_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 176,
		PANEL_LABEL_STRING, "Input Dimensions to Plot:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `map_axes_limits' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_axes_limits_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 196,
		PANEL_LABEL_STRING, "Axes Limits:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `map_xmin' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_xmin_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_xmin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 220,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_xmin_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_ymin' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_ymin_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_ymin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 156,
		XV_Y, 220,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_ymin_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_xmax' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_xmax_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_xmax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 244,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_xmax_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_ymax' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_ymax_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_ymax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 156,
		XV_Y, 244,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_ymax_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_xstep' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_xstep_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_xstep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 40,
		XV_Y, 268,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_xstep_handler,
		NULL);
	return obj;
}

/*
 * Create object `map_ystep' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_ystep_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_ystep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 156,
		XV_Y, 268,
		PANEL_VALUE_DISPLAY_LENGTH, 4,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_ystep_handler,
		NULL);
	return obj;
}

/*
 * Create object `no_norm' in the specified instance.
 */
Xv_opaque
gmap_map_plot_no_norm_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern void		no_norm_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 288,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, no_norm_handler,
		PANEL_CHOICE_STRING, 0, "Do Not Normalize Data for Plot",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `map_plot_label' in the specified instance.
 */
Xv_opaque
gmap_map_plot_map_plot_label_create(ip, owner)
	gmap_map_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	map_plot_label_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 320,
		PANEL_VALUE_DISPLAY_LENGTH, 45,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Plot Label:",
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, map_plot_label_handler,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `plot_pop'.
 */
gmap_plot_pop_objects *
gmap_plot_pop_objects_initialize(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_plot_pop_objects *) calloc(1, sizeof (gmap_plot_pop_objects))))
		return (gmap_plot_pop_objects *) NULL;
	if (!ip->plot_pop)
		ip->plot_pop = gmap_plot_pop_plot_pop_create(ip, owner);
	if (!ip->plot_controls1)
		ip->plot_controls1 = gmap_plot_pop_plot_controls1_create(ip, ip->plot_pop);
	if (!ip->plots_message)
		ip->plots_message = gmap_plot_pop_plots_message_create(ip, ip->plot_controls1);
	if (!ip->dependent_message)
		ip->dependent_message = gmap_plot_pop_dependent_message_create(ip, ip->plot_controls1);
	if (!ip->map_plot_train)
		ip->map_plot_train = gmap_plot_pop_map_plot_train_create(ip, ip->plot_controls1);
	if (!ip->map_plot_test)
		ip->map_plot_test = gmap_plot_pop_map_plot_test_create(ip, ip->plot_controls1);
	if (!ip->map_plot_parameters)
		ip->map_plot_parameters = gmap_plot_pop_map_plot_parameters_create(ip, ip->plot_controls1);
	if (!ip->cost_plot)
		ip->cost_plot = gmap_plot_pop_cost_plot_create(ip, ip->plot_controls1);
	if (!ip->cost_plot_parameters)
		ip->cost_plot_parameters = gmap_plot_pop_cost_plot_parameters_create(ip, ip->plot_controls1);
	if (!ip->trial_average)
		ip->trial_average = gmap_plot_pop_trial_average_create(ip, ip->plot_controls1);
	if (!ip->other_graphs_message)
		ip->other_graphs_message = gmap_plot_pop_other_graphs_message_create(ip, ip->plot_controls1);
	if (!ip->norm_plot)
		ip->norm_plot = gmap_plot_pop_norm_plot_create(ip, ip->plot_controls1);
	if (!ip->norm_plot_parameters)
		ip->norm_plot_parameters = gmap_plot_pop_norm_plot_parameters_create(ip, ip->plot_controls1);
	if (!ip->clus_plot)
		ip->clus_plot = gmap_plot_pop_clus_plot_create(ip, ip->plot_controls1);
	if (!ip->cluster_plot_parameters)
		ip->cluster_plot_parameters = gmap_plot_pop_cluster_plot_parameters_create(ip, ip->plot_controls1);
	return ip;
}

/*
 * Create object `plot_pop' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_plot_pop_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 373,
		XV_HEIGHT, 375,
		XV_LABEL, "Plot Selection",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `plot_controls1' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_plot_controls1_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "Light Gray", NULL);
	return obj;
}

/*
 * Create object `plots_message' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_plots_message_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 8,
		PANEL_LABEL_STRING, "Select Desired Plots:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `dependent_message' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_dependent_message_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 32,
		PANEL_LABEL_STRING, "Algorithm Dependent Plots:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `map_plot_train' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_map_plot_train_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		map_plot_train_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 56,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_LABEL_STRING, "Train",
		PANEL_NOTIFY_PROC, map_plot_train_handler,
		PANEL_CHOICE_STRINGS,
			"",
			"",
			NULL,
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `map_plot_test' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_map_plot_test_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		map_plot_test_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 76,
		XV_Y, 56,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_LABEL_STRING, "Test",
		PANEL_NOTIFY_PROC, map_plot_test_handler,
		PANEL_CHOICE_STRINGS,
			"Mapped Function",
			"Input Data",
			NULL,
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `map_plot_parameters' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_map_plot_parameters_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		gmap_plot_pop_map_plot_parameters_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 216,
		XV_Y, 96,
		PANEL_LABEL_STRING, "Parameters . . .",
		PANEL_NOTIFY_PROC, gmap_plot_pop_map_plot_parameters_notify_callback,
		NULL);
	return obj;
}

/*
 * Create object `cost_plot' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_cost_plot_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		error_graph_select_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 136,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_LABEL_STRING, "Error File Graphs:",
		PANEL_NOTIFY_PROC, error_graph_select_handler,
		PANEL_CHOICE_STRING, 0, "Cost",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `cost_plot_parameters' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_cost_plot_parameters_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		gmap_plot_pop_cost_plot_parameters_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 216,
		XV_Y, 156,
		PANEL_LABEL_STRING, "Parameters . . .",
		PANEL_NOTIFY_PROC, gmap_plot_pop_cost_plot_parameters_notify_callback,
		NULL);
	return obj;
}

/*
 * Create object `trial_average' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_trial_average_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	trial_average_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_NUMERIC_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 184,
		PANEL_VALUE_DISPLAY_LENGTH, 5,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Plot group size:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_MAX_VALUE, 10000,
		PANEL_MIN_VALUE, 0,
		PANEL_VALUE, 0,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, trial_average_handler,
		NULL);
	return obj;
}

/*
 * Create object `other_graphs_message' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_other_graphs_message_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 208,
		PANEL_LABEL_STRING, "Other Graphs:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `norm_plot' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_norm_plot_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		norm_graph_select_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 224,
		PANEL_CHOICE_NROWS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, norm_graph_select_handler,
		PANEL_CHOICE_STRING, 0, "PC/LD Eigenvalues",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `norm_plot_parameters' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_norm_plot_parameters_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		gmap_plot_pop_norm_plot_parameters_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 216,
		XV_Y, 224,
		PANEL_LABEL_STRING, "Parameters . . .",
		PANEL_NOTIFY_PROC, gmap_plot_pop_norm_plot_parameters_notify_callback,
		NULL);
	return obj;
}

/*
 * Create object `clus_plot' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_clus_plot_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		clus_plot_train_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 24,
		XV_Y, 256,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_LABEL_STRING, "Cluster Plots:",
		PANEL_NOTIFY_PROC, clus_plot_train_handler,
		PANEL_CHOICE_STRINGS,
			"Region",
			"Scatter",
			"Internals",
			NULL,
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `cluster_plot_parameters' in the specified instance.
 */
Xv_opaque
gmap_plot_pop_cluster_plot_parameters_create(ip, owner)
	gmap_plot_pop_objects	*ip;
	Xv_opaque	owner;
{
	extern void		gmap_plot_pop_cluster_plot_parameters_notify_callback();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_BUTTON,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 216,
		XV_Y, 296,
		PANEL_LABEL_STRING, "Parameters . . .",
		PANEL_NOTIFY_PROC, gmap_plot_pop_cluster_plot_parameters_notify_callback,
		NULL);
	return obj;
}

/*
 * Initialize an instance of object `cost_plot'.
 */
gmap_cost_plot_objects *
gmap_cost_plot_objects_initialize(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	if (!ip && !(ip = (gmap_cost_plot_objects *) calloc(1, sizeof (gmap_cost_plot_objects))))
		return (gmap_cost_plot_objects *) NULL;
	if (!ip->cost_plot)
		ip->cost_plot = gmap_cost_plot_cost_plot_create(ip, owner);
	if (!ip->cost_line_controls)
		ip->cost_line_controls = gmap_cost_plot_cost_line_controls_create(ip, ip->cost_plot);
	if (!ip->cost_plot_file)
		ip->cost_plot_file = gmap_cost_plot_cost_plot_file_create(ip, ip->cost_line_controls);
	if (!ip->cost_autoscale)
		ip->cost_autoscale = gmap_cost_plot_cost_autoscale_create(ip, ip->cost_line_controls);
	if (!ip->cost_axes_limits)
		ip->cost_axes_limits = gmap_cost_plot_cost_axes_limits_create(ip, ip->cost_line_controls);
	if (!ip->cost_xmin)
		ip->cost_xmin = gmap_cost_plot_cost_xmin_create(ip, ip->cost_line_controls);
	if (!ip->cost_ymin)
		ip->cost_ymin = gmap_cost_plot_cost_ymin_create(ip, ip->cost_line_controls);
	if (!ip->cost_xmax)
		ip->cost_xmax = gmap_cost_plot_cost_xmax_create(ip, ip->cost_line_controls);
	if (!ip->cost_ymax)
		ip->cost_ymax = gmap_cost_plot_cost_ymax_create(ip, ip->cost_line_controls);
	if (!ip->cost_xstep)
		ip->cost_xstep = gmap_cost_plot_cost_xstep_create(ip, ip->cost_line_controls);
	if (!ip->cost_ystep)
		ip->cost_ystep = gmap_cost_plot_cost_ystep_create(ip, ip->cost_line_controls);
	if (!ip->cost_plot_label)
		ip->cost_plot_label = gmap_cost_plot_cost_plot_label_create(ip, ip->cost_line_controls);
	return ip;
}

/*
 * Create object `cost_plot' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_plot_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, FRAME_CMD,
		XV_KEY_DATA, INSTANCE, ip,
		XV_WIDTH, 384,
		XV_HEIGHT, 232,
		XV_LABEL, "Cost Plot Parameters",
		XV_SHOW, FALSE,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_SHOW_RESIZE_CORNER, TRUE,
		FRAME_CMD_PUSHPIN_IN, TRUE,
		NULL);
	xv_set(xv_get(obj, FRAME_CMD_PANEL), WIN_SHOW, FALSE, NULL);
	return obj;
}

/*
 * Create object `cost_line_controls' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_line_controls_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 0,
		XV_Y, 0,
		XV_WIDTH, WIN_EXTEND_TO_EDGE,
		XV_HEIGHT, WIN_EXTEND_TO_EDGE,
		WIN_BORDER, FALSE,
		NULL);
	gcm_initialize_colors(obj, "Light Gray", NULL);
	return obj;
}

/*
 * Create object `cost_plot_file' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_plot_file_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_plot_file_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 16,
		PANEL_VALUE_DISPLAY_LENGTH, 30,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Plot file name:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_plot_file_handler,
		NULL);
	return obj;
}

/*
 * Create object `cost_autoscale' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_autoscale_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern void		cost_autoscale_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TOGGLE, PANEL_FEEDBACK, PANEL_MARKED,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 8,
		XV_Y, 40,
		PANEL_CHOICE_NCOLS, 1,
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_NOTIFY_PROC, cost_autoscale_handler,
		PANEL_CHOICE_STRING, 0, "Autoscale Plot",
		PANEL_VALUE, 0,
		NULL);
	return obj;
}

/*
 * Create object `cost_axes_limits' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_axes_limits_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_MESSAGE,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 16,
		XV_Y, 76,
		PANEL_LABEL_STRING, "Axes Numeric Limits:",
		PANEL_LABEL_BOLD, TRUE,
		NULL);
	return obj;
}

/*
 * Create object `cost_xmin' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_xmin_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_xmin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 100,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_xmin_handler,
		NULL);
	return obj;
}

/*
 * Create object `cost_ymin' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_ymin_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_ymin_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 164,
		XV_Y, 100,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Min:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_ymin_handler,
		NULL);
	return obj;
}

/*
 * Create object `cost_xmax' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_xmax_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_xmax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 124,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_xmax_handler,
		NULL);
	return obj;
}

/*
 * Create object `cost_ymax' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_ymax_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_ymax_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 164,
		XV_Y, 124,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Max:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_ymax_handler,
		NULL);
	return obj;
}

/*
 * Create object `cost_xstep' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_xstep_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_xstep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 32,
		XV_Y, 150,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "X Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_xstep_handler,
		NULL);
	return obj;
}

/*
 * Create object `cost_ystep' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_ystep_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_ystep_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 164,
		XV_Y, 150,
		PANEL_VALUE_DISPLAY_LENGTH, 8,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Y Step:",
		PANEL_LAYOUT, PANEL_HORIZONTAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_ystep_handler,
		NULL);
	return obj;
}

/*
 * Create object `cost_plot_label' in the specified instance.
 */
Xv_opaque
gmap_cost_plot_cost_plot_label_create(ip, owner)
	gmap_cost_plot_objects	*ip;
	Xv_opaque	owner;
{
	extern Panel_setting	cost_plot_label_handler();
	Xv_opaque	obj;
	
	obj = xv_create(owner, PANEL_TEXT,
		XV_KEY_DATA, INSTANCE, ip,
		XV_X, 12,
		XV_Y, 180,
		PANEL_VALUE_DISPLAY_LENGTH, 45,
		PANEL_VALUE_STORED_LENGTH, 80,
		PANEL_LABEL_STRING, "Plot Label:",
		PANEL_LAYOUT, PANEL_VERTICAL,
		PANEL_READ_ONLY, FALSE,
		PANEL_NOTIFY_PROC, cost_plot_label_handler,
		NULL);
	return obj;
}

