/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* lnknet_args.h 	Run time arguments for LNKnet program */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/gmap/lnkmap/lnkmap_args.h,v 10.2 2001/08/23 20:14:09 craig Exp $ */


			/* LNKnet main window arguments */
extern int algorithm;
static int normalization_arg = 0;  /* 0=none, 1=simple, 2=PCA, 3=LDA */
static char *norm_fname_arg = "vowel.norm.simple";
static char *exp_name_arg = "X";
static int exp_number = 1;
static int auto_inc_arg = 0;
static int random_flag_arg = 0;
static int seed_arg = 0;
static int store_only_arg = 0;
/* run_options is a bit vector. (shown little endian)
   1		2	4		8
   TRAIN CLASS_ON_TRAIN CLASS_ON_EVAL CLASS_ON_TEST */
static int run_options = 1;
static int enable_plotting_flag_arg = 0;
static int cross_valid_on_arg = 0;
static int cv_from_file = 0;
static int cv_nfolds = 2;
static char *ext_cv_arg = ".cv";
static int epoch_plots_arg;
static int e_per_plot;

/* file window arguments */
static char *exp_path_arg = "demo/run/";/* path to experiment dir.*/
static char *fpid_arg = "X1knn.pid";
static char *fparam_arg = "X1knn.param";
static char *ferror_arg = "X1knn.err";
static char *frun_arg = "X1knn.run";
static char *flog_arg = "X1knn.log";
static char *fscreen_arg = "X1knn.screen";
static char *run_time_system_arg = "";
static int verbosity_arg = 3;
static int verror_arg = 0;
static int debug_arg = 0;

static char *data_path_arg = "data/map/";/* path to standard data files */
static int standard_data_set_value = 0;
static char *data_bases[NNARGS_MAX_LABELS] = {"0"};
static char *data_fname_arg = "vowel";
static char *ext_eval_arg = ".eval";
static char *ext_test_arg = ".test";
static char *ext_train_arg = ".train";
static int npatterns_train = 0;
static int npatterns_test = 0;
static int npatterns_eval = 0;
static int nraw_arg = 0;
static int noutputs_arg = 0;
static char *labels_arg[NNARGS_MAX_LABELS] = {"0"};


/* feature selection window arguments */
static int select_type = 0;
static int select_n = 0;
static int feature_list[NNARGS_MAX_LABELS];


static ARG LNKMAPargtab[]=
{
  {"algorithm", INT, &algorithm, "Default algorithm number"},
  {"auto_inc", INT, &auto_inc_arg,
     "Automatically increment experiment number"},
  {"cross_valid_on", INT, &cross_valid_on_arg},
  {"cv_from_file", INT, &cv_from_file},
  {"cv_nfolds", INT, &cv_nfolds},
  {"extcv", STRING, (int *) &ext_cv_arg, "extension for cv splits file"},
  {"debug", INT, &debug_arg, "Print debug messages if > 0"},
  {"expname", STRING, (int *) &exp_name_arg, "Default experiment name"},
  {"expnumber", INT, &exp_number, "Default experiment number"},
  {"exteval", STRING,(int *) &ext_eval_arg, "Evaluation filename extension"},
  {"exttest", STRING, (int *) &ext_test_arg, "Test filename extension"},
  {"exttrain", STRING, (int *) &ext_train_arg, "Train filename extension"},
  {"e_per_plot", INT, &e_per_plot, "epochs per plot"},
  {"epoch_plots", INT, &epoch_plots_arg,
     "store multiple plots while training"},
  {"finput", STRING, (int *) &data_fname_arg, "Base name of data file"},
  {"fpid", STRING, (int *) &fpid_arg},
  {"fparam", STRING, (int *)&fparam_arg},
  {"ferror", STRING, (int *)&ferror_arg},
  {"frun", STRING, (int *)&frun_arg},
  {"flog", STRING, (int *)&flog_arg},
  {"fscreen", STRING, (int *)&fscreen_arg},
  {"npatterns_train", INT, &npatterns_train},
  {"npatterns_test", INT, &npatterns_test},
  {"npatterns_eval", INT, &npatterns_eval},
  {"nraw", INT, &nraw_arg},
  {"noutputs", INT, &noutputs_arg},
  {"labels", STRING_LIST, (int *)&labels_arg[0]},
  {"data_bases", STRING_LIST, (int *)&data_bases[0],
     "set of prefixes shown in scroll list"},
  {"normalization",INT, &normalization_arg,"0=none, 1=simple, 2=PCA"},
  {"norm_fname", STRING, (int *)&norm_fname_arg},
  {"pathdata", STRING,(int *) &data_path_arg, "Path to standard data files"},
  {"pathexp", STRING,(int *) &exp_path_arg,
     "Path to standard experiment files"},
  {"plot", INT, &enable_plotting_flag_arg, "Enable plotting"},
  {"random", INT, &random_flag_arg,"Random selection of training items"},
  {"run", INT, &run_options,
     "1:Train, 2:Eval, 4:Test, (can be combined)"},
  {"seed", INT, &seed_arg, "Random number generator seed"},
  {"standard", INT, &standard_data_set_value, "Standard data set number"},
  {"store", INT, &store_only_arg, "store shell script, do not run"},
  {"select_type", INT, &select_type, "feature selection type"},
  {"select_n", INT, &select_n, "n features for selection"},
  {"feature_list", INT_LIST, feature_list},
  {"verbose", INT, (int *) &verbosity_arg,
     "Verbosity level for log message print"},
  {"verror", INT, &verror_arg, "Short or long RMS error print"},
};
#define LNKMAPTABSIZE (sizeof(LNKMAPargtab)/sizeof(ARG))

			/* Plot popup window arguments */
static int outputs_train_arg = 0;
static int outputs_test_arg = 0;
static int scatter_train_arg = 0;
static int scatter_test_arg = 0;

static int clus_scat_arg = 0;
static int clus_internals_arg = 0;
static int clus_region_arg = 0;

/* Plot popup window arguments */
static int cost_plot_arg = 0;
static int norm_plot_arg = 0;

static int trial_average_arg = 0;

/* boundary plot window */
static int all_data_arg = 0;	/* show all data in scatter/histogram plots */
static float distance_limit_arg = .5;
static int show_misses_arg = 0;
static float internals_scale_arg = 1;
static int internals_level_arg = 1;

/* other plot windows */
static int bound_autoscale_arg = 0;
static int cost_autoscale_arg = 0;
static int norm_autoscale_arg = 0;
static int map_autoscale_arg = 0;

static ARG plot_argtab[]=
{
    {"outputs_train", INT, &outputs_train_arg, "Plot train outputs"},
    {"outputs_test", INT, &outputs_test_arg,"Plot test outputs"},
    {"scatter_train", INT, &scatter_train_arg, "Create scatter train"},
    {"scatter_test", INT, &scatter_test_arg,"Create scatter test plot"},
    {"clus_scat", INT, &clus_scat_arg},
    {"clus_internals", INT, &clus_internals_arg},
    {"clus_region", INT, &clus_region_arg},
    {"cost_plot", INT, &cost_plot_arg},
    {"norm_plot", INT, &norm_plot_arg},
    {"trial_average", INT, &trial_average_arg,
       "npatterns to average for cost and perr plots"},
    {"all_data", INT, &all_data_arg,
       "Show all data in scatter/histogram plots"},
    {"distance", FLOAT, (int *) &distance_limit_arg,
       "Distance limit if all_data is off"},
    {"misses", INT, &show_misses_arg, "Highlight missclassified points"},
    {"internals_scale", FLOAT, (int *)&internals_scale_arg},
    {"internals_level", INT, &internals_level_arg},
    {"bound_autoscale", INT, &bound_autoscale_arg, ""},
    {"cost_autoscale", INT, &cost_autoscale_arg, ""},
    {"norm_autoscale", INT, &norm_autoscale_arg, ""},
    {"map_autoscale", INT, &map_autoscale_arg, ""},
};
#define PLOT_TABSIZE (sizeof(plot_argtab)/sizeof(ARG))
