/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * LNKseq.c - Contains main() for project LNKseq
 * This file was generated by `gxv'.
 */
static char rcsid[] = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/gseq/LNKseq_main.c,v 10.3 2001/08/23 20:14:11 craig Exp $";

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include "gseq/gseq_ui.h"
#include "gseq/menus_ui.h"
#include "gseq/reports_ui.h"
#include "gseq/data_ui.h"
#include "gseq/norm_ui.h"
#include "gseq/select_ui.h"
#include "gauss/ggauss_ui.h"
#include "gmix/ggmix_ui.h"
#include "rbf/grbf_ui.h"
#include "mlp/gmlp_ui.h"
#include "kmeans/gkmeans_ui.h"
#include "irbf/girbf_ui.h"
#include "LNKseq_main_ui.h"
#include <nnlib.h>

/*
 * External variable declarations.
 */
gseq_main_window_objects	*Gseq_main_window;
reports_file_pop_objects	*Reports_file_pop;
data_data_pop_objects	*Data_data_pop;
data_defaults_pop_objects	*Data_defaults_pop;
norm_norm_pop_objects	*Norm_norm_pop;
norm_norm_generate_pop_objects	*Norm_norm_generate_pop;
select_select_pop_objects	*Select_select_pop;
ggauss_popup1_objects	*Ggauss_popup1;
ggmix_param_pop_objects	*Ggmix_param_pop;
grbf_popup1_objects	*Grbf_popup1;
gmlp_popup1_objects	*Gmlp_popup1;
gmlp_weight_popup_objects	*Gmlp_weight_popup;
gmlp_cost_popup_objects	*Gmlp_cost_popup;
gmlp_node_popup_objects	*Gmlp_node_popup;
gkmeans_popup1_objects	*Gkmeans_popup1;
girbf_popup1_objects	*Girbf_popup1;
lnkseq_glyph_objects	*LNKseq_glyphs;

void g_get_defaults();

#ifdef MAIN

/*
 * Instance XV_KEY_DATA key.  An instance is a set of related
 * user interface objects.  A pointer to an object's instance
 * is stored under this key in every object.  This must be a
 * global variable.
 */
Attr_attribute	INSTANCE;

/*
 * main for project LNKseq
 */
void
main(argc, argv)
     int	argc;
     char	**argv;
{
    void g_init();
    /*
     * Initialize XView.
     */
    xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
    INSTANCE = xv_unique_key();
	
    /*
     * Initialize user interface components.
     * Do NOT edit the object initializations by hand.
     */
    Gseq_main_window = gseq_main_window_objects_initialize(NULL, NULL);
    gseq_main_window_initialize_popups(Gseq_main_window->main_window);
    gseq_main_window_initialize_alg_popups(Gseq_main_window->main_window);
    LNKseq_glyphs = lnkseq_glyph_objects_initialize(NULL, Gseq_main_window->main_window);

    /* initialize popups */
    init_nnsubs(argc, argv, rcsid);
    /* we should detect -- and not do anything since there are no arguments*/
    g_init();
    g_init_algs();
    g_get_defaults(); /* does the display, as well */

    /*
     * Turn control over to XView.
     */
    xv_main_loop(Gseq_main_window->main_window);
    exit(0);
}


#endif
gseq_main_window_initialize_popups(owner)
     Xv_opaque owner;
{
    Data_data_pop = data_data_pop_objects_initialize(NULL, owner);
    Data_defaults_pop = data_defaults_pop_objects_initialize(NULL, owner);
    Norm_norm_pop = norm_norm_pop_objects_initialize(NULL, owner);
    Norm_norm_generate_pop = 
      norm_norm_generate_pop_objects_initialize(NULL, owner);
    Select_select_pop = select_select_pop_objects_initialize(NULL, owner);
    Reports_file_pop = reports_file_pop_objects_initialize(NULL, owner);
}

gseq_main_window_initialize_alg_popups(owner)
     Xv_opaque owner;
{
    Ggauss_popup1 = ggauss_popup1_objects_initialize(NULL, owner);
    Ggmix_param_pop = ggmix_param_pop_objects_initialize(NULL, owner);
    Grbf_popup1 = grbf_popup1_objects_initialize(NULL, owner);
    Gmlp_popup1 = gmlp_popup1_objects_initialize(NULL, owner);
    Gmlp_weight_popup = gmlp_weight_popup_objects_initialize(NULL, owner);
    Gmlp_cost_popup = gmlp_cost_popup_objects_initialize(NULL, owner);
    Gmlp_node_popup = gmlp_node_popup_objects_initialize(NULL, owner);
    Gkmeans_popup1 = gkmeans_popup1_objects_initialize(NULL, owner);
    Girbf_popup1 = girbf_popup1_objects_initialize(NULL, owner);
}
