/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * LNKseq_main_ui.c - User interface object initialization functions.
 * creation routines for LNKseq_glyphs
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include "LNKseq_main_ui.h"

lnkseq_glyph_objects *
lnkseq_glyph_objects_initialize(ip, owner)
     /*ARGSUSED*/
     lnkseq_glyph_objects *ip;
     Xv_opaque owner;
{
    if(!ip && !(ip = (lnkseq_glyph_objects *) calloc(1, sizeof(lnkseq_glyph_objects))))
      return (lnkseq_glyph_objects *) NULL;
    if (!ip->LNKseq_warning_pic)
      ip->LNKseq_warning_pic = lnkseq_glyphs_LNKseq_warning_pic_create();
    if (!ip->LNKseq_blank_pic)
      ip->LNKseq_blank_pic = lnkseq_glyphs_LNKseq_blank_pic_create();
    return ip;
}

Xv_opaque
lnkseq_glyphs_LNKseq_warning_pic_create()
{
    Xv_opaque image;
    static unsigned short image_bits[] = {
#include "warning.icon"
    };

    image = xv_create(XV_NULL, SERVER_IMAGE,
		      SERVER_IMAGE_DEPTH, 1,
		      SERVER_IMAGE_BITS, image_bits,
		      XV_WIDTH, 64,
		      XV_HEIGHT, 64,
		      NULL);
    return image;
}

Xv_opaque
lnkseq_glyphs_LNKseq_blank_pic_create()
{
    Xv_opaque image;
    static unsigned short image_bits[] = {
#include "blank.icon"
    };

    image = xv_create(XV_NULL, SERVER_IMAGE,
		      SERVER_IMAGE_DEPTH, 1,
		      SERVER_IMAGE_BITS, image_bits,
		      XV_WIDTH, 64,
		      XV_HEIGHT, 64,
		      NULL);
    return image;
}


	
