/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * data_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `data.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <dirent.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include "data_ui.h"
#include "nn_params.h"
#include "../LNKseq_main_ui.h"
#include "../LNKseq_subs.h"

extern	data_data_pop_objects	*Data_data_pop;
extern	data_defaults_pop_objects	*Data_defaults_pop;
extern lnkseq_glyph_objects *LNKseq_glyphs;

#define MAXSTR 256

/* space for file names (allows them to be copied using restore screens) */
/* having two data paths allows user to create relative paths */
static char data_path_full[MAXSTR] = ""; /* doesn't initalize well */
static char data_path_val[MAXSTR] = "./";
static char data_base[MAXSTR] = "vowel";
static char data_base_tmp[MAXSTR];
static char desc_filename[MAXSTR] = "vowel.defaults";
static char ext_train[MAXSTR] = ".train";
static char ext_test[MAXSTR] = ".test";
static char ext_eval[MAXSTR] = ".eval";
static char defaults_suffix[MAXSTR] = ".defaults";

/* space for setting up class count messages here and on priors window */
static char priors_string[MAXSTR];
static char frames_string[MAXSTR];
static float *priors_list = NULL; /* allocated to noutputs long whenever
				     data base is changed */
static float *frames_list = NULL; /* allocated to noutputs long whenever
				     data base is changed */

static int selected_row = -1; /* current row selected in data_base_list */
/* to read the .defaults file for a data base */
DEFAULTS_FILE_STRUCT df_args;

void update_data_base();
void set_test_file(), set_eval_file(), set_train_file();
void display_data_base_msgs(), display_defaults_generate_msgs();
void setup_shown_list();
void data_set_data_base();
void set_test_priors_string(), set_train_priors_string();
void set_eval_priors_string();
FILE *open_data_base_file();
void close_data_base_file();

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init_data()
{
    nn_params.data_path = data_path_full;
    nn_params.data_base = data_base;
    nn_params.desc_fname = desc_filename;
    nn_params.desc_suff = defaults_suffix;
    nn_params.ext_train = ext_train;
    nn_params.ext_eval = ext_eval;
    nn_params.ext_test = ext_test;
    nn_params.output_labels = NULL;
    nn_params.input_labels = NULL;
}

void
g_display_data()
{
    /* data window */
    xv_set(Data_data_pop->data_path, PANEL_VALUE, data_path_val, NULL);
    xv_set(Data_data_pop->data_base, PANEL_VALUE, data_base, NULL);
    display_data_base_msgs();

    xv_set(Data_data_pop->ext_eval, PANEL_VALUE, ext_eval, NULL);
    xv_set(Data_data_pop->ext_test, PANEL_VALUE, ext_test, NULL);
    xv_set(Data_data_pop->ext_train, PANEL_VALUE, ext_train, NULL);

    update_data_base();/* prints npatterns_train, etc and priors_strings */

    /* data generate window */
    display_defaults_generate_msgs();
    xv_set(Data_defaults_pop->data_base_name, PANEL_LABEL_STRING,
	   data_base, NULL);
}

/*
 * Notify callback function for data window buttons
 */
void
data_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->generate_defaults){
	xv_set(Data_defaults_pop->defaults_pop, FRAME_CMD_PUSHPIN_IN,
	       TRUE, NULL);
	xv_set(Data_defaults_pop->defaults_pop, XV_SHOW, TRUE, NULL);
    } else {
	fprintf(stderr, "LNKseq: data_btn_handler: unhandled btn\n");
    }
}

/*
 * Notify callback function for data text items
 */
Panel_setting
data_2_handler(item, event)
	Panel_item	item;
	Event		*event;
{
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    void norm_check_file();
    FILE *fp;
	
    if(item == ip->data_path){
	strcpy(data_path_val, value);
	set_data_path_full();
	norm_check_file();
	setup_shown_list();
	update_data_base();
    } else if(item == ip->data_base){
	if(selected_row >= 0)
	  xv_set(Data_data_pop->data_base_list, PANEL_LIST_SELECT,
		 selected_row, FALSE, NULL);
	strcpy(data_base, value);
	data_set_data_base();
    } else if(item == ip->ext_train){
	strcpy(ext_train, value);
	nn_params.ext_train = ext_train;
	set_train_file();
    } else if(item == ip->ext_eval){
	strcpy(ext_eval, value);
	nn_params.ext_eval = ext_eval;
	set_eval_file();
    } else if(item == ip->ext_test){
	strcpy(ext_test, value);
	nn_params.ext_test = ext_test;
	set_test_file();
    } else if (item == ip->npatterns_train){
	nn_params.npatterns_train = set_atoi_value(value, "npatterns_train",
					   item, nn_params.npatterns_train);
	/* set data_base_tmp and open file */
	fp = open_data_base_file(ext_train);
	set_train_priors_string(fp);
	close_data_base_file(fp);
    } else if (item == ip->npatterns_eval){
	nn_params.npatterns_eval = set_atoi_value(value, "npatterns_eval",
					item, nn_params.npatterns_eval);
	/* set data_base_tmp and open file */
	fp = open_data_base_file(ext_eval);
	set_eval_priors_string(fp);
	close_data_base_file(fp);
    } else if (item == ip->npatterns_test){
	nn_params.npatterns_test = set_atoi_value(value, "npatterns_test",
					item, nn_params.npatterns_test);
	/* set data_base_tmp and open file */
	fp = open_data_base_file(ext_test);
	set_test_priors_string(fp);
	close_data_base_file(fp);
    } else {
	fprintf(stderr, "LNKseq: data_2_handler: unhandled text value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}
#ifdef SGI
/*
 * Notify callback function for `data_base_list'.
 */
int
data_list_handler(item, string, client_data, op, event)
	Panel_item	item;/*ARGSUSED*/
	char		*string;
	Xv_opaque	client_data;
	Panel_list_op	op;
	Event		*event;
{
    /*SUPPRESS 594*/
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *strend;
    int		row, nrows;
	
    switch(op) {
      case PANEL_LIST_OP_DESELECT:
	selected_row = -1;
	break;
      case PANEL_LIST_OP_SELECT:
	nrows = xv_get(item, PANEL_LIST_NROWS, NULL);
	for(row = 0; row < nrows; row++){
	    if(xv_get(item, PANEL_LIST_SELECTED, row) == TRUE) break;
	}
	if(row >= nrows) return XV_ERROR;

	selected_row = row;
	/* set data file prefix and display it */
	strcpy(data_base, string);
	/* strip .defaults off it */
	strend = strstr(data_base, defaults_suffix);
	if(strend != NULL) strend[0] = '\0';
	data_set_data_base();
	break;
      case PANEL_LIST_OP_VALIDATE:
	break;
      case PANEL_LIST_OP_DELETE:
	break;
    }
    return XV_OK;
}
#else
/*
 * Notify callback function for `data_base_list'.
 */
int
data_list_handler(item, string, client_data, op, event, row)
	Panel_item	item;/*ARGSUSED*/
	char		*string;
	Xv_opaque	client_data;
	Panel_list_op	op;
	Event		*event;
	int		row;
{
    /*SUPPRESS 594*/
    data_data_pop_objects *ip =
      (data_data_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *strend;
	
    switch(op) {
      case PANEL_LIST_OP_DESELECT:
	selected_row = -1;
	break;
      case PANEL_LIST_OP_SELECT:
	selected_row = row;
	/* set data file prefix and display it */
	strcpy(data_base, string);
	/* strip .defaults off it */
	strend = strstr(data_base, defaults_suffix);
	if(strend != NULL) strend[0] = '\0';
	data_set_data_base();
	break;
      case PANEL_LIST_OP_VALIDATE:
	break;
      case PANEL_LIST_OP_DELETE:
	break;
    }
    return XV_OK;
}
#endif
/*
 * Event callback function for `data_warning'.
 */
void
data_data_pop_data_warning_event_callback(item, event)
	Panel_item	item;
	Event		*event;
{
    if (event_action(event) == ACTION_SELECT) {
	update_data_base();
    }
    panel_default_handle_event(item, event);
}

/*
 * Event callback function for `data_error_message'.
 */
void
data_data_pop_data_error_message_event_callback(item, event)
	Panel_item	item;
	Event		*event;
{
    if (event_action(event) == ACTION_SELECT) {
	update_data_base();
    }
    panel_default_handle_event(item, event);
}

/*
 * Notify callback function for data generate buttons
 */
void
data_defaults_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    data_defaults_pop_objects *ip =
      (data_defaults_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->data_cancel_button){
	xv_set(ip->defaults_pop, FRAME_CMD_PUSHPIN_IN, FALSE, NULL);
	xv_set(ip->defaults_pop, XV_SHOW, FALSE, NULL);
    } else if(item == ip->data_generate_button){
	/* LNKseq can only deal with sequence classification data */
	df_args.db_type = SEQ_DATA;

	write_defaults_file(path_build(nn_params.data_path,
				       nn_params.desc_fname), &df_args);
	setup_shown_list();
	update_data_base();
    } else {
	fputs("LNKseq: data_defaults_btn_handler: unhandled btn\n", stderr);
    }
}

/*
 * Notify callback function for data generate text items
 */
Panel_setting
data_defaults_2_handler(item, event)
	Panel_item	item;
	Event		*event;
{
    data_defaults_pop_objects *ip =
      (data_defaults_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
    static char tmp[NNMAX_LINE];
	
    if(item == ip->data_n_inputs_set){
	df_args.ninputs = set_atoi_value(value, "data_ninputs_set",
					item, nn_params.nraw);
    } else if(item == ip->data_n_outputs_set){
	df_args.noutputs = set_atoi_value(value, "data_noutputs_set",
					  item, nn_params.noutputs);
    } else if(item == ip->data_input_labels_set){
	if(df_args.input_labels != NULL)
	  deallocate_string_vector(df_args.input_labels,
				   atoi(df_args.input_labels[0]));
	df_args.input_labels =
	  nnargs_get_string_alloc_list(strcpy(tmp, value));
    } else if(item == ip->data_output_labels_set){
	if(df_args.output_labels != NULL)
	  deallocate_string_vector(df_args.output_labels,
				   atoi(df_args.output_labels[0]));
	df_args.output_labels =
	  nnargs_get_string_alloc_list(strcpy(tmp, value));
    } else {
	fprintf(stderr,
		"LNKseq: data_defaults_2_handler: unhandled text: value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for data generate settings
 */
void
data_defaults_3_handler(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;/*ARGSUSED*/
{
    /*SUPPRESS 594*/
    data_defaults_pop_objects *ip =
      (data_defaults_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
#ifdef notdef
    /* only classification data may be used by LNKseq */
    if(item == ip->db_type_set){
	df_args.db_type = value;
    } else {
#endif
	fprintf(stderr,
		"LNKseq: data_defaults_3_handler: unhandled: value: %u\n",
		value);
#ifdef notdef
    }
#endif
}

void
update_data_base()
{
    /* update the data base info on defaults file */
    /* read the data base description when filename changes */
    if(priors_list != NULL) deallocate_vector(priors_list);
    if(frames_list != NULL) deallocate_vector(frames_list);

    if(set_description_values_data_base() < 0){
	/* set error message to say couldn't find data base */
	xv_set(Data_data_pop->data_error_message, PANEL_LABEL_STRING,
	       "Error: Cannot read data base defaults file", NULL);
	xv_set(Data_data_pop->data_warning, PANEL_LABEL_IMAGE,
	       LNKseq_glyphs->LNKseq_warning_pic, NULL);
	priors_list = NULL;
	frames_list = NULL;
    } else {
	xv_set(Data_data_pop->data_error_message, PANEL_LABEL_STRING,
	       "", NULL);
	xv_set(Data_data_pop->data_warning, PANEL_LABEL_IMAGE,
	       LNKseq_glyphs->LNKseq_blank_pic, NULL);
	priors_list = allocate_vector(nn_params.noutputs+1);
	priors_list[0] = (float)nn_params.noutputs;
	frames_list = allocate_vector(nn_params.noutputs+1);
	frames_list[0] = (float)nn_params.noutputs;
    }
    set_test_file();
    set_eval_file();
    set_train_file();
    
}

int
set_description_values_data_base ()
{
    char desc_fullname[MAXSTR];
    FILE *desc_file;
    int rv;
    void set_feature_labels_string();
    
    strcpy(desc_filename, data_base);
    strcat(desc_filename, defaults_suffix);
    nn_params.desc_fname = desc_filename;
    strcpy (desc_fullname, path_build(nn_params.data_path,
				      nn_params.desc_fname));
    /* reset flags */
    if(df_args.input_labels != NULL){
	deallocate_string_vector(df_args.input_labels,
 				 atoi(df_args.input_labels[0]));
	df_args.input_labels = NULL;
    }
    if(df_args.output_labels != NULL){
	deallocate_string_vector(df_args.output_labels,
				 atoi(df_args.output_labels[0]));
	df_args.output_labels = NULL;
    }
    nn_params.db_type = df_args.db_type = SEQ_DATA;
    df_args.ninputs = df_args.noutputs = 0;

    if ((desc_file = fopen(desc_fullname, "r")) == NULL) {
	rv = -1;
    } else {
	read_defaults_file(desc_fullname, &df_args);
	nn_fclose(desc_file, desc_fullname, "for reading data description");
	rv = 0;
    }
    nn_params.nraw = df_args.ninputs;
    nn_params.noutputs = df_args.noutputs;
    nn_params.output_labels = df_args.output_labels;
    nn_params.input_labels = df_args.input_labels;

    /* set defaults messages */
    display_data_base_msgs();
    
    /* set defaults values on generate window */
    display_defaults_generate_msgs();

    /* update ninputs setting */
    update_nraw_and_ninputs();
    set_feature_labels_string();

    return rv;
}

int
set_priors_string(fp, npatterns)
     FILE *fp;
     int npatterns;
{
    int nframes;

    nframes = 0;
    if(fp != NULL){
	if(df_args.db_type == SEQ_DATA){
	    if(priors_list != NULL){
		find_seq_priors(fp, npatterns, nn_params.noutputs,
				priors_list);
		sprintf(priors_string, "%s", make_float_string(priors_list));
	    } else {
		sprintf(priors_string, "noutputs unknown");
	    }
	    if(frames_list != NULL){
		/* !!! data_base_tmp must be set by the calling routine */
		nframes =
		  find_frame_priors(fp, npatterns, nn_params.noutputs,
				    frames_list, nn_params.data_path,
				    data_base_tmp, nn_params.output_labels);
		sprintf(frames_string, "%s", make_float_string(frames_list));
	    } else {
		sprintf(frames_string, "noutputs unknown");
	    }
	} else {
	    sprintf(priors_string, "Not sequence classification data");
	    sprintf(frames_string, "Not sequence classification data");
	}
    } else {
	if(df_args.db_type == SEQ_DATA){
	    sprintf(priors_string, "No File");
	    sprintf(frames_string, "No File");
	} else {
	    sprintf(priors_string, "Not sequence classification data");
	    sprintf(frames_string, "Not sequence classification data");
	}
    }
    return nframes;
}

FILE *
open_data_base_file(ext)
     char *ext;
{
    FILE *fp;

    strcpy(data_base_tmp, data_base);
    strcat(data_base_tmp, ext);
    fp = fopen(path_build(nn_params.data_path, data_base_tmp), "r");
    return fp;
}

void
close_data_base_file(fp)
     FILE *fp;
{
    if(fp != NULL)
      nn_fclose(fp, path_build(nn_params.data_path, data_base),
		"for reading class priors");
}

void
set_test_file()
{
    FILE *fp;

    /* set data_base_tmp and open file */
    fp = open_data_base_file(ext_test);
    xv_set(Data_data_pop->test_msg, PANEL_LABEL_STRING, data_base_tmp, NULL);
    if(fp != NULL) nn_params.npatterns_test = get_n_lines(fp);
    else nn_params.npatterns_test = 0;
    set_test_priors_string(fp);
    close_data_base_file(fp);
}

void
set_test_priors_string(fp)
     FILE *fp;
{
    int nframes;
    nframes = set_priors_string(fp, nn_params.npatterns_test);
    set_int_string(Data_data_pop->npatterns_test, "%d",
		   nn_params.npatterns_test);
    set_int_label(Data_data_pop->nframes_test, "%d", nframes);
    xv_set(Data_data_pop->test_seqs_per_class, PANEL_LABEL_STRING,
	   priors_string, NULL);
    xv_set(Data_data_pop->test_frames_per_class, PANEL_LABEL_STRING,
	   frames_string, NULL);
}

void
set_eval_file()
{
    FILE *fp;

    /* set data_base_tmp and open file */
    fp = open_data_base_file(ext_eval);
    xv_set(Data_data_pop->eval_msg, PANEL_LABEL_STRING, data_base_tmp, NULL);
    if(fp != NULL) nn_params.npatterns_eval = get_n_lines(fp);
    else nn_params.npatterns_eval = 0;
    set_eval_priors_string(fp);
    close_data_base_file(fp);
}

void
set_eval_priors_string(fp)
     FILE *fp;
{
    int nframes;

    nframes = set_priors_string(fp, nn_params.npatterns_eval);
    set_int_string(Data_data_pop->npatterns_eval, "%d",
		   nn_params.npatterns_eval);
    set_int_label(Data_data_pop->nframes_eval, "%d", nframes);
    xv_set(Data_data_pop->eval_seqs_per_class, PANEL_LABEL_STRING,
	   priors_string, NULL);
    xv_set(Data_data_pop->eval_frames_per_class, PANEL_LABEL_STRING,
	   frames_string, NULL);
}

void
set_train_file()
{
    FILE *fp;

    /* set data_base_tmp and open file */
    fp = open_data_base_file(ext_train);
    xv_set(Data_data_pop->train_msg, PANEL_LABEL_STRING, data_base_tmp, NULL);
    if(fp != NULL) nn_params.npatterns_train = get_n_lines(fp);
    else nn_params.npatterns_train = 0;
    
    set_train_priors_string(fp);
    close_data_base_file(fp);
}

void
set_train_priors_string(fp)
     FILE *fp;
{
    int nframes;
    nframes = set_priors_string(fp, nn_params.npatterns_train);
    set_int_string(Data_data_pop->npatterns_train, "%d",
		   nn_params.npatterns_train);
    set_int_label(Data_data_pop->nframes_train, "%d", nframes);
    xv_set(Data_data_pop->train_seqs_per_class, PANEL_LABEL_STRING,
	   priors_string, NULL);
    xv_set(Data_data_pop->train_frames_per_class, PANEL_LABEL_STRING,
	   frames_string, NULL);
}

void
display_data_base_msgs()
{
    static char *input_labels_string = NULL;
    static char *output_labels_string = NULL;

    set_int_label(Data_data_pop->n_inputs_message, "%d", nn_params.nraw);
    set_int_label(Data_data_pop->n_outputs_message, "%d", nn_params.noutputs);
    if(input_labels_string != NULL)
      nn_free(input_labels_string, "for make_labels_string");
    input_labels_string = make_labels_string(df_args.input_labels);
    xv_set (Data_data_pop->input_labels_message, PANEL_LABEL_STRING,
	    input_labels_string, NULL);
    if(output_labels_string != NULL)
      nn_free(output_labels_string, "for make_labels_string");
    output_labels_string = make_labels_string(df_args.output_labels);
    xv_set (Data_data_pop->class_labels_message, PANEL_LABEL_STRING,
	    output_labels_string, NULL);
}

void
display_defaults_generate_msgs()
{
    static char *input_labels_string = NULL;
    static char *output_labels_string = NULL;

    xv_set(Data_defaults_pop->data_base_name, PANEL_LABEL_STRING,
	   data_base, NULL);
#ifdef notdef
    xv_set(Data_defaults_pop->db_type_set, PANEL_VALUE, df_args.db_type, NULL);
#endif
    set_int_string(Data_defaults_pop->data_n_inputs_set, "%d", nn_params.nraw);
    set_int_string(Data_defaults_pop->data_n_outputs_set, "%d",
		   nn_params.noutputs);
    if(input_labels_string != NULL)
      nn_free(input_labels_string, "for make_labels_string");
    input_labels_string = make_labels_string(df_args.input_labels);
    xv_set (Data_defaults_pop->data_input_labels_set, PANEL_VALUE,
	    input_labels_string, NULL);
    if(output_labels_string != NULL)
      nn_free(output_labels_string, "for make_labels_string");
    output_labels_string = make_labels_string(df_args.output_labels);
    xv_set (Data_defaults_pop->data_output_labels_set, PANEL_VALUE,
	    output_labels_string, NULL);
}

void
setup_shown_list()
{
    int nrows, i;
    DIR *dirp;
    struct dirent *dp;
    char *list_string;

    xv_set(Data_data_pop->data_base_list, PANEL_INACTIVE, TRUE, NULL);

    /* empty the current list */
    nrows = xv_get(Data_data_pop->data_base_list, PANEL_LIST_NROWS, NULL);
    for(; nrows > 0; nrows--){
	xv_set(Data_data_pop->data_base_list, PANEL_LIST_DELETE, 0, NULL);
    }
    
    dirp = opendir(nn_params.data_path);
    /* !!! what about failure to open directory? */
    if(dirp == NULL) return;

    for(dp = readdir(dirp); dp != NULL; dp = readdir(dirp)){
	if(strstr(dp->d_name, defaults_suffix) != NULL){
	    /* find the position for this string on the list */
	    for(i = 0; i < nrows; i++){
		list_string = (char *)
		  xv_get(Data_data_pop->data_base_list, PANEL_LIST_STRING,
			 i, NULL);
		if(strcasecmp(list_string, dp->d_name) > 0) break;
	    }
	    xv_set(Data_data_pop->data_base_list,
		   PANEL_LIST_INSERT, i,
		   PANEL_LIST_STRING, i, dp->d_name,
		   NULL);
	    nrows++;
	}
    }
    closedir(dirp);
    xv_set(Data_data_pop->data_base_list, PANEL_INACTIVE, FALSE, NULL);
    selected_row = -1;
}

void
data_set_data_base()
{
    void g_set_normalize_filename();

    nn_params.data_base = data_base;
    /* display data base as selection */
    xv_set(Data_data_pop->data_base, PANEL_VALUE, data_base, NULL);
    xv_set(Data_defaults_pop->data_base_name, PANEL_LABEL_STRING,
	   data_base, NULL);
    g_set_normalize_filename();
    update_data_base();
}


/* defaults file arguments, table, and routines */
static char *data_path_arg = "./";
static char *defaults_suffix_arg = ".defaults";
static char *data_base_arg = "";
static char *ext_eval_arg = ".eval";
static char *ext_test_arg = ".test";
static char *ext_train_arg = ".train";
static int npatterns_train_arg = 0;
static int npatterns_test_arg = 0;
static int npatterns_eval_arg = 0;
static int db_type = 0;
static int ninputs = 0;
static int noutputs = 0;
static char **input_labels = NULL;
static char **class_labels = NULL;

static ARG datatab[] =
{
    {"data_path", STRING, (int *)&data_path_arg, ""},
    {"default_suffix", STRING, (int *)&defaults_suffix_arg, ""},
    {"data_base", STRING, (int *)&data_base_arg, ""},
    {"ext_train", STRING, (int *)&ext_train_arg, ""},
    {"ext_eval", STRING, (int *)&ext_eval_arg, ""},
    {"ext_test", STRING, (int *)&ext_test_arg, ""},
    {"npatterns_train", INT, &npatterns_train_arg, ""},
    {"npatterns_eval", INT, &npatterns_eval_arg, ""},
    {"npatterns_test", INT, &npatterns_test_arg, ""},
    {"db_type", INT, &db_type, "0-class,1-map,2-seq"},
    {"ninputs", INT, &ninputs, ""},
    {"noutputs", INT, &noutputs, ""},
    {"input_labels", STRING_ALLOC_LIST, (int *)&input_labels, ""},
    {"class_labels", STRING_ALLOC_LIST, (int *)&class_labels, ""},
};
#define TABSIZE (sizeof(datatab)/sizeof(ARG))

void
read_data_defaults(default_file, default_fullname)
     FILE *default_file;
     char *default_fullname;
{
    /*SUPPRESS 594*/
    int nargc;

    /* clear input_labels and class_labels, which are not there if they
       were NULL before */
    input_labels = class_labels = NULL;
    data_path_arg = defaults_suffix_arg = data_base_arg = NULL;
    ext_train_arg = ext_eval_arg = ext_test_arg = NULL;

    if(default_file != NULL){
	nargc = nnargs_from_file(default_file, default_fullname,
				 datatab, TABSIZE);
    } else {
	data_path_arg = "./";
        defaults_suffix_arg = ".defaults";
	data_base_arg = "vowel";
	ext_train_arg = ".train";
	ext_eval_arg = ".eval";
	ext_test_arg = ".test";
    }
    nn_params.data_path = strcpy_empty_if_null(data_path_val, data_path_arg);
    nn_params.desc_suff =
      strcpy_empty_if_null(defaults_suffix, defaults_suffix_arg);
    nn_params.data_base = strcpy_empty_if_null(data_base, data_base_arg);
    nn_params.ext_eval = strcpy_empty_if_null(ext_eval, ext_eval_arg);
    nn_params.ext_test = strcpy_empty_if_null(ext_test, ext_test_arg);
    nn_params.ext_train = strcpy_empty_if_null(ext_train, ext_train_arg);
    nn_params.npatterns_train = npatterns_train_arg;
    nn_params.npatterns_test = npatterns_test_arg;
    nn_params.npatterns_eval = npatterns_eval_arg;
    df_args.db_type = nn_params.db_type = db_type;
    df_args.ninputs = nn_params.nraw = ninputs;
    df_args.noutputs = nn_params.noutputs = noutputs;
    if(df_args.input_labels != NULL){
	deallocate_string_vector(df_args.input_labels,
				 atoi(df_args.input_labels[0]));
	df_args.input_labels = NULL;
    }
    if(df_args.output_labels != NULL){
	deallocate_string_vector(df_args.output_labels,
				 atoi(df_args.output_labels[0]));
	df_args.output_labels = NULL;
    }
    /* string_alloc_list substrings are allocated, so this is ok */
    nn_params.input_labels = df_args.input_labels = input_labels;
    nn_params.output_labels = df_args.output_labels = class_labels;

    set_data_path_full();
    setup_shown_list();
    
    g_display_data();
}

void
write_data_defaults(default_file)
     FILE *default_file;
{
    data_path_arg = null_if_empty_string(data_path_val);
    data_path_arg = null_if_empty_string(data_path_val);
    defaults_suffix_arg = null_if_empty_string(defaults_suffix);
    data_base_arg = null_if_empty_string(data_base);
    ext_eval_arg = null_if_empty_string(ext_eval);
    ext_test_arg = null_if_empty_string(ext_test);
    ext_train_arg = null_if_empty_string(ext_train);
    npatterns_train_arg = nn_params.npatterns_train;
    npatterns_test_arg = nn_params.npatterns_test;
    npatterns_eval_arg = nn_params.npatterns_eval;
    db_type = df_args.db_type;
    ninputs = df_args.ninputs;
    noutputs = df_args.noutputs;
    input_labels = df_args.input_labels;
    class_labels = df_args.output_labels;
    if(default_file != NULL){
	fprintf(default_file, "%s %s", "data",
		nnargs_get_flags(datatab, TABSIZE));
    }
}

set_data_path_full()
{
    if(data_path_val[0] == '/')
      strcpy(data_path_full, data_path_val);
    else {
	chdir(data_path_val);
	getwd(data_path_full);
	chdir(nn_params.working_directory);
    }
    nn_params.data_path = data_path_full;
}
