/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* designators for the algorithms in LNKnet */
#ifndef galgs_h
#define galgs_h

/* algorithm integer designator */
typedef enum{
    MLP, GAUSS, RBF, GMIX, IRBF, KMEANS, extra}
algorithm_number;
/* extra is to allow KMEANS + 1 to be a real number */

static char *classifier_strings[] = {
    /* classification algorithms */
    "MLP (Multi-Layer Perceptron)",
    "GAUSS (Gaussian)", 
    "RBF (Radial Basis Function)", 
    "GMIX (Gaussian Mixture)",
    "IRBF (Incremental RBF)", 
    /* clustering algorithms */
    "KMEANS (K Means Clustering)",
    /* contributed algorithms */
};
static char *classifier_names[] = {
    "mlp_seq", "gauss_seq", "rbf_seq", "gmix_seq", "irbf_seq", "kmeans_seq"};

#endif
