/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * gnn_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `gnn.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include <gen_seq_args.h>
#include "../LNKseq_subs.h"
#include "nn_params.h"
#include "gseq_ui.h"
#include "menus_ui.h"
#include "reports_ui.h"
#include "data_ui.h"
#include "norm_ui.h"
#include "select_ui.h"

extern	gseq_main_window_objects	*Gseq_main_window;
extern	data_data_pop_objects	*Data_data_pop;
extern	norm_norm_pop_objects	*Norm_norm_pop;
extern	select_select_pop_objects	*Select_select_pop;
extern	reports_file_pop_objects	*Reports_file_pop;

static int store_only;
static int append_flag;
static int run_options;
static int test_select;
#define MAXSTR 256
static char exp_name[MAXSTR] = "";/* the part the user types */
static char full_exp_name[MAXSTR] = "";/* with algorithm added */
static char ext_test_train[] = ".test_on_train";
static char temp_filename[MAXSTR];
static char ext_cv[MAXSTR] = ".cv";
static char cv_filename[MAXSTR] = "";/* !!! update with data base */

static int exper_pid = 0;

#define RUN_TRAIN 0
#define RUN_TEST 1
#define RUN_TRAIN_AND_TEST 2
#define RUN_CROSS_VALID 3

#define CLASS_TRAIN 0
#define CLASS_EVAL 1
#define CLASS_TEST 2
#define TRAIN_TRAIN 3
#define CV_TRAIN 4

#define DEFAULTS_FILENAME ".lnkseqrc"

#define SHOW_GRAPHICS 1
#define NO_GRAPHICS 0

void g_run();
void set_short_algorithm();
void g_defaults_write();
void set_experiment_name();
void gseq_set_common_flags();
void g_set_cvtest_flag();
void g_set_cv_filename();
void read_defaults();

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init ()
{
    void g_init_data(), g_init_norm(), g_init_select();
    void g_init_reports();
    /* set gseq's variables */
    store_only = 0;
    run_options = 0;
    random_flag = 0;
    test_select = CLASS_EVAL;
    nn_params.exp_name = full_exp_name;
    nn_params.ext_test_train = ext_test_train;
    nn_params.exp_prefix = exp_name;

    /* set variables on gseq's popups */
    g_init_data();
    g_init_norm();
    g_init_select();
    g_init_reports();
}

g_display()
{
    void g_display_data(), g_display_norm(), g_display_select();
    void g_display_reports();

    g_display_data();
    g_display_norm();
    g_display_select();
    g_display_reports();

    xv_set (Gseq_main_window->random_flag, PANEL_VALUE, random_flag, NULL);
    set_int_string(Gseq_main_window->seed, "%d", seed);
    xv_set (Gseq_main_window->store_only, PANEL_VALUE, store_only, NULL);
    xv_set (Gseq_main_window->action_select, PANEL_VALUE, run_options, NULL);
    xv_set (Gseq_main_window->test_select, PANEL_VALUE, test_select, NULL);
    xv_set (Gseq_main_window->cv_from_file, PANEL_VALUE, cross_valid_from_file, NULL);
    xv_set (Gseq_main_window->ext_cv, PANEL_VALUE, ext_cv, NULL);
    set_int_string(Gseq_main_window->cross_valid, "%d", cross_valid);
    /* do graying out for cross valid */
    g_set_cvtest_flag(run_options == RUN_CROSS_VALID);
    xv_set (Gseq_main_window->experiment_name, PANEL_VALUE, exp_name, NULL);
    set_short_algorithm(nn_params.algorithm);
}

/*
 * Notify callback function for main window buttons
 */
void
main_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    gseq_main_window_objects *ip =
      (gseq_main_window_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    void show_algorithm_popup();
    FILE *default_file;
	
    if(item == ip->Continue){
	create_flag = FALSE;
	append_flag = TRUE;
	g_run ();
    } else if(item == ip->start_run){
	create_flag = TRUE;
	append_flag = FALSE;
	g_run();
    } else if(item == ip->stop_run){
	stop_command_file(exper_pid);
	exper_pid = 0;
    } else if(item == ip->save_defaults){
	strcpy (temp_filename, path_build(getenv("HOME"), DEFAULTS_FILENAME));
	if (overwrite_ok (temp_filename)) {
	    g_defaults_write (temp_filename);
	    printf ("\nLNKseq default values saved in %s\n", temp_filename);
	}
    } else if(item == ip->restore_defaults){
	strcpy (temp_filename, path_build(getenv("HOME"), DEFAULTS_FILENAME));
	default_file = fopen(temp_filename, "r");
	read_defaults(default_file, temp_filename);
	if(default_file != NULL)
	  nn_fclose(default_file, temp_filename,
		    "for reading LNKseq defaults");
    }	/* buttons that call up other windows */
    else if (item == ip->data_button){
	xv_set(Data_data_pop->data_pop, FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
	xv_set(Data_data_pop->data_pop, XV_SHOW, TRUE, NULL);
    } else if(item == ip->norm_button){
	xv_set(Norm_norm_pop->norm_pop, FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
	xv_set(Norm_norm_pop->norm_pop, XV_SHOW, TRUE, NULL);
    } else if(item == ip->feature_button){
	xv_set(Select_select_pop->select_pop, FRAME_CMD_PUSHPIN_IN,
	       TRUE, NULL);
	xv_set(Select_select_pop->select_pop, XV_SHOW, TRUE, NULL);
    } else if(item == ip->alg_button){
	show_algorithm_popup();
    } else if(item == ip->report_button){
	xv_set(Reports_file_pop->file_pop, FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
	xv_set(Reports_file_pop->file_pop, XV_SHOW, TRUE, NULL);
    } else {
	fputs("LNKseq: main_btn_handler, unhandled button\n", stderr);
    }
}

/*
 * Notify callback function for main window text fields
 */
Panel_setting
main_2_handler(item, event)
     Panel_item	item;
     Event	*event;
{
    gseq_main_window_objects *ip =
      (gseq_main_window_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if(item == ip->cross_valid){
	cross_valid = set_atoi_low_value(value, "cross_valid_nfolds",
					 item, cross_valid, 2);
    } else if(item == ip->ext_cv){
	strcpy (ext_cv, value);
	xv_set (Gseq_main_window->ext_cv, PANEL_VALUE, ext_cv, NULL);
	g_set_cv_filename();
    } else if(item == ip->experiment_name){
	set_experiment_name(value);
    } else if (item == ip->seed){
	seed = set_atoi_value(value, "seed", item, seed);
    } else {
	fprintf(stderr, "LNKseq: main_2_handler: unhandled: value: %s\n",
		value);
    }    
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for main window settings
 */
void
main_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    gseq_main_window_objects *ip =
      (gseq_main_window_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
    void activate_features();
	
    if(item == ip->store_only){
	nn_params.store_only = store_only = value;
    } else if(item == ip->cv_from_file){
	if(value){
	    cross_valid_from_file = 1;
	    xv_set (ip->ext_cv, PANEL_INACTIVE, FALSE, NULL);
	    xv_set (ip->cross_valid, PANEL_INACTIVE, TRUE, NULL);
	} else {
	    cross_valid_from_file = 0;
	    xv_set (ip->ext_cv, PANEL_INACTIVE, TRUE, NULL);
	    xv_set (ip->cross_valid, PANEL_INACTIVE, FALSE, NULL);
	}
    } else if(item == ip->random_flag){
	random_flag = value;
    } else if(item == ip->action_select){
	run_options = value;
	if(run_options == RUN_TEST)
	  activate_features(FALSE);
	else 
	  activate_features(TRUE);
	g_set_cvtest_flag(run_options == RUN_CROSS_VALID);
    } else if(item == ip->test_select){
	test_select = value;
    } else {
	fputs("LNKseq: main_3_handler: unhandled setting\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    
	    /* gxv_start_connections DO NOT EDIT THIS SECTION */
	    
	    /* gxv_end_connections */
	    
	    value >>= 1;
	}
    }
}

void
g_run ()
{
    if (overwrite_ok(nn_params.shell_path)) {
	if(store_commands(nn_params.shell_path)) return;
	if(!store_only)
	  exper_pid = chdir_and_execute_command(nn_params.shell_fname);
    }
}

void
g_set_cvtest_flag(value)
     int value;
{
    if(value){	    
	cross_valid =
	  atoi(xv_get (Gseq_main_window->cross_valid, PANEL_VALUE));
	xv_set(Gseq_main_window->cv_from_file, PANEL_INACTIVE, FALSE, NULL);
	if(cross_valid_from_file){
	    xv_set(Gseq_main_window->ext_cv, PANEL_INACTIVE, FALSE, NULL);
	} else {
	    xv_set (Gseq_main_window->cross_valid, PANEL_INACTIVE, FALSE, NULL);
	}
	xv_set(Gseq_main_window->test_select,
	       PANEL_VALUE, CLASS_TRAIN,
	       PANEL_INACTIVE, TRUE, NULL);
    } else {
	cross_valid = 0;
	xv_set (Gseq_main_window->cross_valid, PANEL_INACTIVE, TRUE, NULL);
	xv_set (Gseq_main_window->cv_from_file, PANEL_INACTIVE, TRUE, NULL);
	xv_set (Gseq_main_window->ext_cv, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Gseq_main_window->test_select,
	       PANEL_VALUE, test_select,
	       PANEL_INACTIVE, FALSE, NULL);
    }
}

/* set cross_valid without changing anything else.
   needed by feature selection window */
int set_cv_nfolds(cv_val)
     int cv_val;
{
    int rv;
    rv = cross_valid;
    cross_valid = cv_val;
    return rv;
}

void
g_set_cv_filename()
{
    strcpy (cv_filename, nn_params.data_base);
    strcat (cv_filename, nn_params.ext_train);
    strcat (cv_filename, ext_cv);
    cross_valid_fname = cv_filename;
}

void
activate_test_selects(activate_flag)
     int activate_flag;
{
    /* this used to change the run_options */
    if(activate_flag){
	xv_set(Data_data_pop->ext_eval, PANEL_INACTIVE, FALSE, NULL);
	xv_set(Data_data_pop->npatterns_eval, PANEL_INACTIVE, FALSE, NULL);
	xv_set(Data_data_pop->ext_test, PANEL_INACTIVE, FALSE, NULL);
	xv_set(Data_data_pop->npatterns_test, PANEL_INACTIVE, FALSE, NULL);
    } else {
	xv_set(Data_data_pop->ext_eval, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Data_data_pop->npatterns_eval, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Data_data_pop->ext_test, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Data_data_pop->npatterns_test, PANEL_INACTIVE, TRUE, NULL);
    }
}

void
set_algorithm(value)
     int	value;
{
    void set_short_algorithm();

    set_short_algorithm(value);
    set_experiment_name(exp_name); /* adds in classifier name and
				      tells dependents */
}

void
g_defaults_write(default_fullname)
     char *default_fullname;
{
    FILE *default_file;
    
    default_file = fopen(default_fullname, "w", "defaults file");
    write_defaults(default_file);
    nn_fclose(default_file, default_fullname, 
	      "for reading data description");
}

/* defaults file arguments, table, and routines */
static int algorithm_arg = 0;
static char *exp_tmp = "";
static char *ext_cv_arg = ".cv";

static ARG maintab[] =
{
    {"store_only", INT, &store_only, ""},
    {"action", INT, &run_options, "1-TRAIN,2-TEST,3-TRAIN&TEST,4-CV"},
    {"test_file", INT, &test_select, "1-train,2-eval,2-test"},
    {"cv_nfolds", INT, &cross_valid, ""},
    {"cv_from_file", INT, &cross_valid_from_file, ""},
    {"ext_cv", STRING, (int *)&ext_cv_arg, ""},
    {"random", INT, &random_flag, ""},
    {"algorithm", INT, &algorithm_arg, ""},
    {"exp_name", STRING, (int *)&exp_tmp, ""},
    {"seed", INT, &seed, ""},
};
#define TABSIZE (sizeof(maintab)/sizeof(ARG))

void
read_main_defaults(default_file, default_fullname)
     FILE *default_file;
     char *default_fullname;
{
    /*SUPPRESS 594*/
    int nargc;
    
    /* set variables that are not included if they are NULL or 0 */
    exp_tmp = NULL;
    ext_cv_arg = NULL;

    if(default_file != NULL){
	nargc = nnargs_from_file(default_file, default_fullname,
				 maintab, TABSIZE);
    } else {
	/* set some defaults for initial startup */
	random_flag = 1;	/* turn on randomization */
	algorithm_arg = 3;	/* MLP, usually */
	ext_cv_arg = ".cv";
	cross_valid = 2;
	exp_tmp = "X1";
    }
    nn_params.algorithm = algorithm_arg;
    strcpy_empty_if_null(exp_name, exp_tmp);
    strcpy_empty_if_null(ext_cv, ext_cv_arg);
}

void
write_main_defaults (default_file)
     FILE *default_file;
{
    algorithm_arg = nn_params.algorithm;
    exp_tmp = null_if_empty_string(exp_name);
    ext_cv_arg = null_if_empty_string(ext_cv);
    if(default_file != NULL){
	fprintf (default_file, "%s %s", get_program_name(),
		 nnargs_get_flags(maintab, TABSIZE));
    }
}

void
g_get_defaults ()
{
    /* get arguments from default file if present */
    FILE *default_file;
    char *default_fullname;

    default_fullname = path_build(getenv("HOME"), DEFAULTS_FILENAME);
    default_file = fopen(default_fullname, "r");
    read_defaults(default_file, default_fullname);
    if(default_file != NULL)
      nn_fclose(default_file, DEFAULTS_FILENAME,
		"for reading LNKseq defaults");
}

static char *exp_path_tmp;

void
set_temp_exp_path(shell_file)
     FILE *shell_file;
{
    exp_path_tmp = nn_params.exp_path;
    exp_path = nn_params.exp_path = "$loc";
    
    /* print out variable necessary for running remotely */
    fprintf(shell_file, "set loc=`pwd`\n");
}

void
restore_exp_path()
{
    nn_params.exp_path = exp_path = exp_path_tmp;
}

int
store_commands (filename)
     char *filename;
{
    FILE *shell_file;
    void set_common_flags();
    void store_commands_specific();
    
    shell_file = command_file_open (filename, "for run shell file");
    if(shell_file == NULL) return -1;
    
    set_temp_exp_path(shell_file);

    /* store train commands */
    if (run_options == RUN_TRAIN || run_options == RUN_TRAIN_AND_TEST) {
	set_common_flags(TRAIN_TRAIN);
	train_flag = TRUE;
	fprintf(shell_file, "\n#train\n");
	store_commands_specific (shell_file);
	create_flag = FALSE; /* ensure log file contains all of run */
	append_flag = TRUE;
    }
    train_flag = FALSE;

    /* store test commands */
    if(run_options == RUN_TEST || run_options == RUN_TRAIN_AND_TEST) {
	fprintf(shell_file, "\n#test\n");
	set_common_flags(test_select);
	store_commands_specific (shell_file);
	create_flag = FALSE;
	append_flag = TRUE;
    }
    /* store cross valid commands */
    if(run_options == RUN_CROSS_VALID){
	fprintf(shell_file, "\n#cross validation\n");
	set_common_flags(CV_TRAIN);
	if(cross_valid > 1){
	    store_commands_specific (shell_file);
	}
    }

    restore_exp_path();
    
    /* tell the log file where we are */
    /* telling sooner risks the log file being overwritten */
    fprintf(shell_file, "echo \"current directory:\" >> %s\n",
	    nn_params.log_fname);
    fprintf(shell_file, "echo $loc >> %s\n", nn_params.log_fname);
    
    command_file_close (shell_file, filename, "for run shell file");

    /* store screen file */
    g_defaults_write(nn_params.screen_path);

    return 0;
}

void
store_commands_specific (shell_file)
     FILE *shell_file;
{
    void g_store_run_command();
    char *g_get_cluster_fname(), *g_get_alg_args();
    char *temp_fname;
    int clus_alg, temp_alg;
    
    /* store clustering commands */
    if(must_store_clustering() &&
       ((train_flag && create_flag) || cross_valid > 1)){

	/* set param_fname and algorithm */
	temp_fname = param_fname;
	param_fname = g_get_cluster_fname();
	temp_alg = g_get_alg();
	clus_alg = g_get_cluster_alg();
	g_set_alg(clus_alg);
	    
	store_command_head(shell_file);
	fprintf(shell_file, "%s", g_get_alg_args());
	store_command_end(shell_file);
	    
	/* reset param_fname and algorithm */
	param_fname = temp_fname;
	g_set_alg(temp_alg);
	append_flag = TRUE;
    }
    /* store train, test, or cv command */
    store_command_head(shell_file);
    fprintf(shell_file, "%s", g_get_alg_args());
    store_command_end(shell_file);
}

char *
g_get_gen_seq_args()
{
    return nnargs_get_part_flags(gen_tab, GEN_TABSIZE);
}

store_command_head(shell_file)
    FILE *shell_file;
{
    if(nn_params.verbosity > 1)
      fprintf(shell_file, "(time ");
    fprintf(shell_file, "%s\\\n %s",
	    nn_params.classifier_name, g_get_gen_seq_args());
}

store_command_end(shell_file)
     FILE *shell_file;
{
    if(nn_params.verbosity > 1)
      fprintf(shell_file, ")");
    if(store_only){
	fprintf(shell_file, ">");
	if(append_flag) fprintf(shell_file, ">");
	fprintf(shell_file, "& %s\n", nn_params.log_fname);
    } else {
	fprintf(shell_file, "|& nn_tee -h ");
	if(append_flag) fprintf(shell_file, "-a ");
	fprintf(shell_file, "%s\n", nn_params.log_fname);
    }
}

/* build the experiment name string and tell dependent windows */
void
set_experiment_name(value)
     char *value;
{
    void create_experiment_file_names();
    void g_set_cluster_names();

    strcpy(exp_name, value);
    nn_params.exp_prefix = exp_name;
    strcpy(full_exp_name, value);
    strcat(full_exp_name, nn_params.classifier_name);
    nn_params.exp_name = full_exp_name;
    g_set_cluster_names();
    create_experiment_file_names();
}

void
gseq_set_common_flags(which_data)
     int which_data;
{
    static char tmp_data_fname_space[MAXSTR];
    static char tmp_error_fname_space[MAXSTR];
    char *data_exten = NULL, *err_exten = NULL;

    /* build data_fname */
    switch(which_data){
      case CLASS_TRAIN:
      case TRAIN_TRAIN:
      case CV_TRAIN:
	data_exten = nn_params.ext_train;
	nsequences = nn_params.npatterns_train;
	break;
      case CLASS_EVAL:
	nsequences = nn_params.npatterns_eval;
	data_exten = nn_params.ext_eval;
	break;
      case CLASS_TEST:
	nsequences = nn_params.npatterns_test;
	data_exten = nn_params.ext_test;
	break;
    }
    strcpy(tmp_data_fname_space, nn_params.data_base);
    strcat(tmp_data_fname_space, data_exten);
    data_fname = tmp_data_fname_space;

    /* build error_fname */
    switch(which_data){
      case TRAIN_TRAIN:
	err_exten = nn_params.ext_train;
	break;
      case CLASS_TRAIN:
	err_exten = ext_test_train;
	break;
      case CLASS_EVAL:
	err_exten = nn_params.ext_eval;
	break;
      case CLASS_TEST:
	err_exten = nn_params.ext_test;
	break;
      case CV_TRAIN:
	err_exten = ext_cv;
	break;
    }
    strcpy(tmp_error_fname_space, nn_params.error_fname);
    strcat(tmp_error_fname_space, err_exten);
    error_fname = tmp_error_fname_space;
    
    /* train, create */
    /* exp_path */
    /* error_fname */
    param_fname = nn_params.param_fname;
    data_path = nn_params.data_path;
    desc_fname = nn_params.desc_fname;
    /* nsequences */
    ninputs = nn_params.ninputs;
    features = nn_params.features;
    window_width = nn_params.window_width;
    window_frames = nn_params.window_frames;
    normalize = nn_params.normalize;
    norm_fname = nn_params.norm_fname;
    /* cross_valid */
    /* random, seed */
    verbosity = nn_params.verbosity;
    verror = nn_params.verror;
}
