/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * norm_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `norm.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include <norm_args.h>			/* nnargs definitions */
#define NORM_PROGRAM_NAME "norm_seq"
#define PLOT_NORM "plot_norm"
#include <plot_norm_args.h>
#include "nn_params.h"
#include "norm_ui.h"
#include "../LNKseq_main_ui.h"
#include "../LNKseq_subs.h"

extern	norm_norm_pop_objects	*Norm_norm_pop;
extern	norm_norm_generate_pop_objects	*Norm_norm_generate_pop;
extern lnkseq_glyph_objects *LNKseq_glyphs;


/* macros for normalization */
#define NONE 0
#define SIMPLE 1
#define PCA 2
#define LDA 3

#define EXP_AND_PLOT 0
#define PLOT_ONLY 1

#define MAXSTR 256
static char norm_ftmp[MAXSTR];	/* normalization parameter file */
static char data_ftmp[MAXSTR];	/* data file */
static char norm_plot_ftmp[MAXSTR];	/* plot file */
static char norm_plot_lbl_tmp[MAXSTR];	/* plot label */
static char norm_log_ftmp[MAXSTR];	/* log file */
static char norm_shell_ftmp[MAXSTR];	/* shell file */
static int norm_plot;

static int norm_pid = 0;

void g_set_normalize_filename();
void set_select_n();
void g_set_norm_autoscale();
void gnorm_set_common_flags();
void norm_run();
void g_set_norm_plot_label();
void activate_norm_plots();
void norm_check_file();

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init_norm()
{
    nn_params.normalize = 0;
    nn_params.norm_fname = norm_ftmp;
    norm_plot = 1;
    norm_plot_fname = norm_plot_ftmp;
    norm_fname = norm_ftmp;
}

void
g_display_norm()
{
    /* norm window */
    xv_set (Norm_norm_pop->normalize, PANEL_VALUE, nn_params.normalize, NULL);
    xv_set (Norm_norm_pop->norm_file, PANEL_VALUE, nn_params.norm_fname, NULL);
    norm_check_file();

    /* norm_generate window */
    xv_set(Norm_norm_generate_pop->norm_type_msg, PANEL_LABEL_STRING,
	   norm_description(nn_params.normalize), NULL);
    xv_set(Norm_norm_generate_pop->norm_file_msg, PANEL_LABEL_STRING,
	   nn_params.norm_fname, NULL);
    xv_set(Norm_norm_generate_pop->norm_shell_script, PANEL_VALUE,
	   norm_shell_ftmp, NULL);
    xv_set(Norm_norm_generate_pop->norm_log_file, PANEL_VALUE,
	   norm_log_ftmp, NULL);
    xv_set(Norm_norm_generate_pop->norm_do_plot, PANEL_VALUE, norm_plot,
	   NULL);
    xv_set(Norm_norm_generate_pop->norm_plot_file, PANEL_VALUE,
	   norm_plot_fname, NULL);
    xv_set (Norm_norm_generate_pop->norm_autoscale, PANEL_VALUE, 
            norm_auto_scale_flag, NULL);
    g_set_norm_autoscale(norm_auto_scale_flag);
    set_float_string(Norm_norm_generate_pop->norm_xmin, "%5.2g", norm_xmin);
    set_float_string (Norm_norm_generate_pop->norm_xmax, "%5.2g", norm_xmax);
    set_float_string (Norm_norm_generate_pop->norm_ymin, "%5.2g", norm_ymin);
    set_float_string (Norm_norm_generate_pop->norm_ymax, "%5.2g", norm_ymax);
    set_float_string (Norm_norm_generate_pop->norm_xstep, "%5.2g", norm_xstep);
    set_float_string (Norm_norm_generate_pop->norm_ystep, "%5.2g", norm_ystep);
    xv_set(Norm_norm_generate_pop->norm_plot_label, PANEL_VALUE,
	   norm_plot_label, NULL);
    activate_norm_plots(nn_params.normalize == PCA ||
			nn_params.normalize == LDA);

}

/*
 * Notify callback function for norm settings
 */
void
norm_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    norm_norm_pop_objects *ip =
      (norm_norm_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->normalize){
	nn_params.normalize = value;
	/* if this is lda, we need to play with the feature selection */
	if(value == LDA) set_select_n(nn_params.ninputs);
	activate_norm_plots(value == PCA || value == LDA);
	g_set_normalize_filename();
	xv_set(Norm_norm_generate_pop->norm_type_msg, PANEL_LABEL_STRING,
	       norm_description(nn_params.normalize), NULL);

	/* update plot labels */
	sprintf(norm_plot_lbl_tmp, "Norm:%s",
		norm_description(nn_params.normalize));
	norm_plot_label = norm_plot_lbl_tmp;
	xv_set(Norm_norm_generate_pop->norm_plot_label, PANEL_VALUE,
	       norm_plot_label, NULL);
    } else {
	fprintf(stderr,
		"LNKseq: norm_3_handler: unhandled setting: value: %u\n",
		value);
    }
}

/*
 * Notify callback function for norm text items
 */
Panel_setting
norm_2_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    norm_norm_pop_objects *ip =
      (norm_norm_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if(item == ip->norm_file){
	nn_params.norm_fname = strcpy(norm_ftmp, value);
	g_set_norm_fname();
    } else {
	fprintf(stderr, "LNKseq: norm_2_handler: unhandled text: value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for `norm_generate'.
 */
void
norm_btn_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    norm_norm_pop_objects *ip =
      (norm_norm_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->norm_generate){
	xv_set(Norm_norm_generate_pop->norm_generate_pop,
	       FRAME_CMD_PUSHPIN_IN, TRUE, NULL);
	xv_set(Norm_norm_generate_pop->norm_generate_pop, XV_SHOW, TRUE, NULL);
    } else {
	fputs("LNKseq: norm_btn_handler: unhandled button\n", stderr);
    }
}

/*
 * Event callback function for `norm_warning'.
 */
void
norm_norm_pop_norm_warning_event_callback(item, event)
     Panel_item	item;
     Event	*event;
{
    if (event_action(event) == ACTION_SELECT) {
	norm_check_file();
    }
    panel_default_handle_event(item, event);
}

/*
 * Event callback function for `norm_err_message'.
 */
void
norm_norm_pop_norm_err_message_event_callback(item, event)
	Panel_item	item;
	Event		*event;
{
    if (event_action(event) == ACTION_SELECT) {
	norm_check_file();
    }
    panel_default_handle_event(item, event);
}

/*
 * Notify callback function for norm generate buttons
 */
void
norm_gen_btn_handler(item, event)
	Panel_item	item;
	Event		*event;/*ARGSUSED*/
{
    norm_norm_generate_pop_objects *ip =
      (norm_norm_generate_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->norm_cancel){
	stop_command_file(norm_pid);
	norm_pid = 0;
	xv_set(ip->norm_generate_pop,
	       FRAME_CMD_PUSHPIN_IN, FALSE, NULL);
	xv_set(ip->norm_generate_pop, XV_SHOW, FALSE, NULL);
    } else if(item == ip->norm_run){
	norm_run(EXP_AND_PLOT);
    } else if(item == ip->norm_plot_only){
	norm_run(PLOT_ONLY);
    } else {
	fputs("LNKseq: norm_gen_btn_handler: unhandled button\n", stderr);
    }
}

/*
 * Notify callback function for norm generate text items
 */
Panel_setting
norm_gen_2_handler(item, event)
     Panel_item	item;
     Event	*event;/*ARGSUSED*/
{
    norm_norm_generate_pop_objects *ip =
      (norm_norm_generate_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *	value = (char *) xv_get(item, PANEL_VALUE);
	
    if(item == ip->norm_shell_script){
	strcpy(norm_shell_ftmp, value);
    } else if (item == ip->norm_log_file){
	strcpy(norm_log_ftmp, value);
    } else if(item == ip->norm_plot_file){
	norm_plot_fname = strcpy(norm_plot_ftmp, value);
    } else if(item == ip->norm_xmax){
	norm_xmax = set_atof_value(value, "norm_xmax",
				   ip->norm_xmax, norm_xmax);
    } else if(item == ip->norm_xmin){
	norm_xmin = set_atof_value(value, "norm_xmin",
				   ip->norm_xmin, norm_xmin);
    } else if(item == ip->norm_xstep){
	norm_xstep = set_atof_value(value, "norm_xstep",
				   ip->norm_xstep, norm_xstep);
    } else if(item == ip->norm_ymax){
	norm_ymax = set_atof_value(value, "norm_ymax",
				   ip->norm_ymax, norm_ymax);
    } else if(item == ip->norm_ymin){
	norm_ymin = set_atof_value(value, "norm_ymin",
				   ip->norm_ymin, norm_ymin);
    } else if(item == ip->norm_ystep){
	norm_ystep = set_atof_value(value, "norm_ystep",
				   ip->norm_ystep, norm_ystep);
    } else if(item == ip->norm_plot_label){
	g_set_norm_plot_label(value);
    } else {
	fprintf(stderr,
		"LNKseq: norm_gen_2_handler: unhandled text: value: %s\n",
		value);
    }
    return panel_text_notify(item, event);
}

/*
 * Notify callback function for norm generate settings
 */
void
norm_gen_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    norm_norm_generate_pop_objects *ip =
      (norm_norm_generate_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    short	i;
	
    if(item == ip->norm_autoscale){
	g_set_norm_autoscale(value);
    } else if(item == ip->norm_do_plot){
	norm_plot = value;
    } else {
	fputs("LNKseq: norm_gen_3_handler: unhandled setting\n", stderr);
	for (i = 0; i < 1; i++) {
	    if (value & 01)
	      fprintf(stderr, "\t%dth item selected\n", i);
	    
	    value >>= 1;
	}
    }
}

void
g_set_normalize_filename()
{
    static char *norm_string[4] = {"none", "simple", "pca", "lda"};
    
    strcpy (norm_ftmp, nn_params.data_base);
    strcat (norm_ftmp, ".norm.");
    nn_params.norm_fname =
      strcat (norm_ftmp, norm_string[nn_params.normalize]);
    xv_set (Norm_norm_pop->norm_file, PANEL_VALUE, norm_ftmp, NULL);
    g_set_norm_fname();
}

/* set strings that depend on norm_fname */
g_set_norm_fname()
{
    norm_check_file();
    strcpy(norm_shell_ftmp, norm_ftmp);
    strcat(norm_shell_ftmp, ".run");
    xv_set(Norm_norm_generate_pop->norm_shell_script, PANEL_VALUE,
	   norm_shell_ftmp, NULL);
    strcpy(norm_log_ftmp, norm_ftmp);
    strcat(norm_log_ftmp, ".log");
    xv_set(Norm_norm_generate_pop->norm_log_file, PANEL_VALUE,
	   norm_log_ftmp, NULL);
    strcpy(norm_plot_ftmp, norm_ftmp);
    strcat(norm_plot_ftmp, ".plot");
    xv_set(Norm_norm_generate_pop->norm_plot_file, PANEL_VALUE,
	   norm_plot_ftmp, NULL);
    xv_set(Norm_norm_generate_pop->norm_file_msg, PANEL_LABEL_STRING,
	   norm_ftmp, NULL);
}

void
g_set_norm_autoscale (value)
     int value;
{
    int on_off;
    if(value) on_off = TRUE;
    else on_off = FALSE;
    norm_auto_scale_flag = on_off; 
    xv_set(Norm_norm_generate_pop->norm_axes_limits, PANEL_INACTIVE, on_off,
	   NULL);
    xv_set (Norm_norm_generate_pop->norm_xmin, PANEL_INACTIVE, on_off, NULL);
    xv_set (Norm_norm_generate_pop->norm_ymin, PANEL_INACTIVE, on_off, NULL);
    xv_set (Norm_norm_generate_pop->norm_xmax, PANEL_INACTIVE, on_off, NULL);
    xv_set (Norm_norm_generate_pop->norm_ymax, PANEL_INACTIVE, on_off, NULL);
    xv_set (Norm_norm_generate_pop->norm_xstep, PANEL_INACTIVE, on_off, NULL);
    xv_set (Norm_norm_generate_pop->norm_ystep, PANEL_INACTIVE, on_off, NULL);
}

void
g_set_norm_plot_label (value)
     char *value;
{
    sprintf (norm_plot_lbl_tmp, "\"%s\"", value);
    norm_plot_label = norm_plot_lbl_tmp;
}

char *
gnorm_get_plot_label (string)
     char * string;
{
    return string;
}

void
gnorm_set_common_flags()
{
    data_path = nn_params.data_path;
    strcpy(data_ftmp, nn_params.data_base);
    strcat(data_ftmp, nn_params.ext_train);
    data_fname = data_ftmp;
    desc_fname = nn_params.desc_fname;
    norm_fname = nn_params.norm_fname;
    normalization = nn_params.normalize;
    verbosity = nn_params.verbosity;
    /* npatterns is not set because the whole file is read, regardless */
    plot_exp_path = nn_params.exp_path;
    plot_error_fname = norm_fname;
    plot_n_inputs = nn_params.nraw;
    plot_n_outputs = nn_params.noutputs;
    mac_normlines_fname = "norm.mac";
    /* labels */
    norm_data_path = nn_params.data_path;
}

/* defaults file arguments, table, and routines */
static char *norm_shell_arg = "";
static char *norm_log_arg = "";

static ARG normtab[] =
{
    {"normalize", INT, &normalization, ""},
    {"norm_fname", STRING, (int *)&norm_fname, ""},
    {"shell_script", STRING, (int *)&norm_shell_arg, ""},
    {"log_file", STRING, (int *)&norm_log_arg, ""},
    {"generate_plot", INT, &norm_plot, ""},
};
#define NORM_DEF_LEN (sizeof(normtab)/sizeof(ARG))

void
write_norm_defaults(default_file)
     FILE *default_file;
{
    norm_fname = null_if_empty_string(norm_ftmp);
    norm_shell_arg = null_if_empty_string(norm_shell_ftmp);
    norm_log_arg = null_if_empty_string(norm_log_ftmp);

    norm_plot_fname = null_if_empty_string(norm_plot_ftmp);
    norm_plot_label = null_if_empty_string(norm_plot_lbl_tmp);

    /* strings set in gnorm_set_common_flags */
    plot_exp_path = null_if_empty_string(plot_exp_path);
    plot_error_fname = null_if_empty_string(plot_error_fname);
    norm_data_path = null_if_empty_string(norm_data_path);
    mac_normlines_fname = null_if_empty_string(mac_normlines_fname);

    if(default_file != NULL){
	/* regular flags */
	fprintf (default_file, "norm %s",
		 nnargs_get_part_flags(normtab, NORM_DEF_LEN));
	/* plot flags */
	fprintf (default_file, "%s",
		 nnargs_get_flags(norm_argtab, NORM_TABSIZE));
    }
}

void
read_norm_defaults(default_file, default_fullname)
     FILE *default_file;
     char *default_fullname;
{
    int nargc;
    char *argv[256];

    /* zero out flags that are not present when not set */
    norm_auto_scale_flag = 0;
    norm_fname = norm_shell_arg = norm_log_arg = NULL;
    norm_plot_label = norm_plot_fname = NULL;

    /* these flags are reset each time they are used */
    plot_exp_path = plot_error_fname = norm_data_path = NULL;
    mac_normlines_fname = NULL;

    if(default_file != NULL){
	nargc = fill_argv(argv, default_file, default_fullname);
	nargc = nnargs_part (nargc, argv, normtab, NORM_DEF_LEN);
	nargc = nnargs(nargc, argv, norm_argtab, NORM_TABSIZE);
    } else {
	normalization = SIMPLE;
	norm_auto_scale_flag = 1;
    }

    norm_plot_fname = strcpy_empty_if_null(norm_plot_ftmp, norm_plot_fname);
    norm_plot_label =
      strcpy_empty_if_null(norm_plot_lbl_tmp, norm_plot_label);

    nn_params.normalize = normalization;
    norm_fname = nn_params.norm_fname =
      strcpy_empty_if_null(norm_ftmp, norm_fname);
    strcpy_empty_if_null(norm_shell_ftmp, norm_shell_arg);
    strcpy_empty_if_null(norm_log_ftmp, norm_log_arg);
}

void
norm_run(run_flag)
     int run_flag;
{
    char *shell_path;
    shell_path = path_build(nn_params.exp_path, norm_shell_ftmp);
    if(overwrite_ok(shell_path)){
	if(store_norm_commands(shell_path, run_flag)) return;
	if(!nn_params.store_only)
	  norm_pid = chdir_and_execute_command(norm_shell_ftmp);
    }
}

int
store_norm_commands(shell_path, run_flag)
     char *shell_path;
     int run_flag;
{
    FILE *shell_file;

    gnorm_set_common_flags();

    shell_file = command_file_open(shell_path, "for norm shell file");
    if(shell_file == NULL) return -1;

    if(run_flag != PLOT_ONLY){
	fprintf (shell_file, "%s %s", NORM_PROGRAM_NAME,
		 nnargs_get_part_flags(argtab, TABSIZE));
	fprintf(shell_file, "|& nn_tee -h %s\n", norm_log_ftmp);
    }

    if(norm_plot || PLOT_ONLY){
	if(nn_params.normalize == PCA || nn_params.normalize == LDA)
	  fprintf(shell_file, "%s %s", PLOT_NORM,
		  nnargs_get_flags(norm_argtab, NORM_TABSIZE));
    }
    command_file_close(shell_file, shell_path, "for norm shell file");
    return 0;
}

void
activate_norm_plots(activate_flag)
     int activate_flag;
{
    if(activate_flag){
	xv_set(Norm_norm_generate_pop->norm_do_plot, PANEL_INACTIVE, FALSE,
	       NULL);
	xv_set(Norm_norm_generate_pop->norm_plot_file, PANEL_INACTIVE, FALSE,
	       NULL);
	xv_set(Norm_norm_generate_pop->norm_autoscale, PANEL_INACTIVE, FALSE,
	       NULL);
	g_set_norm_autoscale(norm_auto_scale_flag);
	xv_set(Norm_norm_generate_pop->norm_plot_label, PANEL_INACTIVE, FALSE,
	       NULL);
    } else {
	xv_set(Norm_norm_generate_pop->norm_do_plot, PANEL_INACTIVE, TRUE,
	       NULL);
	xv_set(Norm_norm_generate_pop->norm_plot_file, PANEL_INACTIVE, TRUE,
	       NULL);
	xv_set(Norm_norm_generate_pop->norm_autoscale, PANEL_INACTIVE, TRUE,
	       NULL);
	xv_set(Norm_norm_generate_pop->norm_axes_limits, PANEL_INACTIVE, TRUE,
	       NULL);
	xv_set(Norm_norm_generate_pop->norm_xmin, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Norm_norm_generate_pop->norm_ymin, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Norm_norm_generate_pop->norm_xmax, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Norm_norm_generate_pop->norm_ymax, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Norm_norm_generate_pop->norm_xstep, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Norm_norm_generate_pop->norm_ystep, PANEL_INACTIVE, TRUE, NULL);
	xv_set(Norm_norm_generate_pop->norm_plot_label, PANEL_INACTIVE, TRUE,
	       NULL);
    }
}

void
norm_check_file()
{
    time_t train_time, norm_time;
    struct stat buf;
    char *train_path;

    if(nn_params.normalize == NONE){
	norm_clear_error();
	return;
    }
    /* check if the file exists */
    if(file_exists(path_build(nn_params.data_path, nn_params.norm_fname))){
	/* check that the training data file is older than the normalization
	   file */
	train_path = path_build(nn_params.data_path, nn_params.data_base);
	strcat(train_path, nn_params.ext_train);
	if(stat(train_path, &buf) == 0) train_time = buf.st_mtime;
	else train_time = 0;
	if(stat(path_build(nn_params.data_path, nn_params.norm_fname), &buf)
	   == 0) norm_time = buf.st_mtime;
	else norm_time = 1;
	if(norm_time < train_time){
	    norm_error("Warning: Normalization file is older than training file");
	} else{
	    norm_clear_error();
	}
    } else {
	norm_error("Error: Normalization file does not exist");
    }
}

norm_error(string)
     char *string;
{
    xv_set(Norm_norm_pop->norm_err_message, PANEL_LABEL_STRING,
	   string,
	   NULL);
    xv_set(Norm_norm_pop->norm_warning, PANEL_LABEL_IMAGE,
	   LNKseq_glyphs->LNKseq_warning_pic, NULL);
}

norm_clear_error()
{
    xv_set(Norm_norm_pop->norm_err_message, PANEL_LABEL_STRING,
	   "", NULL);
    xv_set(Norm_norm_pop->norm_warning, PANEL_LABEL_IMAGE,
	   LNKseq_glyphs->LNKseq_blank_pic, NULL);
}
