/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * select_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `select.G'.
 */

#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <X11/Xlib.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <nnlib.h>
#include "select_ui.h"
#include "nn_params.h"
#include "../LNKseq_subs.h"
#include "galgs.h"
#include "../LNKseq_main_ui.h"

#define MAXSTR 256

static int select_type; /* ALL vs FIRST_N, etc */

extern	select_select_pop_objects	*Select_select_pop;
extern lnkseq_glyph_objects *LNKseq_glyphs;
static int *feat_map = NULL;
static int *win_map = NULL;

/* macros for select_type */
#define ALL 0
#define FIRST_N 1
#define MANUAL 2

void set_feature_list();
void set_select_type();
void set_select_n();
void g_update_ninputs();
void set_feature_labels_string();
char *get_feature_labels();
void select_draw_windowing();

/* call once, on initialization.  sets variables and initializes
   strings in nn_params */
void
g_init_select()
{
    select_type = ALL;
    nn_params.ninputs = 0;
    nn_params.features = allocate_ivector(1);
    nn_params.features[0] = 0;
    nn_params.window_width = 1;
    nn_params.window_frames = allocate_ivector(1);
    nn_params.window_frames[0] = 0;
}

void
g_display_select()
{
    /* feature selection window */
    xv_set(Select_select_pop->select_type, PANEL_VALUE, select_type, NULL);
    xv_set(Select_select_pop->select_n, PANEL_VALUE, nn_params.ninputs, NULL);
    xv_set(Select_select_pop->select_feature_list, PANEL_VALUE,
	   make_net_string(nn_params.features), NULL);
    set_select_type(select_type);
    /* windowing */
    set_int_string(Select_select_pop->window_width, "%d",
		   nn_params.window_width);
    xv_set(Select_select_pop->window_frames, PANEL_VALUE,
	   make_net_string(nn_params.window_frames), NULL);
}

/*
 * Notify callback function for select settings
 */
void
select_3_handler(item, value, event)
     Panel_item	item;
     int	value;
     Event	*event;/*ARGSUSED*/
{
    select_select_pop_objects *ip =
      (select_select_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
    if(item == ip->select_type){
	set_select_type(value);
    } else {
	fprintf(stderr,
		"LNKseq: select_3_handler: unhandled setting: value: %u\n",
		value);
    }
}

/*
 * Notify callback function for select text items 
 */
Panel_setting
select_2_handler(item, event)
	Panel_item	item;
	Event		*event;
{
    select_select_pop_objects *ip =
      (select_select_pop_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    char *cvalue;
    int ivalue;
    static char tmp[NNMAX_LINE];
	
    if(item == ip->select_feature_list){
	cvalue = (char *) xv_get(item, PANEL_VALUE);
	set_feature_list(cvalue);
    } else if(item == ip->select_n){
	ivalue = (int) xv_get(item, PANEL_VALUE);
	set_select_n(ivalue);
	set_feature_labels_string();
	xv_set(Select_select_pop->select_n, PANEL_VALUE,
	       nn_params.ninputs, NULL);
    } else if(item == ip->window_width){
	cvalue = (char *) xv_get(item, PANEL_VALUE);
	nn_params.window_width =
	  set_atoi_value(cvalue, "window_width", item, nn_params.window_width);
	/* allocate win_map */
	select_draw_windowing(Select_select_pop->canvas1,
			      canvas_paint_window(Select_select_pop->canvas1),
			      (Display *)xv_get(Select_select_pop->canvas1, XV_DISPLAY),
			      xv_get(canvas_paint_window(Select_select_pop->canvas1), XV_XID),
			      (Xv_xrectlist *)NULL);
	/* !!! update mlp ninputs */
    } else if(item == ip->window_frames){
	cvalue = (char *)xv_get(item, PANEL_VALUE);
	if(nn_params.window_frames != NULL)
	  deallocate_ivector(nn_params.window_frames);
	nn_params.window_frames =
	  nnargs_get_int_alloc_list(strcpy(tmp,cvalue));
	select_draw_windowing(Select_select_pop->canvas1,
			      canvas_paint_window(Select_select_pop->canvas1),
			      (Display *)xv_get(Select_select_pop->canvas1, XV_DISPLAY),
			      xv_get(canvas_paint_window(Select_select_pop->canvas1), XV_XID),
			      (Xv_xrectlist *)NULL);
	/* !!! update mlp ninputs */
    } else {
	fprintf(stderr, "LNKseq: select_2_handler: unhandled text item:\n");
    }
	
    return panel_text_notify(item, event);
}

void
activate_features(activate_flag)
     int activate_flag;
{
    if(activate_flag){
	xv_set (Select_select_pop->select_type ,PANEL_INACTIVE, FALSE, NULL);
    } else {
	xv_set (Select_select_pop->select_type, PANEL_INACTIVE, TRUE, NULL);
    }
}

void
set_select_type(value)
     int value;
{
    select_type = value;

    xv_set(Select_select_pop->select_feature_list, PANEL_INACTIVE, TRUE, NULL);
    xv_set(Select_select_pop->select_n, PANEL_INACTIVE, TRUE, NULL);
    
    select_clear_error();
    switch(value){
      case ALL: /* all */
	set_select_n(nn_params.nraw);
	if(nn_params.features != NULL){
	    deallocate_ivector(nn_params.features);
	    nn_params.features = NULL;
	}
	set_feature_labels_string();
	break;
      case FIRST_N: /* first n */
	/* set ninputs to the value of what is stored in select_n */
	xv_set(Select_select_pop->select_n, PANEL_INACTIVE, FALSE, NULL);
	set_select_n(xv_get(Select_select_pop->select_n, PANEL_VALUE));
	if(nn_params.features != NULL){
	    deallocate_ivector(nn_params.features);
	    nn_params.features = NULL;
	}
	set_feature_labels_string();
	break;
      case MANUAL: /* fill in */
	xv_set(Select_select_pop->select_feature_list,
	       PANEL_INACTIVE, FALSE, NULL);
	nn_params.ninputs = 0;
	set_feature_list((char *)xv_get(Select_select_pop->select_feature_list,
					PANEL_VALUE));
	break;
      default: break;
    }
}

void
set_select_n(value)
     int value;
{
    nn_params.ninputs = value;
    if(nn_params.normalize == LDA)
      if(nn_params.ninputs > nn_params.noutputs-1){
	  nn_params.ninputs = nn_params.noutputs-1;
      }
    if(nn_params.ninputs > nn_params.nraw){
	nn_params.ninputs = nn_params.nraw;
    }
    g_update_ninputs();
    select_draw_windowing(Select_select_pop->canvas1,
			  canvas_paint_window(Select_select_pop->canvas1),
			  (Display *)xv_get(Select_select_pop->canvas1, XV_DISPLAY),
			  xv_get(canvas_paint_window(Select_select_pop->canvas1), XV_XID),
			  (Xv_xrectlist *)NULL);
}

/* called when nn_params.nraw is changed */
update_nraw_and_ninputs()
{
    if(select_type == ALL){
	set_select_n(nn_params.nraw);
    } else {
	set_select_n(nn_params.ninputs);
    }
    /* display new value */
    xv_set(Select_select_pop->select_n, PANEL_VALUE, nn_params.ninputs, NULL);
    /* allocate feat_map */
    set_feature_labels_string();
}

void
set_feature_list(value)
     char *value;
{
    static char tmp[NNMAX_LINE];
    int n;

    select_clear_error();
    if(nn_params.features != NULL) deallocate_ivector(nn_params.features);
    nn_params.features = nnargs_get_int_alloc_list(strcpy(tmp,value));
    set_select_n(nn_params.features[0]);
    if(nn_params.features[0] > nn_params.ninputs){
	/* take off the extra entries in feature list */
	nn_params.features[0] = nn_params.ninputs;
	xv_set(Select_select_pop->select_feature_list, PANEL_VALUE,
	       make_net_string(nn_params.features), NULL);
    }
    /* check all the features */
    for(n = 1; n <= nn_params.ninputs; n++){
	if(nn_params.features[n] < 0 ||
	   nn_params.features[n] >= nn_params.nraw ||
	   (nn_params.normalize == LDA &&
	    nn_params.features[n] >= nn_params.noutputs)){
	    select_error("Error: Bad feature in feature list");
	    nn_params.features[0] = 0;
	    set_select_n(0);
	    break;
	}
    }
    set_feature_labels_string();
    select_draw_windowing(Select_select_pop->canvas1,
			  canvas_paint_window(Select_select_pop->canvas1),
			  (Display *)xv_get(Select_select_pop->canvas1, XV_DISPLAY),
			  xv_get(canvas_paint_window(Select_select_pop->canvas1), XV_XID),
			  (Xv_xrectlist *)NULL);
}

void
set_feature_labels_string()
{
    static char *feature_labels_string = NULL;

    if(feature_labels_string != NULL)
      nn_free(feature_labels_string, "for feature_labels_string");
    feature_labels_string = get_feature_labels();
    xv_set(Select_select_pop->feature_labels, PANEL_LABEL_STRING,
	   feature_labels_string, NULL);
}

char *
get_feature_labels()
/* build a list of selected feature labels */
{
    int labels_len, total_length, i;
    char small_string[8];
    char *labels_string;

    if(nn_params.normalize == LDA){
	labels_string =
	  strdup("Feature labels unavailable for LDA normalization");
	if(labels_string == NULL)
	  fatal_error("get_feature_labels: cannot allocate string");
	return labels_string;
    }
    if(nn_params.normalize == PCA){
	labels_string =
	  strdup("Feature labels unavailable for PCA normalization");
	if(labels_string == NULL)
	  fatal_error("get_feature_labels: cannot allocate string");
	return labels_string;
    }
    if(nn_params.input_labels == NULL) labels_len = 0;
    else labels_len = atoi(nn_params.input_labels[0]);

    switch(select_type){
	/* put together a list of the selected features */
      case ALL:
      case FIRST_N:
	if(labels_len == 0){
	    /* just use 0,1,2 */
	    /* 5 chars per number, with the commas and the NIL at the end */
	    total_length = 6*nn_params.ninputs + 1;

	    labels_string = nn_malloc(total_length, "for make_labels_string");
	    labels_string[0] = '\0';
	    for(i = 0; i < nn_params.ninputs; i++){
		sprintf(small_string, "%d", i);
		strcat(labels_string, small_string);
		strcat(labels_string, ",");
	    }
	    /* take off the comma at the end */
	    total_length = strlen(labels_string);
	    if(total_length > 1) labels_string[total_length-1] = '\0';
	    return labels_string;
	}
	/* use the first ninputs entries in the existing list, if it is
	   long enough */
	if(labels_len < nn_params.ninputs){
	    /* labels length isn't long enough, just use 0,1,2,3? */
	    labels_string =
	      strdup("Not enough feature labels for this data base");
	    if(labels_string == NULL)
	      fatal_error("get_feature_labels: cannot allocate string");
	    return labels_string;
	} else if(labels_len == nn_params.ninputs){
	    labels_string = make_labels_string(nn_params.input_labels);
	} else {
	    /* we know that ninputs will fit because it is less than
	       labels_len */
	    sprintf(nn_params.input_labels[0], "%d", nn_params.ninputs);
	    labels_string = make_labels_string(nn_params.input_labels);
	    sprintf(nn_params.input_labels[0], "%d", labels_len);
	}
	return labels_string;
      case MANUAL:
	if(nn_params.features == NULL) return strdup("");
	total_length = 0;

	/* add up the length of the string to be created */
	for(i = 0; i < nn_params.ninputs; i++){
	    /* check for bad feature numbers */
	    if(nn_params.features[i+1] >= labels_len){
		if(labels_len == 0) total_length += 5; /* no more than 99999 */
		else {
		    labels_string =
		      strdup("Bad feature list or not enough labels");
		    if(labels_string == NULL)
		      fatal_error("get_feature_labels: cannot allocate string");
		    return labels_string;
		}
	    } else 
	      total_length +=
		strlen(nn_params.input_labels[nn_params.features[i+1]+1]);
	}
	/* remember the commas and the NIL at the end */
	total_length += nn_params.ninputs + 1;

	labels_string = nn_malloc(total_length, "for make_labels_string");
	labels_string[0] = '\0';
	if(labels_len > 0){
	    for(i = 0; i < nn_params.ninputs; i++){
		strcat(labels_string,
		       nn_params.input_labels[nn_params.features[i+1]+1]);
		strcat(labels_string, ",");
	    }
	} else {
	    for(i = 0; i < nn_params.ninputs && i < nn_params.features[0];
		i++){
		sprintf(small_string, "%d", nn_params.features[i+1]);
		strcat(labels_string, small_string);
		strcat(labels_string, ",");
	    }
	}

	/* take off the comma at the end */
	total_length = strlen(labels_string);
	if(total_length > 1) labels_string[total_length-1] = '\0';
	return labels_string;
    }
}

/* defaults file arguments, table, and routines */
static int ninputs_arg = 0;
static char *search_fname = "";
static char *search_shell = "";
static char *search_log = "";
static int *features = NULL;
static int *window_frames = NULL;
static int window_width = 1;

static ARG selecttab[] =
{
    {"select_type", INT, &select_type, "0-ALL,1-FIRST_N,2-MANUAL"},
    {"ninputs", INT, &ninputs_arg, ""},
    {"search_fname", STRING, (int *)&search_fname, ""},
    {"search_shell", STRING, (int *)&search_shell, ""},
    {"search_log", STRING, (int *)&search_log, ""},
    {"features", INT_ALLOC_LIST, (int *)&features, ""},
    {"window_width", INT, &window_width, ""},
    {"window_frames", INT_ALLOC_LIST, (int *)&window_frames, ""},
};
#define SELECT_DEF_LEN (sizeof(selecttab)/sizeof(ARG))

void
read_select_defaults(default_file, default_fullname)
     FILE *default_file;
     char *default_fullname;
{
    int nargc;
    char *argv[256];

    /* clear flags that are not present in the defaults file if they
       are not "set" */
    features = window_frames = NULL;
    search_fname = search_shell = search_log = NULL;

    /* these flags are reset each time they are used */

    if(default_file != NULL){
	nargc = nnargs_from_file (default_file, default_fullname,
				  selecttab, SELECT_DEF_LEN);
    } else {
    }

    nn_params.features = features;
    nn_params.ninputs = ninputs_arg;
    nn_params.window_width = window_width;
    nn_params.window_frames = window_frames;
}

void
write_select_defaults(default_file)
     FILE *default_file;
{
    features = nn_params.features;
    ninputs_arg = nn_params.ninputs;
    window_width = nn_params.window_width;
    window_frames = nn_params.window_frames;

    if(default_file != NULL){
	/* regular flags */
	fprintf (default_file, "select %s",
		 nnargs_get_flags(selecttab, SELECT_DEF_LEN));
    }
}

struct drawing_coords{
    int box_startx;
    int box_starty;
    int box_endx;
    int box_endy;
    int window_select_startx;
    int window_select_starty;
    int window_select_endx;
    int window_select_endy;
    int feature_select_startx;
    int feature_select_starty;
    int feature_select_endx;
    int feature_select_endy;
} drawC;

void
select_draw_windowing(canvas, paint_window, dpy, xwin, rects)
	Canvas		canvas;
	Xv_window	paint_window;
	Display		*dpy;
	Window		xwin;
	Xv_xrectlist	*rects;
{
    GC gc;
    XFontStruct *font_struct;
    int font_height, max_len;
#define BOX_WIDTH 20
#define BOX_FRAME 2
#define BOX_START 10
    int i, j;
    char *string1="Frames in Window";
    char *string2="Features";
    char small_string[10], *cp;

    gc = DefaultGC(dpy, DefaultScreen(dpy));
			  
    /* check for NULL before allocating */
    feat_map = allocate_ivector(nn_params.nraw);
    win_map = allocate_ivector(nn_params.window_width);

    /* set ones for selected features */
    if(select_type == ALL || select_type == FIRST_N){
	for(i = 0; i < nn_params.ninputs; i++) feat_map[i] = 1;
	for(; i < nn_params.nraw; i++) feat_map[i] = 0;
    } else {
	for(i = 0; i < nn_params.nraw; i++) feat_map[i] = 0;
	for(i = 1; i <= nn_params.ninputs; i++){
	    if(nn_params.features[i] < nn_params.nraw &&
	       nn_params.features[i] >= 0)
	      feat_map[nn_params.features[i]] = 1;
	}
    }

    /* set ones for selected frames */
    if(nn_params.window_frames != NULL && nn_params.window_frames[0] != 0){
	for(j = 1; j <= nn_params.window_frames[0]; j++){
	    if(nn_params.window_frames[j] < nn_params.window_width &&
	       nn_params.window_frames[j] >= 0){
		win_map[nn_params.window_frames[j]] = 1;
	    }
	}
    } else {
	for(j = 0; j < nn_params.window_width; j++){
	    win_map[j] = 1;
	}
    }
	    
    /* clear the window */
    XClearWindow(dpy, xwin);

    /* get font information for positioning */
    font_struct = XQueryFont(dpy, XGContextFromGC(gc));
    font_height = font_struct->ascent + font_struct->descent;

    /* draw the label for the frames */
    XDrawString(dpy,xwin,gc,BOX_START+2*font_height,BOX_START,
		string1, strlen(string1));/* "Frames in Window" */

    /* draw the label for the features vertically */
    small_string[1] = '\0';/* "Features" */
    for(i = 0, cp = string2; *cp != '\0'; cp++, i++){
	small_string[0] = *cp;
	XDrawString(dpy,xwin,gc,BOX_START,BOX_START+((i+2)*font_height),
		    small_string,1);
    }

    /* draw x and y axis labels (start and end numbers) */
    max_len = 0;
    for(i = 0; i < nn_params.nraw; i++){
	sprintf(small_string, "%d", i);
	XDrawString(dpy, xwin, gc,
		    BOX_START+font_height,
		    BOX_START+2*font_height+i*BOX_WIDTH,
		    small_string, strlen(small_string));
	/* get the maximum width of the string for positioning the boxes */
	if(max_len < strlen(small_string)) max_len = strlen(small_string);
    }
    for(j = 0; j < nn_params.window_width; j++){
	sprintf(small_string, "%d", j);
	XDrawString(dpy, xwin, gc,
		    BOX_START+font_height*(1+max_len)+j*BOX_WIDTH,
		    BOX_START+font_height,
		    small_string, strlen(small_string));
    }
    
    /* draw squares for selected patterns */
    drawC.box_startx = BOX_START+font_height*(1+max_len);
    drawC.box_starty = BOX_START+font_height+BOX_FRAME;
    drawC.box_endx = drawC.box_startx+nn_params.window_width*BOX_WIDTH;
    drawC.box_endy = drawC.box_starty+nn_params.nraw*BOX_WIDTH;

    for(i = 0; i < nn_params.nraw; i++){
	for(j = 0; j < nn_params.window_width; j++){
	    if(win_map[j] && feat_map[i]){
		XFillRectangle(dpy, xwin, gc,
			       drawC.box_startx+j*BOX_WIDTH,
			       drawC.box_starty+i*BOX_WIDTH,
			       BOX_WIDTH-BOX_FRAME, BOX_WIDTH-BOX_FRAME);
	    } else {
		XDrawRectangle(dpy, xwin, gc,
			       drawC.box_startx+j*BOX_WIDTH,
			       drawC.box_starty+i*BOX_WIDTH,
			       BOX_WIDTH-BOX_FRAME, BOX_WIDTH-BOX_FRAME);
	    }
	}
    }
    deallocate_ivector(feat_map);
    deallocate_ivector(win_map);
    win_map = feat_map = NULL;

#ifdef notdef
    /* draw squares for selecting windows */
    drawC.window_select_startx = drawC.box_startx;
    drawC.window_select_starty = drawC.box_endy+font_height;
    drawC.window_select_endx = drawC.box_endx;
    drawC.window_select_endy = drawC.window_select_starty+BOX_WIDTH;

    for(j = 0; j < nn_params.window_width; j++){
	if(win_map[j]){
	    XFillRectangle(dpy, xwin, gc,
			   drawC.window_select_startx+j*BOX_WIDTH,
			   drawC.window_select_starty,
			   BOX_WIDTH-BOX_FRAME, BOX_WIDTH-BOX_FRAME);
	} else {
	    XDrawRectangle(dpy, xwin, gc,
			   drawC.window_select_startx+j*BOX_WIDTH,
			   drawC.window_select_starty,
			   BOX_WIDTH-BOX_FRAME, BOX_WIDTH-BOX_FRAME);
	}
    }
#endif
}

/*
 * Event callback function for `canvas1'.
 */
Notify_value
select_canvas_handler(win, event, arg, type)
     Xv_window	win;
     Event		*event;
     Notify_arg	arg;
     Notify_event_type type;
{
    select_select_pop_objects *ip = (select_select_pop_objects *)
      xv_get(xv_get(win, CANVAS_PAINT_CANVAS_WINDOW), XV_KEY_DATA, INSTANCE);
    int x, y, i;
    GC gc;
    Xv_window paint_window;
    Display *dpy;
    Window xwin;
#ifdef notdef
    dpy = (Display *)xv_get(Select_select_pop->canvas1, XV_DISPLAY);
    gc = DefaultGC(dpy, DefaultScreen(dpy));
    paint_window = canvas_paint_window(Select_select_pop->canvas1);
    xwin = xv_get(paint_window, XV_XID);
	
    if(event_is_down(event) && event_action(event) == ACTION_SELECT){
	/* find where the selection was */
	x = event_x(event);
	y = event_y(event);
	/* if in the right row */
	if(drawC.window_select_starty <= y && y <= drawC.window_select_endy){
	    /* check the column */
	    if(drawC.window_select_startx <= x &&
	       x <= drawC.window_select_endx ){
		/* there was a selection in the xth box of the
		   windowing selection region */
		x -= drawC.window_select_startx;
		x /= BOX_WIDTH;
		if(win_map[x]){
		    /* if it is turned on, turn it off */
		    win_map[x] = 0;
		    /* !!! rebuild the selection list */
		    /* turn off the column and box */
		    XClearArea(dpy, xwin,
			       drawC.window_select_startx+x*BOX_WIDTH,
			       drawC.window_select_starty,
			       BOX_WIDTH, BOX_WIDTH, FALSE);
		    XDrawRectangle(dpy, xwin, gc,
				   drawC.window_select_startx+x*BOX_WIDTH,
				   drawC.window_select_starty,
				   BOX_WIDTH-BOX_FRAME,
				   BOX_WIDTH-BOX_FRAME);
		    XClearArea(dpy, xwin,
			       drawC.box_startx+x*BOX_WIDTH,
			       drawC.box_starty,
			       BOX_WIDTH, BOX_WIDTH*nn_params.nraw, FALSE);
		    for(i = 0; i < nn_params.nraw; i++){
			XDrawRectangle(dpy, xwin, gc,
				       drawC.box_startx+x*BOX_WIDTH,
				       drawC.box_starty+i*BOX_WIDTH,
				       BOX_WIDTH-BOX_FRAME,
				       BOX_WIDTH-BOX_FRAME);
		    }
		} else {
		    /* if it is turned off, turn it on */
		    win_map[x] = 1;
		    /* !!! rebuild the selection list */
		    /* turn on the column and box */
		    XFillRectangle(dpy, xwin, gc,
				   drawC.window_select_startx+x*BOX_WIDTH,
				   drawC.window_select_starty,
				   BOX_WIDTH-BOX_FRAME,
				   BOX_WIDTH-BOX_FRAME);
		    for(i = 0; i < nn_params.nraw; i++){
			if(feat_map[i]){
			    XFillRectangle(dpy, xwin, gc,
					   drawC.box_startx+x*BOX_WIDTH,
					   drawC.box_starty+i*BOX_WIDTH,
					   BOX_WIDTH-BOX_FRAME,
					   BOX_WIDTH-BOX_FRAME);
			}
		    }
		}
	    }
	}
    }
#endif
    /* gxv_start_connections DO NOT EDIT THIS SECTION */

    /* gxv_end_connections */

    return notify_next_event_func(win, (Notify_event) event, arg, type);
}

select_error(string)
     char *string;
{
    xv_set(Select_select_pop->select_error_message, PANEL_LABEL_STRING,
	   string, NULL);
    xv_set(Select_select_pop->select_warning, PANEL_LABEL_IMAGE,
	   LNKseq_glyphs->LNKseq_warning_pic, NULL);
}

select_clear_error()
{
    /* clear error message if we have made it this far */
    xv_set(Select_select_pop->select_error_message, PANEL_LABEL_STRING,
	   "", NULL);
    xv_set(Select_select_pop->select_warning, PANEL_LABEL_IMAGE,
	   LNKseq_glyphs->LNKseq_blank_pic, NULL);
}
