/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* artmap.h */

/* DEFINITIONS AND DECLARATIONS FOR artmap.c */

#ifndef artmap_h
#define artmap_h


void artmap_train(DEFAULTS_FILE_STRUCT *df_args, int create_flag,
		  int nfinputs, int *features, int normalize, int npatterns,
		  int debg, int verbosity, int verror, char *data_path,
		  char *data_fname, char *norm_fname, char *exp_path,
		  char *error_fname, char *param_fname, char *comment,
		  int adjust_priors, int priors_npatterns, float *priors_list,
		  int nepochs, int random_flag, int train_cycle,
		  float ro_a_train, float ro_b, float beta, float alpha,
		  int ARTnorm, int complement_coding, int is_fast_commit,
		  int gc_threshold);
void artmap_test(DEFAULTS_FILE_STRUCT *df_args, int create_flag,
		 int nfinputs, int *features, int npatterns, int debg,
		 int verbosity, int verror, char *data_path, char *data_fname,
		 char *exp_path, char *error_fname, char *param_fname,
		 float ro_a_test, float ro_b, float beta, float alpha,
		 int ARTnorm, int complement_coding);
void artmap_cross_valid(DEFAULTS_FILE_STRUCT *df_args, int nfinputs,
			int *features, int normalize, int npatterns,
			int debg, int verbosity, int verror, int cv_nfolds,
			int cv_nsplits, int use_cv_splits, int *cv_splits,
			char **cv_train_mask, char **cv_test_mask,
			char *data_path, char *data_fname, char *norm_fname, 
			char *exp_path, char *error_fname, char *param_fname,
			char *comment, int nepochs, int random_flag,
			int adjust_priors, int priors_npatterns,
			float *priors_list, int cv_random, int train_cycle,
			float ro_a_train, float ro_a_test, float ro_b,
			float beta, float alpha, int ARTnorm,
			int complement_coding, int is_fast_commit,
			int gc_threshold);
#endif
