/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*  Argument Variables for artmap program */
static int no_complement_code = 0; /* 0=don't, 1=do */
static int slow_commit = 0;  /* 0=fast commit, 1=slow_commit */
static int input_sum_to_one = 0;/* 0=don't, 1=do */
static float ro_a_train = -1, /* Unset flag */
             ro_a_test = -1,
             ro_b = -1;
static int nepochs = 1;
static float beta = -1.;
static float alpha = 0.;
static int prune_threshold = -1;/* None */
static int train_cycle = 0; /* 0=continue until epochs, 1=continue until no new
			      f2a nodes, follow with a removal stage */

static ARG	artmap_tab[]=
{
    {"alpha", FLOAT, (int *)&alpha,
       "Choice parameter (>0, D=0, minimizes recoding)"},
    {"ARTnorm",BOOLEAN,&input_sum_to_one,"normalize using ART normalization"},
    {"beta", FLOAT, (int *)&beta,"Learning rate of Fuzzy ART's"},
    /* The next thing should be integrated into other norms, but I didn't want 
     * to mess with files controlled elsewhere */
    {"epochs", INT, &nepochs,
       "number of times to run through all training data"},
    {"no_complement_code", BOOLEAN, &no_complement_code,
       "Don't complement code the input"},
    {"prune_threshold", INT, &prune_threshold, 
       "Prune categories that capture fewer than this many inputs",-1,1000},
    {"slow_commit", BOOLEAN, &slow_commit, "Commit patterns slowly"},
    {"train_cycle", BOOLEAN, &train_cycle,
       "stop when errs doesn't change for two consecutive epochs (default: do all epochs"},
    {"vigilance_a_train", FLOAT, (int *)&ro_a_train,
       "Vigilance for Fuzzy ART a during training"},
    {"vigilance_a_test", FLOAT, (int *)&ro_a_test, 
       "Vigilance for Fuzzy ART a during testing"},
    {"vigilance_b", FLOAT, (int *)&ro_b, "Vigilance for Fuzzy ART b",0.0,1.0},
};
#define ARTMAP_TABSIZE (sizeof(artmap_tab)/sizeof(ARG))

