/* bintree.h */

/* DEFINITIONS AND DECLARATIONS FOR bintree.c */

#ifndef bintree_h
#define bintree_h

void bintree_train(int nraw, int ninputs, int *features, int noutputs,
		   int linear, int full_tree, int leaf_min_npatterns,
		   int normalize, int npatterns, int debg, int verbosity,
		   int random_flag, char *data_path, char *data_fname,
		   char *norm_fname, char *exp_path, char *param_fname,
		   char *comment, int adjust_priors, int priors_npatterns,
		   float *priors_list);
float bintree_cross_valid(int nraw, int ninputs, int *features, int noutputs,
			  int linear, int train_full_tree, int test_full_tree,
			  int leaf_min_npatterns, int max_nodes,
			  int normalize, int npatterns, int debg,
			  int verbosity, int verror, int random_flag,
			  int cv_nfolds, int cv_nsplits, int use_cv_splits,
			  int *cv_splits, char **cv_train_mask,
			  char **cv_test_mask, char *data_path,
			  char *data_fname, char *norm_fname, char *exp_path,
			  char *error_fname, char *param_fname, char **labels,
			  char *comment, int adjust_train, int adjust_test,
			  int priors_npatterns, float *train_priors_list,
			  float *test_priors_list, int cv_random,
			  int log_outputs,
			  int report_cost, int roc_target, float roc_lower,
			  float roc_upper);
void bintree_test(int create_flag, int nraw, int ninputs, int *features,
		  int noutputs, int full_tree, int max_nodes, int npatterns,
		  int debg, int verbosity, int verror, char *data_path,
		  char *data_fname, char *exp_path, char *error_fname,
		  char *param_fname, char **labels, int adjust_priors,
		  float *priors_list, int log_outputs);
#endif
