/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* committee_pack.h */

/* DEFINITIONS AND DECLARATIONS FOR committee_pack.c */

/* DEFINITIONS OF INTERNAL STRUCTURES AND TYPES */
#ifdef committee_pack_h_internal_types
#undef committee_pack_h_internal_types
/* committee_pack_h_internal_types is defined in `committee_pack.c' */

typedef struct {
    int		ninputs;
    int		noutputs;
    int		nclassifiers;
    int		class_type;
    float	*outputs;	/* space for output values used by error
   				 * report functions */
    float	*class_cnt;	/* number of samples seen in each class */
    float	total_npatterns;/* total number of samples seen */
    int		adjust_priors;	/*whether to adjust testing priors */
    float	*priors_list;	/* when adjusting priors in testing */
    float	*median_array;
    int		*vote_cnt;
}               COMMITTEE_PARAMS;

				/* Parameter Tables */
static PARAM    paramtab[] = {
    {"ninputs", P_INT},
    {"nclassifiers", P_INT},
    {"noutputs", P_INT},
    {"total_npat", P_FLOAT},
    {"class_type", P_INT},
};
#define TABSIZE (sizeof(paramtab)/sizeof(PARAM))

static PARAM    paramtab_l[] = {
    {"class_cnt", P_FLOAT_VECTOR},
};
#define TABSIZE_L (sizeof(paramtab_l)/sizeof(PARAM))
#endif


#ifndef committee_pack_h
#define committee_pack_h

/* DECLARATION OF EXTERNAL FUNCTIONS */
int committee_build (int ninputs, int noutputs, int class_type);
void committee_init (int model);
void committee_free (int model);
int committee_read_model (FILE *fp);
int committee_write_model (int model, FILE *fp);
void *committee_param (int model, char *param_name);
int committee_inc_ctrain (int model, float *inputs, int desired_class);
int committee_classify (int model, float *inputs);

#ifdef committee_pack_h_statics
#undef committee_pack_h_statics
static void committee_set_scalar_params (COMMITTEE_PARAMS *gpp);
static void committee_set_vector_params (COMMITTEE_PARAMS *gpp);
#endif

#endif
