/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* def_args.h */

/*  Argument Variables for defaults files */
/* the type of data base described in this file */
/* only one of these flags should be set */
static int def_map_flag=0;
static int def_class_flag = 0;
static int def_seq_flag = 0;

static int def_ninputs = 2;
static int def_noutputs = 10;
static char **def_labels= NULL;
static char **def_input_labels= NULL;
static char **def_input_types= NULL;
static int *def_categories = NULL;
/* this flag should be ignored, from now on */
/* it has been changed from an int to a flag to ignore it better */
static int def_npatterns = 0;

static ARG def_argtab[]=
{
  {"labels", STRING_ALLOC_LIST, (int *)&def_labels,
     "set of labels describing outputs"},
  {"input_labels", STRING_ALLOC_LIST, (int *)&def_input_labels,
     "set of labels describing inputs"},
  {"class", BOOLEAN, &def_class_flag, "classification data base"},
  {"map", BOOLEAN, &def_map_flag, "mapping data base"},
  {"seq", BOOLEAN, &def_seq_flag, "sequence data base"},
  {"ninputs", INT, &def_ninputs, "number of input dimensions"},
  {"noutputs", INT, &def_noutputs,"number of output dimensions"},
  {"npatterns", BOOLEAN, &def_npatterns, "number of lines in the file"},
  {"input_types", STRING_ALLOC_LIST, (int *)&def_input_types,
     "types are: CONT[INUOUS], BIN[ARY], CAT[EGORICAL]:N (integer values 0 - N-1), CIRC[ULAR]:N (cont values 0-N)"},
  {"categories", INT_ALLOC_LIST, (int *)&def_categories,
   "groupings of categorical data"},
};
#define DEF_TABSIZE (sizeof(def_argtab)/sizeof(ARG))

