/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/em_clus_args.h,v 11.3 2001/08/23 20:14:33 craig Exp $ */


/* Argument variables for em_clus program */
static int	cluster_by_class = 0; /* 1 cluster by ncenter_list */
static int	add_random_offset = 0;
static int	reduce_step = 1; /* # of centers to remove before retrain */
static int 	max_iteration = 30;
static int 	ncenters = 16;
static int	*ncenters_list = NULL;
static float 	split_percentage = 20.0;
static float 	stop_percentage = 0.01;
static int	use_kmeans = 0;
static float	kmeans_stop_percentage = 1.;
static float	variance_scale = 4.;
static float	minimum_variance = 1e-5;

static ARG	em_clus_tab[] =
{
    {"cluster_by_class", BOOLEAN, &cluster_by_class,
       "cluster centers by class"},
    {"ncenters", INT,&ncenters,
       "number of desired clusters (total, or per-class if cluster_by_class)"},
    {"ncenters_list", INT_ALLOC_LIST, (int *)&ncenters_list,
       "number of clusters for each class. default: \"ncenters\" for all"},
    {"split_percentage", FLOAT, (int *)&split_percentage,
       "add +/- this percentage stdev on each split"},
    {"add_random_offset", BOOLEAN, &add_random_offset,
       "add a small random offset to each new center when splitting"},
    {"max_iteration", INT,&max_iteration,
       "maximum iterations after each split"},
    {"stop_percentage", FLOAT, (int *)&stop_percentage,
       "stop when percent change in ave log likelihood is less than this"},
    {"reduce_step", INT, &reduce_step,
       "number of centers to remove at a time for non-binary goal"},
    {"use_kmeans", BOOLEAN, &use_kmeans,
       "initialize em_clus by having it run kmeans"},
    {"kmeans_stop_percentage", FLOAT, (int *)&kmeans_stop_percentage,
       "stop kmeans when percent change in ave sq error is less than this"},
    {"var_spread", FLOAT, (int *)&variance_scale,
       "variance multiplier after each split"},
    {"minvar", FLOAT, (int *)&minimum_variance, "minimum value of variance"},
};
#define EM_CLUS_TABSIZE (sizeof(em_clus_tab)/sizeof(ARG))
