/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/feat_sel_args.h,v 11.3 2001/08/23 20:14:33 craig Exp $ */


/*  Argument Variables for feat_sel program */
static char *exp_path = "./";
static char *data_path = "data/";
static char *data_fname = "";
static char *desc_fname = "";
static int npatterns = 0;
static int normalize = 0;
static char *norm_fname = "vowel.norm.simple";
static int debug = 0;		/* 0=no messages, >0=print debug messages */
static int k = 1;

static ARG argtab[]=
{
    {"pathexp", STRING, (int *) &exp_path, "path to experiment files"},
    {"pathdata", STRING, (int *) &data_path, "path to data files"},
    {"finput", STRING, (int *) &data_fname, "input data file"},
    {"fdescribe", STRING, (int *) &desc_fname, "description file for finput"},
    {"npatterns", INT, &npatterns,
       "number of patterns to read from finput. 0=all"},
    {"normalize", BOOLEAN, &normalize,"normalize inputs using fnorm data"},
    {"fnorm", STRING, (int *) &norm_fname, "normalization file for finput"},
    {"debug", INT,  &debug, "print debug messages"},
    {"k", INT, &k, "number of nearest neighbors for classification"},
};
#define TABSIZE (sizeof(argtab)/sizeof(ARG))

