/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/gauss_args.h,v 11.3 2001/08/23 20:14:33 craig Exp $ */


/* Variables set from command line flags 
-----------------------------------------*/
static int	covariance_type = 0;
static float	minimum_variance = .00001;
static int	variance_type = 0;/* 0=Grand variance, 1=Per Class Variance*/
static float	max_ratio = 1e6;

/*** Argument Table ***/
static ARG	gauss_tab[] =
{
    {"full", BOOLEAN, &covariance_type,
       "Full Covariance Matrices, Default: Diagonal"},
    {"per_class", BOOLEAN, &variance_type,
       "Per Class Variances, Default: Grand Overall"},
    {"minvar", FLOAT, (int *)&minimum_variance, "minimum value of variance"},
    {"max_ratio", FLOAT, (int *)&max_ratio,
       "maximum accepted eigen value ratio"},
};
#define GAUSS_TABSIZE (sizeof(gauss_tab)/sizeof(ARG))
