/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef GEN2CARGS
#define GEN2CARGS
#define NAME_LEN 64

char *param_fname = "";
char *class_suff = "";
char classify_name[NAME_LEN];
char normalize_name[NAME_LEN];
char class_exten[NAME_LEN];
static int  adjust_test = 0;
static int  test_uniform_priors = 0;
static float    *test_priors_list = NULL;

static ARG argtab2c[] = 
{
    {"model_file", STRING, (int *)&param_fname, "classifier model to be translated"},
    {"suffix", STRING, (int *)&class_suff,
      "add _<suffix> to routine names e.g. classify_X1() default: classify()"},
    {"adjust_test_priors", BOOLEAN, &adjust_test,
       "adjust outputs to reflect class probabilities in priors_list"},
    {"test_uniform_priors", BOOLEAN, &test_uniform_priors,
       "if adjusting priors in testing, make class probabilities uniform"},
    {"test_priors_list", FLOAT_ALLOC_LIST, (int *)&test_priors_list,
       "class probabilities list for scaling in testing"},
};
#define TABSIZE2C (sizeof(argtab2c)/sizeof(ARG))

#ifdef GEN2CVARS
/* general variables */
static int  ninputs;                     /* from generic args list */
static int *features;                              /* from generic args list */
static char nraw_name[NAME_LEN];
static char ninputs_name[NAME_LEN];
#ifndef GEN_NO_OUTPUTS
static int  noutputs;
static char noutputs_name[NAME_LEN];
#endif
#endif /* GEN2CVARS */

#undef NAME_LEN
#endif /* GEN2CARGS */
