/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/gen_search_args.h,v 11.4 2001/08/23 20:14:34 craig Exp $ */


static int search_direction = 0;/* 0-forward,1-backward,2-for_and_back */
static int stop_early = 0;
static int search_n = 0;
static int search_verbosity = 3;
static char *search_param_fname = "feat_sel.param";
static int roc_cost = 0;
static int roc_target = 1;
static float roc_lower = 0.0;
static float roc_upper = 1.0;

static ARG search_tab[]=
{
    {"search_type", INT,  &search_direction,
       "0-forward, 1-backward, 2-2forward,1back"},
    {"stop_early", BOOLEAN, &stop_early,
       "stop search when search_n found"},
    {"search_n", INT, &search_n, "stop search early at n features"},
    {"search_verbosity", INT, &search_verbosity,
       "0-best 1-best for nfeatures 2-each set tested"},
    {"search_fparam", STRING, (int *) &search_param_fname,
       "file for search list storage"},
    {"roc_cost", BOOLEAN, &roc_cost,
       "use ROC as search error rather than percent error"},
    {"roc_target", INT, &roc_target,
     "index of the target class for roc_cost in feature selection"},
    {"roc_lower", FLOAT, (int *)&roc_lower,
       "lower limit of average ROC cost"},
    {"roc_upper", FLOAT, (int *)&roc_upper,
       "upper limit of average ROC cost"},
};
#define SEARCH_TABSIZE (sizeof(search_tab)/sizeof(ARG))
