/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* Arguments found in all sequence classifiers */
/**/
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/gen_seq_args.h,v 11.3 2001/08/23 20:14:35 craig Exp $ */

static int	train_flag = 0;	/* 0=don't train, 1=train network */
static int	create_flag = 0;
static char	*exp_path = "./";
static char	*error_fname = "gen.err";
static char	*param_fname = "gen.param";
static char	*data_path = "data/";
static char	*data_fname = "";
static char	*desc_fname = "";
static int	nsequences = 0;
static int	ninputs = 0;
static int	*features = NULL;
static int window_width = 1;
static int *window_frames = NULL;
static int	normalize = 0;	/* 0=don't normalize inputs,
				   1=normalize inputs */
static char	*norm_fname = "vowel.norm.simple";
static int	cross_valid = 0;/* 0,1=normal testing
				 * 1 < store N fold cross valid models */
static int	cross_valid_from_file = 0;
static char	*cross_valid_fname = "vowel.test.cv";
static int	cv_random = 0;
static int	random_flag = 0;/* 0= present data in flist order
				   1= randomize data order before each epoch */
static int	seed = 0;
static int	debug = 0;	/* 0=no messages, >0=print debug messages */
static int	verbosity = 3;	/* 0= minimal log info,
				   >0=print more log info */
static int	verror = 0;	/* 0=no mserr msg, 1=short mserr msg,
				   2=long mserr msg */

static ARG	gen_tab[] =
{
    {"train", BOOLEAN, &train_flag, "perform training"},
    {"create", BOOLEAN, &create_flag,
       "if -train: create new model file. default, read in model file"},
    {"pathexp", STRING, (int *) &exp_path, "path to experiment files"},
    {"ferror", STRING, (int *) &error_fname, "error (results) file"},
    {"fparam", STRING, (int *) &param_fname, "file for model storage"},
    {"pathdata", STRING, (int *) &data_path, "path to data files"},
    {"flist", STRING, (int *) &data_fname, "list file for input data"},
    {"fdescribe", STRING, (int *) &desc_fname, "description file for data"},
    {"nsequences", INT, &nsequences, "number of sequences to read from flist"},
    {"fnorm", STRING, (int *) &norm_fname, "normalization file for flist"},
    {"normalize", BOOLEAN, &normalize, "normalize inputs using fnorm data"},
    {"features", INT_ALLOC_LIST, (int *)&features,
       "select these features of normalized data"},
    {"ninputs", INT, &ninputs, "number of normalized and selected inputs"},
    {"window_width", INT, &window_width,
       "number of frames to concatenate to build each input pattern"},
    {"window_frames", INT_ALLOC_LIST, (int *)&window_frames,
      "concatenate these frames in a moving window to build each pattern"},
    {"cross_valid", INT, &cross_valid, "N fold cross validation testing"},
    {"cross_valid_from_file", BOOLEAN, &cross_valid_from_file,
       "do cross validation testing with splits taken from fcross_valid"},
    {"fcross_valid", STRING, (int *)&cross_valid_fname,
       "cross validation splits file"},
    {"random_cv", BOOLEAN, &cv_random,
       "randomize patterns for automatic cross valid fold assignment"},
    {"random", BOOLEAN, &random_flag,
       "select training sequences in random order"},
    {"seed", INT, &seed, "seed for all random number generation"},
    {"debug", INT, &debug, "print debug messages"},
    {"verbose", INT, &verbosity, "verbosity level for log message print"},
    {"verror", INT, &verror,
       "verbosity level for error file print (0 is no file)"},
};
#define GEN_TABSIZE (sizeof(gen_tab)/sizeof(ARG))
