/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* inc_pack.h */

/* DEFINITIONS AND DECLARATIONS FOR inc_pack.c */

/* DEFINITIONS OF INTERNAL STRUCTURES AND TYPES */
#ifdef inc_pack_h_internal_types
#undef inc_pack_h_internal_types
/* inc_pack_h_internal_types is defined in `inc_pack.c' */

typedef struct {
    int		ninputs;	/* number of elements in patterns */
    int		noutputs;	/* number of elements in patterns */
    int		*features;	/* features of raw data used */
    float	*outputs;	/* space for output values used by error
   				 * report functions */
    float	*class_cnt;	/* number of samples seen in each class */
    float	total_npatterns;/* total number of samples seen */
    int		adjust_priors;	/*whether to adjust testing priors */
    float	*priors_list;	/* when adjusting priors in testing */
}               GENERIC_PARAMS;

				/* Parameter Tables */
static PARAM    paramtab[] = {
    {"ninputs", P_INT},
    {"noutputs", P_INT},
    {"total_npat", P_FLOAT},
};
#define TABSIZE (sizeof(paramtab)/sizeof(PARAM))

static PARAM    paramtab_l[] = {
    {"features", P_INT_VECTOR},
    {"class_cnt", P_FLOAT_VECTOR},
};
#define TABSIZE_L (sizeof(paramtab_l)/sizeof(PARAM))
#endif


#ifndef inc_pack_h
#define inc_pack_h

/* DECLARATION OF EXTERNAL FUNCTIONS */
int generic_build (int ninputs, int nclasses);
void generic_init (int model, int *nn_features);
void generic_test_init (int model, int adjust_priors, float *priors_list);
void generic_free (int model);
int generic_read_model (FILE *fp);
int generic_write_model (int model, FILE *fp);
void *generic_param (int model, char *param_name);
int generic_inc_ctrain (int model, float *inputs, int desired_class);
int generic_classify (int model, float *inputs);
int generic_copy_exemplar (int model, int pattern, float *inputs);

#ifdef inc_pack_h_statics
#undef inc_pack_h_statics
#endif

#endif
