/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/gmix_args.h,v 11.3 2001/08/23 20:14:35 craig Exp $ */


/* Argument variables for gmix program */
static int	tied_flag;
static int	grand_flag;
static int	full_flag;
static float	minimum_variance = 1e-6;
static float	max_ratio = 1e6;
static float	var_spread = 4.;
static char	*cluster_param_fname = "kmeans.param";
static float	gmix_stop_percentage = 1.;
static int	nepochs = 1;

static ARG	gmix_tab[] =
{
    {"tied", BOOLEAN, &tied_flag, "use tied mixtures"},
    {"grand", INT, &grand_flag,
       "covariances: 2-grand overall, 1-grand per class, 0-per mixture component", 0, 2},
    {"full", BOOLEAN, &full_flag,
       "full covariance matrices (default diagonal)"},
    {"minvar", FLOAT, (int *)&minimum_variance, "minimum value of variance"},
    {"max_ratio", FLOAT, (int *)&max_ratio,
       "maximum accepted eigen value ratio"},
    {"var_spread", FLOAT, (int *)&var_spread, "initial variance multiplier"},
    {"fclparam", STRING, (int *)&cluster_param_fname,
       "name of cluster parameter file"},
    {"gmix_stop_percentage", FLOAT, (int *)&gmix_stop_percentage,
       "stop when percent change in ave log likelihood is less than this"},
    {"epochs", INT, &nepochs,
       "number of times to run through all training data"},
};
#define GMIX_TABSIZE (sizeof(gmix_tab)/sizeof(ARG))
