/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* gmix_seq.h */

/* DEFINITIONS AND DECLARATIONS FOR gmix_seq.c */

#ifndef gmix_seq_h
#define gmix_seq_h

/* declarations for other files */
void gmix_seq_train(int create_flag, int db_type, int noutputs,
		    int nsequences, int debg, int verbosity, int verror,
		    int nepochs, char *data_path, char *data_fname,
		    char *exp_path, char *error_fname, char *param_fname,
		    char **labels, char *comment, int log_outputs,
		    int tied_flag, int grand_flag, int full_flag,
		    float minimum_variance, float max_ratio,
		    float var_spread, char *cluster_param_fname,
		    float stop_percentage);
void gmix_seq_cross_valid(int db_type, int noutputs, int nsequences,
			  int debg, int verbosity, int verror, int nepochs,
			  int cv_nfolds, int cv_nsplits, int use_cv_splits,
			  int *cv_splits, char **cv_train_mask,
			  char **cv_test_mask, int cv_random,
			  char *data_path, char *data_fname, char *exp_path,
			  char *error_fname, char *param_fname, char **labels,
			  char *comment, int log_outputs, int tied_flag,
			  int grand_flag, int full_flag,
			  float minimum_variance, float max_ratio,
			  float var_spread, char *cluster_param_fname,
			  float stop_percentage);
void gmix_seq_test(int create_flag, int db_type, int nsequences, int debg,
		   int verbosity, int verror, char *data_path,
		   char *data_fname, char *exp_path, char *error_fname,
		   char *param_fname, char **labels);
     
#endif
