/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* gnn_args.h */

/*  Argument Variables for gnn program */
static int gnn_map_flag=0;           /* 0=classify, 1=map */
static int gnn_ninputs = 2; 		/* number of dimensions to input data */
static int gnn_noutputs = 10; 		/* number of output dimensions */
static int gnn_n_patterns = 0;  /* number of patterns (trials) to run at max. */
static char *gnn_labels [NNARGS_MAX_LABELS]= {"0"};  
	/* set of labels describing outputs used as input arguments */

static ARG gnn_argtab[]=
{
  {"labels",STRING_LIST,(int *)&gnn_labels[0],"set of labels describing outputs"},
  {"map", BOOLEAN, &gnn_map_flag, "perform mapping (default classification)"},
  {"ninputs", INT,(int *)&gnn_ninputs,"number of dimensions to input data"},
  {"noutputs", INT,(int *)&gnn_noutputs,"number of output dimensions"},
  {"npatterns",INT,(int *)&gnn_n_patterns,"number of patterns (trials) to run"},
};
#define GNN_TABSIZE (sizeof(gnn_argtab)/sizeof(ARG))

