/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/histogram_args.h,v 11.3 2001/08/23 20:14:35 craig Exp $ */


/* arguments not on general list */
static int	grand_bins = 0;
static int	bin_type = 0;
static int	nbins = 2;
static int	*nBinsPerClass = NULL;
static float	minimum_var = 1e-6;
static float	range_factor = 1.5;
static int	use_gauss = 0;
static float	user_min = -3;
static float	user_max = 3;

static ARG	histogram_tab[] =
{
    {"grand_bins", INT, &grand_bins,
       "0-Per Class, Per Input Bins, 1-Per Input Bins, 2-User Supplied Bins"},
    {"bin_type", INT, &bin_type,
       "0-equal width histogram bins, 1-bins with an equal number of patterns"},
    {"nbins", INT, &nbins,
       "number of bins for each histogram"},
    {"nBinsPerClass", INT_ALLOC_LIST, (int *)&nBinsPerClass,
       "number of bins for histograms in each class"},
    {"min_var", FLOAT, (int *)&minimum_var,
       "minimum variance for Gaussians"},
    {"range_factor", FLOAT, (int *)&range_factor,
       "Factor to multiply data range by to get histogram range"},
    {"user_min", FLOAT, (int *)&user_min,
       "Histogram start for each dimension, for each class"},
    {"user_max", FLOAT, (int *)&user_max,
       "Histogram end for each dimension, for each class"},
    {"use_gauss", FLAG, &use_gauss,
       "Use Gaussian outputs for outlyers, default: allow unknown class"},
};
#define HISTOGRAM_TABSIZE (sizeof(histogram_tab)/sizeof(ARG))
