/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* irbf.h */

/* DEFINITIONS AND DECLARATIONS FOR irbf.c */

#ifndef irbf_h
#define irbf_h

void irbf_train(int create_flag, int nraw, int ninputs, int *pfeatures,
		int noutputs, int npatterns, int debg, int verbosity,
		int verror, int random_flag, char *data_path,
		char *data_fname, char *exp_path, char *error_fname,
		char *param_fname, char **labels, char *comment,
		int adjust_priors, int priors_npatterns, float *priors_list,
		int log_outputs, int nepochs, int bias, int grand_flag,
		float hspread, float max_magnitude, char *cluster_param_fname,
		float minimum_variance, float weight_eta, float mean_eta,
		float inv_var_eta, int cost_func, float cost_param,
		int norm_outputs);
float irbf_cross_valid(int map_flag, int nraw, int ninputs, int *pfeatures,
		       int noutputs, int npatterns, int debg, int verbosity,
		       int verror, int random_flag, int cv_nfolds,
		       int cv_nsplits, int use_cv_splits, int *cv_splits,
		       char **cv_train_mask, char **cv_test_mask,
		       char *data_path, char *data_fname, char *exp_path,
		       char *error_fname, char *param_fname, char **labels,
		       char *comment, int adjust_train, int adjust_test,
		       int priors_npatterns, float *train_priors_list,
		       float *test_priors_list, int cv_random,
		       int log_outputs,
		       int report_cost, int roc_target, float roc_lower,
		       float roc_upper, 
		       int nepochs, int bias, int grand_flag,
		       float extra_hspread, float hspread,
		       float max_magnitude, char *cluster_param_fname,
		       float minimum_variance, float weight_eta,
		       float mean_eta, float inv_var_eta, int cost_func,
		       float cost_param, int norm_outputs);
void irbf_test(int create, int map_flag, int nraw, int ninputs, int noutputs,
	       int npatterns, int debg, int verbosity, int verror,
	       char *data_path, char *data_fname, char *exp_path,
	       char *error_fname, char *param_fname, char **labels,
	       int adjust_priors, float *priors_list, int log_outputs,
	       float extra_hspread, int cost_func, float cost_param);
#endif
