/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/irbf_args.h,v 11.3 2001/08/23 20:14:35 craig Exp $ */


/* Argument variables for irbf program */
static char	*cluster_param_fname = "kmeans.param";
static int	grand_flag = 0;
static int	nepochs = 1;
static float	hspread=1.0;
static float	extra_hspread=1.0;
static float	max_magnitude=1.0e-2;
static float	minimum_variance = 1e-6;
static int	bias = 0;
static float	weight_eta = .1;
static float	mean_eta = .01;
static float	var_eta = .01;
static int	cost_func = 0;
static float	cost_param = 1;
static int	no_norm_outputs = 0;

static ARG	irbf_tab[] =
{
    {"fclparam", STRING, (int *) &cluster_param_fname,
       "name of cluster parameter file"},
    {"epochs", INT, &nepochs,
       "number of times to run through all training data"},
    {"hspread", FLOAT, (int *)&hspread, "factor to multiply all variances"},
    {"exhspread", FLOAT, (int *)&extra_hspread,
       "additional hspread for testing"},
    {"max_magnitude", FLOAT, (int *)&max_magnitude,
       "maximum magnitude of initial weights"},
    {"minvar", FLOAT, (int *)&minimum_variance, "minimum value of variance"},
    {"bias", BOOLEAN, &bias, "add a constant output node"},
    {"grand", FLAG, &grand_flag, "use grand variances"},
    {"weight_eta", FLOAT, (int *)&weight_eta, "stepsize for weights"},
    {"mean_eta", FLOAT, (int *)&mean_eta, "stepsize for means"},
    {"var_eta", FLOAT, (int *)&var_eta, "stepsize for variances"},
    {"cost_func", INT, &cost_func, "0=SQ_ERR, 4=TOP2DIFF"},
    {"cost_param", FLOAT, (int *)&cost_param,
       "parameter for cost function initialization"},
    {"no_norm_outputs", BOOLEAN, &no_norm_outputs,
       "do not normalize hidden node outputs to sum to one"},
};
#define IRBF_TABSIZE (sizeof(irbf_tab)/sizeof(ARG))
