/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/irbfm_args.h,v 11.3 2001/08/23 20:14:35 craig Exp $ */


/* Argument variables for irbfm program */
static int	train_flag = 0;	/* 0=don't train, 1=train network */
static int	create_flag = 0;/* 0=load a network, 1=create a new network */
static char	*exp_path = "./";
static char	*error_fname = "irbfm.err";
static char	*param_fname = "irbfm.param";
static char	*data_path = "data/";
static char	*data_fname = "vowel.test";
static char	*desc_fname = "vowel.test.defaults";
static char	*labels[NNARGS_MAX_LABELS] = {"0"};
static int	nraw = 2;
static int	noutputs = 10;
static int	npatterns = 100;
static int	ninputs = 0;
static int	features[NNARGS_MAX_LABELS] = {0};
static int	random_flag = 0;/* 0= present data in finput order
				   1= randomize data order before each epoch */
static int	seed = 0;
static int	debug = 0;	/* 0=no messages, >0=print debug messages */
static int	verbosity = 3;	/* 0= minimal log info,
				   >0=print more log info */
static int	verror = 0;	/* 0=no mserr msg, 1=short mserr msg,
				   2=long mserr msg */
/* arguments not on general list */
static char	*cluster_param_fname = "kmeans.param";
static int	grand_flag = 0;
static int	nepochs = 1;
static float	hspread=1.0;
static float	extra_hspread=1.0;
static float	max_magnitude=1.0e-2;
static float	minimum_variance = 1e-6;
static int	bias = 0;
static float	weight_eta = 1.;
static float	mean_eta = 0.01;
static float	var_eta = 0.01;

static ARG length_tab[]=
{
    {"nraw", INT, &nraw, "number of dimensions in data"},
    {"noutputs", INT, &noutputs, "number of outputs in data"},
};
#define LEN_TABSIZE (sizeof(length_tab)/sizeof(ARG))

static ARG	argtab[] =
{
    {"train", BOOLEAN, &train_flag, "perform training"},
    {"create", BOOLEAN, &create_flag,
       "if -train: create new model file. default, read in model file"},
    {"pathexp", STRING, (int *) &exp_path, "path to experiment files"},
    {"ferror", STRING, (int *) &error_fname, "error (results) file"},
    {"fparam", STRING, (int *) &param_fname, "file for model storage"},
    {"pathdata", STRING, (int *) &data_path, "path to data files"},
    {"finput", STRING, (int *) &data_fname, "input data file"},
    {"fdescribe", STRING, (int *) &desc_fname, "description file for finput"},
    {"labels", STRING_LIST, (int *) &labels[0],
       "set of labels describing outputs"},
    {"nraw", INT, &nraw, "number of dimensions in data"},
    {"noutputs", INT, &noutputs, "number of outputs in data"},
    {"npatterns", INT, &npatterns, "number of patterns to read from finput"},
    {"random", BOOLEAN, &random_flag,
       "select training patterns in random order"},
    {"seed", INT, &seed, "seed for all random number generation"},
    {"debug", INT, &debug, "print debug messages"},
    {"verbose", INT, &verbosity, "verbosity level for log message print"},
    {"verror", INT, &verror,
       "verbosity level for error file print (0 is no file)"},
    /* irbfm specific arguments */
    {"fclparam", STRING, (int *) &cluster_param_fname,
       "name of cluster parameter file"},
    {"epochs", INT, &nepochs,
       "number of times to run through all training data"},
    {"hspread", FLOAT, (int *)&hspread, "factor to multiply all variances"},
    {"exhspread", FLOAT, (int *)&extra_hspread,
       "additional hspread for testing"},
    {"max_magnitude", FLOAT, (int *)&max_magnitude,
       "maximum magnitude of weights on initialization"},
    {"minvar", FLOAT, (int *)&minimum_variance, "minimum value of variance"},
    {"bias", BOOLEAN, &bias, "add a constant output node"},
    {"grand", FLAG, &grand_flag, "use grand variances"},
    {"weight_eta", FLOAT, (int *)&weight_eta, "stepsize for weights"},
    {"mean_eta", FLOAT, (int *)&mean_eta, "stepsize for means"},
    {"var_eta", FLOAT, (int *)&var_eta, "stepsize for variances"},
};
#define TABSIZE (sizeof(argtab)/sizeof(ARG))
