/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/kmeans_seq_args.h,v 11.3 2001/08/23 20:14:35 craig Exp $ */


/* Argument variables for kmeans program */
/* arguments not on general list */
static int	cluster_by_class = 0; /* 1 cluster by ncenter_list */
static int	add_random_offset = 0;
static int	reduce_step = 1; /* # of centers to remove before retrain */
static int 	max_iteration = 10;
static int 	ncenters = 16;
static int	*ncenters_list = NULL;
static float	split_percentage = 1.0;
static float	stop_percentage = 1.0;

static ARG	kmeans_tab[] =
{
    {"cluster_by_class", BOOLEAN, &cluster_by_class,
       "cluster centers by class"},
    {"ncenters", INT,&ncenters,"number of desired centers or clusters"},
    {"ncenters_list", INT_ALLOC_LIST, (int *)&ncenters_list,
       "number of clusters for each class. default: \"ncenters\" for all"},
    {"split_percentage", FLOAT, (int *)&split_percentage,
       "add +/- this percentage stdev on each split"},
    {"add_random_offset", BOOLEAN, &add_random_offset,
       "add a small random offset to each new center when splitting"},
    {"max_iteration", INT,&max_iteration,
       "maximum iterations after each split"},
    {"stop_percentage", FLOAT, (int *)&stop_percentage,
       "stop when ave sqrd error percent change less than this"},
    {"reduce_step", INT, &reduce_step,
       "number of centers to remove at a time for non-binary goal"},
};
#define KMEANS_TABSIZE (sizeof(kmeans_tab)/sizeof(ARG))
