/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/kmeansm_args.h,v 11.3 2001/08/23 20:14:36 craig Exp $ */


/* Argument variables for kmeans program */
static char	*exp_path = "./";
static char	*error_fname = "kmeans.err";
static char	*param_fname = "kmeans.param";
static char	*data_path = "data/";
static char	*data_fname = "vowel.test";
static char	*desc_fname = "vowel.test.defaults";
static char	*labels[NNARGS_MAX_LABELS] = {"0"};
static int	nraw = 2;
static int	noutputs = 10;
static int	npatterns = 100;
static int	ninputs = 0;
static int	features[NNARGS_MAX_LABELS] = {0};
static int	normalize = 0;	/* 0=don't normalize inputs,
				   1=normalize inputs */
static char	*norm_fname = "vowel.norm.simple";
static int	seed = 0;
static int	debug = 0;	/* 0=no messages, >0=print debug messages */
static int	verbosity = 3;	/* 0= minimal log info,
				   >0=print more log info */
static int	verror = 0;	/* 0=no mserr msg, 1=short mserr msg,
				   2=long mserr msg */
/* arguments not on general list */
static int	add_random_offset = 0;
static int	reduce_step = 1; /* # of centers to remove before retrain */
static int 	max_iteration = 10;
static int 	ncenters = 16;
static float 	split_percentage = 1.0;
static float 	stop_percentage = 1.0;

static ARG length_tab[]=
{
    {"nraw", INT, &nraw, "number of dimensions in data"},
    {"noutputs", INT, &noutputs, "number of outputs in data"},
};
#define LEN_TABSIZE (sizeof(length_tab)/sizeof(ARG))

static ARG	argtab[] =
{
    {"pathexp", STRING, (int *) &exp_path, "path to experiment files"},
    {"ferror", STRING, (int *) &error_fname, "error (results) file"},
    {"fparam", STRING, (int *) &param_fname, "file for model storage"},
    {"pathdata", STRING, (int *) &data_path, "path to data files"},
    {"finput", STRING, (int *) &data_fname, "input data file"},
    {"fdescribe", STRING, (int *) &desc_fname, "description file for finput"},
    {"labels", STRING_LIST, (int *) &labels[0],
       "set of labels describing outputs"},
    {"nraw", INT, &nraw, "number of dimensions in data"},
    {"noutputs", INT, &noutputs, "number of outputs in data"},
    {"npatterns", INT, &npatterns, "number of patterns to read from finput"},
    {"ninputs", INT, &ninputs, "number of dimensions to use in data"},
    {"features", INT_LIST, features, "features of normalized data to use"},
    {"normalize", BOOLEAN, &normalize, "normalize inputs using fnorm data"},
    {"fnorm", STRING, (int *) &norm_fname, "normalization file for finput"},
    {"seed", INT, &seed, "seed for all random number generation"},
    {"debug", INT, &debug, "print debug messages"},
    {"verbose", INT, &verbosity, "verbosity level for log message print"},
    {"verror", INT, &verror,
       "verbosity level for error file print (0 is no file)"},
    /* kmeans specific arguments */
    {"ncenters", INT,&ncenters,"number of desired centers or clusters"},
    {"split_percentage", FLOAT, (int *)&split_percentage,
       "add +/- this percentage stdev on each split"},
    {"add_random_offset", BOOLEAN, &add_random_offset,
       "add a small random offset to each new center when splitting"},
    {"max_iteration", INT,&max_iteration,
       "maximum iterations after each split"},
    {"stop_percentage", FLOAT, (int *)&stop_percentage,
       "stop when ave sqrd error percent change less than this"},
    {"reduce_step", INT, &reduce_step,
       "number of center to remove before next kmeans"},
};
#define TABSIZE (sizeof(argtab)/sizeof(ARG))
