/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* lead_clus_pack.h */

/* DEFINITIONS AND DECLARATIONS FOR lead_clus_pack.c */

/* DEFINITIONS OF INTERNAL STRUCTURES AND TYPES */
#ifdef lead_clus_pack_h_internal_types
#undef lead_clus_pack_h_internal_types
/* lead_clus_pack_h_internal_types is defined in `lead_clus_pack.c' */

typedef struct {
    int		ninputs;	/* number of elements in patterns */
    int		ncenters;	/* number of cluster centers */
    int		max_centers;	/* number of centers there is space for in
				   pcenter and pvariance */
    int		*features;	/* features of raw data used */
    float	*outputs;	/* space for output values */
    int		total_vectors;	/* total number of vectors */
    float	**pcenter;	/* final centers to return */
    float	**pvariance;	/* variance of final centers */
    float	delta;		/* distance apart of centers */
}LEAD_CLUS_PARAMS;
#endif


#ifndef lead_clus_pack_h
#define lead_clus_pack_h
int lead_clus_build (int ninputs, int ncenters);
void lead_clus_init (int model, int *nn_features, float delta);
void lead_clus_free (int model);
int lead_clus_read_model (FILE *fp);
int lead_clus_write_model (int model, int noutputs, FILE *fp);
int lead_clus_write_model_list (int *model_list, int noutputs, FILE *fp);
void *lead_clus_param (int model, char *param_name);
void lead_clus_inc_train (int model, float *input);
int lead_clus_cluster (int model, float *input);

/* DECLARATION OF EXTERNAL FUNCTIONS */

#ifdef lead_clus_pack_h_statics
#undef lead_clus_pack_h_statics
#endif

#endif
