/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* lvq.h */

/* DEFINITIONS AND DECLARATIONS FOR lvq.c */

#ifndef lvq_h
#define lvq_h

void lvq_train(int create_flag, int nraw, int ninputs, int *pfeatures,
	       int noutputs, int npatterns, int debg, int verbosity,
	       int verror, int nepochs, int random_flag, char *data_path,
	       char *data_fname, char *exp_path, char *error_fname,
	       char *param_fname, char **labels, char *comment,
	       int adjust_priors, int priors_npatterns, float *priors_list,
	       char *cluster_param_fname, int lvq_type, float alpha,
	       float window, float epsilon);
float lvq_cross_valid(int nraw, int ninputs, int *pfeatures, int noutputs,
		      int npatterns, int debg, int verbosity, int verror,
		      int nepochs, int random_flag, int cv_nfolds,
		      int cv_nsplits, int use_cv_splits, int *cv_splits,
		      char **cv_train_mask, char **cv_test_mask,
		      char *data_path, char *data_fname, char *exp_path,
		      char *error_fname, char *param_fname, char **labels,
		      char *comment, int adjust_train, int priors_npatterns,
		      float *train_priors_list, int cv_random,
		      char *cluster_param_fname, int lvq_type, float alpha,
		      float window, float epsilon);
void lvq_test(int create, int nraw, int ninputs, int *features, int noutputs,
	      int npatterns, int debg, int verbosity, int verror,
	      char *data_path, char *data_fname, char *exp_path,
	      char *error_fname, char *param_fname, char **labels);
#endif
