/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $header: lvq_args.h,v 5.1 92/04/24 10:02:55 kukolich Exp $ */


/*  Argument Variables for lvq program */
static char	*cluster_param_fname = "kmeans.param";
static float	alpha = .3;
static int	lvq_type = 1;	/* 0=olvq1, 1=lvq1, 2=lvq2, 3=lvq3 */
static float	window = .25;	/* for lvq2 and lvq3 */
static float	epsilon = .2;	/* for lvq3 */
static int	nepochs = 1;

static ARG	lvq_tab[] =
{
    {"fclparam", STRING, (int *)&cluster_param_fname,
       "name of cluster parameter file"},
    {"lvq_type", INT, &lvq_type, "0=OLVQ1, 1=LVQ1, 2=LVQ2, 3=LVQ3", 0, 3},
    {"alpha", FLOAT, (int *)&alpha, "step size for center movement", 0, 1},
    {"window", FLOAT, (int *)&window, "window width for LVQ2 and LVQ3", 0, 1},
    {"epsilon", FLOAT, (int *)&epsilon,
       "factor for stepsize in LVQ3 when both correct", 0, 1},
    {"epochs", INT,  &nepochs,
       "number of times to run through all training data"},
};
#define LVQ_TABSIZE (sizeof(lvq_tab)/sizeof(ARG))
