/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* mlp.h */

/* DEFINITIONS AND DECLARATIONS FOR mlp.c */

#ifndef mlp_h
#define mlp_h

/* declarations for other files */
void mlp_train(int create_flag, int map_flag, int nraw, int ninputs,
	       int *features, int noutputs, int normalize, int npatterns,
	       int verbosity, int verror, int nepochs,
	       int random_flag, char *data_path, char *data_fname,
	       char *norm_fname, char *exp_path, char *error_fname,
	       char *param_fname, char **labels, char *comment,
	       int adjust_priors, int priors_npatterns, float *priors_list,
	       float *etta_list, float alpha, float tolerance,
	       float decay, float kappa, float epsilon,
	       float *sigmoid_param_list, int *nnodes, int *batch,
	       int cost_type, float cost_param, int etta_type, int hfunction,
	       int ofunction, float max_magnitude, int log_outputs,
	       float etta_nepochs);

float mlp_cross_valid(int map_flag, int nraw, int ninputs, int *features,
		      int noutputs, int normalize, int npatterns,
		      int verbosity, int verror, int nepochs, int random_flag,
		      int cv_nfolds, int cv_nsplits, int use_cv_splits,
		      int *cv_splits, char **cv_train_mask,
		      char **cv_test_mask, char *data_path, char *data_fname,
		      char *norm_fname, char *exp_path, char *error_fname,
		      char *param_fname, char **labels,
		      char *comment, int report_cost, int roc_target,
		      float roc_lower, float roc_upper,
		      int adjust_train, int priors_npatterns,
		      float *train_priors_list, int adjust_test,
		      float *test_priors_list, int cv_random,
		      float *etta_list, float alpha, float tolerance,
		      float decay, float kappa, float epsilon,
		      float *sigmoid_param_list, int *nnodes, int *batch,
		      int cost_type, float cost_param, int etta_type,
		      int hfunction, int ofunction, float max_magnitude,
		      int log_outputs, float etta_nepochs);

void mlp_test(int create_flag, int map_flag, int nraw, int ninputs,
	      int *features, int noutputs, int npatterns,
	      int verbosity, int verror, char *data_path, char *data_fname,
	      char *exp_path, char *error_fname, char *param_fname,
	      char **labels, int adjust_priors, float *priors_list,
	      int *nnodes, int cost_type, float cost_param, int log_outputs);

#endif
