/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* mlp_args.h */

/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/mlp_args.h,v 11.4 2001/08/23 20:14:36 craig Exp $ */


/*  Argument Variables for mlp program */
#define NNODES_SIZE (11)
static int	nnodes[NNODES_SIZE] = {3,2,25,10,0,0,0,0,0,0,0};
/*# of layers, nodes/layer*/
static float	alpha = 0.6;
static float	etta=0.1;
static int	use_etta_list = 0;
static float	*etta_list = NULL;
static int	step_change=0;	/* 0=no mas, 1=multiple adaptive stepsize */
static float	epsilon = .1;
static float	kappa = .01;
static float	etta_nepochs = 10;
static float	decay = 0.;
static float	tolerance = .01;
static int	hfunction = 0;
static int	ofunction = 0;
static float	sigmoid_param = 1.;
static int use_sigmoid_param_list = 0;
static float *sigmoid_param_list = NULL;
static int	cost_func = 0;	/*Error criterion 0=standard, 1=cross entropy,
				 * 2 = maximum likelihood,
				 * 3 = perceptron convergence procedure
				 * 4 = top 2 diff
				 * 11 = ROC cost */
static float	cost_param = 1;	/* used to initialize cost functions */
static int	nepochs = 1;
#define BATCH_SIZE (4)
static int	batch[BATCH_SIZE] = {3,1,1,0};

/* initial weight update interval, max, inc */
static float	max_magnitude = .1;

static ARG	mlp_tab[] =
{
    {"nodes", INT_LIST, (int *) &nnodes[0], "number of nodes in each layer",
       NNODES_SIZE},
    {"alpha", FLOAT, (int *) &alpha,"momentum of weights",0,2},
    {"etta", FLOAT, (int *) &etta, "stepsize for gradient descent"},
    {"use_etta_list", BOOLEAN, &use_etta_list,
       "use etta_list as stepsize for each layer. default: use etta for all"},
    {"etta_list", FLOAT_ALLOC_LIST, (int *)&etta_list,
       "list of stepsizes for weights between each mlp layer"},
    {"etta_change_type", INT, &step_change,
       "0: no change 1: constant then c/ntrials reduction 2: multiple-adaptive step size"},
    {"epsilon",FLOAT,(int *) &epsilon,
       "decrement for multiple adaptive stepsize"},
    {"kappa", FLOAT, (int *) &kappa,
       "increment for multiple adaptive stepsize (multiplied)"},
    {"etta_nepochs", FLOAT, (int *)&etta_nepochs,
       "number of epochs (float) to hold etta constant before reduction"},
    {"decay", FLOAT, (int *) &decay,
       "factor of weight to subtract each update"},
    {"tolerance", FLOAT, (int *) &tolerance, "tolerance in output error"},
    {"hfunction", INT, &hfunction,
       "hidden layer sigmoid 0=sigm(0,1),1=sym sigm(-1,1), 3=step, 4=linear"},
    {"ofunction", INT, &ofunction,
       "output layer sigmoid 0=sigm(0,1),1=sym sigm(-1,1), 3=step, 4=linear"},
    {"sigmoid_param", FLOAT, (int *) &sigmoid_param, "spread for sigmoids"},
    {"use_sig_param_list", BOOLEAN, &use_sigmoid_param_list,
       "use sig_param_list as sigmoid spread for each connecting layer"},
    {"sig_param_list", FLOAT_ALLOC_LIST, (int *)&sigmoid_param_list,
       "list of spreads for sigmoids between each mlp layer"},
    {"cost_func", INT, &cost_func,
       "0=SQ_ERR, 1=CROSS_ENTROPY, 2=MAX_LIKE, 3=PCP, 4=TOP2DIFF"},
    {"cost_param", FLOAT, (int *)&cost_param,
       "parameter for cost function initialization"},
    {"epochs", INT, &nepochs,
       "number of times to run through all training data"},
    {"batch", INT_LIST,(int *) &batch[0],
       "update weights every N patterns: initial_N,max_N,increase_by_N_per_epoch",
   BATCH_SIZE},
    {"init_mag", FLOAT, (int *)&max_magnitude,
       "maximum magnitude of initial weights"},
};
#define MLP_TABSIZE (sizeof(mlp_tab)/sizeof(ARG))
