/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* mlp_seq_pack.h */

/* DEFINITIONS AND DECLARATIONS FOR mlp_seq_pack.c */

#ifndef mlp_seq_pack_h
#define mlp_seq_pack_h

/* DEFINITIONS OF INTERNAL STRUCTURES AND TYPES */
#ifdef mlp_seq_pack_h_internal_types
#undef mlp_seq_pack_h_internal_types
/* mlp_seq_pack_h_internal_types is defined in `mlp_seq_pack.c' */

typedef struct {
    int    noutputs;	/* number of elements in patterns */
    float *seq_sums;
    float clip_floor;	/* lowest permitted output for seq_sums */
    int	   mlp_model;
} MLP_SEQ_PARAMS;
#endif


/* DECLERATION OF EXTERNAL FUNCTIONS */
int mlp_seq_build(int noutputs);
void mlp_seq_init(int model, int mlp_model, float clip_floor);
void mlp_seq_free(int model);
void *mlp_seq_param(int model, char *param_name);
void mlp_seq_batch_classify(int model, float *inputs);
int mlp_seq_update_classify(int model);

#endif
