/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* mlpm.h */

/* DEFINITIONS AND DECLARATIONS FOR mlpm.c */

#ifndef mlpm_h
#define mlpm_h

/* declarations for other files */
void mlpm_train(int create_flag, int db_type, int nraw, int ninputs,
		int *features, int noutputs, int normalize, int npatterns,
		int verbosity, int verror, int nepochs, int random_flag,
		char *data_path, char *data_fname, char *norm_fname,
		char *exp_path, char *error_fname, char *param_fname,
		char **labels, char *comment, float *etta_list, float alpha,
		float tolerance, float decay, float kappa, float epsilon,
		float *sigmoid_param_list, int *nnodes, int *batch,
		int etta_type, int hfunction, int ofunction,
		float max_magnitude, float etta_nepochs);

void mlpm_cross_valid(int map_flag, int nraw, int ninputs, int *features,
		      int noutputs, int normalize, int npatterns,
		      int verbosity, int verror, int nepochs, int random_flag,
		      int cv_nfolds, int cv_nsplits, int use_cv_splits,
		      int *cv_splits, char **cv_train_mask,
		      char **cv_test_mask, char *data_path, char *data_fname,
		      char *norm_fname, char *exp_path, char *error_fname,
		      char *param_fname, char **labels, char *comment,
		      float *etta_list, float alpha, float tolerance,
		      float decay, float kappa, float epsilon,
		      float *sigmoid_param_list, int *nnodes, int *batch,
		      int etta_type, int hfunction, int ofunction,
		      float max_magnitude, float etta_nepochs);

void mlpm_test(int create_flag, int map_flag, int nraw, int ninputs,
	       int *features, int noutputs, int npatterns, int verbosity,
	       int verror, char *data_path, char *data_fname, char *exp_path,
	       char *error_fname, char *param_fname, char **labels,
	       int *nnodes);

#endif
