/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* mlp_args.h */

/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/mlpm_args.h,v 11.3 2001/08/23 20:14:36 craig Exp $ */


/*  Argument Variables for mlp program */
static int	train_flag = 0;	/* 0=don't train, 1=train network */
static int	create_flag = 0;/* 0=load old params, 1=create new params */
static char	*exp_path = "./";
static char	*error_fname = "mlp.err";
static char	*param_fname = "mlp.param";
static char	*data_path = "data/";
static char	*data_fname = "vowel.test";
static char	*desc_fname = "vowel.test.defaults";
static char	*labels[NNARGS_MAX_LABELS] = {"0"};
static int	nraw = 2;
static int	npatterns = 100;
static int	features[NNARGS_MAX_LABELS] = {0};
static int	normalize = 0;	/* 0=don't normalize inputs,
				   1=normalize inputs */
static char	*norm_fname = "vowel.norm.simple";
static int	cross_valid = 0;/* 0,1=normal testing
				 * 1 < N fold cross validation testing */
static int	cross_valid_from_file = 0;
static char	*cross_valid_fname = "vowel.test.cv";
static int	random_flag = 0;/* 0= present data in finput order
				   1= randomize data order before each epoch */
static int	seed = 0;
static int	debug = 0;	/* 0=no messages, >0=print debug messages */
static int	verbosity = 3;	/* 0= minimal log info,
				   >0=print more log info */
static int	verror = 0;	/* 0=no mserr msg, 1=short mserr msg,
				   2=long mserr msg */
/* arguments not on general list */
#define NNODES_SIZE (11)
static int	nnodes[NNODES_SIZE] = {3,2,25,10,0,0,0,0,0,0,0};
/*# of layers, nodes/layer*/
static float	alpha = 0.6;
static float	etta=0.1;
static int	use_etta_list = 0;
static float	*etta_list = NULL;
static int	etta_type=0;	/* 0=no mas, 1=multiple adaptive stepsize */
static float	epsilon = .1;
static float	kappa = .01;
static float	etta_nepochs = 0.;
static float	decay = 0.;
static float	tolerance = .01;
static int	hfunction = 0;
static int	ofunction = 4;
static float	sigmoid_param = 1.;
static int	use_sigmoid_param_list = 0;
static float	*sigmoid_param_list = NULL;
static int	nepochs = 1;
#define BATCH_SIZE (4)
static int	batch[BATCH_SIZE] = {3,1,1,0};
/* initial weight update interval, max, inc */
static float	max_magnitude = .1;

static ARG length_tab[]=
{
    {"nraw", INT, &nraw, "number of dimensions in data"},
    {"nodes", INT_LIST, (int *) &nnodes[0], "number of nodes in each layer",
       NNODES_SIZE},
};
#define LEN_TABSIZE (sizeof(length_tab)/sizeof(ARG))

static ARG	argtab[] =
{
    {"train", BOOLEAN, &train_flag, "perform training"},
    {"create", BOOLEAN, &create_flag,
       "new error file, if -train: new param file"},
    {"pathexp", STRING, (int *) &exp_path, "path to experiment files"},
    {"ferror", STRING, (int *) &error_fname, "error (results) file"},
    {"fparam", STRING, (int *) &param_fname, "file for model storage"},
    {"pathdata", STRING, (int *) &data_path, "path to data files"},
    {"finput", STRING, (int *) &data_fname, "input data file"},
    {"fdescribe", STRING, (int *) &desc_fname, "description file for finput"},
    {"labels", STRING_LIST, (int *) &labels[0],
       "set of labels describing outputs"},
    {"nraw", INT, &nraw, "number of dimensions in data"},
    {"npatterns", INT, &npatterns, "number of patterns to read from finput"},
    {"features", INT_LIST, features, "features of normalized data to use"},
    {"normalize", BOOLEAN, &normalize, "normalize inputs using fnorm data"},
    {"fnorm", STRING, (int *) &norm_fname, "normalization file for finput"},
    {"cross_valid", INT, &cross_valid, "N fold cross validation testing"},
    {"cross_valid_from_file", BOOLEAN, &cross_valid_from_file,
       "do cross validation testing with splits taken from fcross_valid"},
    {"fcross_valid", STRING, (int *)&cross_valid_fname,
       "cross validation splits file"},
    {"random", BOOLEAN, &random_flag,
       "select training patterns in random order"},
    {"seed", INT, &seed, "seed for all random number generation"},
    {"debug", INT, &debug, "print debug messages"},
    {"verbose", INT, &verbosity, "verbosity level for log message print"},
    {"verror", INT, &verror,
       "verbosity level for error file print (0 is no file)"},
    /* mlp specific arguments */
    {"nodes", INT_LIST, (int *) &nnodes[0], "number of nodes in each layer",
       NNODES_SIZE},
    {"alpha", FLOAT, (int *) &alpha,"momentum of weights",0,2},
    {"etta", FLOAT, (int *) &etta, "stepsize for gradient descent"},
        {"use_etta_list", BOOLEAN, &use_etta_list,
       "use etta_list as stepsize for each layer. default: use etta for all"},
    {"etta_list", FLOAT_ALLOC_LIST, (int *)&etta_list,
       "list of stepsizes for weights between each mlp layer"},
    {"etta_change_type", INT, &etta_type,
       "0: no change 1: constant then c/ntrials reduction 2: multiple-adaptive step size"},
    {"epsilon",FLOAT,(int *) &epsilon,
       "decrement for multiple adaptive stepsize"},
    {"kappa", FLOAT, (int *) &kappa,
       "increment for multiple adaptive stepsize (multiplied)"},
    {"etta_nepochs", FLOAT, (int *)&etta_nepochs,
       "number of epochs (float) to hold etta constant before reduction"},
    {"decay", FLOAT, (int *) &decay,
       "factor of weight to subtract each update"},
    {"tolerance", FLOAT, (int *) &tolerance, "tolerance in output error"},
    {"hfunction", INT, &hfunction,
       "hidden layer function  0=sigm(0-1),\n  1=sym sigm(-1-1), 4=linear"},
    {"ofunction", INT, &ofunction,
       "output layer function  0=sigm(0-1),\n  1=sym sigm(-1-1), 4=linear"},
    {"sigmoid_param", FLOAT, (int *) &sigmoid_param,"spread for sigmoids"},
    {"use_sig_param_list", BOOLEAN, &use_sigmoid_param_list,
       "use sig_param_list as sigmoid spread for each connecting layer"},
    {"sig_param_list", FLOAT_ALLOC_LIST, (int *)&sigmoid_param_list,
       "list of spreads for sigmoids between each mlp layer"},
    {"epochs", INT, &nepochs,
       "number of times to run through all training data"},
    {"batch", INT_LIST,(int *) &batch[0],
       "update weights every N patterns: initial_N,max_N,increase_by_N_per_epoch",
   BATCH_SIZE},
    {"init_mag", FLOAT, (int *)&max_magnitude,
       "maximum magnitude of initial weights"},
};
#define TABSIZE (sizeof(argtab)/sizeof(ARG))
