/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/nbayes_args.h,v 11.4 2001/08/23 20:14:36 craig Exp $ */


/* arguments not on general list */
static int	nbins = 10;
static int	*nBinsPerInput = NULL;
static int	discreteData = 0;
static float	rangeFactor = 1.5;
static int	ignore_unseen = 0;
static int	unity_laplace = 0;

static ARG	nbayes_tab[] =
{
    {"nbins", INT, &nbins,
       "number of bins for each nbayes"},
    {"nBinsPerInput", INT_ALLOC_LIST, (int *)&nBinsPerInput,
       "number of bins for each Input"},
    {"discrete", BOOLEAN, &discreteData,
     "data is discrete, contiguous, integer values starting at 0. default assumes continuous data"},
    {"range_factor", FLOAT, (int *)&rangeFactor,
     "Factor to multiply data range by to get continuous nbayes range.\nNOT USED when discrete flag is set"},
    {"ignore_unseen", BOOLEAN, &ignore_unseen, "Train classifier to ignore discrete test inputs with unknown values. Default is to use the laplace correction"},
    {"unity_laplace", FLAG, &unity_laplace, "Laplace correction is 1. Default is 1/Npat"},
};
#define NBAYES_TABSIZE (sizeof(nbayes_tab)/sizeof(ARG))
