/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/norm_apply_args.h,v 11.3 2001/08/23 20:14:36 craig Exp $ */


/* Argument variables for norm_apply program */
static char	*data_path = "data/";
static char	*data_fname = "";
static char	*data_out_fname = "";
static char	*desc_fname = "";
static char	*desc_out_fname = "";
static int	npatterns = 0;
static int	ninputs = 0;
static int	*features = NULL;
static int	normalize = 0;	/* 0=don't normalize inputs,
				   1=normalize inputs */
static char	*norm_fname = "vowel.norm.simple";

static ARG	norm_tab[] =
{
    {"pathdata", STRING, (int *) &data_path, "path to data files"},
    {"finput", STRING, (int *) &data_fname, "input data file"},
    {"foutput", STRING, (int *) &data_out_fname, "output data file"},
    {"fdescribe", STRING, (int *) &desc_fname, "description file for finput"},
    {"foutdescribe", STRING, (int *) &desc_out_fname,
       "description file for fouput"},
    {"npatterns", INT, &npatterns, "number of patterns to read from finput"},
    {"ninputs", INT, &ninputs, "number of dimensions to use in data"},
    {"features", INT_ALLOC_LIST, (int *)&features,
       "features of normalized data to use"},
    {"normalize", BOOLEAN, &normalize, "normalize inputs using fnorm data"},
    {"fnorm", STRING, (int *) &norm_fname, "normalization file for finput"},
};
#define NORM_TABSIZE (sizeof(norm_tab)/sizeof(ARG))
