/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* norm_args.h */

/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/norm_args.h,v 11.3 2001/08/23 20:14:36 craig Exp $ */

 
/*  Argument Variables for norm program */
static char *data_path = "data/";
static char *data_fname = "vowel.train";
static char *desc_fname ="vowel.train.defaults";
static char *norm_fname = "vowel.norm.simple";
static int normalization = 0;  /* 0=none, 1=simple, 2=PCA, 3=LDA */
static int debug = 0; /* 0=no messages, >0=print debug messages */
static int verbosity = 3; /* 0= minimal log info, >0=print more log info */

static ARG argtab[]=
{
    {"pathdata", STRING, (int *) &data_path, "path to data files"},
    {"finput", STRING, (int *) &data_fname, "input data file"},
    {"fdescribe", STRING, (int *) &desc_fname, "description file for finput"},
    {"normalization", INT, &normalization,"0=none, 1=simple, 2=PCA, 3=LDA"},
    {"fparam", STRING, (int *) &norm_fname,
       "file for storing normalization model"},
    {"debug", INT, (int *) &debug, "print debug messages"},
    {"verbose", INT, (int *) &verbosity,
       "verbosity level for log message print"},
};
#define TABSIZE (sizeof(argtab)/sizeof(ARG))

