/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/***---------------------------------------------------------------------------
* NAME:		param_util.h
* PURPOSE:	typdefs needed for parameter file processor
* USAGE: 	#include "/u/es/hybrid/iwr/param/param_util.h"
* CREATED:	25-Sep-90 es                             MIT LINCOLN LABORATORY
--------------------------------------------------------------------------***/
#define P_INT		0
#define P_FLOAT		1
#define P_BOOLEAN	2
#define P_FLAG		P_BOOLEAN
#define P_CHAR		3
#define P_STRING	4
#define P_DOUBLE	5
#define P_INT_VECTOR	6
#define P_STRING_VECTOR	7
#define P_FLOAT_VECTOR	8
#define P_DOUBLE_VECTOR	9
#define P_INT_MATRIX	10
#define P_FLOAT_MATRIX	11
#define P_DOUBLE_MATRIX	12

#define MAXFIELD	50
#define MAXLINE		100


typedef struct
	{
	char		*label;		/* parameter label */
	unsigned	type;		/* variable type */
	int		*variable;	/* pointer to variable */
        int             n_dim1;         /* dimension 1 */
        int             n_dim2;         /* dimension 2 */
	}
PARAM;

#define BEG_BLK_STR "<BEGIN_PARAM>"
#define END_BLK_STR "<END_PARAM>"
#define BEG_VEC_STR "{BEGIN_VECTOR"
#define END_VEC_STR "END_VECTOR}"
#define BEG_MAT_STR "{BEGIN_MATRIX"
#define END_MAT_STR "END_MATRIX}"

#define FLAG_TRUE	"YES"
#define FLAG_FALSE	"NO"

int param_putblk();
int param_getblk();
void param_setvarptr();
void param_setdim();
void param_inc_allptrs();
int param_put();
int param_get();
void param_put_begblkstr();
void param_put_endblkstr();
int param_find_begblk();
int param_find_endblk();
PARAM *param_find();
