/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/parzen_args.h,v 11.3 2001/08/23 20:14:36 craig Exp $ */
/* $Source: /data/speech/kukolich/cvsroot/lnknet/src/include/parzen_args.h,v $ */


/* Variables set from command line flags 
-----------------------------------------*/
static float	minimum_variance = .00001;
static int	per_input = 0;
static int	per_class = 0;
static float	spread = 1.;
static int	linear = 0;

/*** Argument Table ***/
static ARG	parzen_tab[] =
{
    {"per_input", BOOLEAN, &per_input,
       "estimate variances for each input, default: spherical Gaussians"},
    {"per_class", BOOLEAN, &per_class,
       "estimate variances for each class, default: equal Gaussians for all classes"},
    {"minvar", FLOAT, (int *)&minimum_variance, "minimum value of variance"},
    {"spread", FLOAT, (int *)&spread,
       "factor for scaling kernel functions for testing"},
    {"linear", BOOLEAN, &linear,
       "Use step functions for kernels. Default: Gaussian kernels"},
};
#define PARZEN_TABSIZE (sizeof(parzen_tab)/sizeof(ARG))
