/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_bound.h */

/* DEFINITIONS AND DECLARATIONS FOR plot_bound.c */

#ifndef plot_bound_h
#define plot_bound_h

void plot_boundary_in_window (char *error_filename, int two_d, char *print_filename, char *plot_label);
void plot_bound (void);
float plot_scatter (FILE *data_file, int n_patterns, float *stddev);
void plot_profile_in_window (char *error_filename, int two_d, char *print_filename, char *plot_label);
void plot_profile (void);
float plot_histogram (FILE *data_file, int n_patterns, float *stddev);
int find_class (register float *inputs);
int x2u (float raw_x);
int y2v (float raw_y);
int xlength2u (float raw_x);
int ylength2v (float raw_y);
void draw_ellipse (float scale, int ucenter, int vcenter,
		   int uwidth, int vwidth);
void draw_angle_ellipse (float scale, int ucenter, int vcenter,
			 int uwidth, int vwidth, double theta);
void get_ellipse_rotation (float a, float b, float c, float *px, float *py,
			   double *ptheta);
void calc_bound_autoscale (FILE *data_file, int two_d);
void mac_scatter (FILE *data_file);
void set_is_cluster (void);
void plot_legend (int two_d);

/* these are defined in each of the alg_plot_bound.c files */
int get_extra_plot_args (int argc, char **argv);
void read_model (FILE *param_file, int *total_trials, int *ninputs,
		 int *noutputs, int **features, int adjust_priors,
		 float *priors_list);
int classify (float *inputs);
float *get_outputs (void);
void over_plot (int two_d, float internals_scale, int internals_level,
		char **plot_labels, int x_dimen, int y_dimen, float bound_xmax,
		float bound_xmin, float bound_ymax, float bound_ymin,
		int ubot, int utop, int vbot, int vtop);

#endif
