/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_cost_args.h */

/*  Argument Variables for plot_cost program */
#ifdef PLOT_COST

static char *plot_exp_path = "./";
static char *plot_error_fname = "knn.err";
static int plot_trial_average = 100; 
static int no_graphics = 0;
#endif

static int cost_autoscale = 0;
static char *cost_plot_fname = "cost.plot"; 
static float cost_xmin = 0.0;
static float cost_xmax = 10000.0;
static float cost_xstep = 1000.0;
static float cost_ymin = 0.0;
static float cost_ymax = 5.0;
static float cost_ystep = 1.0;
static char *cost_plot_label = "Cost Plot";
static int cost_func = 0; /* SQ_ERR */ 
static int mac_cost_flag = 0;
static char *mac_costlines_fname = "cost.mac";
static int class_data = 0;
static int seq_data = 0;
static int map_data = 0;

static ARG cost_argtab[]=
{
  {"pathexp", STRING, (int *) &plot_exp_path, "path to experiment files"},
  {"ferror", STRING, (int *) &plot_error_fname, "name of error file (appended)"},
  {"fplot", STRING, (int *) &cost_plot_fname, "name of plot file (appended)"},
  {"autoscale", BOOLEAN, &cost_autoscale,
	"0 - supplied axes limits; 1 - autoscale both axes"},
  {"xmin", FLOAT, (int *) &cost_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &cost_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &cost_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &cost_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &cost_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &cost_ystep, "step for y axis"},
  {"trials", INT, &plot_trial_average,
	  "number of points to average for each plot point"},
  {"title", STRING, (int *)&cost_plot_label, "displayed at top of graph"},
  {"cost_func", INT, &cost_func, "cost function"},
  {"mac", BOOLEAN, &mac_cost_flag, "create files for Macintosh plotting"},
  {"fmaclines", STRING, (int *)&mac_costlines_fname,
     "Macintosh cost plot data file"},
  {"no_graphics", BOOLEAN, &no_graphics,
     "create plot file, but do not display it"},
  {"class", BOOLEAN, &class_data, "data is from a classifcation error file"},
  {"map", BOOLEAN, &map_data, "data is from a mapping error file"},
  {"seq", BOOLEAN, &seq_data, "data is from a sequence error file"},
};
#define COST_TABSIZE (sizeof(cost_argtab)/sizeof(ARG))

