/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_detect_args.h */

#ifndef plot_detect_args_h
#define plot_detect_args_h

/*  Argument Variables for plot_detect program */
static int target = 0;

#define EXPERIMENT_PATH ""
static char *plot_exp_path = EXPERIMENT_PATH;
static char *error_fname = "detect.err";
static char *plot_detect_fname = "detect.plot";

static int no_detect_graphics = 0;
static int noutputs = 0;

static float detect_xmin = 0.0;
static float detect_xmax = 100.0;
static float detect_xstep = 10.0;
static float detect_ymin = 0.0;
static float detect_ymax = 100.0;
static float detect_ystep = 10.0;
static char *detect_plot_label = "Error Rate vs Detection Rate    ";

static int mac_detect_flag = 0;
static char *mac_detectlines_fname = "detect.mac";

static int verbose = 2;
static float reject_rate= 0.0;
static float table_begin = 0.;
static float table_end = 100.;
static float table_step = 2.;
static int no_borders = 0;
static int log_outputs = 0;

static ARG detect_argtab[]=
{
  {"target", INT, (int *) &target, "target class [0 - nclasses-1]"},
  {"pathexp",STRING,(int *) &plot_exp_path,"path to experiment files"},
  {"ferror",STRING,(int *) &error_fname,
     "error file in pathexp created with -verror 2"},
  {"fplot",STRING, (int *) &plot_detect_fname, "plot file stored in pathexp"},
  {"noutputs", INT, (int *) &noutputs, "number of outputs"},
  {"reject", FLOAT, (int *) &reject_rate,"fraction of patterns to reject"},
  {"xmin", FLOAT, (int *) &detect_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &detect_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &detect_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &detect_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &detect_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &detect_ystep, "step for y axis"},
  {"title",STRING,(int *)&detect_plot_label,"displayed at bottom of graph"},
  {"table_begin", FLOAT, (int *) &table_begin,
     "percent false alarm rate for first table entry", 0, 100},
  {"table_end", FLOAT, (int *) &table_end,
     "percent false alarm rate for last table entry", 0, 100},
  {"table_step", FLOAT, (int *) &table_step,
     "step size for false alarm rate for table entries", 0, 100},
  {"verbose", INT, &verbose,
     "0=No Table, 1=Area under ROC 2=Sampled Table 3=Full Table"},
  {"mac",BOOLEAN, &mac_detect_flag, "create files for Macintosh plotting"},
  {"fmaclines", STRING, (int *) &mac_detectlines_fname,
     "Macintosh percent error plot data file (appended)"},
  {"no_graphics", BOOLEAN, &no_detect_graphics,
     "create plot file, but do not display it"},
  {"no_borders", BOOLEAN, &no_borders,
     "no grid, labels, or titles on plot"},
  {"log_outputs", BOOLEAN, &log_outputs,
   "data in error file is log10. default is linear inputs"},
};

#define DETECT_TABSIZE (sizeof(detect_argtab)/sizeof(ARG))


#endif
