/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_map_args.h */

/*  Argument Variables for plot_map program */

#ifdef PLOT_MAP

static char *plot_exp_path = "./";
static char *plot_error_fname = "mlp.param";
static int plot_n_inputs = 0;
static int plot_n_outputs = 0;
static char *plot_labels [NNARGS_MAX_LABELS] = {"0"};
#endif
static int map_autoscale = 0;
static char *plot_fname = "mapping.plot";
static float map_xmin = -3.0;
static float map_xmax = 3.0;
static float map_xstep = 1.0;
static float map_ymin = -3.0;
static float map_ymax = 3.0;
static float map_ystep = 1.0;
static char *map_plot_label = "Mapping Plot";
static int map_in_dim = 0;
static int map_out_dim = 0;
static int map_npoints = 50;
static int outputs_plot = 0;
static int map_scat_plot = 0;
static int map_scat_n_patterns = 0;
static char *map_scat_data_fullname = "vowel.train";
static int no_map_graphics = 0;
static int map_no_norm = 0;
static float map_other_vars[NNARGS_MAX_LABELS] = {0.};

static ARG map_argtab[]=
{
  {"pathexp", STRING, (int *) &plot_exp_path, "path to experiment files"},
  {"fparam", STRING, (int *) &plot_error_fname, "name of parameter file"},
  {"fmap", STRING, (int *) &plot_fname,"name of map plot file"},
  {"title", STRING, (int *)&map_plot_label, "map plot title"},
  {"input_dim", INT, &map_in_dim, "dimension to show from input vector"},
  {"output_dim", INT, &map_out_dim, "dimension to show from output vector"},
  {"autoscale", BOOLEAN, &map_autoscale,
     "0 - supplied axes limits; 1 - autoscale both axes"},
  {"xmin", FLOAT, (int *) &map_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &map_xmax, "upper x axis limit"},
  {"xstep", FLOAT, (int *) &map_xstep, "step for x axis"},
  {"ymin", FLOAT, (int *) &map_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &map_ymax, "upper y axis limit"},
  {"ystep", FLOAT, (int *) &map_ystep, "step for y axis"},
  {"outputs", BOOLEAN, &outputs_plot, "Plot function outputs if on"},
  {"npoints", INT, &map_npoints, "points per dimension in grid"},
  {"map_scat", BOOLEAN, &map_scat_plot, "Create map_scat plot if on"},
  {"fdata", STRING, (int *) &map_scat_data_fullname,
     "full path name of data file  for map_scat plot"},
  {"labels", STRING_LIST,(int *)&plot_labels[0],
     "set of labels describing outputs"},
  {"ninputs", INT, &plot_n_inputs,"number of dimensions to use in data"},
  {"noutputs", INT, &plot_n_outputs,"use nclasses instead"},
  {"npatterns", INT, &map_scat_n_patterns,
     "number of patterns for map_scat plot"},
  {"no_graphics", BOOLEAN, &no_map_graphics,
     "create plot file, but do not display it"},
  {"no_norm", BOOLEAN, &map_no_norm, "plot un-normalized data"},
  {"other_vars", FLOAT_LIST, (int *)&map_other_vars[0],
     "settings for all dimensions (default: unplotted dimensions = 0)"},
};
#define MAP_TABSIZE (sizeof(map_argtab)/sizeof(ARG))

