/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_norm_args.h */

/*  Argument Variables for plot_norm program */
#ifdef PLOT_NORM

#define EXPERIMENT_PATH "../results"

static char *plot_exp_path = EXPERIMENT_PATH;
static char *plot_error_fname = "norm.param";
static int plot_n_inputs = 0;
static int plot_n_outputs = 0;
static char *plot_labels [NNARGS_MAX_LABELS] = {"0"};
static int no_graphics = 0;
#endif

    /* for compatibility with other plot programs */
static int norm_auto_scale_flag = 0;
static char *norm_plot_fname = "norm.plot"; 
static char *norm_data_path = "../data/"; 
static float norm_xmin = 0;
static float norm_xmax = 100;
static float norm_xstep = 10;
static float norm_ymin = 0;
static float norm_ymax = 100;
static float norm_ystep = 10;
static char *norm_plot_label = "Normalization Eigenvalue Percentage Plot";
static int mac_norm_flag = 0;
static char *mac_normlines_fname = "norm.mac";

static ARG norm_argtab[]=
{
  {"pathexp", STRING, (int *) &plot_exp_path, "path to experiment files"},
  {"fparam", STRING, (int *) &plot_error_fname, "name of parameter file (appended)"},
  {"ninputs", INT, &plot_n_inputs,"number of dimensions to use in data"},
  {"noutputs", INT, &plot_n_outputs,"use nclasses instead"},
  {"labels", STRING_LIST,(int *)&plot_labels[0],"set of labels describing outputs"},
  {"pathdata", STRING, (int *) &norm_data_path, "path to normalization files"},
  {"fplot", STRING, (int *) &norm_plot_fname, "name of plot file (appended)"},
  {"autoscale", BOOLEAN, &norm_auto_scale_flag,
	"0 - supplied axes limits; 1 - autoscale both axes"},
  {"xmin", FLOAT, (int *) &norm_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &norm_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &norm_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &norm_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &norm_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &norm_ystep, "step for y axis"},
  {"title", STRING, (int *)&norm_plot_label, "displayed at bottom of graph"},
  {"mac", BOOLEAN, &mac_norm_flag, "create files for Macintosh plotting"},
  {"fmaclines", STRING, (int *)&mac_normlines_fname,
     "Macintosh normalization eigenvalue plot data file"},
  {"no_graphics", BOOLEAN, &no_graphics,
     "create plot file, but do not display it"},
};
#define NORM_TABSIZE (sizeof(norm_argtab)/sizeof(ARG))

