/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_perr_args.h */

/*  Argument Variables for plot_perr program */
#ifdef PLOT_PERR

#define EXPERIMENT_PATH "experiment/"

static char *plot_exp_path = EXPERIMENT_PATH;
static char *plot_error_fname = "knn.err";
static int plot_trial_average = 100; 
#endif

static int perr_auto_scale_flag = 0;
static char *perr_plot_fname = "perr.plot"; 
static float perr_xmin = 0.0;
static float perr_xmax = 10000.0;
static float perr_xstep = 1000.0;
static float perr_ymin = 0.0;
static float perr_ymax = 100.0;
static float perr_ystep = 10.0;
static char *perr_plot_label = "%% Error Plot";

static int mac_perr_flag = 0;
static char *mac_perrlines_fname = "perr.mac";
static int no_graphics = 0;
static int class_data = 0;
static int seq_data = 0;
static int map_data = 0;

static ARG perr_argtab[]=
{
  {"pathexp", STRING, (int *) &plot_exp_path, "path to experiment files"},
  {"ferror", STRING, (int *) &plot_error_fname, "name of error file (appended)"},
  {"fplot", STRING, (int *) &perr_plot_fname, "name of plot file (appended)"},
  {"autoscale", BOOLEAN, &perr_auto_scale_flag,
	"0 - supplied axes limits; 1 - autoscale both axes"},
  {"xmin", FLOAT, (int *) &perr_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &perr_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &perr_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &perr_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &perr_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &perr_ystep, "step for y axis"},
  {"trials", INT, &plot_trial_average,
	  "number of points to average for each plot point"},
  {"title", STRING, (int *)&perr_plot_label, "displayed at bottom of graph"},
  {"mac", BOOLEAN, &mac_perr_flag, "create files for Macintosh plotting"},
  {"fmaclines", STRING, (int *)&mac_perrlines_fname,
     "Macintosh percent error plot data file"},
  {"no_graphics", BOOLEAN, &no_graphics,
     "create plot file, but do not display it"},
  {"class", BOOLEAN, &class_data, "data is from a classifcation error file"},
  {"map", BOOLEAN, &map_data, "data is from a mapping error file"},
  {"seq", BOOLEAN, &seq_data, "data is from a sequence error file"},
};
#define PERR_TABSIZE (sizeof(perr_argtab)/sizeof(ARG))

