/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#define EXPERIMENT_PATH ""

static int bin_plot = 0;
static int target = 0;
static int nbins= 5;
static int var_bin_flag;
static float *var_bin_ends=NULL;
static int min_bin_count= 5;
static int chi_square_flag= 0;
static char *plot_exp_path = EXPERIMENT_PATH;
static char *error_fname = "prob.err";
static char *plot_prob_fname = "prob.plot";
static int no_prob_graphics = 0;
static int noutputs = 0;
static int npatterns = 0;
static float prob_xmin = 0.0;
static float prob_xmax = 100.0;
static float prob_xstep = 10.0;
static float prob_ymin = 0.0;
static float prob_ymax = 100.0;
static float prob_ystep = 10.0;
static int verbose = 2;
static int no_text = 0;
static int sum_to_one = 0;
static char *prob_plot_label = "Actual vs. Predicted Probability    ";
static int mac_prob_flag = 0;
static char *mac_problines_fname = "prob.mac";

static ARG prob_argtab[]=
{
  {"bin_plot", BOOLEAN, &bin_plot,
     "Generate Probability Bin (Comparison) Plot Default: Scatter Plot"},
  {"target", INT, (int *) &target, "target class [0 - nclasses-1]"},
  {"nbins", INT, &nbins, "number of bins for the histogram"},
  {"var_bin", BOOLEAN, &var_bin_flag, "variable-width bin"},
  {"bin_ends", FLOAT_ALLOC_LIST, (int *)&var_bin_ends,
     "variable bin limits. must be in order from 0 to 100"},
  {"min_bin_count", INT, &min_bin_count,
     "minimum number of items per bin before combining bins"},
  {"chi_square", BOOLEAN, &chi_square_flag,
     "calculate chi square number"},
  {"pathexp",STRING,(int *) &plot_exp_path,"path to experiment files"},
  {"ferror",STRING,(int *) &error_fname,
     "classifier error file in pathexp created with -verror 2"},
  {"fplot",STRING, (int *) &plot_prob_fname,
     "plot file stored in pathexp"},
  {"no_graphics", BOOLEAN, &no_prob_graphics,
     "create plot file, but do not display it"},
  {"noutputs", INT, (int *) &noutputs, "number of outputs"},
  {"npatterns", INT, (int *) &npatterns, "number of patterns or points"},
  {"xmin", FLOAT, (int *) &prob_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &prob_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &prob_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &prob_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &prob_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &prob_ystep, "step for y axis"},
  {"verbose", INT, &verbose, "0=No Table, 1=Table, 2= +plot data"},
  {"no_text", BOOLEAN, &no_text, "Do not print text on plot points"},
  {"sum_to_one", BOOLEAN, &sum_to_one, "Normalize outputs to sum to one"},
  {"title",STRING,(int *)&prob_plot_label,"displayed at bottom of graph"},
  {"mac",BOOLEAN, &mac_prob_flag, "create files for Macintosh plotting"},
  {"fmaclines", STRING, (int *) &mac_problines_fname,
     "Macintosh percent error plot data file (appended)"},
};

#define PROB_TABSIZE (sizeof(prob_argtab)/sizeof(ARG))
