/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_reject_args.h */

#ifndef plot_reject_args_h
#define plot_reject_args_h

/*  Argument Variables for plot_reject program */

#ifdef PLOT_REJECT
#define EXPERIMENT_PATH ""
static char *plot_exp_path = EXPERIMENT_PATH;
static char *error_fname = "reject.err";
static char *plot_reject_fname = "reject.plot";
#endif

static int no_graphics = 0;
static int noutputs = 0;
static int npatterns = 0;

static float reject_xmin = 0.0;
static float reject_xmax = 100.0;
static float reject_xstep = 10.0;
static float reject_ymin = 0.0;
static float reject_ymax = 100.0;
static float reject_ystep = 10.0;
static char *reject_plot_label = "Error Rate vs Rejection Rate    ";

static int mac_reject_flag = 0;
static char *mac_rejectlines_fname = "reject.mac";

static int sum_to_one = 0;
static int verbose = 1;
static float table_begin = 0.;
static float table_end = 100.;
static float table_step = 2.;

static ARG reject_argtab[]=
{
  {"pathexp",STRING,(int *) &plot_exp_path,"path to experiment files"},
  {"ferror",STRING,(int *) &error_fname,"name of error file (appended)"},
  {"fplot",STRING, (int *) &plot_reject_fname, "name of plot file (appended)"},
  {"noutputs", INT, (int *) &noutputs, "number of outputs"},
  {"npatterns", INT, (int *) &npatterns, "number of patterns or points"},
  {"xmin", FLOAT, (int *) &reject_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &reject_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &reject_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &reject_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &reject_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &reject_ystep, "step for y axis"},
  {"title",STRING,(int *)&reject_plot_label,"displayed at bottom of graph"},
  {"table_begin", FLOAT, (int *) &table_begin,
     "percent rejection rate for first table entry", 0, 100},
  {"table_end", FLOAT, (int *) &table_end,
     "percent rejection rate for last table entry", 0, 100},
  {"table_step", FLOAT, (int *) &table_step,
     "step size for rejection rate for table entries"},
  {"verbose", INT, &verbose, "0=No Table, 1=Sampled Table, 2=Full Table"},
  {"sum_to_one", BOOLEAN, &sum_to_one, "Normalize outputs to sum to one"},
  {"mac",BOOLEAN,&mac_reject_flag,"create files for Macintosh plotting"},
  {"fmaclines",STRING,(int *)&mac_rejectlines_fname,
     "Macintosh percent error plot data file (appended)"},
  {"no_graphics", BOOLEAN, &no_graphics,
     "create plot file, but do not display it"},
};

#define REJECT_TABSIZE (sizeof(reject_argtab)/sizeof(ARG))


#endif
