/* plot_rmserr_args.h */

/*  Argument Variables for plot_rmserr program */
#ifdef PLOT_RMSERR

#define EXPERIMENT_PATH "experiment/"

static char *plot_exp_path = EXPERIMENT_PATH;
static char *plot_error_fname = "knn.err";
static int plot_trial_average = 100; 
#endif

static int rmserr_auto_scale_flag = 0;
static char *rmserr_plot_fname = "rmserr.plot"; 
static float rmserr_xmin = 0.0;
static float rmserr_xmax = 10000.0;
static float rmserr_xstep = 1000.0;
static float rmserr_ymin = 0.0;
static float rmserr_ymax = 5.0;
static float rmserr_ystep = 1.0;
static int rmserr_line_type = 1; /* 1 - solid, 2 - dotted */
static char *rmserr_plot_label = "RMS Error Plot";

static ARG rmserr_argtab[]=
{
  {"pathexp", STRING, (int *) &plot_exp_path, "path to experiment files"},
  {"ferror", STRING, (int *) &plot_error_fname, "name of error file (appended)"},
  {"fplot", STRING, (int *) &rmserr_plot_fname, "name of plot file (appended)"},
  {"autoscale", BOOLEAN, &rmserr_auto_scale_flag,
	"0 - supplied axes limits; 1 - autoscale both axes"},
  {"xmin", FLOAT, (int *) &rmserr_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &rmserr_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &rmserr_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &rmserr_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &rmserr_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &rmserr_ystep, "step for y axis"},
  {"line_type", INT, &rmserr_line_type, "0 - no lines, 1 - solid, 2 - dotted "},
  {"trials", INT, &plot_trial_average,
	  "number of points to average for each plot point"},
  {"title", STRING, (int *)&rmserr_plot_label, "displayed at top of graph"},
};
#define RMSERR_TABSIZE (sizeof(rmserr_argtab)/sizeof(ARG))

