/* plot_scat_args.h */

/*  Argument Variables for plot_scat program */
#ifdef PLOT_SCAT

#define EXPERIMENT_PATH "experiment/"

static char *plot_exp_path = EXPERIMENT_PATH;
static char *plot_error_fname = "knn.err";
static int plot_n_inputs = 0;
static int plot_n_outputs = 0;
static char *plot_labels [NNARGS_MAX_LABELS] = {"5","testing","..","1","2","3"};
#endif

static int scat_auto_scale_flag = 0;
static char *scat_plot_fname = "scat.plot"; 
static float scat_xmin = -5.0;
static float scat_xmax = 5.0;
static float scat_xstep = 1.0;
static float scat_ymin = -5.0;
static float scat_ymax = 5.0;
static float scat_ystep = 1.0;
static char *scat_plot_label = "Scatter Plot";
static int scat_dim_1 = 1;
static int scat_dim_2 = 2;

static ARG scat_argtab[]=
{
  {"pathexp", STRING, (int *) &plot_exp_path, "path to experiment files"},
  {"ferror", STRING, (int *) &plot_error_fname, "name of error file (appended)"},
  {"fplot", STRING, (int *) &scat_plot_fname, "name of plot file (appended)"},
  {"autoscale", BOOLEAN, &scat_auto_scale_flag,
	"0 - supplied axes limits; 1 - autoscale both axes"},
  {"xmin", FLOAT, (int *) &scat_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &scat_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &scat_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &scat_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &scat_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &scat_ystep, "step for y axis"},
  {"ninputs", INT, &plot_n_inputs,"number of dimensions to use in data"},
  {"noutputs", INT, &plot_n_outputs,"use nclasses instead"},
  {"labels", STRING_LIST,(int *)&plot_labels[0],"set of labels describing outputs"},
  {"title", STRING, (int *)&scat_plot_label, "displayed at bottom of graph"},
  {"first_dim", INT, &scat_dim_1, "first dimension from input vector"},
  {"second_dim", INT, &scat_dim_2, "second dimension from input vector"},
};
#define SCAT_TABSIZE (sizeof(scat_argtab)/sizeof(ARG))

