/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_select_args.h */

/*  Argument Variables for plot_select program */
#ifdef PLOT_SELECT

#define EXPERIMENT_PATH "experiment/"

static char *plot_exp_path = EXPERIMENT_PATH;
static char *plot_error_fname = "select.param";
#endif

    /* for compatibility with other plot programs */
static int select_auto_scale_flag = 0;
static char *select_plot_fname = "select.plot"; 
static float select_xmin = 0.0;
static float select_xmax = 100.0;
static float select_xstep = 10.0;
static float select_ymin = 0.0;
static float select_ymax = 100.0;
static float select_ystep = 10.0;
static char *select_plot_label = "Feature Selection Plot";
static int mac_search_flag = 0;
static char *mac_searchlines_fname = "search.mac";
static int no_graphics = 0;

static ARG select_argtab[]=
{
  {"pathexp", STRING, (int *) &plot_exp_path, "path to experiment files"},
  {"fparam", STRING, (int *) &plot_error_fname, "name of parameter file (appended)"},
  {"fplot", STRING, (int *) &select_plot_fname, "name of plot file (appended)"},
  {"autoscale", BOOLEAN, &select_auto_scale_flag,
	"0 - supplied axes limits; 1 - autoscale both axes"},
  {"xmin", FLOAT, (int *) &select_xmin, "lower x axis limit"},
  {"xmax", FLOAT, (int *) &select_xmax, "upper x axis limit"},
  {"ymin", FLOAT, (int *) &select_ymin, "lower y axis limit"},
  {"ymax", FLOAT, (int *) &select_ymax, "upper y axis limit"},
  {"xstep", FLOAT, (int *) &select_xstep, "step for x axis"},
  {"ystep", FLOAT, (int *) &select_ystep, "step for y axis"},
  {"title", STRING, (int *)&select_plot_label, "displayed at bottom of graph"},
  {"mac", BOOLEAN, &mac_search_flag, "create files for Macintosh plotting"},
  {"fmaclines", STRING, (int *)&mac_searchlines_fname,
     "Macintosh feature search plot data file"},
  {"no_graphics", BOOLEAN, &no_graphics,
     "create plot file, but do not display it"},
};
#define SELECT_TABSIZE (sizeof(select_argtab)/sizeof(ARG))
