/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* plot_struct.h */

static char *struct_plot_fname = "struct.plot";
static char *struct_param_fname = "struct.param";
static char *struct_defaults_fname = "";
static int struct_no_text = 0;
static int struct_autoscale = 0;
static int no_graphics = 0;

static ARG struct_plot_argtab[] = 
{
    {"fparam", STRING, (int *)&struct_param_fname, "name of parameter file"},
    {"fplot", STRING, (int *)&struct_plot_fname, "name of file for plot storage"},
    {"fdescribe", STRING, (int *)&struct_defaults_fname,
       "full name of defaults file for training data base"},
    {"autoscale", BOOLEAN, &struct_autoscale,
       "scale plot to fit in the plotting window"},
    {"no_text", BOOLEAN, &struct_no_text, "Do not print node text"},
    {"no_graphics", BOOLEAN, &no_graphics,
       "create plot file, but do not display it"},
};
#define STRUCT_PLOT_TABSIZE (sizeof(struct_plot_argtab)/sizeof(ARG))

void uvbeam_outline(int u1, int v1, int u2, int v2, int width);

