/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* ran_clus_pack.h */

/* DEFINITIONS AND DECLARATIONS FOR ran_clus_pack.c */

/* DEFINITIONS OF INTERNAL STRUCTURES AND TYPES */
#ifdef ran_clus_pack_h_internal_types
#undef ran_clus_pack_h_internal_types
/* ran_clus_pack_h_internal_types is defined in `ran_clus_pack.c' */
typedef struct {
    int		cluster_by_class;	
    int		ninputs;	/* number of elements in patterns */
    int		noutputs;	/* number of classes */
    int		ncenters;	/* number of centers wanted */
    int		nstored;	/* number of centers collected so far */
    int		*ncenters_list;	/* ncenters wanted per class */
    int		*nstored_list;	/* ncenters stored per class */
    int		*features;	/* features of raw data used */
    float	*outputs;	/* outputs, in case we test */
    int		*counts;	/* points assigned to center for variance
				   calculation */
    int		**count_list;	/* counts by class */
    float	***pcenter_list;
    float	***pvariance_list;
    float	**pcenter;	/* final centers to return */
    float	**pvariance;	/* variance of final centers */
}	RAN_CLUS_PARAMS;
#endif


#ifndef ran_clus_pack_h
#define ran_clus_pack_h

/* DECLARATION OF EXTERNAL FUNCTIONS */
int ran_clus_build (int ninputs, int noutputs, int *ncenters_list,
		    int cluster_by_class);
void ran_clus_init (int model, int *nn_features);
void ran_clus_free (int model);
int ran_clus_read_model (FILE *fp);
int ran_clus_write_model (int model, FILE *fp);
void *ran_clus_param (int model, char *param_name);
void ran_clus_inc_train (int model, float *input, int class);
void ran_clus_batch_train (int model, float *input, int class);
void ran_clus_batch_update (int model);
int ran_clus_cluster (int model, float *input);

#endif
