/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/rbf_seq_args.h,v 11.3 2001/08/23 20:14:37 craig Exp $ */


/* Argument variables for rbf program */
static char	*cluster_param_fname = "kmeans.param";
static float	hspread=1.0;
static float	extra_hspread=1.0;
static float	max_ratio=1.0e6;
static float	minimum_variance = 1e-6;
static int	bias = 0;
static int	no_norm_outputs = 0;
static float	clip_floor = 1e-3;

static ARG	rbf_tab[] =
{
    {"fclparam", STRING, (int *) &cluster_param_fname,
       "name of cluster parameter file"},
    {"hspread", FLOAT, (int *)&hspread, "factor to multiply all variances"},
    {"exhspread", FLOAT, (int *)&extra_hspread,
       "additional hspread for testing"},
    {"max_ratio", FLOAT, (int *)&max_ratio,
       "maximum accepted eigen value ratio"},
    {"minvar", FLOAT, (int *)&minimum_variance, "minimum value of variance"},
    {"bias", BOOLEAN, &bias, "add a constant output node"},
    {"no_norm_outputs", BOOLEAN, &no_norm_outputs,
       "do not normalize final outputs to sum to one"},
    {"clip_floor", FLOAT, (int *)&clip_floor,
       "outputs of RBF network clipped to be between clip_floor and 1"},
};
#define RBF_TABSIZE (sizeof(rbf_tab)/sizeof(ARG))
