/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* svm.h */

/* DEFINITIONS AND DECLARATIONS FOR svm.c */

#ifndef svm_h
#define svm_h

/* declarations for other files */
void svm_train(      int nraw, int ninputs, int *features, int noutputs,
		     int normalize, int npatterns, int verbosity, 
		     char *data_path, char *data_fname, char *norm_fname,
		     char *exp_path, char *param_fname, char *comment, char **labels, 
                     float cbound, int kernel_type, float kernel_sigma,
		     int kernel_order, float kernel_poly_divisor,
                     int fit_posterior_using_sigmoid,
		     float kkt_tolerance, float alpha_tolerance,
                     int multi_class_type);

float svm_cross_valid(int db_type, int nraw, int ninputs,
			    int  *features, int noutputs, int normalize,
			    int npatterns, int verbosity, int verror,
			    int cv_nfolds, int cv_nsplits, int use_cv_splits,
			    int *cv_splits, char **cv_train_mask,
			    char **cv_test_mask, char *data_path,
			    char *data_fname, char *norm_fname,
			    char *exp_path, char *error_fname,
			    char *param_fname, char **labels, char *comment,
			    int adjust_test, float *test_priors_list,
			    int cv_random, int log_outputs,
			    int report_cost, int roc_target, float roc_lower,
			    float roc_upper,
                            float cbound, int kernel_type, float kernel_sigma,
		            int kernel_order, float kernel_poly_divisor,
                            int sigmoid_fit,
		            float kkt_tolerance, float alpha_tolerance,
                            int multi_model_type);

void svm_test(int create_flag, int db_type, int nraw, int ninputs,
		    int *features, int noutputs, int npatterns, int verbosity,
		    int verror, char *data_path, char *data_fname,
		    char *exp_path, char *error_fname, char *param_fname,
		    char **labels, int adjust_test, float *priors_list,
		    int sigmoid_fit);
#endif
