/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/svm_args.h,v 11.3 2001/08/23 20:14:37 craig Exp $ */


/* arguments not on general list */
static float cbound = 1.0;
static int kernel_type = 0;
static float kernel_sigma =1.0;
static int kernel_order = 2;
static float kernel_poly_divisor =1.0;
static int sigmoid_fit=0;
static float kkt_tolerance = .001;
static float alpha_tolerance = .001;
static int multi_class_type = 0;



static ARG	svm_tab[] =
{
  {"cbound", FLOAT, (int *)&cbound, 
       "upper bound for Lagrange multipliers"},
  {"kernel_type", INT, &kernel_type, 
        "kernel 0=linear, 1=gauss, 2=poly x^n, 3=inhomogeneous poly (1+x)^n, 4=linear+sv"},
  {"kernel_sigma", FLOAT, (int *)&kernel_sigma, 
        "standard deviation for gaussian kernel"},
  {"kernel_order", INT, &kernel_order, 
        "order or power for polynomial kernels"},
  {"kernel_poly_divisor", FLOAT, (int *)&kernel_poly_divisor, 
        "divide poly term x or (x+1) by this factor before raising to power"},
  {"sigmoid_fit", BOOLEAN, &sigmoid_fit, 
        "fit sigmoid to output to approximate posterior prob"},
  {"kkt_tolerance", FLOAT, (int *)&kkt_tolerance, 
         "tolerance for kkt +/-1 match conditions"},
  {"alpha_tolerance", FLOAT, (int *)&alpha_tolerance, 
         "clamp Lagrange multipliers lower than this to zero"},
  {"mclass_type", INT, &multi_class_type, 
         "type of multi-class classifier 0=each vs others, 1=all pairs"},
};

#define SVM_TABSIZE (sizeof(svm_tab)/sizeof(ARG))
