/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		lippicDecl
* PURPOSE:	declarations of functions in the xlippic libraries
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/include/xlippic.h,v 11.3 2001/11/29 18:57:56 kukolich Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/include/xlippic.h,v $
* CREATED: 7-May-99 lck				MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* maximum plotting sizes */
#define G_XMAX 1023	/* highest x point that can be plotted */
#define G_YMAX 780	/* highest y point that can be plotted */

void fatal_error();
void g_clip(int u1, int v1, int u2, int v2);
int g_code(int u, int v);
void g_initerr(void);
void g_line(int u1, int v1, int u2, int v2);
void g_move(int x, int y);
void g_vect(int x, int y);
void gcolor(char *string);
void gexit(int flag);
void gextend(int x);
void gflush(void);
void ghardcopy(int flag);
void gimagen(int verbose);
void ginit (char *command_string);
void gputc(/*int center, char c*/);
void gprintf(int center, char *fmt, ...);
void greset(void);
void grcmove(int l_offset, int c_offset);
char *gsave(char *name, int verbose);
/* this is commented out so the auto conversion to double isn't screwed up */
void gscale(/*float x, float y, float xf, float yf*/);
void gsymbol(/*char symbol, int r*/);
void gtexture(int type);
void gwtitle(char *title);
void hc_blob(int npoints, int *xarray, int *yarray);
void hc_circle(int xi, int yi, int ri);
void hc_cont(int x, int y);
void hc_color(char *s);
void hc_fill(int mode);
void hc_font(char *s);
void hc_label(char *s);
void hc_move(int x, int y);
void hc_poly(int count);
void hc_polydraw(void);
void hc_putstring(char *s);
void hc_reset(void);
void hc_space(int x0, int y0, int x1, int y1);
void hc_texture(int mode);
/* this takes a variable argument list */
void lippic_fatal_error(char * fmt, ...);
char *lippic_malloc(unsigned n, char *for_message);
void sig_init(void);
void uvarc(int u, int v, int r, int abegin, int aend);
void uvbeam(int u1, int v1, int u2, int v2, int width);
void uvblob(char *color, int npoints, int *xarray, int *yarray);
void uvblock(char *color, int u1, int v1, int u2, int v2);
void uvcircle(int u, int v, int r);
void uvcont(int u, int v);
void uvdot(char *color, int u, int v, int r);
void uvframe(int width, int u1, int v1, int u2, int v2);
void uvline(int u1, int v1, int u2, int v2);
void uvmove(int u, int v);
void uvpairs(int x0, int y0, int x[], int y[], int n, int texture, char *color);
void uvpoint(int u, int v);
void uvrcont(int u, int v);
void uvrect(int u1, int v1, int u2, int v2);
void uvrmove(int u, int v);
void uvprintf(int u, int v, int center, char *fmt, ...);
int xybar();
int xygraph();
int xygraph_advanced(float *xinput, float *yinput, int npoints,
		     int symbol_mode,	 char *symbol_string, int symbol_type,
		     int symbol_radius, int line_type, int grid_type,
		     char *graph_label, int auto_abscissas, float auto_xmin,
		     float auto_xstep, float height_fract, float width_fract,
		     float xoffset_fract, float yoffset_fract, int xlog,
		     int auto_xaxis, float xmin, float xmax, float xstep,
		     char *xlabel,	int ylog, int auto_yaxis, float ymin,
		     float ymax, float ystep, char *ylabel, char *color,
		     int no_xbotticks, int no_xtopticks, int no_xlabels,
		     int no_yleftticks, int no_yrightticks, int no_ylabels,
		     int no_xbotlabel, int no_xtoplabel, int no_ybotlabel,
		     int no_ytoplabel);
int xygraph_scale(float *xinput, float *yinput, int npoints,
		  int symbol_mode, char *symbol_string, int symbol_type, 
		  int symbol_radius, int line_type, int grid_type,
		  char *graph_label, int auto_abscissas, float auto_xmin,
		  float auto_xstep, float height_fract, float width_fract,
		  float xoffset_fract, float yoffset_fract, int xlog,
		  int auto_xaxis, float xmin, float xmax, float xstep,
		  char *xlabel, int ylog, int auto_yaxis, float ymin,
		  float ymax, float ystep, char *ylabel, char *color,
		  int *ubot, int * vbot, int *utop, int *vtop,
		  float *axis_xmin, float *axis_xmax, float *axis_xstep,
		  float *axis_ymin, float *axis_ymax, float *axis_ystep);
void x_plot_blob(int npoint, int *xarray, int *yarray);
void x_plot_label( char *string);
