/***---------------------------------------------------------------------------
* NAME:		chi
* PURPOSE:	test chi square routines 
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lib/chi.c,v 1.6 2001/08/23 20:14:42 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lib/chi.c,v $
* CREATED: 23-AUGUST-90 rpl                           MIT LINCOLN LABORATORY
--------------------------------------------------------------------------***/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
static char rcsid[] = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/lib/chi.c,v 1.6 2001/08/23 20:14:42 craig Exp $";
/* header files 
-----------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <math.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "nnlib.h"

/* definitions  
----------------*/
#define TABSIZE (sizeof(argtab)/sizeof(ARG))

/* Variables set from command line flags 
-----------------------------------------*/
static float *actual_list = NULL;
static float *predicted_list = NULL;
static int n=0;
static int dof=0;

/*** Argument Table ***/
static ARG argtab[]=
{
  {"actual", FLOAT_ALLOC_LIST, (int *)&actual_list, "list of actual heads"},
  {"predicted", FLOAT_ALLOC_LIST, (int *)&predicted_list,
   "list of predicted heads"},
  {"n", INT,&n,"number of original bins"},
  {"dof", INT,&dof,"number of original degrees of freedom"},
};


main(register int argc, register char **argv)
{
     int i;
     float value, significance;

     init_nnsubs(argc, argv, rcsid);
     argc=nnargs(argc,argv,argtab,TABSIZE);
     
     /* shift array down because first number holds size */
     for(i=0; i<n; i++) {
	 actual_list[i] = actual_list[i+1];
	 predicted_list[i] = predicted_list[i+1];
     }

     value = chi_square(n, &dof, actual_list, predicted_list, &significance);
     printf("value %f  dof %d  significance %f\n", value, dof, significance);
     if ( significance < .05)
       printf("Difference in probabilities is significant at the .05 level\n");
 }
