/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include "nnlib.h"

#define MODEL_STORE_SIZE 10

int model_get_number(void ***pmodel_list, int *pmlist_length, int model_size)
{
    register int new_model, mlist_length;
    register void **model_list;

    model_list = *pmodel_list;
    mlist_length = *pmlist_length;

    for(new_model = 0; new_model < mlist_length; new_model++)
	if(model_list[new_model] == NULL) break;

    /* if there are no empty entries in model_list */
    if(new_model == mlist_length){
	/* if there are NO entries in model_list */
	if(mlist_length == 0){
	    *pmodel_list = model_list = allocate_pvector(MODEL_STORE_SIZE);
	    *pmlist_length = mlist_length = MODEL_STORE_SIZE;
	} else {
	    *pmodel_list =
	      model_list = reallocate_pvector(model_list, mlist_length,
					      mlist_length + MODEL_STORE_SIZE);
	    mlist_length += MODEL_STORE_SIZE;
	    *pmlist_length = mlist_length;
	}
    }
    model_list[new_model] = (void *)nn_malloc(model_size,
					      "for model structure");
    return(new_model);
}
