/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/***-------------------------------------------------------------------------
* NAME: swap.c
* PURPOSE:     swap functions to swap two variables of various types
* USAGE:
*
* SEE ALSO:     
* DESCRIPTION: 
*
* GLOBAL FUNCTIONS:
*   swap_int()             swaps two integers
*   swap_float()           swaps two floats
*   swap_char()            swaps two chars
*   swap_string()          swaps two strings   
*
* ALGORITHM:
* REFERENCE:
*
* BUGS AND LIMITATIONS:
*   A
*
* $Header: 
* $Source: 
* CREATED: 09-AUG-93 deniz                             MIT LINCOLN LABORATORY
--------------------------------------------------------------------------***/


/* Include necessary header files */
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "nnlib.h"


/************************************************************************
* NAME: swap_int(a, b)
* DESCRIPTION:
*   swaps two integers a, b. if a = b returns 0; else returns 1
*
*************************************************************************/
int swap_int(int *a, int *b)
{
    int swap;
    int x;
    
    if(*a != *b){ x = *a; *a = *b; *b = x; swap = 1; }
    else{ swap = 0; }

    return((int) swap);
}


/************************************************************************
* NAME: swap_float(a, b)
* DESCRIPTION:
*   swaps two floats a, b. if a = b returns 0; else returns 1
*
*************************************************************************/
int swap_float(float *a, float *b)
{
    int swap;
    float x;
    
    if(*a != *b){ x = *a; *a = *b; *b = x; swap = 1; }
    else{ swap = 0; }

    return((int) swap);
}


/************************************************************************
* NAME: swap_char(a, b)
* DESCRIPTION:
*   swaps two chars a, b. if a = b returns 0; else returns 1
*
*************************************************************************/
int swap_char(char *a, char *b)
{
    int swap;
    char x;
    
    if(*a != *b){ x = *a; *a = *b; *b = x; swap = 1; }
    else{ swap = 0; }

    return((int) swap);
}


/************************************************************************
* NAME: swap_string(a, b)
* DESCRIPTION:
*   swaps two strings a, b. if a = b returns 0; else returns 1
*
*   lck: I changed the swaps to switch *a and *b (the strings)
*   rather than **a and **b (the first character in each string)
*
*************************************************************************/
int swap_string(char **a, char **b)
{
    int swap;
    char *x;
    
    if(*a != *b || !strcmp(*a, *b)){ x = *a; *a = *b; *b = x; swap = 1; }
    else{ swap = 0; }

    return((int) swap);
}

