/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)system.c    5.2 (Berkeley) 3/9/86";
#endif /* LIBC_SCCS and not lint */

/* system, modified to change the process group id of the created sh */
/* modified Feb 1992 by Linda Kukolich */

/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#if HAVE_SYS_WAIT_H
#include    <sys/wait.h>
#endif
#include    <sys/types.h>
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
/* returns the process group of the new process */
int
nn_system(char *s)
{
    int pid, rv, wait_status;
    
    if ((pid = fork()) == 0) {
    /* inside the child process */
    /* get the real new pid */
    pid = getpid();
    /* set the process group to that new pid */
    setpgid(pid, pid);
    /* run the shell command requested */
    execl("/bin/sh", "sh", "-c", s, 0);
    /* kill the child process */
    _exit(127);
    }
    /* you only get here if you are the parent process */
    rv = wait(&wait_status);
    return(pid);
}
