/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <math.h>
#include "nnlib.h"

#define NINPUTS 3
main(int argc, char **argv)
{
    int i, ninputs;
    static float means[3] = {0., 1., 2.};
    static float inv_var[3] = {1., 2., 4.};
    static float inv_var2[3] = {2., 2., 2.};
    float x[3], log_det_covar, log_det_covar2;
    float output, output2, output3;

    if(argc != NINPUTS + 1){
	fprintf(stderr, "Usage: %s x1 x2 x3\n", argv[0]);
	exit(1);
    }
    for(i = 0; i < NINPUTS; i++)
      if(sscanf(argv[i+1], "%f", &x[i]) != 1){
	  fprintf(stderr, "all %d arguments must be floats\n", NINPUTS);
	  exit(1);
      }
    for(ninputs = 1; ninputs <= NINPUTS; ninputs++){
	log_det_covar = 0;
	for(i = 0; i < ninputs; i++){
	    log_det_covar += log10(1/inv_var[i]);
	}

	log_det_covar2 = 0;
	for(i = 0; i < ninputs; i++){
	    log_det_covar2 += log10(1/inv_var2[i]);
	}

	output = 0;
	for(i = 0; i < ninputs; i++){
	    float o;
	    o = get_log_gauss_output_scalar(x[i], means[i], inv_var[i]);
	    printf("output[%d] = %.2f\n",i, o);
	    output += o;
	}
	output2 = get_log_gauss_output_diag(ninputs, x, means, inv_var,
					    log_det_covar);
	printf("inputs: ");
	for(i = 0; i < ninputs; i++){
	    printf("%.2f ", x[i]);
	}
	printf("\n");
	printf("scalar: %.2f diag; %.2f\n", output, output2);

	output = 0;
	for(i = 0; i < ninputs; i++){
	    output += get_log_gauss_output_scalar(x[i], means[i], inv_var2[i]);
	}
	output2 = get_log_gauss_output_diag(ninputs, x, means, inv_var2,
					    log_det_covar2);
	output3 = get_log_gauss_output_sphere(ninputs, x, means, inv_var2[0]);
	printf("scalar: %.2f diag; %.2f sphere: %.2f\n",
	       output, output2, output3, output2/output);
    }
}
