/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * Copyright 1989 by Metis Technology, Inc.
 *
 *                        All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its 
 * documentation for any purpose and without fee is hereby granted, 
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in 
 * supporting documentation.
 *
 * METIS TECHNOLOGY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL METIS TECHNOLOGY BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 */




#ifndef _Plot_h
#define _Plot_h

/*

 Resources:

 Name            Class      RepType     Default Value
 ----            -----      -------     -------------
 background      Background     Pixel       XtDefaultBackground
 border          BorderColor    Pixel       XtDefaultForeground
 borderWidth         BorderWidth    Dimension   1
 batchGraphics       BatchGraphics  Boolean     True
 destroyCallback     Callback       Pointer     NULL
 file            File       String      NULL
 font            Font       XFontStruct XtDefaultFont
 foreground      Foreground     Pixel       XtDefaultForeground
 height          Height     Dimension   0
 horizMargin         Margin     Dimension   4
 mappedWhenManaged   MappedWhenManaged  Boolean     True
 plotHeight      PlotHeight     int     780
 plotWidth       PlotWidth      int     1023
 sensitive       Sensitive      Boolean     True
 vertMargin      Margin     Dimension   4
 width           Width      Dimension   0
 x           Position       Position    0
 y           Position       Position    0

*/

#define XtNbatchGraphics    "batchGraphics"
#define XtNhorizMargin      "horizMargin"
#define XtNplotHeight       "plotHeight"
#define XtNplotWidth        "plotWidth"
#define XtNvertMargin       "vertMargin"

#define XtCBatchGraphics    "BatchGraphics"
#define XtCPlotWidth        "PlotWidth"
#define XtCPlotHeight       "PlotHeight"

typedef struct _PlotClassRec*   PlotWidgetClass;
typedef struct _PlotRec*    PlotWidget;

extern WidgetClass plotWidgetClass;

extern void PlotTranslate();
extern void Plot();
extern void ClearPlot();
extern void ResetPlotColor();
extern void OverlayPlot();
extern void DumpPlot();

#endif /*_Plot_h */
