/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
 * Copyright 1989 by Metis Technology, Inc.
 *
 *                        All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its 
 * documentation for any purpose and without fee is hereby granted, 
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in 
 * supporting documentation.
 *
 * METIS TECHNOLOGY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL METIS TECHNOLOGY BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 */



#ifndef _PlotP_h
#define _PlotP_h

#include "Plot.h"
#include <X11/CoreP.h>

typedef struct { int empty; } PlotClassPart;

typedef struct _PlotClassRec {
    CoreClassPart   core_class;
    PlotClassPart   plot_class;
} PlotClassRec;

extern PlotClassRec plotClassRec;

typedef struct _PlotCmdRec *PlotCmdBuf;

typedef struct {
  /* resources */
  Pixel     foreground; /* foreground */
  XFontStruct   *font;      /* default label font */
  String    file;       /* plot file */
  int       plot_width; /* width (plot coordinates) */
  int       plot_height;    /* height (plot coordinates) */
  Dimension horiz_margin;   /* inner horizontal margins (pixels) */
  Dimension vert_margin;    /* inner vertical margins (pixels) */
  Boolean   batch_graphics; /* enable graphics batching */
  /* private state */
  FILE      *fp;
  PlotCmdBuf    *plotbuflist;
  int       plotlistlength; /* maximum number of plot buffers */
  int       plotlistsize;   /* current number of plot buffers */
  int       plotbuflength;  /* maximum number of commands in a buffer */
  int       plotbufsize;    /* number of commands in last buffer */
  GC        eraseGC;
  GC        drawGC;
  XPoint    currentpoint;
  int       linemode;
  int       fillmode;
  int       quad_width;
  short     space_width, space_height;
  short     space_disp_x, space_disp_y;
  double    scale_x, scale_y;
  double    disp_x, disp_y;
  int       batch_state;    /* current buffer state */
  caddr_t   batch_buf;  /* buffer for batching graphics */
  int       batch_bufsize;  /* size of batching buffer */
  int       batch_entries;  /* number of entries in batch buffer */
  Boolean   overlay_mode;   /* overlay mode active */
} PlotPart;

typedef struct _PlotRec {
    CorePart        core;
    PlotPart        plot;
} PlotRec;

#endif /* _PlotP_h */
