/***---------------------------------------------------------------------------
* NAME:		allocate.c 
* PURPOSE:	allocate/deallocate utility subroutines 
*
* DESCRIPTION:
*   lippic_malloc()		- allocate memory with error checking
* 
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/allocate.c,v 11.4 2001/08/23 20:15:05 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/allocate.c,v $
* CREATED: 26-July-90 rpl                             MIT LINCOLN LABORATORY
--------------------------------------------------------------------------***/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */



/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <math.h>
#include <stdio.h>
#if HAVE_MALLOC_H
#include <malloc.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif

/***---------------------------------------------------------------------------
* NAME:		lippic_malloc
* PURPOSE:	malloc that checks return and prints error message if problem
* EXAMPLE:
*    char *p;
*    p = lippic_malloc((unsigned)100, "for word names in subroutine add_wordname");
* NOTE:
*     The second argument is used in an error message if the malloc() fails.
*     It should describe what the space is for and begin with "for ...".
--------------------------------------------------------------------------***/
char *lippic_malloc( n, for_message)
unsigned n;
char *for_message;	/* what storage is for */
    {
      void lippic_fatal_error(char *args, int n, char *message);
    char *p;

    p = malloc(n);
    if ( p == NULL)
    	lippic_fatal_error( "lippic_malloc: Can't allocate %d bytes %s", 
			(int)n, for_message);
    return(p);
    }

