/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "xlippic.h"
/***---------------------------------------------------------------------------
* NAME:		ezbar
* PURPOSE:	easy to use version of xybar that creates a bar chart 
* USAGE: 
* ezbar(x, y, n, graph_label, xlabel, ylabel, color)
*
*	float x[], y[] - arrays with x and y coordinates
*	int n          - number of points to plot
*	char *graph_label - label for top of graph
*	char *xlabel - label for x axis
*	char *ylabel - label for y axis
*       char *color  - color for plot
* 
* RETURN VALUE:
*	Zero if ok, -1 if error
*
* EXAMPLE:
*	float x[100], y[100];
*
*	ginit(4,1);
*   ghardcopy(1);
* 	ezbar(x, y, 100, "Ezbar Example", "Time(Secs)", "Energy");
*
* NOTES:
*  Uses xygraph to create full screen linear bar chart with grid, 
*  with automatic scaling of x and y axes, and with option of various symbols. 
*  Users that desire log axes, graph scaling, different grid markings,
*  multiple overlapped graphs, no auto-scaling, etc. should use xygraph.
*  Don't make the y axis label too long. It is printed horizontally
*  and overlaps with the graph if its too big.
* SEE ALSO: xygraph(), graph(1G) in UNIX Manual Vol. 1
* 
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/ezbar.c,v 11.3 2001/08/23 20:15:05 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/ezbar.c,v $
* CREATED: 8-Jun-84 rpl    LAST UPDATE: 9-Aug-84 rpl	MIT LINCOLN LABORATORY
--------------------------------------------------------------------------***/
void
ezbar(x, y, n, graph_label, xlabel, ylabel, color)
float x[], y[]; 
int n;
char *graph_label;
char *xlabel;
char *ylabel;
char *color;
{

  xybar(x, y, n,
          0, 1.0,
          1, graph_label,
          0, 0.0, 0.0,
          1.0, 1.0, 0.0, 0.0,
          0, 1, 0.0, 1.0, 0.1, xlabel,
          0, 1, 0.0, 1.0, 0.1, ylabel, color);

}
