/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		g_clip 
* PURPOSE:	clip the line (u1, v1) to (u2,v2) to uv window 
* USAGE: 
* 	g_clip(u1,v1,u2,v2)
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/g_clip.c,v 11.3 2001/08/23 20:15:05 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/g_clip.c,v $
* CREATED: 4-Apr-84 rpl   LAST UPDATE:  4-Apr-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include "xlippic.h"
void
g_clip (u1,v1,u2,v2)	/* clip the line (u1,v1) to (u2,v2) to uv window */
int u1,v1,u2,v2;	/* see Reference 1 p. 124 */
{
	int c1,c2;
	int t;		/* temporary variable used in swap */
	float k;
	/* set c1 and c2 to codes indicate whether points are 
	   within uv window, below, above, left, or right of window 
	   --------------------------------------------------------*/
	c1=g_code(u1,v1);	
	c2=g_code(u2,v2);	

	/* simple continue if within window */
	if ( c1==0 && c2 ==0)
		{
		g_vect(u2, v2);
		if( GG_.hardcopy == 1)
			hc_cont(u2, v2);
		return;
		}

	/* clip line as long as one point is outside window */
	while (c1!=0 || c2!=0)	
	{
		/* 
		printf("Outside window c1=%d, c2=%d\n"); 
		*/
		/* line completely outside window */
		if (c1!=0 && c2!=0) 
		    {
		    /* 
		    printf("Line completely outside window\n"); 
		    */
		    return;	
		    }

		if (c1 == 0)
		    {
		    SWAP(c1,c2);
		    SWAP(u1,u2);
		    SWAP(v1,v2);
		    }

		/* move right */
		if (c1 & 01)	
		    {
		    /*
		    printf("move right\n"); 
		    */
		    k = (float)(v2-v1)*(float)(GG_.umin -u1)/(float)(u2 -u1);
		    v1 = v1 + (int)k;
		    u1=GG_.umin;
		    }

		/* move left */
		else if (c1 & 02)	
		{
		    /* 
		    printf("move left\n"); 
		    */
		    k = (float)(v2-v1)*(float)(GG_.umax -u1)/(float)(u2 -u1);
		    v1 = v1 + (int)k;
		    u1=GG_.umax;
		}
		if (c1 & 04)	/* move up */
		{
		    /* 
		    printf("move up\n"); 
		    */
		    k = (float)(u2-u1)*(float)(GG_.vmin -v1)/(float)(v2 -v1);
		    u1 = u1 + (int)k;
		    v1=GG_.vmin;
		}
		else if (c1 & 010)	/* move down */
		{
		    /*
		    printf("move down\n"); 
		    */
		    k = (float)(u2-u1)*(float)(GG_.vmax -v1)/(float)(v2 -v1);
		    u1 = u1 + (int)k;
		    v1=GG_.vmax;
		}
	/* recompute code */
	c1=g_code(u1,v1);	
	}
	/* (u1,v1) to (u2,v2) is the visible line */
	g_line(u1, v1, u2, v2);
	if ( GG_.hardcopy == 1)
	    {
	    hc_move(u1, v1);
	    hc_cont(u2, v2);
	    }
}
