/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#include <stdio.h>
#include <math.h>

/* assumes a sun workstation with open windows 
   -------------------------------------------------------------------*/
/* plotting range */
#define G_XMAX 1023	/* highest x point that can be plotted */
#define G_YMAX 780	/* highest y point that can be plotted */
#define G_XMIN 0	/* minimum x point */
#define G_YMIN 0	/* minimum y point */

/* plotting colors */
#define MAX_COLOR_STRING 100  /* max characters in string describing color */

/* margins for blanking characters */
#if 0
#define CBLANK_LEFT 2
#define CBLANK_RIGHT 4
#define CBLANK_TOP 3
#define CBLANK_BOTTOM 5
#endif
#define CBLANK_LEFT 1
#define CBLANK_RIGHT 1
#define CBLANK_TOP 1
#define CBLANK_BOTTOM 1

/* buffers for gprintf */
#define DOPRNT_LIMIT 144
#define DOPRNT_BUFFER 256

/* size of buffer used when hardcopy is turned on with ghardcopy() */
#define HC_BUFFER 4096

#define SWAP(x,y) {t=x; x=y; y=t;}	/* swap x with y */
#define LOG10(x) log(x)*.434294		/* log of x to the base 10 */
#define POW10(x) exp(x*2.302585)	/* 10 to the xth power */
extern struct GG_
{
	int ucur;		/* current position */
	int vcur;
	int uold;		/* old current position */
	int vold;
	int umin;		/* uv window limits used for clipping */
	int umax;
	int vmin;
	int vmax;
	int uscale;			/* scaling flag set when u values are scaled */
	int vscale;			/* scaling flag set when v values are scaled */
	int uoffset;		/* u offset for scaling */
	int voffset;    	/* v offset for scaling */
	float ufract;		/* u fraction for scaling */
	float vfract;		/* v fraction for scaling */
	int clp;		/* clipping on */
	int csize;		/* character size */
	int texture;		/* vector line texture (solid, dotted, ..) */
	char color[MAX_COLOR_STRING];	/* x colors */
	int blanking;		/* blank area around symbols and characters */
	int inityet;		/* has ginit been called yet */
	int noscreen;		/* put graphics to screen */
	int hardcopy;		/* hard copy on or off */
}
GG_;
extern float GGa[];
extern float GGb[];
extern int GGc[];
extern int GGd[];
extern float GGcs[],GGsn[];
extern char GGerror[];


int x_plot_init(), gmouse(), gmouse_wait ();
void  x_plot_exit(), x_plot_end(), x_plot_move(), x_plot_cont();
void x_plot_point(), x_plot_poly(), x_plot_polydraw();
void x_plot_block(), x_plot_fill(), x_plot_line(), x_plot_label();
void x_plot_window_title(), x_plot_arc(), x_plot_circle(), x_plot_erase();
void x_plot_linemode(), x_plot_space(), x_plot_color(), x_plot_font();
void x_plot_send_command();
