/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <signal.h>
#if HAVE_UNISTD_H
#include <unistd.h>
#endif 
#include "g_gvt.h"
#include "xlippic.h"
#define SET 1
#define RESET 0

extern RETSIGTYPE sig_tstop(int);

/*-----------------------------------------------------------------------------
* NAME:		sig_init 
* PURPOSE:	initialize graphics signal handling 
* USAGE: 
* 	sig_init() 
* DESCRIPTION:
*	Arranges to catch signals produced from the keyboard.
*   On a SUN running openwindows 
*   ---------------------------
*   Stop (CTRL-Z): 
*       If hardcopy mode is on the user is queried to see if
*       a plot file should be made (f).
*
*       If the response is 'f' 
*       then a file is created and normal operation is continued.
*       If the response is anything else then 
*	graphics memory is turned off (not erased) and normal avt operation is
*       restored.
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/g_signal.c,v 11.4 2001/08/23 20:15:06 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/g_signal.c,v $
* CREATED: 15-Mar-84 rpl LAST UPDATE: 15-Jun-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/

/*static int lastmode;*/	/* last terminal mode when CTRL-Z occurred */

void sig_init()
{	
  signal(SIGTSTP,sig_tstop);

}

/*-----------------------------------------------------------------------------
* NAME:		sig_tstop 
* PURPOSE:	catch CTRL-Z: create plot file or hardcopy
* USAGE: 
* 	called only from sig_init 
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/g_signal.c,v 11.4 2001/08/23 20:15:06 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/g_signal.c,v $
* CREATED: 15-Mar-84 rpl   LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
RETSIGTYPE sig_tstop(int ignore)
{
  char str[80];

  str[0] = '*';

  /* does user desire to save a plot file, create hardcopy, or real quit ?
     ------------------------------------------------------------------------*/
  if ( GG_.hardcopy != 0)
    {
      /* query for plot file, hardcopy, or real quit */
      printf("\nCreate File (f), real Suspend (*)?, ");

      while ( fgets(str, 80, stdin) == NULL)
	;
    }

  /* decode response; implot and verplot only works on vax 
     -------------------------------------------------*/
  switch (str[0])
    {
    case 'f':
    case 'F':
      /* create a plot file 
	 -----------------------*/
      (void) gsave((char *)0,1);
      /* get ready to catch next stop signal */
      signal(SIGTSTP,sig_tstop);
      printf("DONE\n");
      return;
    case 'i':
    case 'I':
      /* create hardcopy on the imagen laser printer 
	 ----------------------------------------------*/
      gimagen(1);
      /* get ready to catch next stop signal */
      signal(SIGTSTP,sig_tstop);
      return;
    default:
      /* real suspension 
	 ----------------------------------------*/
      /* reset catching of continue  and send another stop signal */
      signal(SIGTSTP,SIG_DFL);
      kill(getpid(),SIGTSTP);
      return;
    }
}
