/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		garrow 
* PURPOSE:	draw arrow head pointing to last point on last vector drawn
* USAGE: 
*	garrow (length)
*	int length - length of arrow ( 0 to 1023) 
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/garrow.c,v 11.3 2001/08/23 20:15:06 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/garrow.c,v $
* CREATED: 15-Mar-84 rpl  LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include "xlippic.h"
#include <math.h>
void
garrow (length)	/* draw arrowhead on last vector pointing to most recent */
int length;
{
	float u1,v1,usav,t;

	/* t is angle formed clockwise from the vertical */
	t=atan2((float)(GG_.ucur-GG_.uold),(float)(GG_.vcur-GG_.vold));	
	/* u1 is horizontal component of arrow, v1 is vertical */
	u1=(float)(-length);
	/* v1=u1*sqrt(3) so that 30 degree angle is formed */
	v1=u1*1.73205;		
	usav=u1;
	/* rotate points t degrees clockwise about vertical */
	u1=u1*cos(t)+v1*sin(t);
	v1=(-usav)*sin(t)+v1*cos(t);
	uvrcont((int)u1,(int)v1);
	uvmove(GG_.uold,GG_.vold);

	/* now do other side of arrow */
	u1=(float)length;
	v1=(-u1)*1.73205;
	usav=u1;
	u1=u1*cos(t)+v1*sin(t);
	v1=(-usav)*sin(t)+v1*cos(t);
	uvrcont((int)u1,(int)v1);
	/* move back to original position */
	uvmove(GG_.uold,GG_.vold);
}
