/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		gcmove 
* PURPOSE:	character move specified in lines and spaces 
* USAGE: 
* 	gcmove( line, column)
*	int line - line number (1 is top line, 35 is bottom)
*	int column - column (1 is farthest left, 73 is farthest right)
*	
* DESCRIPTION:
*	Moves graphics cursor to a point for printing characters or output
*   using gprintf or gputc without centering. Point is specified in
*   terms of lines and columns of graphics size characters.
*   Note that magic offsets and factors are selected to line these positions
*   with those positions obtained when spaces and carriage returns are
*   output in graphics alpha mode. Gcmove doesn't work correctly with
*   gprintf, uvprintf, and gputc if centering is non zero with these functions.
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gcmove.c,v 11.3 2001/08/23 20:15:07 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gcmove.c,v $
* CREATED: 26-Mar-84 rpl    LAST UPDATE: 26-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include	<stdio.h>
#include "g_gvt.h"
#include "xlippic.h"
#define MAGIC_YOFFSET 8.0	/* shift to get chars lined up in y axis */
void
gcmove(line, column)
int line;	
int column;
{
	int csize;
	int u, v;

	/* limit to 35 lines, 73 columns */
	if ( line < 1)
		line = 1;
	else if ( line > 35)
		line = 35;
	if ( column < 1)
		column = 1;
	else if ( column > 73)
		column = 73;



	/* get character size */
	csize=GG_.csize;

	/* calculate character bottom left in terms of u, v */
	/* note only first entry of a and b are used */
	u = (int)((column-1)*GGb[csize]);
	v = G_YMAX - (int)((line*GGa[csize]) - MAGIC_YOFFSET);

	/* enter graphics mode and go to desired position */
	uvmove(u, v);

}
