/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		gcrlf 
* PURPOSE:	carriage return line feed on graphics screen
* USAGE: 
* 	grcrlf()
*	
* DESCRIPTION:
*	Moves graphics cursor down a distance equivalent to one normal
*   line width on the gvt screen and to the beginning of that line.
*   A '\n' in a gprintf or uvprintf doesn not move the cursor.
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gcrlf.c,v 11.3 2001/08/23 20:15:07 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gcrlf.c,v $
* CREATED: 8-Sep-84 rpl    LAST UPDATE: 8-Sep-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include	<stdio.h>
#include "g_gvt.h"
#include "xlippic.h"
void
gcrlf()
{
	int csize;
	int vdelta;
	int u,v;

	/* get character size */
	csize=GG_.csize;

	/* calculate offset to move down one row */
	/* note only first entry of a and b are used */
	vdelta = -1*(int)(0.5 + GGa[csize]);

	v = GG_.vcur+vdelta;
	u = 0;

	/* enter graphics mode and go to desired position */
	uvmove(u, v);

}
