/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		gextend 
* PURPOSE:	turn invisible line extension on and off 
* USAGE: 
* 	gextend(flag) 
*   	int x   -  0 = turn line extension off (lines clipped at screen edges)
*		        -  1 = turn invisible line extension on
* DESCRIPTION:
*   When invisible line extension is turned on, all vectors are drawn
* as if the range of displayable points was infinite (32bits)
* and only those parts of a display that occur with the range of
* displayable points is visible on the screen. This requires a
* significant amount of overhead computation and should be used only
* when necessary. When invisible line extension is off, all vectors
* are clipped at the edges of the screen.
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gextend.c,v 11.3 2001/08/23 20:15:07 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gextend.c,v $
* CREATED: 1-Jan-82 pc    LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
void
gextend(x)
int x;
{
	if ( x == 0)
	    GG_.clp=0;
	else
	    GG_.clp=1;

}
