/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:     ginit 
* PURPOSE:  initialize x lippic routines
* USAGE: 
*   ginit()
* LIMITATIONS:
*   Designed for SUN openwindows xview where a new window 
*       for displaying plots
*       is opened when this routine is called.
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/ginit.c,v 11.3 2001/08/23 20:15:07 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/ginit.c,v $
* CREATED: 9-Sept-91 rpl                                MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#if HAVE_STRINGS_H
#include <strings.h>
#endif
#include <math.h>
#include "g_gvt.h"
#include "xlippic.h"
void
ginit ( command_string) 
char *command_string;
{
    float a,b;
    int i;


    /* init has been called  and put graphics to screen */
    GG_.inityet=1;

    /* no graphics screen desired */
    if ( strcmp(command_string, "no graphics") == 0)
        {
        GG_.noscreen=1;
        }
    else
        {
        GG_.noscreen=0;
        /* initialize openwindows graphics window */
        x_plot_init(command_string);
        }

    /* reset modes */
    greset();
    gcolor("foreground");

    /* initialize signal handling */
    sig_init();

    /* hardcopy is off */
    ghardcopy(0);

    /* go to home position */
    GG_.ucur=0;
    GG_.vcur=0;
    GG_.uold=0;
    GG_.vold=0;
    uvmove(0,0);

    /* compute cos and sin values for circle routine */
    a=3.14159/180.;     
    for (i=0 ; i < 361 ; i++)
    {
        b=(float)(i)*a;
        GGcs[i]=cos(b);
        GGsn[i]=sin(b);
    }
}
