/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		gputc 
* PURPOSE:	graphics putc at current location with optional centering
* USAGE: 
* 	gputc( center, c)
*	int center - 0 = character is above right of current position
*                    1,2 = character is centered on current position
*	char c 	   - character to output 
*	
* DESCRIPTION:
*	Prints character on the graphics display screen starting
*   at the point where the last point was plotted.
*   The character either is centered on the last plotted point 
*   or it starts above right of the point. 
*   Blanking can be turned on with gblank() for gvt terminals.  
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gputc.c,v 11.3 2001/08/23 20:15:08 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gputc.c,v $
* CREATED: 26-Mar-84 rpl    LAST UPDATE: 26-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include	<stdio.h>
#include "g_gvt.h"
#include "xlippic.h"
void
gputc(center, cc)
int center;	/* center flag */
char cc;
{
	int u, v;
	char hclabel[2];
	u = GG_.ucur;
	v = GG_.vcur;

	/* make sure cursor is at correct location */
	if (center == 0 && GG_.blanking == 0 )
		uvmove(u, v);

	/* center character */
	if ( center !=0 )
	    {
	    u += GGc[GG_.csize];
	    v += GGd[GG_.csize];
	    uvmove(u, v);
	    }

	/* write character out */
	hclabel[0] = cc;
	hclabel[1] = '\0';
	x_plot_label(hclabel);

	if ( GG_.hardcopy == 1)
	    hc_label(hclabel);

}
