/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		gtexture 
* PURPOSE:	select solid, dotted, dot-dash, short-dash, long-dash line texture
* USAGE: 
* 	gtexture(line_type)
*	int line_type - line texture: 
*         0 = normal solid lines
*         1 = dotted lines
*	  2 = dot-dashed lines
*         3 = short-dashed lines
*	  4 = long dashed lines
* LIMITATIONS:
*	Sets the vector line type. It applies to all
*   plotting commands issued after being called. 
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gtexture.c,v 11.3 2001/08/23 20:15:08 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gtexture.c,v $
* CREATED: 4-Apr-84 rpl   LAST UPDATE:  4-Apr-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include "xlippic.h"
void
gtexture (type)	
int type;	/* vector line type 0=solid, 1=dotted, 2=dot-dashed */
	        /*                  3=short-dashed, 4=long-dashed   */
{		
	if ( type == 0 )
		x_plot_linemode("solid");
	else if ( type == 1)
		x_plot_linemode("dotted");
	else if ( type == 2)
		x_plot_linemode("dotdashed");
	else if ( type == 3)
		x_plot_linemode("shortdashed");
	else if ( type == 4)
		x_plot_linemode("longdashed");
	else
	  lippic_fatal_error("gtexture: line type must be 0 to 4 not %d",type);

	GG_.texture = type;
}
