/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		gtoscreen 
* PURPOSE:	turn graphics output to graphics screen on and off 
* USAGE: 
* 	gtoscreen(flag) 
*   	int flag   -  0 = no grapics will appear on screen 
*		      1 = graphics appears on terminal (default)
* DESCRIPTION:
*           Normally, lippic commands cause graphics images and
*	text to appear on a graphics screen.
*       Sometimes only plot files are required or it is desirable 
*       to turn off graphics to avoid this overhead.
*       
* EXAMPLE:
*
*		char *gsave()
*   	ginit("");
*		ghardcopy(1);
*       gtoscreen(0);
*        ........
*        printf("Created file %s\n",gsave(0,0));
*        .......
*		 gexit(0);
*
* SEE ALSO: gsave(), gversatec(), plot(5)
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gtoscreen.c,v 11.3 2001/08/23 20:15:08 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/gtoscreen.c,v $
* CREATED: 11-Dec-84 rpl LAST UPDATE: 11-Dec-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include "xlippic.h"

void
gtoscreen(flag)
int flag;
{

	/* turn off */
	if (flag <=0)
	    {
	    GG_.noscreen = 1;
	    }
	/* turn on */
	else
	    {
	    GG_.noscreen = 0;
	    uvmove(GG_.ucur, GG_.vcur);
	    }
}
