/***---------------------------------------------------------------------------
* NAME:		test_xlib.c 
* PURPOSE:	test new xlib routines one at a time 
*
* DESCRIPTION:
* Links to new xlib routines and tests them one at a time.
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/test_xlib.c,v 1.7 2001/08/23 20:15:10 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/test_xlib.c,v $
* CREATED: 20-Sept-91 rpl                             MIT LINCOLN LABORATORY
--------------------------------------------------------------------------***/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
static char rcsid[] = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/test_xlib.c,v 1.7 2001/08/23 20:15:10 craig Exp $";


/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <math.h>
#include <stdio.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <nnlib.h>
#include "math.h"
#include "xlippic.h"

/* definitions
----------------*/
#define TABSIZE (sizeof(argtab)/sizeof(ARG))

/* Variables set from command line flags 
-----------------------------------------*/
static int debug=0;
static int verbose=0;
int silent_flag=0;
int file_flag=0;
int quit_flag=1; 
char *command= "-geometry 1023x780+100+100 -fg blue -bg yellow -title test_screen";


static ARG argtab[]=
{
  {"command", STRING,(int *)&command,"command line string for plot"},
  {"debug", INT,&debug,"higher values for more printout"},
  {"files", FLAG,&file_flag,"create plot files for all plots"},
  {"quit", INT,&quit_flag,"destroy graphics window on gexit"},
  {"silent", INT,&silent_flag,"don't wait for CR's between plots"},
  {"v", INT, &verbose, "verbosity"}
};

void getcr(void);

int
main(argc,argv)
register int argc;
register char **argv;
 {
  /* local variables
  ----------------------*/
  int i;

  init_nnsubs(argc, argv, rcsid);
  argc=nnargs(argc,argv,argtab,TABSIZE);
  /* Print out the input flag configuration used */
  if ( verbose >= 2)
	nnargs_print_table(argtab,TABSIZE,stdout);

  ginit(command);
  gtexture(0);
  uvmove(500,500);
  x_plot_label("hello out there");
  for(i=0;i<1000; i+=10)
      uvline(i,0,i,100);
  getcr();
  gexit(quit_flag);
  return(0);
}

/*------------------------------------------------
Wait for cr 
-------------------------------------------------*/
void
getcr(void)
{
  char dummy[80];                  /* string returned from gets */

  printf("Hit CR to continue:");
  fflush(stdout);
  /* get string */
  fgets(dummy, 80, stdin);
}



#if 0
==========================================================
    empty stuff
==========================================================

/* make plots 
------------------------------------------*/
ginit(4,1);
if (file_flag !=0)
	ghardcopy(1);

demo_text();
	getcr();
tezgraph();
	getcr();
tezbar();
	getcr();
tezscatter();
	getcr();
txybar();
	getcr();
t2xygraph();
	getcr();
txygraph();
	getcr();
tlog();
	getcr();
txypie();
	getcr();
tarray();
	getcr();
tuvspairs();
	getcr();
ovals();
	getcr();
demo_text();
	getcr();
spiral();
	getcr();
tscale();
	getcr();
doily();
    getcr();
tdragon();
	getcr();
checkerboard();
	getcr();
if ( silent_flag ==0)
	{
	tetch();
	getcr();
	}
gexit(1);
}
/*------------------------------------------------
Wait for cr 
-------------------------------------------------*/
getcr()
{
int dummy[80];                  /* string returned from gets */

if (file_flag != 0)
	gsave(0,1);

if ( silent_flag == 0) 
	{
	/* create plot file and print prompt */
	aeffects(3,1);
	aeffects(1,1);
	gflush();
	printf("Hit CR for next plot:");
	aeffects(0,0);
	gflush();
	/* get string */
	gets(dummy);
	}

/* clear screen */
gclear();
aclear();
}
#endif
