/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		uvarc 
* PURPOSE:	draw a part of a circle counter clockwise 
* USAGE: 
* 	uvarc( u, v, r, abegin, aend)
*	int u,v - coordinates of center of circle(currently 0-1023, 0-780) 
*       int r - radius of circle 
*       int abegin, aend - beginning and ending angles in degrees 
*                          from 3 o`clock (0 to 360)
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvarc.c,v 11.3 2001/08/23 20:15:10 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvarc.c,v $
* CREATED: 1-Jan-82 pc    LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include <stdio.h>
#include "xlippic.h"
void
uvarc(u, v, r, abegin, aend)
int u, v;	        /* center */
int r;			/* radius */
int abegin, aend;	/* beginning and ending angles in degrees */
{
	int i;
	int j,k;
	int temp;
	/* fix funny cases with negative angles */
	if ( abegin < 0 && aend < 0 && abegin > -360 && aend > -360)
		{
		temp = abegin;
		abegin = 360+aend;
		aend = 360 + temp;
		}
	if ( abegin < 0 && aend > 0) 
		abegin += 360;
	if ( abegin > 0 && aend < 0) 
		aend += 360;
	/* check values after fixes */
	if ( abegin > 360 || aend > 360 || abegin < 0 || aend < 0)
	    {
	    lippic_fatal_error("%s not %d %d",
		"uvarc: begin and ending angles must be 0 to 360", 
		abegin, aend);
	    }
	if ( aend >= abegin)
		{
		j = u + (int)(r*GGcs[abegin]);
		k = v + (int)(r*GGsn[abegin]);
		uvmove(j, k);
		for (i=abegin+3 ; i < aend ; i+=3) 
		    {
		    j = u + (int)(r*GGcs[i]);
		    k = v + (int)(r*GGsn[i]);
		    uvcont(j, k);
		    }
		/* get last point */
		j = u + (int)(r*GGcs[aend]);
		k = v + (int)(r*GGsn[aend]);
		uvcont(j, k);
		}
	/* crosses 3 o'clock line */
	else
		{
		j = u + (int)(r*GGcs[abegin]);
		k = v + (int)(r*GGsn[abegin]);
		uvmove(j, k);
		for (i=abegin+3 ; i < 360 ; i+=3) 
		    {
		    j = u + (int)(r*GGcs[i]);
		    k = v + (int)(r*GGsn[i]);
		    uvcont(j, k);
		    }
		for (i=i-360 ; i <= aend ; i+=3) 
		    {
		    j = u + (int)(r*GGcs[i]);
		    k = v + (int)(r*GGsn[i]);
		    uvcont(j, k);
		    }
		/* get last point */
		j = u + (int)(r*GGcs[aend]);
		k = v + (int)(r*GGsn[aend]);
		uvcont(j, k);
		}
}
