/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:     uvblob 
* PURPOSE:  color pixels in a closed polygon area 
* USAGE: 
*   uvblob (color_string, npoints, xarray, yarray)
*       char *color       - color string
*   int npoints       - number of points in closed polygon
*   int *xarray, *yarray - arrays with points on polygon edge 
* DESCRIPTION:
*       Colors all pixels in a polygon area defined
*  by a closed curve with npoints points.
*  Hardcopy only draws edge.
*  Leaves color as it was when the call was made.
*  If color is a null string or "current" uses current foreground color.
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvblob.c,v 11.3 2001/08/23 20:15:11 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvblob.c,v $
* CREATED: 15-Mar-84 rpl    LAST UPDATE: 15-Mar-84 rpl  MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#if HAVE_STRINGS_H
#include <strings.h>
#endif
#include "xlippic.h"
void
uvblob (color, npoints,xarray,yarray)   
char *color;            /* x color string */
int npoints, *xarray, *yarray;                /* closed curve */
{
    char save_color[MAX_COLOR_STRING];

    strcpy(save_color, GG_.color);
    gcolor(color);


    /* output block for graphics display */
    x_plot_blob(npoints, xarray, yarray);

    if ( GG_.hardcopy != 0) 
        {
        hc_blob(npoints, xarray, yarray);
        }


    /* color back to normal */
    gcolor(save_color);
}
