/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		uvblock 
* PURPOSE:	draw, erase, or reverse all pixels in a rectangular block area 
* USAGE: 
*	uvblock (color_string, u1,v1,u2,v2)	
*       char *color       - color string
*	int u1, v1	- point at one corner of block(currently 0-1023, 0-780)
*	int u2, v2	- point at opposite corner of block
* DESCRIPTION:
*       Colors all pixels in a rectangular area defined
*  by two opposite corners.  
*  Hardcopy uses uvbeam to produce solid block and ignores 
*  erased and reversed pixel block.
*  Leaves color as it was when the call was made.
*  If color is a null string or "current" uses current foreground color.
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvblock.c,v 11.3 2001/08/23 20:15:11 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvblock.c,v $
* CREATED: 15-Mar-84 rpl    LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#if HAVE_STRINGS_H
#include <strings.h>
#endif
#include "xlippic.h"
void
uvblock (color, u1,v1,u2,v2)	/* draw block between (u1,v1) and (u2,v2) */
char *color;			/* 0=solid, 1=erase, 2=reverse */
int u1,v1,u2,v2;                /* opposite corners */
{
	static int xarray[5];
	static int yarray[5];

	xarray[0] = u1;
	yarray[0] = v1;
	xarray[1] = u2;
	yarray[1] = v1;
	xarray[2] = u2;
	yarray[2] = v2;
	xarray[3] = u1;
	yarray[3] = v2;
	xarray[4] = u1;
	yarray[4] = v1;
	uvblob(color, 5, xarray, yarray);
}
