/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		uvcircle 
* PURPOSE:	draw a circle 
* USAGE: 
* 	uvcircle(u,v,r) 
*	int u,v	- coordinates of center (currently 0-1023, 0-780) 
*   	int r   - radius 
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvcircle.c,v 11.3 2001/08/23 20:15:11 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvcircle.c,v $
* CREATED: 1-Jan-82 pc    LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include "xlippic.h"
void
uvcircle (u,v,r)	/* draw circle of radius r, center (u,v) */
int u, v, r;
{
int i,j,k;

	/* no scaling required, draw raw circle */
	if (GG_.uscale == 0 && GG_.vscale == 0 )
	    x_plot_circle(u, v, r);
	/* draw circle using lines with scaling*/
	else
	    {
	    uvmove(u+r,v);
	    for (i=0 ; i <= 360 ; i+=4)
		{
		j = u + (int)(r*GGcs[i]);
		k = v + (int)(r*GGsn[i]);
		uvcont(j, k);
		}
	    }
	uvmove(u, v);

	/* draw circle in hardcopy buffer */
	if ( GG_.hardcopy == 1)
		hc_circle(u, v, r);

}
