/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */

/*-----------------------------------------------------------------------------
* NAME:		uvclear
* PURPOSE:	clear all pixels in a rectangular block area 
* USAGE: 
*	uvclear (u1,v1,u2,v2)	
*	int u1, v1	- point at one corner of block(currently 0-1023, 0-780)
*	int u2, v2	- point at opposite corner of block
* DESCRIPTION:
*       Erases all pixels in a rectangular area defined
*  by two opposite corners.  Erase only works on terminal and does not
*  produce a new screen when hardcopy mode is on or cause images on
*  hardcopy screen to dissapear.
*  Uses one mode of uvblock.
*
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvclear.c,v 11.3 2001/08/23 20:15:11 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvclear.c,v $
* CREATED: 15-Mar-84 rpl    LAST UPDATE: 6-Jun-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include "xlippic.h"
void
uvclear (u1,v1,u2,v2)	        /* erase between (u1,v1) and (u2,v2) */
int u1,v1,u2,v2;                /* opposite corners */
{
	uvblock( "background", u1, v1, u2, v2);
}
