/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		uvcont 
* PURPOSE:	continue drawing line to new point 
* USAGE: 
* 	uvcont(u,v) 
*	int u,v	- coordinates of new point (currently 0-1023, 0-780)
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvcont.c,v 11.3 2001/08/23 20:15:11 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvcont.c,v $
* CREATED: 1-Jan-82 pc    LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*--------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include "xlippic.h"
void
uvcont (u,v)	/* continue line to (u,v) */
int u,v;
{
	/* error if graphics not initialized */
	if ( !GG_.inityet)
		g_initerr();


	/* if invisible line extension is on, then extend the line */
	if (GG_.clp == 1) 
	    g_clip(GG_.ucur,GG_.vcur,u,v);	
	/* otherwise output vector with simple clipping at screen edges */
	else 
	    {
	    g_vect(u, v);			
	    if ( GG_.hardcopy == 1)
		    hc_cont(u, v);
	    }

	/* save current position */
	GG_.ucur = u;
	GG_.vcur = v;

}
