/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		uvctick 
* PURPOSE:	draw tick marks around inside of a circle 
* USAGE: 
* uvctick (u, v, r, intervals, length, angle, cflag)
*	int u,v - coordinates of center (currently 0-1023, 0-780)
*	int r - radius 
*       int intervals - number of intervals to divide the circle
*       int length - size of tickmarks (0 to r)
*	int angle - clockwize angle offset in degrees from 3 o`clock (0-360)
*	int cflag -  0=draw only tick marks
*		         1=draw circle and tick marks
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvctick.c,v 11.3 2001/08/23 20:15:12 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvctick.c,v $
* CREATED: 1-Jan-82 pc    LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include <math.h>
#include "xlippic.h"
void
uvctick (u, v, r, intervals, length, angle, cflag)
int u,v;	/* coordinates of center */
int r;		/* radius */
int intervals;	/* number of intervals */
int length;	/* length of tick marks */
int angle;	/* degrees from 3 o'clock */
int cflag;	/* draw circle or not */
{
	register int i;
	float c,d,j;

	if ( cflag != 0)
		uvcircle(u,v,r);

	c=3.14159/180.;
	j=360./(float)intervals;
	for (i=0 ; i < intervals ; i++)
	    {
	    d=((float)(i*j+angle))*c;
	    uvmove(u+(int)(r*cos(d)),v+(int)(r*sin(d)));
	    uvcont(u+(int)((r-length)*cos(d)),v+(int)((r-length)*sin(d)));
	    }
}
