/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		uvpoly 
* PURPOSE:	draw an s-sided polygon with given angle and radius 
* USAGE: 
*	uvpoly (s,u,v,r,a)	
*	int s	- number of sides 
*	int u,v	- coordinates of center  (currently 0-1023, 0-780)
*   	int r   - radius  
*	int a	- angle of first vertex in degrees (0-360)
*                 zero points to three-o'clock, positive moves counter clockwise
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvpoly.c,v 11.3 2001/08/23 20:15:13 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvpoly.c,v $
* CREATED: 1-Jan-82 pc    LAST UPDATE: 15-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "g_gvt.h"
#include <math.h>
#include "xlippic.h"
/* s-sided polygon, center (u,v), radius r, angle a */
void
uvpoly (s,u,v,r,a)	
int u,v,r,a;
int s;
{
	float c,d,j;
	int i;


	c=3.14159/180.;
	j=360./(float)s;

	for (i=0 ; i < s ; i++)
	    {
	    d=((float)i*j+a)*c;
	    if (i == 0) 
		uvmove((int)(u+r*cos(d)),(int)(v+r*sin(d)));
	    else 
		uvcont((int)(u+r*cos(d)),(int)(v+r*sin(d)));
	    }
	d=a*c;
	uvcont((int)(u+r*cos(d)),(int)(v+r*sin(d)));

}
