/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*-----------------------------------------------------------------------------
* NAME:		uvputc 
* PURPOSE:	graphics putc at specific position with optional centering 
* USAGE: 
* 	uvputc( u, v, center, c)
*	int u - x coordinate of position
*	int v - y coordinate of position
*	int center - 0 = character is above right of position
*		     1,2 = character is centered on position
*	char c 	   - character to output 
*	
* DESCRIPTION:
*	Prints character on the graphics display screen 
*   at a desired position. The character either is centered on the position
*   (center=1) or it starts above right of the point (center = 0).
*   Blanking can be turned on with gblank for gvt terminals.
* $Header: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvputc.c,v 11.3 2001/08/23 20:15:13 craig Exp $
* $Source: /data/speech/kukolich/cvsroot/lnknet/src/lippic/xlippic/uvputc.c,v $
* CREATED: 26-Mar-84 rpl    LAST UPDATE: 26-Mar-84 rpl	MIT LINCOLN LABORATORY
*---------------------------------------------------------------------------*/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include	<stdio.h>
#include "g_gvt.h"
#include "xlippic.h"
void
uvputc(u, v, center , cc)
int u, v;	/* x and y coordinates of point */
int center;	/* center character flag */
char cc;	/* character */
{
	/* enter graphics mode and go to desired position */
	uvmove(u, v);

	/* print character */
	gputc(center, cc);
}
