/*SUPPRESS 592*/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/LnkLabel/LnkLabel.c,v 11.3 2001/08/23 20:15:22 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                           LnkLabel Widget                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/LnkLabel/LnkLabel.c,v $
 *
 * Language: C
 *
 * File Modification History:
 *  18-Sep-95     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "LnkLabelP.h"

/* Private Data */

/* Private Data */
static void Initialize (Widget request, Widget New_w,
			ArgList new_args, Cardinal * num_args );
static void Destroy(Widget w);

/************************************************************
  Full Class Record Constant
 ***********************************************************/
#define Superclass (&xmLabelClassRec)

LnkLabelClassRec lnkLabelClassRec = {
  { /* core fields */
    /* superclass		*/	(WidgetClass) Superclass,
    /* class_name		*/	"LnkLabel",
    /* widget_size		*/	sizeof(LnkLabelRec),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	XmInheritRealize,
    /* actions			*/	NULL,
    /* num_actions		*/	0,
    /* resources		*/	NULL,
    /* num_resources		*/	0,
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	XtExposeCompressMultiple,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	Destroy,
    /* resize			*/	XmInheritResize,
    /* expose			*/	XtInheritExpose,
    /* set_values		*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	NULL,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL,
  },
  /* private class fields */
  {
#if (XmVersion < 1002 )
    /* border highlight         */     _XmHightlightBorder,
    /* border unhightlight      */     _XmUnhighlightBorder,
#else
    /* border highlight         */     XmInheritBorderHighlight,
    /* border unhightlight      */     XmInheritBorderUnhighlight,
#endif
    /* translations             */     XtInheritTranslations,
    /* arm_and_activate         */     NULL,
    /* syn resources            */     NULL,
    /* num syn_resources        */     0,
    /* extension                */     NULL,
  },
  /* label class fields */
  {
      /* setOverrideCallback    */     XmInheritSetOverrideCallback,
      /* menuProcs              */     NULL,
      /* translations           */     XtInheritTranslations,
      /* extension              */     NULL,
  },
/* LnkLabel class fields */
  {
      /* nothing		*/	0,
  },
};

WidgetClass lnkLabelWidgetClass = (WidgetClass)&lnkLabelClassRec;

/***********************************************************************
  Private Procedures
 ***********************************************************************/

/* I'm leaving this around out of paranoia and habit. I think there
   really is nothing new to add */
static void
Initialize (Widget request, Widget new_w,
	    ArgList new_args, Cardinal * num_args)
{
    LnkLabelWidget req_LnkLabel = (LnkLabelWidget) request;
    LnkLabelWidget new_LnkLabel = (LnkLabelWidget) new_w;
}

static void
Destroy(Widget w)
{
    LnkLabelWidget LnkLabel = (LnkLabelWidget) w;
}

/***********************************************************************
  Utility Routines
 ***********************************************************************/
/***********************************************************************
  Action Routines
 ***********************************************************************/
/***********************************************************************
  Converters
 ***********************************************************************/
/***********************************************************************
  Client Utility Routines
 ***********************************************************************/
