/*
 * Copyright 1990, 1995 Integrated Computer Solutions, Inc. 
 *
 * All Rights Reserved.
 *
 * MODULE:    NoAcc.c
 *
 * DESCRIPTION: This file contains definitions for functions that are part 
 *		with the SunSoft acc compiler on SPARC SunOS 4 systems.  This
 *		module needs to be compiled and linked with bx.o if you are
 *		using a compiler other than acc (specifically "cc" which is
 *		provided with SunOS 4).  This file is NOT necessary if using
 *		acc.
 *
 *		If you are using an ANSI C compiler other than acc, you will
 *		need to link this module to obtain the definition of
 *		__ansi_fflush.
 */
/****************************************************************************
 *      INCLUDE FILES
 ****************************************************************************/
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <memory.h>

/****************************************************************************
 *      MACROS
 ****************************************************************************/
#ifndef ARGLIST
#if (NeedFunctionPrototypes == 0)
#define PROTOTYPE(p)    ()
#define ARGLIST(p)      p
#define ARG(a, b)       a b;
#define GRA(a, b)       a b;
#define UARG(a, b)      a b;
#define GRAU(a, b)      a b;
#else
#define PROTOTYPE(p)    p
#define ARGLIST(p)      (
#define ARG(a, b)       a b,
#define GRA(a, b)       a b)
#ifdef __cplusplus
#define UARG(a, b)      a,
#define GRAU(a, b)      a)
#else
#define UARG(a, b)      a b,
#define GRAU(a, b)      a b)
#endif
#endif
#endif

/****************************************************************************
 *      CODE
 ****************************************************************************/

/*#ifndef __STDC__*/
void *
memmove ARGLIST((s1, s2, n))
    ARG(char *, s1)
    ARG(char *, s2)
    GRA(int, n)
{
    return(memcpy(s1, s2, n));
}

unsigned long
strtoul ARGLIST((str, ptr, base))
    ARG(char *, str)
    ARG(char **, ptr)
    GRA(int, base)
{
#if HAVE_STRTOL
    return((unsigned long)strtol(str, ptr, base));
#else
    return((unsigned long)strtol(str, ptr, base));
#endif
}

char *
strerror ARGLIST((errnum))
    GRA(int, errnum)
{
    static char	buf[64];
    
    sprintf(buf, "%d", errnum);
    return(buf);
}

typedef char (*ExitFunction)();
int
atexit ARGLIST((func))
    GRA(ExitFunction, func)
{
    return(on_exit(func, 0));
}

/*
 * _lib_version is used by the SunSoft math library provided with acc.  It
 * may also be necessary to define this for ANSI compilers other than acc.
 */
enum version {libm_ieee = -1, c_issue_4, ansi_1, strict_ansi};
enum version _lib_version = strict_ansi;

/*#endif*/ /* __STDC__ */

int
__ansi_fflush ARGLIST((stream))
    GRA(FILE *, stream)
{
    return(fflush(stream));
}

