/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef artmap_H
#define artmap_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/artmap/artmap.h,v 1.3 2001/08/23 20:15:28 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            ARTMAP                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $ARTMAPHOME/src/artmap.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for artmap
 * 
 * Calling Sequence:
 *   #include <artmap.h>
 *
 * Modification History:
 *  20-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" artmap.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget artmapDialogShell;
  Widget artmapForm;
  Widget setNormLabel;
  Widget complementCodeToggle;
  Widget sumToOneToggle;
  Widget artParamFrame;
  Widget artParamLabel;
  Widget artParamForm;
  Widget alphaForm;
  Widget alphaLabel;
  Widget alphaText;
  Widget alphaOKPBtn;
  Widget alphaCancelPBtn;
  Widget betaForm;
  Widget betaLabel;
  Widget betaText;
  Widget betaOKPBtn;
  Widget betaCancelPBtn;
  Widget vigilanceFrame;
  Widget vigilanceLabel;
  Widget vigilanceForm;
  Widget artAVigilLabel;
  Widget artATrainForm;
  Widget artATrainLabel;
  Widget artATrainText;
  Widget artATrainOKPBtn;
  Widget artATrainCancelPBtn;
  Widget artATestForm;
  Widget artATestLabel;
  Widget artATestText;
  Widget artATestOKPBtn;
  Widget artATestCancelPBtn;
  Widget artBVigilLabel;
  Widget artBTrainTestForm;
  Widget artBTrainTestLabel;
  Widget artBTrainTestText;
  Widget artBTrainTestOKPBtn;
  Widget artBTrainTestCancelPBtn;
  Widget haltFrame;
  Widget haltLabel;
  Widget haltForm;
  Widget epochsForm;
  Widget epochsLabel;
  Widget epochsText;
  Widget epochsOKPBtn;
  Widget epochsCancelPBtn;
  Widget trainCycleToggle;
  Widget pruneToggle;
  Widget pruneThreshForm;
  Widget pruneThreshLabel;
  Widget pruneThreshText;
  Widget pruneThreshOKPBtn;
  Widget pruneThreshCancelPBtn;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} ArtmapWidgets;
 
#endif
