/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef bintree_H
#define bintree_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/bintree/bintree.h,v 1.3 2001/08/23 20:15:32 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            BINTREE                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $BINTREEHOME/src/bintree.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for bintree
 * 
 * Calling Sequence:
 *   #include <bintree.h>
 *
 * Modification History:
 *  20-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" bintree.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget bintreeDialogShell;
  Widget bintreeForm;
  Widget linearRadioBox;
  Widget singleFeatureToggle;
  Widget linearToggle;
  Widget trainFrame;
  Widget trainLabel;
  Widget trainForm;
  Widget stopEarlyRadioBox;
  Widget trainFullToggle;
  Widget stopEarlyToggle;
  Widget leafMinForm;
  Widget leafMinLabel;
  Widget leafMinText;
  Widget leafMinOKPBtn;
  Widget leafMinCancelPBtn;
  Widget testFrame;
  Widget testLabel;
  Widget testForm;
  Widget pruneRadioBox;
  Widget testFullToggle;
  Widget pruneToggle;
  Widget maxNodesForm;
  Widget maxNodesText;
  Widget maxNodesOKPBtn;
  Widget maxNodesCancelPBtn;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} BintreeWidgets;
 
#endif
