/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
***************************************************************************/
#ifndef data_params_H
#define data_params_H
 
/* rcsid = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/data/data_params.h,v 1.8 2001/08/23 20:16:10 craig Exp $" */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            LNKNET                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/data/data_params.h,v $
 *
 * Language: C
 *
 * Purpose: Structure definitions for lnknet
 * 
 * Calling Sequence:
 *   #include <data_params.h>
 *
 * Modification History:
 *  23-Aug-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
#define DEFAULTS_SUFFIX ".defaults"

/* for the file selector */
#define PREVDIR "../ (Go up 1 directory level)"

/* stuff for multiple file selector */
typedef struct {
  char *name;
  int directory; /* True if entry is a directory name; otherwise, False */
} FileEntry;

typedef struct {
  int n_files;
  char *dirname;
  FileEntry *file;
} FileList;
 
/*
   structure for parameters found on the data window
*/
typedef struct {
    char *data_path;
    char *data_base; /* prefix for creating other names */
    char *desc_fname;
    char *ext_train;
    char *ext_test_train;
    char *ext_eval;
    char *ext_test;
    char *train_fname; /* derived from data_base and ext_train */
    char *eval_fname; /* derived from data_base and ext_eval */
    char *test_fname; /* derived from data_base and ext_test */
    int npatterns_train;
    char * npatterns_train_string;
    int npatterns_eval;
    char * npatterns_eval_string;
    int npatterns_test;
    char * npatterns_test_string;
    int nraw;
    int noutputs;
    int db_type;
    char **class_labels;
    char **input_labels;
  int *categories;
    char *priors_string; /* temporary string, one for all file types */
    float *priors_list;
    char *select_data_path;
    char *select_data_base;
    int defaults_nraw;
    char * defaults_nraw_string;
    int defaults_noutputs;
    char *defaults_noutputs_string;
    char **defaults_input_labels;
    char *defaults_input_labels_string;
    char **defaults_class_labels;
    char *defaults_class_labels_string;
  int *defaults_categories;
  char *defaults_categories_string;
    int defaults_db_type;
    FileList select_filelist;
} DataParams;
#endif
