/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef detect_H
#define detect_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/detect/detect.h,v 1.4 2001/08/23 20:16:17 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            DETECT                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $DETECTHOME/src/detect.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for detect
 * 
 * Calling Sequence:
 *   #include <detect.h>
 *
 * Modification History:
 *  9-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" detect.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget detectDialogShell;
  Widget detectForm;
  Widget targetForm;
  Widget targetLabel;
  Widget targetText;
  Widget targetOKPBtn;
  Widget targetCancelPBtn;
  Widget targetLabelLabel;
  Widget tableFrame;
  Widget tableForm;
  Widget verboseOptionMenu;
  Widget verbosePulldownMenu;
  Widget noTablePBtn;
  Widget areaPBtn;
  Widget faRatePBtn;
  Widget fullPBtn;
  Widget tableBeginForm;
  Widget tableBeginLabel;
  Widget tableBeginText;
  Widget tableBeginOKPBtn;
  Widget tableBeginCancelPBtn;
  Widget tableEndForm;
  Widget tableEndLabel;
  Widget tableEndText;
  Widget tableEndOKPBtn;
  Widget tableEndCancelPBtn;
  Widget tableStepForm;
  Widget tableStepLabel;
  Widget tableStepText;
  Widget tableStepOKPBtn;
  Widget tableStepCancelPBtn;
  Widget tableLabel;
  Widget axesFrame;
  Widget axesForm;
  Widget axesLimitsLabel;
  Widget xminForm;
  Widget xminLabel;
  Widget xminText;
  Widget xminOKPBtn;
  Widget xminCancelPBtn;
  Widget xmaxForm;
  Widget xmaxLabel;
  Widget xmaxText;
  Widget xmaxOKPBtn;
  Widget xmaxCancelPBtn;
  Widget xstepForm;
  Widget xstepLabel;
  Widget xstepText;
  Widget xstepOKPBtn;
  Widget xstepCancelPBtn;
  Widget yminForm;
  Widget yminLabel;
  Widget yminText;
  Widget yminOKPBtn;
  Widget yminCancelPBtn;
  Widget ymaxForm;
  Widget ymaxLabel;
  Widget ymaxText;
  Widget ymaxOKPBtn;
  Widget ymaxCancelPBtn;
  Widget ystepForm;
  Widget ystepLabel;
  Widget ystepText;
  Widget ystepOKPBtn;
  Widget ystepCancelPBtn;
  Widget axesLabel;
  Widget rejectForm;
  Widget rejectLabel;
  Widget rejectText;
  Widget rejectOKPBtn;
  Widget rejectCancelPBtn;
  Widget plotLabelLabel1;
  Widget plotLabelLabel;
  Widget plotFnameLabel1;
  Widget plotFnameLabel;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} DetectWidgets;
 
#endif
