/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef em_clus_H
#define em_clus_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/em_clus/em_clus.h,v 1.4 2001/08/23 20:16:22 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            EM_CLUS                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $EM_CLUSHOME/src/em_clus.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for em_clus
 * 
 * Calling Sequence:
 *   #include <em_clus.h>
 *
 * Modification History:
 *  18-Oct-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" em_clus.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget em_clusDialogShell;
  Widget em_clusForm;
  Widget clusterFrame;
  Widget clusterForm;
  Widget clusterByClassRadioBox;
  Widget ignoreClassToggle;
  Widget clusterByClassToggle;
  Widget ncentersByClassRadioBox;
  Widget equalNcentersToggle;
  Widget ncentersByClassToggle;
  Widget ncentersForm;
  Widget ncentersLabel;
  Widget ncentersText;
  Widget ncentersOKPBtn;
  Widget ncentersCancelPBtn;
  Widget ncentersListForm;
  Widget ncentersListLabel;
  Widget ncentersListText;
  Widget ncentersListOKPBtn;
  Widget ncentersListCancelPBtn;
  Widget totalNcentersLabel;
  Widget reduceStepForm;
  Widget reduceStepLabel;
  Widget reduceStepText;
  Widget reduceStepOKPBtn;
  Widget reduceStepCancelPBtn;
  Widget clusterLabel;
  Widget stopFrame;
  Widget stopForm;
  Widget stopPercentageForm;
  Widget stopPercentageLabel;
  Widget stopPercentageText;
  Widget stopPercentageOKPBtn;
  Widget stopPercentageCancelPBtn;
  Widget maxIterationForm;
  Widget maxIterationLabel;
  Widget maxIterationText;
  Widget maxIterationOKPBtn;
  Widget maxIterationCancelPBtn;
  Widget stopLabel;
  Widget perturbFrame;
  Widget perturbForm;
  Widget splitPercentageForm;
  Widget splitPercentageLabel;
  Widget splitPercentageText;
  Widget splitPercentageOKPBtn;
  Widget splitPercentageCancelPBtn;
  Widget addRandomOffsetToggle;
  Widget perturbLabel;
  Widget varianceFrame;
  Widget varianceForm;
  Widget varSpreadForm;
  Widget varSpreadLabel;
  Widget varSpreadText;
  Widget varSpreadOKPBtn;
  Widget varSpreadCancelPBtn;
  Widget minVarForm;
  Widget minVarLabel;
  Widget minVarText;
  Widget minVarOKPBtn;
  Widget minVarCancelPBtn;
  Widget varianceLabel;
  Widget kmeansFrame;
  Widget kmeansForm;
  Widget useKmeansToggle;
  Widget kmeansStopForm;
  Widget kmeansStopLabel;
  Widget kmeansStopText;
  Widget kmeansStopOKPBtn;
  Widget kmeansStopCancelPBtn;
  Widget kmeansLabel;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} Em_clusWidgets;
 
#endif
