/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef gauss_H
#define gauss_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/gauss/gauss.h,v 1.5 2001/08/23 20:16:27 craig Exp $" */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            GAUSS PARAM WINDOW                        ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: gauss/gauss.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for gauss param window
 * 
 * Calling Sequence:
 *   #include "gauss.h"
 *
 * Modification History:
 *  14-Sep-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" gauss.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget gaussDialogShell;
  Widget gaussForm;
  Widget minVarForm;
  Widget minVarLabel;
  Widget minVarText;
  Widget minVarOKPBtn;
  Widget minVarCancelPBtn;
  Widget fullRadioBox;
  Widget fullDiagonalToggle;
  Widget fullFullToggle;
  Widget linearLabel;
  Widget quadraticLabel;
  Widget grandLabel;
  Widget grandRadioBox;
  Widget grandPerClassToggle;
  Widget grandGrandToggle;
  Widget separator;
  Widget buttonForm;
  Widget closePBtn;
} GaussWidgets;
 
#endif
