/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef gmix_H
#define gmix_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/gmix/gmix.h,v 1.5 2001/08/23 20:16:30 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            GMIX                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $GMIXHOME/src/gmix.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for gmix
 * 
 * Calling Sequence:
 *   #include <gmix.h>
 *
 * Modification History:
 *  8-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" gmix.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget gmixDialogShell;
  Widget gmixForm;
  Widget clusterFrame;
  Widget clusterForm;
  Widget createClustersToggle;
  Widget clustAlgOptionMenu;
  Widget clustAlgPulldownMenu;
  Widget kmeansPBtn;
  Widget em_clusPBtn;
  Widget lead_clusPBtn;
  Widget ran_clusPBtn;
  Widget clustParamsPBtn;
  Widget clustFnameLabel1;
  Widget clustFnameLabel;
  Widget clusterLabel;
  Widget covarianceFrame;
  Widget covarianceForm;
  Widget grandTypeLabel;
  Widget grandTypeRadioBox;
  Widget perClassToggle;
  Widget grandClassToggle;
  Widget grandOverallToggle;
  Widget covTypeRadioBox;
  Widget diagonalToggle;
  Widget fullToggle;
  Widget mixTypeFrame;
  Widget mixTypeLabel;
  Widget mixTypeRadioBox;
  Widget unTiedToggle;
  Widget tiedToggle;
  Widget covarianceLabel;
  Widget varSpreadForm;
  Widget varSpreadLabel;
  Widget varSpreadText;
  Widget varSpreadOKPBtn;
  Widget varSpreadCancelPBtn;
  Widget epochsForm;
  Widget epochsLabel;
  Widget epochsText;
  Widget epochsOKPBtn;
  Widget epochsCancelPBtn;
  Widget stopPercentForm;
  Widget stopPercentLabel;
  Widget stopPercentText;
  Widget stopPercentOKPBtn;
  Widget stopPercentCancelPBtn;
  Widget maxRatioForm;
  Widget maxRatioLabel;
  Widget maxRatioText;
  Widget maxRatioOKPBtn;
  Widget maxRatioCancelPBtn;
  Widget minVarForm;
  Widget minVarLabel;
  Widget minVarText;
  Widget minVarOKPBtn;
  Widget minVarCancelPBtn;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} GmixWidgets;
 
#endif
