/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef histogram_H
#define histogram_H
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/histogram/histogram.h,v 1.4 2001/08/23 20:16:34 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            HISTOGRAM                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $HISTOGRAMHOME/src/histogram.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for histogram
 * 
 * Calling Sequence:
 *   #include <histogram.h>
 *
 * Modification History:
 *  8-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" histogram.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget histogramDialogShell;
  Widget histogramForm;
  Widget binNumFrame;
  Widget binNumForm;
  Widget specifyBinsRadioBox;
  Widget equalNbinsToggle;
  Widget specifyBinsToggle;
  Widget nBinsForm;
  Widget nBinsLabel;
  Widget nBinsText;
  Widget nBinsOKPBtn;
  Widget nBinsCancelPBtn;
  Widget nBinsPerClassForm;
  Widget nBinsPerClassLabel;
  Widget nBinsPerClassText;
  Widget nBinsPerClassOKPBtn;
  Widget nBinsPerClassCancelPBtn;
  Widget totalNbinsLabel;
  Widget grandBinsLabel;
  Widget grandBinsRadioBox;
  Widget perComponentToggle;
  Widget perFeatureToggle;
  Widget grandToggle;
  Widget hyperCubeLabel;
  Widget userMinForm;
  Widget userMinLabel;
  Widget userMinText;
  Widget userMinOKPBtn;
  Widget userMinCancelPBtn;
  Widget userMaxForm;
  Widget userMaxLabel;
  Widget userMaxText;
  Widget userMaxOKPBtn;
  Widget userMaxCancelPBtn;
  Widget binNumLabel;
  Widget binTypeLabel;
  Widget binTypeRadioBox;
  Widget equalWidthToggle;
  Widget equalNumToggle;
  Widget rangeFactorForm;
  Widget rangeFactorLabel;
  Widget rangeFactorText;
  Widget rangeFactorOKPBtn;
  Widget rangeFactorCancelPBtn;
  Widget useGaussLabel;
  Widget useGaussRadioBox;
  Widget unknownToggle;
  Widget useGaussToggle;
  Widget minVarForm;
  Widget minVarLabel;
  Widget minVarText;
  Widget minVarOKPBtn;
  Widget minVarCancelPBtn;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} HistogramWidgets;
 
#endif
