/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
 
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lead_clus/lead_clus_create.c,v 11.4 2001/08/23 20:16:50 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            LEAD_CLUS                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source $
 *
 * Language: C
 *
 * File Modification History:
 *  23-Oct-1995     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <Xm/Xm.h>
#include "lead_clus.h"
/*
 * External Functions
 */
 
/*
 * Externals
 */
extern Lead_clusWidgets *Lead_clusClone;
 
/******************************************************************************
 ******************************************************************************
 *
 * Module Name: lead_clus_create
 *
 * Purpose: 
 * 
 * Calling Sequence:
 *   lead_clus_create(w, client, call)
 *
 * Inputs:
 *   Widget w            widget calling this callback
 *   XtPointer client    client data attached to widget
 *   XtPointer call      pointer to callback structure
 *
 * Outputs:
 *   none
 *
 * Return Value:
 *   none
 *
 * Side Effects:
 *   none
 *
 * Restrictions:
 *   none
 *
 * Modification History:
 *  23-Oct-1995     Linda C Kukolich  initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
void
lead_clus_create(Widget w, XtPointer client, XtPointer call)
{
  if (!strcmp(client, "lead_clusDialogShell")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    /*
     * Allocate space for the structure
     */
    Lead_clusClone = (Lead_clusWidgets *)XtMalloc(sizeof(Lead_clusWidgets));
    Lead_clusClone->lead_clusDialogShell = w;
 
  } else if (!strcmp(client, "lead_clusForm")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->lead_clusForm = w;
 
  } else if (!strcmp(client, "clusterByClassRadioBox")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->clusterByClassRadioBox = w;
 
  } else if (!strcmp(client, "ignoreClassToggle")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->ignoreClassToggle = w;
 
  } else if (!strcmp(client, "clusterByClassToggle")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->clusterByClassToggle = w;
 
  } else if (!strcmp(client, "deltaByClassRadioBox")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaByClassRadioBox = w;
 
  } else if (!strcmp(client, "equalDeltaToggle")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->equalDeltaToggle = w;
 
  } else if (!strcmp(client, "deltaByClassToggle")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaByClassToggle = w;
 
  } else if (!strcmp(client, "deltaForm")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaForm = w;
 
  } else if (!strcmp(client, "deltaLabel")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaLabel = w;
 
  } else if (!strcmp(client, "deltaText")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaText = w;
 
  } else if (!strcmp(client, "deltaOKPBtn")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaOKPBtn = w;
 
  } else if (!strcmp(client, "deltaCancelPBtn")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaCancelPBtn = w;
 
  } else if (!strcmp(client, "deltaListForm")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaListForm = w;
 
  } else if (!strcmp(client, "deltaListLabel")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaListLabel = w;
 
  } else if (!strcmp(client, "deltaListText")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaListText = w;
 
  } else if (!strcmp(client, "deltaListOKPBtn")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaListOKPBtn = w;
 
  } else if (!strcmp(client, "deltaListCancelPBtn")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->deltaListCancelPBtn = w;
 
  } else if (!strcmp(client, "buttonForm")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->buttonForm = w;
 
  } else if (!strcmp(client, "separator")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->separator = w;
 
  } else if (!strcmp(client, "closePBtn")) {
    /*fprintf (stderr, "lead_clus_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, Lead_clusClone, NULL);
    Lead_clusClone->closePBtn = w;
 
  } else {
    fprintf(stderr, "lead_clus_create: unknown client: %s\n", (char *)client);
  }
}
