/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
#ifndef lnk_H
#define lnk_H
 
/* rcsid = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk.h,v 1.10 2001/08/23 20:16:54 craig Exp $" */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            LNKNET                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $LNKNETHOME/src/lnk.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for lnknet
 * 
 * Calling Sequence:
 *   #include <lnk.h>
 *
 * Modification History:
 *  23-Aug-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" lnk.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget lnkTopLevelShell;
  Widget lnkForm;
  Widget mainMenu;
  Widget fileCascadeButton;
  Widget filePulldownMenu;
  Widget fileQuitPBtn;
  Widget controlFrame;
  Widget controlForm;
  Widget controlLabel;
  Widget startPBtn;
  Widget stopPBtn;
  Widget continuePBtn;
  Widget plotOnlyPBtn;
  Widget storeOnlyToggle;
  Widget experimentFrame;
  Widget experimentForm;
  Widget actionSelectLabel;
  Widget actionSelectRadioBox;
  Widget actionSelectTrainToggle;
  Widget actionSelectTestToggle;
  Widget actionSelectTrainTestToggle;
  Widget actionSelectCrossValidToggle;
  Widget testSelectLabel;
  Widget testSelectRadioBox;
  Widget testSelectTrainToggle;
  Widget testSelectEvalToggle;
  Widget testSelectTestToggle;
  Widget crossValidFrame;
  Widget crossValidForm;
  Widget crossValidLabel;
  Widget cvFromFileRadioBox;
  Widget cvAutoSplitToggleButton;
  Widget cvFromFileToggleButton;
  Widget cvRandomToggle;
  Widget cvFoldsForm;
  Widget cvFoldsLabel;
  Widget cvFoldsText;
  Widget cvFoldsOKPBtn;
  Widget cvFoldsCancelPBtn;
  Widget extCvForm;
  Widget extCvLabel;
  Widget extCvText;
  Widget extCvOKPBtn;
  Widget extCvCancelPBtn;
  Widget cvFilenameLabel1;
  Widget cvFilenameLabel;
  Widget randomFrame;
  Widget randomLabel;
  Widget randomForm;
  Widget randomToggle;
  Widget seedForm;
  Widget seedLabel;
  Widget seedText;
  Widget seedOKPBtn;
  Widget seedCancelPBtn;
  Widget algorithmsOptionMenu;
  Widget algorithmsPulldownMenu;
  Widget algNeuralNetworksLabel;
  Widget algMlpPBtn;
  Widget algRbfPBtn;
  Widget algIrbfPBtn;
  Widget algSeparator;
  Widget algLikelihoodLabel;
  Widget algGaussPBtn;
  Widget algGmixPBtn;
  Widget algHistogramPBtn;
  Widget algParzenPBtn;
  Widget algSeparator1;
  Widget algNearestNeighborLabel;
  Widget algKnnPBtn;
  Widget algCknnPBtn;
  Widget algNc_classPBtn;
  Widget algLvqPBtn;
  Widget algNbayesPBtn;
  Widget algSvmPBtn;
  Widget algSeparator2;
  Widget algRuleBasedLabel;
  Widget algBintreePBtn;
  Widget algHyperPBtn;
  Widget algSeparator3;
  Widget algCombinationsLabel;
  Widget algCommitteePBtn;
  Widget algSeparator4;
  Widget algClusterLabel;
  Widget algKmeansPBtn;
  Widget algEm_clusPBtn;
  Widget algLead_clusPBtn;
  Widget algRan_clusPBtn;
  Widget algSeparator5;
  Widget algContributedLabel;
  Widget algArtmapPBtn;
  Widget algorithmParamsPBtn;
  Widget experimentNameForm;
  Widget experimentNameLabel;
  Widget experimentNameText;
  Widget experimentNameOKPBtn;
  Widget experimentNameCancelPBtn;
  Widget expWindowsRC;
  Widget expWindowsLabel;
  Widget reportPBtn;
  Widget dataPBtn;
  Widget normPBtn;
  Widget featurePBtn;
  Widget priorsPBtn;
  Widget plotPBtn;
  Widget otherWindowsRC;
  Widget otherWindowsLabel;
  Widget printPBtn;
  Widget ccodePBtn;
  Widget committeeDataPBtn;
  Widget defaultsRC;
  Widget defaultsLabel;
  Widget saveDefaultsPBtn;
  Widget restoreDefaultsPBtn;
} LnkWidgets;
 
#endif
