/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/* designators for the algorithms in LNKnet */
#ifndef lnk_algs_h
#define lnk_algs_h

static char *classifier_strings[] = {
    /* classification algorithms */
    "MLP (Multi-Layer Perceptron)",
    "RBF (Radial Basis Function)", 
    "IRBF (Incremental RBF)", 
    "HISTOGRAM",
    "NBAYES (Naive Bayes)",
    "SVM (Support Vector Machine)",
    "PARZEN (Parzen Window)",
    "GAUSS (Gaussian)", 
    "GMIX (Gaussian Mixture)",
    "KNN (K-Nearest Neighbor)",
    "CKNN (Condensed KNN)",
    "NC_CLASS (Nearest Cluster)",
    "LVQ (Learning Vector Quantizer)", 
    "HYPER (Hypersphere)",
    "BINTREE (Binary Tree)",
    "COMMITTEE",
    /* clustering algorithms */
    "KMEANS (K Means Clustering)",
    "EM_CLUS (GMIX Clustering)",
    "LEAD_CLUS (Leader Clustering)",
    "RAN_CLUS (Random Clustering)", 
    /* contributed algorithms */
    "ARTMAP (Fuzzy ART Map)",
};
static char *classifier_names[] = {
    "mlp", "rbf", "irbf", "histogram", "nbayes", "svm", "parzen", "gauss",
    "gmix", "knn",
    "cknn", "nc_class", "lvq", "hyper", "bintree", "committee",
    "kmeans", "em_clus", "lead_clus", "ran_clus",
    "artmap"};
#endif
