/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
 
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk_create.c,v 11.6 2001/08/23 20:16:55 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            LNKNET                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source $
 *
 * Language: C
 *
 * File Modification History:
 *  29-Nov-1995     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <Xm/Xm.h>
#include "lnk.h"
/*
 * External Functions
 */
 
/*
 * Externals
 */
extern LnkWidgets *LnkClone;
 
/******************************************************************************
 ******************************************************************************
 *
 * Module Name: lnk_create
 *
 * Purpose: 
 * 
 * Calling Sequence:
 *   lnk_create(w, client, call)
 *
 * Inputs:
 *   Widget w            widget calling this callback
 *   XtPointer client    client data attached to widget
 *   XtPointer call      pointer to callback structure
 *
 * Outputs:
 *   none
 *
 * Return Value:
 *   none
 *
 * Side Effects:
 *   none
 *
 * Restrictions:
 *   none
 *
 * Modification History:
 *  29-Nov-1995     Linda C Kukolich  initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
void
lnk_create(Widget w, XtPointer client, XtPointer call)
{
  if (!strcmp(client, "lnkTopLevelShell")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    /*
     * Allocate space for the structure
     */
    LnkClone = (LnkWidgets *)XtMalloc(sizeof(LnkWidgets));
    LnkClone->lnkTopLevelShell = w;
 
  } else if (!strcmp(client, "lnkForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->lnkForm = w;
 
  } else if (!strcmp(client, "mainMenu")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->mainMenu = w;
 
  } else if (!strcmp(client, "fileCascadeButton")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->fileCascadeButton = w;
 
  } else if (!strcmp(client, "filePulldownMenu")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->filePulldownMenu = w;
 
  } else if (!strcmp(client, "fileQuitPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->fileQuitPBtn = w;
 
  } else if (!strcmp(client, "controlFrame")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->controlFrame = w;
 
  } else if (!strcmp(client, "controlLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->controlLabel = w;
 
  } else if (!strcmp(client, "controlForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->controlForm = w;
 
  } else if (!strcmp(client, "startPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->startPBtn = w;
 
  } else if (!strcmp(client, "stopPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->stopPBtn = w;
 
  } else if (!strcmp(client, "continuePBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->continuePBtn = w;
 
  } else if (!strcmp(client, "plotOnlyPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->plotOnlyPBtn = w;
 
  } else if (!strcmp(client, "storeOnlyToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->storeOnlyToggle = w;
 
  } else if (!strcmp(client, "experimentFrame")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->experimentFrame = w;
 
  } else if (!strcmp(client, "experimentForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->experimentForm = w;
 
  } else if (!strcmp(client, "actionSelectRadioBox")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->actionSelectRadioBox = w;
 
  } else if (!strcmp(client, "actionSelectTrainToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->actionSelectTrainToggle = w;
 
  } else if (!strcmp(client, "actionSelectTestToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->actionSelectTestToggle = w;
 
  } else if (!strcmp(client, "actionSelectTrainTestToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->actionSelectTrainTestToggle = w;
 
  } else if (!strcmp(client, "actionSelectCrossValidToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->actionSelectCrossValidToggle = w;
 
  } else if (!strcmp(client, "testSelectLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->testSelectLabel = w;
 
  } else if (!strcmp(client, "testSelectRadioBox")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->testSelectRadioBox = w;
 
  } else if (!strcmp(client, "testSelectTrainToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->testSelectTrainToggle = w;
 
  } else if (!strcmp(client, "testSelectEvalToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->testSelectEvalToggle = w;
 
  } else if (!strcmp(client, "testSelectTestToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->testSelectTestToggle = w;
 
  } else if (!strcmp(client, "actionSelectLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->actionSelectLabel = w;
 
  } else if (!strcmp(client, "crossValidFrame")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->crossValidFrame = w;
 
  } else if (!strcmp(client, "crossValidForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->crossValidForm = w;
 
  } else if (!strcmp(client, "cvFromFileRadioBox")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFromFileRadioBox = w;
 
  } else if (!strcmp(client, "cvAutoSplitToggleButton")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvAutoSplitToggleButton = w;
 
  } else if (!strcmp(client, "cvFromFileToggleButton")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFromFileToggleButton = w;
 
  } else if (!strcmp(client, "cvRandomToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvRandomToggle = w;
 
  } else if (!strcmp(client, "cvFoldsForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFoldsForm = w;
 
  } else if (!strcmp(client, "cvFoldsLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFoldsLabel = w;
 
  } else if (!strcmp(client, "cvFoldsText")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFoldsText = w;
 
  } else if (!strcmp(client, "cvFoldsOKPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFoldsOKPBtn = w;
 
  } else if (!strcmp(client, "cvFoldsCancelPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFoldsCancelPBtn = w;
 
  } else if (!strcmp(client, "extCvForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->extCvForm = w;
 
  } else if (!strcmp(client, "extCvLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->extCvLabel = w;
 
  } else if (!strcmp(client, "extCvText")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->extCvText = w;
 
  } else if (!strcmp(client, "extCvOKPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->extCvOKPBtn = w;
 
  } else if (!strcmp(client, "extCvCancelPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->extCvCancelPBtn = w;
 
  } else if (!strcmp(client, "cvFilenameLabel1")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFilenameLabel1 = w;
 
  } else if (!strcmp(client, "cvFilenameLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->cvFilenameLabel = w;
 
  } else if (!strcmp(client, "crossValidLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->crossValidLabel = w;
 
  } else if (!strcmp(client, "randomFrame")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->randomFrame = w;
 
  } else if (!strcmp(client, "randomForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->randomForm = w;
 
  } else if (!strcmp(client, "randomToggle")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->randomToggle = w;
 
  } else if (!strcmp(client, "seedForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->seedForm = w;
 
  } else if (!strcmp(client, "seedLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->seedLabel = w;
 
  } else if (!strcmp(client, "seedText")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->seedText = w;
 
  } else if (!strcmp(client, "seedOKPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->seedOKPBtn = w;
 
  } else if (!strcmp(client, "seedCancelPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->seedCancelPBtn = w;
 
  } else if (!strcmp(client, "randomLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->randomLabel = w;
 
  } else if (!strcmp(client, "algorithmsOptionMenu")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algorithmsOptionMenu = w;
 
  } else if (!strcmp(client, "algorithmsPulldownMenu")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algorithmsPulldownMenu = w;
 
  } else if (!strcmp(client, "algNeuralNetworksLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algNeuralNetworksLabel = w;
 
  } else if (!strcmp(client, "algMlpPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algMlpPBtn = w;
 
  } else if (!strcmp(client, "algRbfPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algRbfPBtn = w;
 
  } else if (!strcmp(client, "algIrbfPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algIrbfPBtn = w;
 
  } else if (!strcmp(client, "algSeparator")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algSeparator = w;
 
  } else if (!strcmp(client, "algLikelihoodLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algLikelihoodLabel = w;
 
  } else if (!strcmp(client, "algGaussPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algGaussPBtn = w;
 
  } else if (!strcmp(client, "algGmixPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algGmixPBtn = w;
 
  } else if (!strcmp(client, "algHistogramPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algHistogramPBtn = w;
 
  } else if (!strcmp(client, "algParzenPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algParzenPBtn = w;
 
  } else if (!strcmp(client, "algSeparator1")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algSeparator1 = w;
 
  } else if (!strcmp(client, "algNearestNeighborLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algNearestNeighborLabel = w;
 
  } else if (!strcmp(client, "algKnnPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algKnnPBtn = w;
 
  } else if (!strcmp(client, "algCknnPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algCknnPBtn = w;
 
  } else if (!strcmp(client, "algNc_classPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algNc_classPBtn = w;
 
  } else if (!strcmp(client, "algLvqPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algLvqPBtn = w;
 
  } else if (!strcmp(client, "algSeparator2")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algSeparator2 = w;
 
  } else if (!strcmp(client, "algRuleBasedLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algRuleBasedLabel = w;
 
  } else if (!strcmp(client, "algBintreePBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algBintreePBtn = w;
 
  } else if (!strcmp(client, "algHyperPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algHyperPBtn = w;
 
  } else if (!strcmp(client, "algNbayesPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algNbayesPBtn = w;
 
  } else if (!strcmp(client, "algSvmPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algSvmPBtn = w;
 
  } else if (!strcmp(client, "algSeparator3")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algSeparator3 = w;
 
  } else if (!strcmp(client, "algCombinationsLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algCombinationsLabel = w;
 
  } else if (!strcmp(client, "algCommitteePBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algCommitteePBtn = w;
 
  } else if (!strcmp(client, "algSeparator4")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algSeparator4 = w;
 
  } else if (!strcmp(client, "algClusterLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algClusterLabel = w;
 
  } else if (!strcmp(client, "algKmeansPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algKmeansPBtn = w;
 
  } else if (!strcmp(client, "algEm_clusPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algEm_clusPBtn = w;
 
  } else if (!strcmp(client, "algLead_clusPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algLead_clusPBtn = w;
 
  } else if (!strcmp(client, "algRan_clusPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algRan_clusPBtn = w;
 
  } else if (!strcmp(client, "algSeparator5")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algSeparator5 = w;
 
  } else if (!strcmp(client, "algContributedLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algContributedLabel = w;
 
  } else if (!strcmp(client, "algArtmapPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algArtmapPBtn = w;
 
  } else if (!strcmp(client, "algorithmParamsPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->algorithmParamsPBtn = w;
 
  } else if (!strcmp(client, "experimentNameForm")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->experimentNameForm = w;
 
  } else if (!strcmp(client, "experimentNameLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->experimentNameLabel = w;
 
  } else if (!strcmp(client, "experimentNameText")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->experimentNameText = w;
 
  } else if (!strcmp(client, "experimentNameOKPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->experimentNameOKPBtn = w;
 
  } else if (!strcmp(client, "experimentNameCancelPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->experimentNameCancelPBtn = w;
 
  } else if (!strcmp(client, "expWindowsRC")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->expWindowsRC = w;
 
  } else if (!strcmp(client, "expWindowsLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->expWindowsLabel = w;
 
  } else if (!strcmp(client, "reportPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->reportPBtn = w;
 
  } else if (!strcmp(client, "dataPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->dataPBtn = w;
 
  } else if (!strcmp(client, "normPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->normPBtn = w;
 
  } else if (!strcmp(client, "featurePBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->featurePBtn = w;
 
  } else if (!strcmp(client, "priorsPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->priorsPBtn = w;
 
  } else if (!strcmp(client, "plotPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->plotPBtn = w;
 
  } else if (!strcmp(client, "otherWindowsRC")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->otherWindowsRC = w;
 
  } else if (!strcmp(client, "otherWindowsLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->otherWindowsLabel = w;
 
  } else if (!strcmp(client, "printPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->printPBtn = w;
 
  } else if (!strcmp(client, "ccodePBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->ccodePBtn = w;
 
  } else if (!strcmp(client, "committeeDataPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->committeeDataPBtn = w;
 
  } else if (!strcmp(client, "defaultsRC")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->defaultsRC = w;
 
  } else if (!strcmp(client, "defaultsLabel")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->defaultsLabel = w;
 
  } else if (!strcmp(client, "saveDefaultsPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->saveDefaultsPBtn = w;
 
  } else if (!strcmp(client, "restoreDefaultsPBtn")) {
    /*fprintf (stderr, "lnk_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, LnkClone, NULL);
    LnkClone->restoreDefaultsPBtn = w;
 
  } else {
    fprintf(stderr, "lnk_create: unknown client: %s\n", (char *)client);
  }
}
