/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/***************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
#ifndef lnk_func_H
#define lnk_func_H
/* rcsid_h "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk_func.h,v 1.11 2001/11/05 19:57:49 kukolich Exp $" */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                       lnknet                                 ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk_func.h,v $
 *
 * Language: C
 *
 * Purpose:
 * 
 * Calling Sequence:
 *   #include "lnk_func.h"
 *
 * Modification History:
 *  14-Sep-95     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
#include "lnk_params.h"
/* lnk_callback.c */
void lnk_callback(Widget w, XtPointer client, XtPointer call);
/* lnk_request.c */
void lnk_request(String request);
void g_run(RUN_TYPE run_flag);
void g_set_cv_filename();
void g_set_cvtest_flag(Boolean cv_on);
void set_experiment_name();
/* lnk_script.c */
void gnn_set_common_flags(int which_data);
void read_main_defaults(int argc, char **argv);
void write_main_defaults(FILE *default_file);
int store_commands(String filename, RUN_TYPE run_flag);
void store_commands_specific(FILE *shell_file, RUN_TYPE run_flag);
void write_notebook_entry(RUN_TYPE run_flag);
void store_command_head(FILE *shell_file);
void store_command_end(FILE *shell_file);
char * g_get_gen_class_args();
char * g_get_important_args();
Boolean notebook_important_change(char *);
/* lnk_algs.c */
void set_algorithm(ALGORITHM_TYPE value);
void set_short_algorithm(ALGORITHM_TYPE value);
Boolean alg_is_clus();
Boolean alg_is_epoch_class();
Boolean alg_is_continuous_outputs();
Boolean alg_is_likelihood();
Boolean alg_is_bayesian();
Boolean alg_has_struct_plot();
void show_algorithm_popup();
char *g_get_plot_label();
void g_update_ninputs();
void g_get_test_args(FILE *);
char *g_get_alg_args();
char *g_get_important_alg_args();
Boolean must_store_clustering();
char *g_get_cluster_fname();
ALGORITHM_TYPE g_get_cluster_alg();
Boolean alg_uses_clustering();
ALGORITHM_TYPE g_get_alg();
void g_set_alg(ALGORITHM_TYPE alg);
int g_get_epochs();
void g_set_epochs(int);
void g_set_cluster_names();
void set_common_flags(int which_data);
void read_defaults(String screen_fname);
void read_init_defaults();
void write_defaults(String screen_fname);
void display_defaults();
TEST_TYPE gnn_get_which_data();
void display_algorithm_menu();
#endif
