/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
#ifndef lnk_params_H
#define lnk_params_H
/* rcsid = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk_params.h,v 1.11 2001/08/23 20:16:55 craig Exp $"*/

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                       LNKnet window system                                 ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk_params.h,v $
 *
 * Language: C
 *
 * Purpose:
 * 
 * Calling Sequence:
 *   #include "lnk_params.h"
 *
 * Modification History:
 *  25-Aug-95     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
#define DEFAULTS_FILENAME ".lnknetrc"

typedef enum{
    TRAIN = 0, TEST, TRAIN_TEST, CROSS_VALID,
} ACTION_TYPE;

typedef enum {
    CLASS_TRAIN, CLASS_EVAL, CLASS_TEST, TRAIN_TRAIN, CV_TRAIN
} TEST_TYPE;

typedef enum {
    NO_GRAPHICS, SHOW_GRAPHICS
} GRAPHICS_TYPE;

/* algorithm integer designator */
typedef enum{
    MLP = 0, RBF, IRBF, HISTOGRAM, NBAYES, SVM, PARZEN, GAUSS, GMIX, KNN, CKNN,
      NC_CLASS,
    LVQ, HYPER, BINTREE, COMMITTEE,
    KMEANS, EM_CLUS, LEAD_CLUS, RAN_CLUS, ARTMAP, extra}
ALGORITHM_TYPE;
/* extra is to allow ARTMAP + 1 to be a real number */

typedef struct {
    int store_only;
    int train_flag;
    int create_flag;
    int append_flag;
    int continue_flag;
    ACTION_TYPE action;
    TEST_TYPE test_select;
    char *exp_prefix;
    char *exp_name;
    ALGORITHM_TYPE classifier_num;
    char *classifier_name;
    char *classifier_string;
    int random_flag;
    int seed;
    char *seed_string;
    int cv_random;
    int cv_from_file;
    int cv_nfolds;
    char *cvFolds_string;
    char *ext_cv;
    char *cv_filename;
    int exper_pid;
} LnkParams;

#endif
