/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */

/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk_request.c,v 11.4 2001/08/23 20:16:55 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            lnknet window system                      ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/lnk/lnk_request.c,v $
 *
 * Language: C
 *
 * File Modification History:
 *  23-Aug-1995     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <Xm/Xm.h>
#include <nnlib.h>
 
/*
 * Externals
 */
#include "lnk.h"
extern LnkWidgets *LnkClone;
#include "lnk_params.h"
LnkParams lnk_params; /* this is the real one */

#include "../main/lnknet.h"
extern LnkGlyphs *LnknetClone;
#include "../data/data_params.h"
extern DataParams data_params;
#include "../reports/reports_params.h"
extern ReportsParams reports_params;

/*
 * External Functions
 */
#include "../main/lnknet_subs.h"
#include "lnk_func.h"
#include "../reports/reports_func.h"
#include "../plots/plots_func.h"
#include "../ccode/ccode_func.h"

/******************************************************************************
 ******************************************************************************
 *
 * Module Name: lnk_request
 *
 * Purpose: 
 * 
 * Calling Sequence:
 *   lnk_request()
 *
 * Inputs:
 *   none
 *
 * Outputs:
 *   none
 *
 * Return Value:
 *   none
 *
 * Side Effects:
 *   none
 *
 * Restrictions:
 *   none
 *
 * Modification History:
 *  23-Aug-1995     Linda C Kukolich  initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
void
lnk_request(String request)
{
    if (!strcmp(request, "init")){
	lnk_params.store_only = 0;
	lnk_params.train_flag = 0;
	lnk_params.create_flag = 0;
	lnk_params.append_flag = 0;
	lnk_params.continue_flag = 0;
	lnk_params.action = TRAIN;
	lnk_params.test_select = CLASS_TRAIN;
	lnk_params.exp_prefix = NULL;
	lnk_params.exp_name = NULL;
	lnk_params.classifier_num = 0;
	lnk_params.classifier_name = NULL;
	lnk_params.random_flag = 0;
	lnk_params.seed = 0;
	lnk_params.seed_string = NULL;
	lnk_params.cv_random = 0;
	lnk_params.cv_from_file = 0;
	lnk_params.cv_nfolds = 0;
	lnk_params.cvFolds_string = NULL;
	lnk_params.ext_cv = NULL;
	lnk_params.cv_filename = NULL;
	lnk_params.exper_pid = 0;

    } else if (!strcmp(request, "display")){
	char string[10];

	show_toggle_value (LnkClone->randomToggle,
			   (Boolean)lnk_params.random_flag);

	XtFree(lnk_params.seed_string);
	sprintf(string, "%d", lnk_params.seed);
	lnk_params.seed_string = XtNewString(string);
	show_string_text(LnkClone->seedText,
			 lnk_params.seed_string);

	show_toggle_value (LnkClone->storeOnlyToggle,
			   lnk_params.store_only);

	show_radio_value( LnkClone->actionSelectRadioBox, lnk_params.action);

	show_radio_value(LnkClone->testSelectRadioBox, lnk_params.test_select);
	
	show_radio_value(LnkClone->cvFromFileRadioBox,
			 lnk_params.cv_from_file);

	show_string_text (LnkClone->extCvText, lnk_params.ext_cv);

	XtFree(lnk_params.cvFolds_string);
	sprintf(string, "%d", lnk_params.cv_nfolds);
	lnk_params.cvFolds_string = XtNewString(string);
	show_string_text(LnkClone->cvFoldsText,
			 lnk_params.cvFolds_string);

	show_toggle_value(LnkClone->cvRandomToggle, lnk_params.cv_random);
	show_string_label (LnkClone->cvFilenameLabel, lnk_params.cv_filename);
	/* do graying out for cross valid */
	g_set_cvtest_flag(lnk_params.action == CROSS_VALID);

	show_string_text (LnkClone->experimentNameText, lnk_params.exp_prefix);
	set_short_algorithm(lnk_params.classifier_num);
	/* set the algorithm on the option menu */
	/* this doesn't work because there are extra entries in the menu
	   for the labels before the pushbuttons */
	/*show_option_value(LnkClone->algorithmsOptionMenu,
			  lnk_params.classifier_num);*/
	/* what we need to do is compare the text of the buttons with the
	   text in classifier_string */
	display_algorithm_menu();

    } else if (!strcmp(request, "dataWarningOn")){
	set_background_color (LnkClone->dataPBtn, LnknetClone->redColor);

    } else if (!strcmp(request, "dataWarningOff")){
	/* The background color is set to the current color of the report
	   button. If the report button aquires color coded errors, 
	   this needs to change */
	/* I can't just use the normal background color 'cause I at least
	   change the color of my pushbuttons to be different and this
	   should at least work for me :) */
	/* I can't pre-get this color because everytime I have tried to
	   in the past, the code gets called before the real color
	   has been set and I end up with white buttons */
	/* enough comments for two lines of real code repeated three times? */
	Pixel bgColor;
	bgColor = get_background_color(LnkClone->reportPBtn);
	set_background_color (LnkClone->dataPBtn, bgColor);

    } else if (!strcmp(request, "normWarningOn")){
	set_background_color (LnkClone->normPBtn, LnknetClone->redColor);

    } else if (!strcmp(request, "normWarningOff")){
	Pixel bgColor;
	bgColor = get_background_color(LnkClone->reportPBtn);
	set_background_color (LnkClone->normPBtn, bgColor);

    } else if (!strcmp(request, "featureWarningOn")){
	set_background_color (LnkClone->featurePBtn, LnknetClone->redColor);

    } else if (!strcmp(request, "featureWarningOff")){
	Pixel bgColor;
	bgColor = get_background_color(LnkClone->reportPBtn);
	set_background_color (LnkClone->featurePBtn, bgColor);

    } else {
	fprintf (stderr, "lnk_request: unknown request: %s\n", request);
    }
}

void
g_run( RUN_TYPE run_flag)
{
    if (overwrite_ok(LnkClone->lnkForm, reports_params.shell_path)) {
	if(store_commands(reports_params.shell_path, run_flag)) return;
	if(!lnk_params.store_only)
	  lnk_params.exper_pid =
	    chdir_and_execute_command(reports_params.shell_fname);
    }
}

void
set_experiment_name()
{
    XtFree(lnk_params.exp_name);
    lnk_params.exp_name = (String) XtMalloc(strlen(lnk_params.exp_prefix) +
					    strlen(lnk_params.classifier_name)
					    + 1);
    strcpy(lnk_params.exp_name, lnk_params.exp_prefix);
    strcat(lnk_params.exp_name, lnk_params.classifier_name);
    create_experiment_file_names();
    g_set_cluster_names();
    ccode_request("paramFname");
    create_plot_file_names();
    reports_request("major_note");
}

void
g_set_cv_filename()
{
    XtFree(lnk_params.cv_filename);
    lnk_params.cv_filename = XtNewString(data_params.data_base);
    lnk_params.cv_filename = StringConcat(lnk_params.cv_filename,
					  data_params.ext_train);
    lnk_params.cv_filename = StringConcat(lnk_params.cv_filename,
					  lnk_params.ext_cv);
    show_string_label(LnkClone->cvFilenameLabel, lnk_params.cv_filename);
}

void
g_set_cvtest_flag(Boolean cv_on)
{
    gray_out_item(LnkClone->crossValidFrame, !cv_on);
    gray_out_item(LnkClone->testSelectRadioBox, cv_on);
    gray_out_item(LnkClone->testSelectLabel, cv_on);
    if(cv_on){
	show_radio_value(LnkClone->testSelectRadioBox, CLASS_TRAIN);
    } else {
	show_radio_value(LnkClone->testSelectRadioBox, lnk_params.test_select);
    }
}

TEST_TYPE
gnn_get_which_data()
{
    if(lnk_params.action == TRAIN) return TRAIN_TRAIN;
    else if(lnk_params.action == TRAIN_TEST || lnk_params.action == TEST)
      return lnk_params.test_select;
    else return CV_TRAIN;
}

void
display_algorithm_menu()
{
    Widget menu;
    int num_buttons, i;
    WidgetList buttons;
    XmString xmstr;
    String text;
    
    XtVaGetValues( LnkClone->algorithmsOptionMenu, XmNsubMenuId, &menu, NULL);
    XtVaGetValues( menu, XmNnumChildren, &num_buttons,
		  XmNchildren, &buttons, NULL);
    for(i = 0; i < num_buttons; i++){
	XtVaGetValues(buttons[i], XmNlabelString, &xmstr, NULL);
	if(xmstr == NULL) continue;
	/* XmFONTLIST_DEFAULT_TAG is the Motif 1.2 default string tag.
	   In Motif 1.1 they used XmSTRING_DEFAULT_CHARSET instead.
	   Try both, since one seems to be used on the IBM and the
	   other is used on the Sun. This could be because the Sun version
	   is using a default converter and the IBM has to do things by
	   hand using the StringtoXmString converter in lnkUTIL.c That is,
	   if this is true. I don't know which converters are used. Only
	   that this works on both machines. */
	if(XmStringGetLtoR(xmstr, XmFONTLIST_DEFAULT_TAG, &text) != True){
	    if(XmStringGetLtoR(xmstr, XmSTRING_DEFAULT_CHARSET,
			       &text) != True){
		text = XtNewString("");
	    }
	}
	if (strcmp (lnk_params.classifier_string, text) == 0){
	    XmStringFree(xmstr);
	    XtFree(text);
	    break;
	}
	XmStringFree(xmstr);
	XtFree(text);
	xmstr = NULL;
	text = NULL;
    }
    if(i < num_buttons)
      /* this is the button we want */
      XtVaSetValues( LnkClone->algorithmsOptionMenu, XmNmenuHistory, buttons[i], NULL);
}
