/*SUPPRESS 592*/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/*
  $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/lnknetGlyphsCR.c,v 11.3 2001/08/23 20:17:00 craig Exp $ */


 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            lnknetGlyphs                              ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/lnknetGlyphsCR.c,v $
 *
 * Language: C
 *
 * File Modification History:
 *  08-Sep-95     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include "lnknetGlyphsCON.h"
#include "lnknet.h"
#include <X11/cursorfont.h>
#include <Xm/Xm.h>
/*
 * External Functions
 */
 
/*
 * Externals
 */
extern LnkGlyphs *LnknetClone;

/******************************************************************************
 ******************************************************************************
 *
 * Module Name: CreatelnknetGlyphs
 *
 * Purpose: 
 *   Create warning and cursor glyphs for use by the lnknet windows
 * 
 * Calling Sequence:
 *   CreatelnknetGlyphs()
 *
 * Inputs:
 *   Widget parent;
 *
 * Outputs:
 *   none
 *
 * Return Value:
 *   none
 *
 * Side Effects:
 *   none
 *
 * Restrictions:
 *   none
 *
 * Modification History:
 *  08-Sep-95     Linda C Kukolich  initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */

void
CreatelnknetGlyphs(Widget parent)
{
    unsigned int depth;
    Colormap colormap;
    XColor screenRedColor, realRedColor;
    Display *display;

    display = XtDisplay(parent);
    LnknetClone = (LnkGlyphs *)XtMalloc(sizeof(LnkGlyphs));
    LnknetClone->cursor = XCreateFontCursor(display, XC_left_ptr);
    LnknetClone->busyCursor = XCreateFontCursor(display, XC_watch);

    /* get the current background color */
    XtVaGetValues(parent,
		  XmNbackground, &LnknetClone->bgColor,
		  XmNdepth, &depth,
		  XmNcolormap, &colormap, NULL);

    /* try to get a red color from X. If no red was found, take
       the closest thing that was found */
    if(!XAllocNamedColor(display, colormap,
			 "red",
			 &screenRedColor, &realRedColor)){
	XtVaGetValues(parent, XmNforeground, &LnknetClone->redColor, NULL);
    } else {
	LnknetClone->redColor = screenRedColor.pixel;
    }

    /* create some red pixmaps using the current background */
    LnknetClone->largeWarning =
      XCreatePixmapFromBitmapData(display,
				  DefaultRootWindow(display),
				  largeWarning_bits, largeWarning_width,
				  largeWarning_height,
				  LnknetClone->redColor, LnknetClone->bgColor,
				  depth);
    LnknetClone->largeBlank =
      XCreatePixmapFromBitmapData(display,
				  DefaultRootWindow(display),
				  largeBlank_bits, largeBlank_width,
				  largeBlank_height,
				  LnknetClone->redColor, LnknetClone->bgColor,
				  depth);
    LnknetClone->smallWarning =
      XCreatePixmapFromBitmapData(display,
				  DefaultRootWindow(display),
				  smallWarning_bits, smallWarning_width,
				  smallWarning_height,
				  LnknetClone->redColor, LnknetClone->bgColor,
				  depth);
    LnknetClone->smallBlank =
      XCreatePixmapFromBitmapData(display,
				  DefaultRootWindow(display),
				  smallBlank_bits, smallBlank_width,
				  smallBlank_height,
				  LnknetClone->redColor, LnknetClone->bgColor,
				  depth);
#ifdef notused
    LnknetClone->largeBlank = XPM_PIXMAP(parent, largeBlank_icon);
    LnknetClone->largeWarning = XPM_PIXMAP(parent, largeWarning_icon);
    LnknetClone->smallBlank = XPM_PIXMAP(parent, smallBlank_icon);
    LnknetClone->smallWarning = XPM_PIXMAP(parent, smallWarning_icon);
#endif
}
