/*SUPPRESS 592*/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
 
/*
$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/lnknet_subs.c,v 11.6 2001/08/23 20:17:00 craig Exp $
*/


 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                           LNKnet Window Interface                    ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/lnknet_subs.c,v $
 *
 * Language: C
 *
 * File Modification History:
 *  23-Aug-1995     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <Xm/Xm.h>
/* for the warningMessageDialog */
#include <Xm/MessageB.h>
/* for the radio Box show/get */
#include <Xm/ToggleB.h>
#include <nnlib.h>
#include "lnknet_subs.h"
/* for killpq */
#include <signal.h>
/*
 * External Functions
 */
 
/*
 * Externals
 */
/* this is needed for the question popup */
extern XtAppContext lnknetAppContext;

/****************************************************************************
 module: show_radio_value, show_toggle_value, show_int_text, show_int_label,
     show_float_text, show_float_label,
     show_string_text, show_string_label, show_image_label
 purpose: Display strings, integers, and floats in text and label widgets 
*****************************************************************************/
void
show_radio_value(Widget w, int value)
/* set the value of w, a radioBox rowColumn widget, to value, 
   that is, set the desired toggle button on. */
{
    WidgetList toggles;
    Widget on_toggle;
    int num_toggles, i;
    Boolean xstate;

    XtVaGetValues(w, XmNnumChildren, &num_toggles,
          XmNchildren, &toggles,
          XmNmenuHistory, &on_toggle, NULL);
    /* rpl change to avoid use of XmMenuHistory and on_toggle which isnt
       set right in lesstif */
   /* turn all on toggles off */
    for(i = 0; i < num_toggles; i++)
        {
        xstate = XmToggleButtonGetState(toggles[i]);
        if ( xstate == True )
                {
        show_toggle_value(toggles[i], False);
                }
       }
    
    if(0 <= value && value < num_toggles){
    show_toggle_value(toggles[value], True);
    }
    /* set up the menuHistory so future calls will work */
    XtVaSetValues(w, XmNmenuHistory, toggles[value], NULL);
#ifdef notused
    /*The first True sets the toggle. The second True asks for a valueChange
      callback to be called which happens to tell the parent radioBox to
      turn off all the other toggles
      This also calls my toggle setting
      callbacks, which erases any state I've been keeping */
    if(0 <= value && value < num_toggles){
    XmToggleButtonSetState(toggles[value], True, True);
    }
#endif
}

void
show_toggle_value(Widget w, Boolean value)
{
    XtVaSetValues(w, XmNset, value, NULL);
}

/* this one is for optionMenus */
void
show_option_value(Widget w, int value)
{
    Widget menu;
    int num_buttons;
    WidgetList buttons;

    XtVaGetValues( w, XmNsubMenuId, &menu, NULL);
    XtVaGetValues( menu, XmNnumChildren, &num_buttons,
          XmNchildren, &buttons, NULL ) ;

    XtVaSetValues( w, XmNmenuHistory, buttons[value], NULL ) ;
}

void
show_int_text (Widget w, int value)
{
    char string[10];
    
    sprintf (string, "%d", value);
    /* use XmTextFieldReplace here? */
    XtVaSetValues (w, XmNvalue, string, NULL);
}

void
show_int_label (Widget w, int value)
{
    char string[10];
    XmString xmstring;
    
    sprintf (string, "%d", value);

#if (XmVersion >= 1002)
    xmstring = XmStringCreateLocalized(string);
#else
    xmstring = XmStringCreateSimple(string);
#endif    
    XtVaSetValues (w, XmNlabelString, xmstring, NULL);
    XmStringFree (xmstring);
}

void 
show_float_text (Widget w, float value)
{
    char string[10];
    
    sprintf (string, "%5.2g", value);
    XtVaSetValues (w, XmNvalue, string, NULL);
}

void 
show_float_label (Widget w, float value)
{
    char string[10];
    XmString xmstring;
    
    sprintf (string, "%5.2g", value);
#if (XmVersion >= 1002)
    xmstring = XmStringCreateLocalized(string);
#else
    xmstring = XmStringCreateSimple(string);
#endif    
    XtVaSetValues (w, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
}

void
show_string_text(Widget w, String string)
{
    XtVaSetValues(w, XmNvalue, string, NULL);
}

void
show_string_label(Widget w, String string)
{
    XmString xmstring;
#if (XmVersion >= 1002)
    xmstring = XmStringCreateLocalized(string);
#else
    xmstring = XmStringCreateSimple(string);
#endif    
    XtVaSetValues(w, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
}

void
show_image_label(Widget w, Pixmap image)
{
    XtVaSetValues(w, XmNlabelPixmap, image, NULL);
    
}

void
set_background_color(Widget w, Pixel color)
{
    XtVaSetValues(w, XmNbackground, color, NULL);
}

Pixel get_background_color(Widget w)
{
    Pixel bg;

    XtVaGetValues(w, XmNbackground, &bg, NULL);
    return bg;
}

/****************************************************************************
  module: get_string_text
  purpose: get the string from a text widget
 ****************************************************************************/
/* the result of this get must be freed using XtFree */
String
get_string_text(Widget w)
{
    String string;
    XtVaGetValues(w, XmNvalue, &string, NULL);
    return string;
}


/* modified this function to avoid using the XnNmenuHistory value which 
   seems to be set incorrectly in lesstif rpl  oct 1999 */
int
get_radio_value(Widget w)
{
    WidgetList toggles;
    int num_toggles, i, imatch;
    Widget on_toggle;
    Boolean xstate;

    XtVaGetValues(w, XmNnumChildren, &num_toggles,
          XmNchildren, &toggles,
          XmNmenuHistory, &on_toggle, NULL);
        /* rpl change*/
    for(i = 0; i < num_toggles; i++)
        {
        xstate = XmToggleButtonGetState(toggles[i]);
        if ( xstate == True )
                {
                imatch = i;
                }
       }
    return imatch;
}

int
get_toggle_value(Widget w)
{
    Boolean i;
    XtVaGetValues(w, XmNset, &i, NULL);
    return i;
}

/****************************************************************************
  module: StringConcat
  purpose: concatenate a string onto the end of an existing one
 ****************************************************************************/
String
StringConcat(String s1, String s2)
{
    int length;
    if(s2 == NULL) return s1;
    if(s1 == NULL){
    s1 = XtNewString(s2);
    } else {
    length = strlen(s1) + strlen(s2) + 1;
    s1 = XtRealloc(s1, length);
    strcat(s1, s2);
    }
    return s1;
}

/****************************************************************************
  module: close_popup, open_popup
  purpose: to popup or down a dialog box, send the bulletin board child of the
      dialogShell as the widget w
 ****************************************************************************/
void
close_popup(Widget w)
{
    XtUnmanageChild(w);
    XtPopdown(XtParent(w));
}

void
open_popup(Widget w)
{
    XtManageChild(w);
    XtPopup(XtParent(w), XtGrabNone);
}


/****************************************************************************
  module: file_exists
  purpose: check to see if a file already exists
 ****************************************************************************/
int
file_exists (filename)
     char *filename;
{
    FILE *file;
    int return_val;
    
    if ((file = fopen(filename, "r")) == NULL) {
        return_val = FALSE;
    } else {
        return_val = TRUE;
    nn_fclose(file, filename, "for file existence check");
    }
    return return_val;
}

/****************************************************************************
  module: overwrite_ok
  purpose: check to see if it is ok to overwrite a file, if the file is there
 ****************************************************************************/
Boolean
overwrite_ok (Widget parent, String filename)
{
    int return_value;

    return_value = TRUE;
    if (file_exists(filename)) {
    return_value =
      questionMessageDialog(parent,
                "Shell file exists: OK to overwrite?",
                "Overwrite", "Cancel");
    }
    return return_value;
}



/****************************************************************************
  module: set_atof_value, set_atof_low_value, set_atof_range_value
     set_atoi_value, set_atoi_low_value, set_atoi_range_value
     set_string_not_empty
  purpose: routines for interpretting strings as floats, integers, and
  strings that may not be empty
 ****************************************************************************/

float
set_atof_value(Widget w, String name, float value)
{
    float new_val;
    String str;
    char warn_string[128];
    
    str = get_string_text(w);
    if(sscanf (str, "%f", &new_val) == 1){
    return new_val;
    } else {
    sprintf(warn_string, "set_atof_value -- %s is not a valid float", str);
    warningMessageDialog(w, warn_string);
    show_float_text(w, value);
    return value;
    }
}

int
set_atoi_value(Widget w, String name, int value)
{
    int new_val;
    String str;
    char warn_string[128];
    
    str = get_string_text(w);
    if(sscanf (str, "%d", &new_val) == 1){
    return new_val;
    } else {
    sprintf(warn_string,"set_atoi_value -- %s is not a valid integer", str);
    warningMessageDialog(w, warn_string);
    show_int_text(w, value);
    return value;
    }
}

float
set_atof_range_value(Widget w, String name,
             float value, float low, float high)
{
    float new_val;
    String str;
    char warn_string[128];
    
    str = get_string_text(w);
    if(sscanf (str, "%f", &new_val) == 1){
    if(new_val >= low && new_val <= high)
      return new_val;
    else {
        sprintf(warn_string, "set_atof_range_value -- new value (%f) is out of range (%f,%f)",
            new_val, low, high);
        warningMessageDialog(w, warn_string);
        show_float_text(w, value);
        return value;
    }
    } else {
    sprintf(warn_string,"set_atof_range_value -- %s is not a valid float",
        str);
    warningMessageDialog(w, warn_string);
    show_float_text(w, value);
    return value;
    }
}

float
set_atof_low_value(Widget w, String name, float value, float low)
{
    float new_val;
    char warn_string[128];
    String str;
    
    str = get_string_text(w);
    if(sscanf (str, "%f", &new_val) == 1){
    if(new_val >= low)
      return new_val;
    else {
        sprintf(warn_string,"set_atof_low_value -- new value (%f) must be greater than (%f)",
            new_val, low);
        warningMessageDialog(w, warn_string);
        show_float_text(w, value);
        return value;
    }
    } else {
    sprintf(warn_string,"set_atof_low_value -- %s is not a valid float",
        str);
    warningMessageDialog(w, warn_string);
    show_float_text(w, value);
    return value;
    }
}

int
set_atoi_low_value(Widget w, String name, int value, int low)
{
    int new_val;
    char warn_string[128];
    String str;
    
    str = get_string_text(w);
    if(sscanf (str, "%d", &new_val) == 1){
    if(new_val >= low)
      return new_val;
    else {
        sprintf(warn_string,"set_atoi_low_value -- new value (%d) must be greater than (%d)",
            new_val, low);
        warningMessageDialog(w, warn_string);
        show_int_text(w, value);
        return value;
    }
    } else {
    sprintf(warn_string, "set_atoi_low_value -- %s is not a valid integer",
        str);
    warningMessageDialog(w, warn_string);
    show_int_text(w, value);
    return value;
    }
}

int
set_atoi_range_value(Widget w, String name,
             int value, int low, int high)
{
    int new_val;
    char warn_string[128];
    String str;
    
    str = get_string_text(w);
    if(sscanf (str, "%d", &new_val) == 1){
    if(new_val >= low && new_val <= high)
      return new_val;
    else {
        sprintf(warn_string,"set_atoi_range_value -- new value (%d) is out of range (%d,%d)",
            new_val, low, high);
        warningMessageDialog(w, warn_string);
        show_int_text(w, value);
        return value;
    }
    } else {
    sprintf(warn_string, "set_atoi_range_value -- %s is not a valid integer",
        str);
    warningMessageDialog(w, warn_string);
    show_int_text(w, value);
    return value;
    }
}

String
set_string_not_empty(Widget w, String name, String value)
{
    char warn_string[128];
    String str;
    
    str = get_string_text(w);
    if(strcmp(str, "") == 0){
    sprintf(warn_string,"set_string_value -- cannot set %s to an empty string",
        name);
    warningMessageDialog(w, warn_string);
    show_string_text(w, value);
    XtFree(str);
    return XtNewString(value);
    } else {
    return str;
    }
}
 
/******************************************************************************
******************************************************************************
*
* Module Name: warningMessageDialog
*
* Purpose: Post a Message Dialog.
* 
* Calling Sequence:
*   warningMessageDialog(parent, message)
*
* Inputs:
*   Widget parent       parent of Message Dialog
*   char *message       message to put in message dialog
*
* Outputs:
*   none
*
* Return Value:
*   none
*
* Side Effects:
*   none
*
* Restrictions:
*   none
*
* Modification History:
*  23-Mar-1994     Linda Sue Sohn  initial creation (vtraceMessageDialog)
*  31-Aug-1995     Linda Kukolich  modified for use in LNKnet
*
******************************************************************************
******************************************************************************
*/
 
void
warningMessageDialog(Widget parent, String message)
{
    static Widget messageDialog = NULL;
    Arg args[10];
    Cardinal ac;
    XmString xmstring;
    Boolean argok;
    Pixel background;

    /* make sure the warning gets recorded in the count */
    warning(message);

    /* build the message box */
    if(!messageDialog){
    background = (Pixel)CONVERT(parent, "Red", "Pixel", 9, &argok); 

    ac = 0;
    XtSetArg(args[ac], XmNdialogType, XmDIALOG_ERROR); ac++;
    xmstring = XmStringCreateLtoR("Warning Message", XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[ac], XmNdialogTitle, xmstring); ac++;
    XtSetArg(args[ac], XmNdialogStyle, 
         XmDIALOG_APPLICATION_MODAL); ac++;
    XtSetArg(args[ac], XmNbackground, background); ac++;
    messageDialog = XmCreateMessageDialog(parent, "warningMessage", 
                          args, ac);
    XmStringFree(xmstring);

    XtUnmanageChild(XmMessageBoxGetChild(messageDialog,
                         XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(messageDialog,
                         XmDIALOG_HELP_BUTTON));
    }
    /* load the message */
    xmstring = XmStringCreateLtoR(message, XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(messageDialog, XmNmessageString, xmstring, NULL);
    XmStringFree(xmstring);
  
    XtManageChild (messageDialog);
    XtPopup (XtParent(messageDialog), XtGrabNone);
    /* hitting OK will pop this down. No one does anything until OK is hit */
}

/************************************************************************
  Module: questionMessageDialog
  Purpose: as the user a yes/no question and get an immediate response
  Inputs: Widget parent, String question
  Outputs: int answer;
    answer is True for YES and 0 for No
  Side Effects: A dialog is posted to the screen and nothing happens
        in this application until the user picks one of the responses.
*************************************************************************/
  
#define QUESTION_YES 1
#define QUESTION_NO 2
#define QUESTION_MAYBE 0
void
questionMessageResponse(Widget w, XtPointer client_data, XtPointer call_data)
{
    int *answer = (int *)client_data;
    XmAnyCallbackStruct *acs = (XmAnyCallbackStruct *) call_data;
    if(acs->reason == XmCR_OK)
      *answer = QUESTION_YES;
    else if (acs->reason == XmCR_CANCEL)
      *answer = QUESTION_NO;
}

int
questionMessageDialog(Widget parent, String message,
              String okText, String cancelText)
{
    static Widget messageDialog = NULL; /* static to avoid multiple creation */
    XmString xmstring, xmMessageString, xmOkString, xmCancelString;
    static int answer;
    Cardinal ac;
    Arg args[10];

    if(!messageDialog){
    ac = 0;
    XtSetArg(args[ac], XmNdialogStyle, XmDIALOG_APPLICATION_MODAL); ac++;
#if (XmVersion >= 1002)
    xmstring = XmStringCreateLocalized("Question");
#else
    xmstring = XmStringCreateSimple("Question");
#endif    
    XtSetArg(args[ac], XmNdialogTitle, xmstring); ac++;
    XtSetArg(args[ac], XmNdialogType, XmDIALOG_QUESTION); ac++;
    messageDialog = XmCreateMessageDialog(parent,
                          "messageDialog",
                          args, 
                          ac);
    XtUnmanageChild(XmMessageBoxGetChild(messageDialog,
                         XmDIALOG_HELP_BUTTON));
    XmStringFree(xmstring);
    XtAddCallback(messageDialog, XmNokCallback,
              questionMessageResponse, & answer);
    XtAddCallback(messageDialog, XmNcancelCallback,
              questionMessageResponse, & answer);
    }
    answer = QUESTION_MAYBE;
#if (XmVersion >= 1002)
    xmMessageString = XmStringCreateLocalized(message);
    xmOkString = XmStringCreateLocalized(okText);
    xmCancelString = XmStringCreateLocalized(cancelText);
#else
    xmMessageString = XmStringCreateSimple(message);
    xmOkString = XmStringCreateSimple(okText);
    xmCancelString = XmStringCreateSimple(cancelText);
#endif    
    XtVaSetValues(messageDialog,
          XmNmessageString, xmMessageString,
          XmNokLabelString, xmOkString, 
          XmNcancelLabelString, xmCancelString, NULL);

    XmStringFree(xmMessageString);
    XmStringFree(xmOkString);
    XmStringFree(xmCancelString);

    XtManageChild (messageDialog);
    XtPopup(XtParent(messageDialog), XtGrabNone);

    /* put in an event loop */
    while( answer == QUESTION_MAYBE)
      XtAppProcessEvent(lnknetAppContext, XtIMAll);
    XtPopdown(XtParent(messageDialog));
    /* make sure the dialog goes away before returning. Sync with server
       and update the display */
    XSync(XtDisplay(messageDialog), 0);
    XmUpdateDisplay(parent);

    return (answer == QUESTION_YES);
}
#undef QUESTION_YES
#undef QUESTION_NO
#undef QUESTION_MAYBE

/****************************************************************************
 module: make_int_string, make_float_string, make_labels_string
 purpose: make a String from an array of ints, floats, or strings in nnargs
   format. In nnargs format, the first entry of the array contains the
   integer length of the array.
   The idea here is to grow the string as numbers are added to it.
   the new string is allocated (It was static in the Xview LNKnet for
   make_int_string and make_float_string but not make_labels_string!!!)
 Calling Sequence:
     int *array1;
     float *array2;
     String *array3, s;
     ...
     s = make_int_string(array1);
     OR s = make_float_string(array2);
     OR s = make_float_string(array3);
     ...
     XtFree(s);
     ...
 
*****************************************************************************/
String
make_int_string (array)
     int array[];
{
    String dummy;
    char token[16];
    int i;
    
    dummy = XtNewString("");
    if(array == NULL) return dummy;
    if (array[0] > 0) {
    sprintf (token, "%d", array[1]);
    dummy = XtRealloc(dummy, strlen(dummy) + strlen(token) + 1);
    strcat(dummy, token);
    }
    if (array[0] > 1) {
    for(i=2; i<= array[0] && i <= NNARGS_MAX_NET; i++){
        sprintf(token, "%d", array[i]);
        /* we need an extra char for the comma! */
        dummy = XtRealloc(dummy, strlen(dummy) + strlen(token) + 2);
        strcat(dummy, ",");
        strcat(dummy, token);
    }
    }
    return dummy;
}

char *
make_float_string (array)
     float array[];
{
    String dummy;
    char token[16];
    int i;
    
    dummy = XtNewString("");
    if(array == NULL) return dummy;
    if (array[0] > 0) {
    sprintf (token, "%g", array[1]);
    dummy = XtRealloc(dummy, strlen(dummy) + strlen(token) + 1);
    strcat(dummy, token);
    }
    if (array[0] > 1) {
    for(i=2; i<= array[0] && i <= NNARGS_MAX_NET; i++){
        sprintf(token, "%g", array[i]);
        /* we need an extra char for the comma! */
        dummy = XtRealloc(dummy, strlen(dummy) + strlen(token) + 2);
        strcat(dummy, ",");
        strcat(dummy, token);
    }
    }
    return dummy;
}

char *
make_labels_string (array)
     char *array[];
{
    char *dummy;
    int i, array_len, total_length;
    
    if(array == NULL) array_len = 0;
    else array_len = atoi(array[0]);
    /* add up the length of the string to be created */
    total_length = 0;
    for(i = 1; i <= array_len; i++)
      total_length += strlen(array[i]);
    /* remember the commas and the NIL at the end */
    total_length += array_len + 1;

    /* allocate space for the string */
    dummy = nn_malloc(total_length, "for make_labels_string");
    dummy[0] = '\0';

    if(array_len > 0){
    for(i = 1; i <= array_len; i++){
        strcat(dummy, array[i]);
        strcat(dummy, ",");
    }
    }
    /* take off the comma at the end */
    total_length = strlen(dummy);
    if(total_length > 1) dummy[total_length-1] = '\0';

    return dummy;
}

String *
copy_string_vector(String *string_list, int length)
{
    String *str_list;
    int i;

    if(string_list == NULL) return NULL;
    /* allocate an array to hold the strings */
    str_list = (String *)allocate_pvector(length);
    /* copy each of the component strings */
    for(i = 0; i < length; i++){
    str_list[i] = nn_strdup(string_list[i]);
    }
    return str_list;
}

/* this routine copies a int vector in nnargs format which is stored in
   a static array to a newly allocated int vector.
   the nnargs format for vectors is {length, f1, f2, ... }, that is
   when length is n, there are n+1 entries filled in the vector and
   the first entry is the length of the vector. */
int *
copy_static2alloc_ivector(int *fromV)
{
    int count;
    int *toV;
    count = fromV[0];
    toV = allocate_ivector(count+1);
    for(; count >= 0; count--){
    toV[count] = fromV[count];
    }
    return toV;
}

/* this routine copies a int vector which is stored in one array
   to another array which is assumed to be long enough */
void
copy_alloc2static_ivector(int *fromV, int*toV)
{
    int count;
    if(fromV == NULL){
    toV[0] = 0.;
    } else {
    count = fromV[0];
    for(; count >= 0; count--){
        toV[count] = fromV[count];
    }
    }
}

/* this routine copies a float vector in nnargs format which is stored in
   a static array to a newly allocated float vector.
   the nnargs format for vectors is {length, f1, f2, ... }, that is
   when length is n, there are n+1 entries filled in the vector and
   the first entry is the length of the vector. */
float *
copy_static2alloc_vector(float *fromV)
{
    int count;
    float *toV;
    count = fromV[0];
    toV = allocate_vector(count+1);
    for(; count >= 0; count--){
    toV[count] = fromV[count];
    }
    return toV;
}

/* this routine copies a float vector which is stored in one array
   to another array which is assumed to be long enough */
void
copy_alloc2static_vector(float *fromV, float*toV)
{
    int count;
    if(fromV == NULL){
    toV[0] = 0.;
    } else {
    count = fromV[0];
    for(; count >= 0; count--){
        toV[count] = fromV[count];
    }
    }
}

void
gray_out_item(Widget w, Boolean onOff)
{
    XtSetSensitive(w, !onOff);
}

FILE *
command_file_open (Widget w, String filename)
{
    FILE *shell_file;

    shell_file = fopen(filename, "w");
    if(shell_file == NULL){
    warningMessageDialog(w, "Cannot create file for shell script");
    return NULL;
    }
    fprintf (shell_file, "#!/bin/csh -ef\n# %s\n", filename);
    
    return shell_file;
}

void
command_file_close (shell_file, filename, message)
     char *filename, *message;
     FILE *shell_file;
{
    String chartmp;
    nn_fclose (shell_file, filename, message);
    
    chartmp = XtNewString("chmod +x ");
    chartmp = StringConcat(chartmp, filename);
    system (chartmp);
    XtFree(chartmp);
}

int
execute_command_file(filename)
     char *filename;
{
    int cur_com_pgrp;
    String chartmp;
    chartmp = XtNewString("csh -ef ");
    chartmp = StringConcat(chartmp, filename);
    chartmp = StringConcat(chartmp, "&");
    cur_com_pgrp = nn_system (chartmp);
    XtFree(chartmp);
    return(cur_com_pgrp);
}

void
stop_command_file(int cur_com_pgrp)
{
    if(cur_com_pgrp != 0){
    killpg (cur_com_pgrp, SIGKILL);
    printf("\nKilled the most recently started run file\n");
    cur_com_pgrp = 0;
    }
}
