/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/***************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
***************************************************************************/
#ifndef lnknet_subs_H
#define lnknet_subs_H
 
/* rcsid_h = "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/lnknet_subs.h,v 1.11 2001/08/23 20:17:00 craig Exp $" */

/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            LNKNET subroutines                        ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/lnknet_subs.h,v $
 *
 * Language: C
 *
 * Purpose: Subroutines shared by windows of LNKnet interface
 * 
 * Calling Sequence:
 *   #include <lnknet_subs.h>
 *
 * Modification History:
 *  24-Aug-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
void show_radio_value(Widget, int);
void show_toggle_value(Widget, Boolean);
void show_option_value(Widget, int);
void show_int_text(Widget, int);
void show_int_label(Widget, int);
void show_float_text(Widget, float);
void show_float_label(Widget, float);
void show_string_text(Widget, String);
void show_string_label(Widget, String);
void show_image_label(Widget, Pixmap);
void set_background_color(Widget, Pixel);
Pixel get_background_color(Widget);
int get_radio_value(Widget);
int get_toggle_value(Widget);
String get_string_text(Widget);
void close_popup(Widget);
void open_popup(Widget);
Boolean overwrite_ok(Widget, String);
float set_atof_value(Widget w, String name, float deflt);
int set_atoi_value(Widget w, String name, int deflt);
float set_atof_range_value(Widget w, String name, float deflt,
			   float low, float high);
float set_atof_low_value(Widget w, String name, float deflt, float low);
int set_atoi_range_value(Widget w, String name, int deflt,
			 int low, int high);
int set_atoi_low_value(Widget w, String name, int deflt, int low);
String set_string_not_empty(Widget w, String name, String deflt);
void warningMessageDialog(Widget, String);
int questionMessageDialog(Widget parent, String message,
			  String okText, String cancelText);
String make_int_string(int array[]);
String make_float_string(float array[]);
String make_labels_string(String array[]);
String *copy_string_vector(String *string_list, int length);
void copy_alloc2static_vector(float *fromV, float *toV);
float *copy_static2alloc_vector(float *fromV);
void copy_alloc2static_ivector(int *fromV, int *toV);
int *copy_static2alloc_ivector(int *fromV);
String StringConcat(String s1, String s2);
void gray_out_item(Widget, Boolean);
FILE *command_file_open(Widget w, String filename);
int execute_command_file(String filename);
void stop_command_file(int pid);
void command_file_close(FILE *shell_file, String filename, String message);
/* from show_cursor.c */
void show_cursor(Cursor);

/* this gets used by several windows that generate and run scripts */
typedef enum{
    PLOT_ONLY = 0, EXP_AND_PLOT,
} RUN_TYPE;

int okTextValueChanged(Widget textWidget, Widget okButton, Widget cancelButton,
		       Widget dialogShell, int buttonsMapped, String oldText);
int okTextActivate(Widget textWidget, Widget okButton, Widget cancelButton,
		   String *newText);
int okTextCancel(Widget textWidget, Widget okButton, Widget cancelButton,
		 String oldText);

int file_exists(char *filename);
void CreatelnknetGlyphs(Widget parent);
#endif
