/*SUPPRESS 592*/
/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */

/*
  $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/show_cursor.c,v 11.3 2001/08/23 20:17:01 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            lnknet                              ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/main/show_cursor.c,v $
 *
 * Language: C
 *
 * File Modification History:
 *  08-Sep-95     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <Xm/Xm.h>
/*
 * External Functions
 */
 
/*
 * Externals
 */
#include "../lnk/lnk.h"
extern LnkWidgets *LnkClone;
#include "../data/data.h"
extern DataWidgets *DataClone;
#include "../data/defaults.h"
extern DefaultsWidgets *DefaultsClone;
#include "../data/dataSelect.h"
extern DataSelectWidgets *DataSelectClone;
#include "../gauss/gauss.h"
extern GaussWidgets *GaussClone;
#include "../reports/reports.h"
extern ReportsWidgets *ReportsClone;
 
/******************************************************************************
 ******************************************************************************
 *
 * Module Name: show_cursor
 *
 * Purpose: 
 *   change the cursor for all the lnknet windows
 * 
 * Calling Sequence:
 *   show_cursor()
 *
 * Inputs:
 *   none
 *
 * Outputs:
 *   none
 *
 * Return Value:
 *   none
 *
 * Side Effects:
 *   none
 *
 * Restrictions:
 *   none
 *
 * Modification History:
 *  08-Sep-95     Linda C Kukolich  initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
#define SET_CURSOR(w, c) if(XtIsRealized(w)) XDefineCursor (XtDisplay(w), XtWindow(w), (c));
void
show_cursor(Cursor cursor)
{
    SET_CURSOR(LnkClone->lnkTopLevelShell, cursor);
    SET_CURSOR(DataClone->dataDialogShell, cursor);
    SET_CURSOR(DefaultsClone->defaultsDialogShell, cursor);
    SET_CURSOR(DataSelectClone->dataSelectDialogShell, cursor);
    SET_CURSOR(GaussClone->gaussDialogShell, cursor);
    SET_CURSOR(ReportsClone->reportsDialogShell, cursor);
}
