/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef mlpWeight_H
#define mlpWeight_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/mlp/mlpWeight.h,v 1.4 2001/08/23 20:17:04 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            MLPWEIGHT                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $MLPWEIGHTHOME/src/mlpWeight.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for mlpWeight
 * 
 * Calling Sequence:
 *   #include <mlpWeight.h>
 *
 * Modification History:
 *  3-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" mlpWeight.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget mlpWeightDialogShell;
  Widget mlpWeightForm;
  Widget weightFrame;
  Widget weightForm;
  Widget ettaChangeRadioBox;
  Widget constEttaToggle;
  Widget cOverTToggle;
  Widget masToggle;
  Widget ettaNepochsForm;
  Widget ettaNepochsLabel;
  Widget ettaNepochsText;
  Widget ettaNepochsOKPBtn;
  Widget ettaNepochsCancelPBtn;
  Widget kappaForm;
  Widget kappaLabel;
  Widget kappaText;
  Widget kappaOKPBtn;
  Widget kappaCancelPBtn;
  Widget epsilonForm;
  Widget epsilonLabel;
  Widget epsilonText;
  Widget epsilonOKPBtn;
  Widget epsilonCancelPBtn;
  Widget useEttaListRadioBox;
  Widget noEttaListToggle;
  Widget useEttaListToggle;
  Widget ettaListForm;
  Widget ettaListLabel;
  Widget ettaListText;
  Widget ettaListOKPBtn;
  Widget ettaListCancelPBtn;
  Widget weightUpdateLabel;
  Widget weightUpdateRadioBox;
  Widget trialUpdateToggle;
  Widget batchUpdateToggle;
  Widget weightLabel;
  Widget decayForm;
  Widget decayLabel;
  Widget decayText;
  Widget decayOKPBtn;
  Widget decayCancelPBtn;
  Widget momentumForm;
  Widget momentumLabel;
  Widget momentumText;
  Widget momentumOKPBtn;
  Widget momentumCancelPBtn;
  Widget toleranceForm;
  Widget toleranceLabel;
  Widget toleranceText;
  Widget toleranceOKPBtn;
  Widget toleranceCancelPBtn;
  Widget maxWeightForm;
  Widget maxWeightLabel;
  Widget maxWeightText;
  Widget maxWeightOKPBtn;
  Widget maxWeightCancelPBtn;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} MlpWeightWidgets;
 
#endif
