/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/***************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
#ifndef mlp_params_H
#define mlp_params_H
/* rcsid_h "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/mlp/mlp_params.h,v 1.3 2001/08/23 20:17:05 craig Exp $" */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                     parameters for mlp windows                       ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/mlp/mlp_params.h,v $
 *
 * Language: C
 *
 * Purpose:
 * 
 * Calling Sequence:
 *   #include "mlp_params.h"
 *
 * Modification History:
 *  03-Nov-95     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
typedef struct {
    /*mlp*/
    int epochs;
    char * epochs_string;
    int *layers;
    char *layers_string;
    float etta;
    char *etta_string;
    /*mlpWeight*/
    int ettaChange;
    float ettaNepochs;
    char *ettaNepochs_string;
    float kappa;
    char *kappa_string;
    float epsilon;
    char *epsilon_string;
    int useEttaList;
    float *ettaList;
    char *ettaList_string;
    float decay;
    char *decay_string;
    float momentum;
    char *momentum_string;
    float tolerance;
    char *tolerance_string;
    float maxWeight;
    char *maxWeight_string;
    int weightUpdate;
    /*mlpCost*/
    int costFunc;
    float costParam;
    char *costParam_string;
    /*mlpNode*/
    int ofunction;
    int hfunction;
    float sigmoidParam;
    char *sigmoidParam_string;
    int useSigmoidList;
    float *sigmoidList;
    char *sigmoidList_string;
} MlpParams;
#endif
