/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef normGen_H
#define normGen_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/norm/normGen.h,v 1.4 2001/08/23 20:17:14 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            NORMGEN                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $NORMGENHOME/src/normGen.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for normGen
 * 
 * Calling Sequence:
 *   #include <normGen.h>
 *
 * Modification History:
 *  2-Oct-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" normGen.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget normGenDialogShell;
  Widget normGenForm;
  Widget normalizationLabel1;
  Widget normalizationLabel;
  Widget normFnameLabel1;
  Widget normFnameLabel;
  Widget normScriptLabel1;
  Widget normScriptLabel;
  Widget normLogLabel1;
  Widget normLogLabel;
  Widget separator;
  Widget genPlotToggle;
  Widget plotForm;
  Widget plotFnameLabel1;
  Widget plotFnameLabel;
  Widget plotLabelLabel1;
  Widget plotLabelLabel;
  Widget scaleFrame;
  Widget scaleForm;
  Widget autoscaleToggle;
  Widget axesForm;
  Widget axesLimitsLabel;
  Widget xminForm;
  Widget xminLabel;
  Widget xminText;
  Widget xminOKPBtn;
  Widget xminCancelPBtn;
  Widget xmaxForm;
  Widget xmaxLabel;
  Widget xmaxText;
  Widget xmaxOKPBtn;
  Widget xmaxCancelPBtn;
  Widget xstepForm;
  Widget xstepLabel;
  Widget xstepText;
  Widget xstepOKPBtn;
  Widget xstepCancelPBtn;
  Widget yminForm;
  Widget yminLabel;
  Widget yminText;
  Widget yminOKPBtn;
  Widget yminCancelPBtn;
  Widget ymaxForm;
  Widget ymaxLabel;
  Widget ymaxText;
  Widget ymaxOKPBtn;
  Widget ymaxCancelPBtn;
  Widget ystepForm;
  Widget ystepLabel;
  Widget ystepText;
  Widget ystepOKPBtn;
  Widget ystepCancelPBtn;
  Widget scaleLabel;
  Widget buttonForm;
  Widget separator1;
  Widget runPBtn;
  Widget plotOnlyPBtn;
  Widget stopPBtn;
  Widget closePBtn;
} NormGenWidgets;
 
#endif
