/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef parzen_H
#define parzen_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/parzen/parzen.h,v 1.3 2001/08/23 20:17:18 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            PARZEN                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $PARZENHOME/src/parzen.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for parzen
 * 
 * Calling Sequence:
 *   #include <parzen.h>
 *
 * Modification History:
 *  9-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" parzen.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget parzenDialogShell;
  Widget parzenForm;
  Widget trainFrame;
  Widget trainLabel;
  Widget trainForm;
  Widget grandLabel;
  Widget grandRadioBox;
  Widget perClassToggle;
  Widget grandToggle;
  Widget perInputLabel;
  Widget perInputRadioBox;
  Widget uniformToggle;
  Widget perInputToggle;
  Widget minVarForm;
  Widget minVarLabel;
  Widget minVarText;
  Widget minVarOKPBtn;
  Widget minVarCancelPBtn;
  Widget testFrame;
  Widget testLabel;
  Widget testForm;
  Widget spreadForm;
  Widget spreadLabel;
  Widget spreadText;
  Widget spreadOKPBtn;
  Widget spreadCancelPBtn;
  Widget linearLabel;
  Widget linearRadioBox;
  Widget gaussToggle;
  Widget linearToggle;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} ParzenWidgets;
 
#endif
