/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef plots_H
#define plots_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/plots/plots.h,v 1.3 2001/08/23 20:17:22 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            PLOTS                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $PLOTSHOME/src/plots.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for plots
 * 
 * Calling Sequence:
 *   #include <plots.h>
 *
 * Modification History:
 *  24-Oct-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" plots.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget plotsDialogShell;
  Widget plotsForm;
  Widget parameterPlotsFrame;
  Widget parameterPlotsLabel;
  Widget parameterPlotsForm;
  Widget regionFrame;
  Widget regionLabel;
  Widget regionForm;
  Widget regionToggle;
  Widget scatterToggle;
  Widget internalsToggle;
  Widget regionParamsPBtn;
  Widget profileFrame;
  Widget profileLabel;
  Widget profileForm;
  Widget profileToggle;
  Widget histogramToggle;
  Widget profileParamsPBtn;
  Widget doTrainPlotsLabel;
  Widget doTrainPlotsRadioBox;
  Widget noTrainPlotsToggle;
  Widget doTrainPlotsToggle;
  Widget epochPlotsToggle;
  Widget ePerPlotForm;
  Widget ePerPlotLabel;
  Widget ePerPlotText;
  Widget ePerPlotOKPBtn;
  Widget ePerPlotCancelPBtn;
  Widget structFrame;
  Widget structLabel;
  Widget structForm;
  Widget structToggle;
  Widget structParamsPBtn;
  Widget trainErrorFrame;
  Widget trainErrorLabel;
  Widget trainErrorForm;
  Widget costForm;
  Widget costToggle;
  Widget costParamsPBtn;
  Widget perrForm;
  Widget perrToggle;
  Widget perrParamsPBtn;
  Widget testErrorFrame;
  Widget testErrorLabel;
  Widget testErrorForm;
  Widget probToggle;
  Widget probParamsPBtn;
  Widget detectToggle;
  Widget detectParamsPBtn;
  Widget rejectToggle;
  Widget rejectParamsPBtn;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} PlotsWidgets;
 
#endif
