/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef print_H
#define print_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/print/print.h,v 1.3 2001/08/23 20:17:25 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            PRINT                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $PRINTHOME/src/print.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for print
 * 
 * Calling Sequence:
 *   #include <print.h>
 *
 * Modification History:
 *  16-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" print.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget printDialogShell;
  Widget printForm;
  Widget existLabel;
  Widget fileSelectionLabel;
  Widget fileNameLabel;
  Widget fileExistsLabel;
  Widget filePsLabel;
  Widget fileMifLabel;
  Widget logToggle;
  Widget logNameLabel;
  Widget logExistsLabel;
  Widget logPsLabel;
  Widget logMifLabel;
  Widget regionToggle;
  Widget regionNameLabel;
  Widget regionExistsLabel;
  Widget regionPsLabel;
  Widget regionMifLabel;
  Widget profileToggle;
  Widget profileNameLabel;
  Widget profileExistsLabel;
  Widget profilePsLabel;
  Widget profileMifLabel;
  Widget costToggle;
  Widget costNameLabel;
  Widget costExistsLabel;
  Widget costPsLabel;
  Widget costMifLabel;
  Widget perrToggle;
  Widget perrNameLabel;
  Widget perrExistsLabel;
  Widget perrPsLabel;
  Widget perrMifLabel;
  Widget structToggle;
  Widget structNameLabel;
  Widget structExistsLabel;
  Widget structPsLabel;
  Widget structMifLabel;
  Widget probToggle;
  Widget probNameLabel;
  Widget probExistsLabel;
  Widget probPsLabel;
  Widget probMifLabel;
  Widget detectToggle;
  Widget detectNameLabel;
  Widget detectExistsLabel;
  Widget detectPsLabel;
  Widget detectMifLabel;
  Widget rejectToggle;
  Widget rejectNameLabel;
  Widget rejectExistsLabel;
  Widget rejectPsLabel;
  Widget rejectMifLabel;
  Widget printerForm;
  Widget printerLabel;
  Widget printerText;
  Widget printerOKPBtn;
  Widget printerCancelPBtn;
  Widget buttonForm;
  Widget separator;
  Widget previewPBtn;
  Widget printPBtn;
  Widget psPBtn;
  Widget mifPBtn;
  Widget updatePBtn;
  Widget closePBtn;
} PrintWidgets;
 
#endif
