/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef priors_H
#define priors_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/priors/priors.h,v 1.3 2001/08/23 20:17:30 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            PRIORS                                    ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $PRIORSHOME/src/priors.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for priors
 * 
 * Calling Sequence:
 *   #include <priors.h>
 *
 * Modification History:
 *  18-Oct-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" priors.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget priorsDialogShell;
  Widget priorsForm;
  Widget trainFrame;
  Widget trainLabel;
  Widget trainForm;
  Widget adjustTrainRadioBox;
  Widget trainAsIsToggle;
  Widget adjustTrainToggle;
  Widget samplePriorsForm;
  Widget samplePriorsLabel;
  Widget trainUniformRadioBox;
  Widget trainSpecifyPriorsToggle;
  Widget trainUniformToggle;
  Widget trainPriorsListForm;
  Widget trainPriorsListLabel;
  Widget trainPriorsListText;
  Widget trainPriorsListOKPBtn;
  Widget trainPriorsListCancelPBtn;
  Widget priorsNpatternsForm;
  Widget priorsNpatternsLabel;
  Widget priorsNpatternsText;
  Widget priorsNpatternsOKPBtn;
  Widget priorsNpatternsCancelPBtn;
  Widget testFrame;
  Widget testLabel;
  Widget testForm;
  Widget adjustTestRadioBox;
  Widget testAsIsToggle;
  Widget adjustTestToggle;
  Widget scalePriorsForm;
  Widget scalePriorsLabel;
  Widget testUniformRadioBox;
  Widget testSpecifyPriorsToggle;
  Widget testUniformToggle;
  Widget testPriorsListForm;
  Widget testPriorsListLabel;
  Widget testPriorsListText;
  Widget testPriorsListOKPBtn;
  Widget testPriorsListCancelPBtn;
  Widget filePriorsListLabel;
  Widget trainFilePriorsLabel1;
  Widget trainFilePriorsLabel;
  Widget evalFilePriorsLabel1;
  Widget evalFilePriorsLabel;
  Widget testFilePriorsLabel1;
  Widget testFilePriorsLabel;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} PriorsWidgets;
 
#endif
