/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef region_H
#define region_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/region/region.h,v 1.4 2001/08/23 20:17:45 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            REGION                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $REGIONHOME/src/region.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for region
 * 
 * Calling Sequence:
 *   #include <region.h>
 *
 * Modification History:
 *  27-Oct-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" region.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget regionDialogShell;
  Widget regionForm;
  Widget regionPrefixLabel1;
  Widget regionPrefixLabel;
  Widget dimensionFrame;
  Widget dimensionForm;
  Widget xDimenForm;
  Widget xDimenLabel;
  Widget xDimenText;
  Widget xDimenOKPBtn;
  Widget xDimenCancelPBtn;
  Widget xDimenLabelLabel1;
  Widget xDimenLabelLabel;
  Widget yDimenForm;
  Widget yDimenLabel;
  Widget yDimenText;
  Widget yDimenOKPBtn;
  Widget yDimenCancelPBtn;
  Widget yDimenLabelLabel1;
  Widget yDimenLabelLabel;
  Widget otherVarForm;
  Widget otherVarLabel;
  Widget otherVarText;
  Widget otherVarOKPBtn;
  Widget otherVarCancelPBtn;
  Widget dimensionLabel;
  Widget decisionFrame;
  Widget decisionForm;
  Widget nPointsForm;
  Widget nPointsLabel;
  Widget nPointsText;
  Widget nPointsOKPBtn;
  Widget nPointsCancelPBtn;
  Widget decisionLabel;
  Widget scaleFrame;
  Widget scaleForm;
  Widget autoscaleToggle;
  Widget axesForm;
  Widget axesLimitsLabel;
  Widget xminForm;
  Widget xminLabel;
  Widget xminText;
  Widget xminOKPBtn;
  Widget xminCancelPBtn;
  Widget xmaxForm;
  Widget xmaxLabel;
  Widget xmaxText;
  Widget xmaxOKPBtn;
  Widget xmaxCancelPBtn;
  Widget xstepForm;
  Widget xstepLabel;
  Widget xstepText;
  Widget xstepOKPBtn;
  Widget xstepCancelPBtn;
  Widget yminForm;
  Widget yminLabel;
  Widget yminText;
  Widget yminOKPBtn;
  Widget yminCancelPBtn;
  Widget ymaxForm;
  Widget ymaxLabel;
  Widget ymaxText;
  Widget ymaxOKPBtn;
  Widget ymaxCancelPBtn;
  Widget ystepForm;
  Widget ystepLabel;
  Widget ystepText;
  Widget ystepOKPBtn;
  Widget ystepCancelPBtn;
  Widget noNormToggle;
  Widget scaleLabel;
  Widget colorToggle;
  Widget scatterFrame;
  Widget scatterForm;
  Widget showMissesToggle;
  Widget showAllToggle;
  Widget distLimForm;
  Widget distLimLabel;
  Widget distLimText;
  Widget distLimOKPBtn;
  Widget distLimCancelPBtn;
  Widget scatterLabel;
  Widget internalsFrame;
  Widget internalsForm;
  Widget internalsLevelForm;
  Widget internalsLevelLabel;
  Widget internalsLevelText;
  Widget internalsLevelOKPBtn;
  Widget internalsLevelCancelPBtn;
  Widget internalsScaleForm;
  Widget internalsScaleLabel;
  Widget internalsScaleText;
  Widget internalsScaleOKPBtn;
  Widget internalsScaleCancelPBtn;
  Widget internalsLabel;
  Widget plotLabelLabel1;
  Widget plotLabelLabel;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} RegionWidgets;
 
#endif
