/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
 
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/region/region_create.c,v 11.4 2001/08/23 20:17:46 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            REGION                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source $
 *
 * Language: C
 *
 * File Modification History:
 *  27-Oct-1995     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <Xm/Xm.h>
#include "region.h"
/*
 * External Functions
 */
 
/*
 * Externals
 */
extern RegionWidgets *RegionClone;
 
/******************************************************************************
 ******************************************************************************
 *
 * Module Name: region_create
 *
 * Purpose: 
 * 
 * Calling Sequence:
 *   region_create(w, client, call)
 *
 * Inputs:
 *   Widget w            widget calling this callback
 *   XtPointer client    client data attached to widget
 *   XtPointer call      pointer to callback structure
 *
 * Outputs:
 *   none
 *
 * Return Value:
 *   none
 *
 * Side Effects:
 *   none
 *
 * Restrictions:
 *   none
 *
 * Modification History:
 *  27-Oct-1995     Linda C Kukolich  initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
void
region_create(Widget w, XtPointer client, XtPointer call)
{
  if (!strcmp(client, "regionDialogShell")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    /*
     * Allocate space for the structure
     */
    RegionClone = (RegionWidgets *)XtMalloc(sizeof(RegionWidgets));
    RegionClone->regionDialogShell = w;
 
  } else if (!strcmp(client, "regionForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->regionForm = w;
 
  } else if (!strcmp(client, "regionPrefixLabel1")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->regionPrefixLabel1 = w;
 
  } else if (!strcmp(client, "regionPrefixLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->regionPrefixLabel = w;
 
  } else if (!strcmp(client, "dimensionFrame")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->dimensionFrame = w;
 
  } else if (!strcmp(client, "dimensionForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->dimensionForm = w;
 
  } else if (!strcmp(client, "xDimenForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xDimenForm = w;
 
  } else if (!strcmp(client, "xDimenLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xDimenLabel = w;
 
  } else if (!strcmp(client, "xDimenText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xDimenText = w;
 
  } else if (!strcmp(client, "xDimenOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xDimenOKPBtn = w;
 
  } else if (!strcmp(client, "xDimenCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xDimenCancelPBtn = w;
 
  } else if (!strcmp(client, "xDimenLabelLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xDimenLabelLabel = w;
 
  } else if (!strcmp(client, "xDimenLabelLabel1")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xDimenLabelLabel1 = w;
 
  } else if (!strcmp(client, "yDimenForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yDimenForm = w;
 
  } else if (!strcmp(client, "yDimenLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yDimenLabel = w;
 
  } else if (!strcmp(client, "yDimenText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yDimenText = w;
 
  } else if (!strcmp(client, "yDimenOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yDimenOKPBtn = w;
 
  } else if (!strcmp(client, "yDimenCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yDimenCancelPBtn = w;
 
  } else if (!strcmp(client, "yDimenLabelLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yDimenLabelLabel = w;
 
  } else if (!strcmp(client, "yDimenLabelLabel1")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yDimenLabelLabel1 = w;
 
  } else if (!strcmp(client, "otherVarForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->otherVarForm = w;
 
  } else if (!strcmp(client, "otherVarLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->otherVarLabel = w;
 
  } else if (!strcmp(client, "otherVarText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->otherVarText = w;
 
  } else if (!strcmp(client, "otherVarOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->otherVarOKPBtn = w;
 
  } else if (!strcmp(client, "otherVarCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->otherVarCancelPBtn = w;
 
  } else if (!strcmp(client, "dimensionLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->dimensionLabel = w;
 
  } else if (!strcmp(client, "decisionFrame")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->decisionFrame = w;
 
  } else if (!strcmp(client, "decisionForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->decisionForm = w;
 
  } else if (!strcmp(client, "nPointsForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->nPointsForm = w;
 
  } else if (!strcmp(client, "nPointsLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->nPointsLabel = w;
 
  } else if (!strcmp(client, "nPointsText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->nPointsText = w;
 
  } else if (!strcmp(client, "nPointsOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->nPointsOKPBtn = w;
 
  } else if (!strcmp(client, "nPointsCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->nPointsCancelPBtn = w;
 
  } else if (!strcmp(client, "decisionLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->decisionLabel = w;
 
  } else if (!strcmp(client, "scaleFrame")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->scaleFrame = w;
 
  } else if (!strcmp(client, "scaleForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->scaleForm = w;
 
  } else if (!strcmp(client, "autoscaleToggle")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->autoscaleToggle = w;
 
  } else if (!strcmp(client, "axesForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->axesForm = w;
 
  } else if (!strcmp(client, "axesLimitsLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->axesLimitsLabel = w;
 
  } else if (!strcmp(client, "xminForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xminForm = w;
 
  } else if (!strcmp(client, "xminLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xminLabel = w;
 
  } else if (!strcmp(client, "xminText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xminText = w;
 
  } else if (!strcmp(client, "xminOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xminOKPBtn = w;
 
  } else if (!strcmp(client, "xminCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xminCancelPBtn = w;
 
  } else if (!strcmp(client, "xmaxForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xmaxForm = w;
 
  } else if (!strcmp(client, "xmaxLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xmaxLabel = w;
 
  } else if (!strcmp(client, "xmaxText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xmaxText = w;
 
  } else if (!strcmp(client, "xmaxOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xmaxOKPBtn = w;
 
  } else if (!strcmp(client, "xmaxCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xmaxCancelPBtn = w;
 
  } else if (!strcmp(client, "xstepForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xstepForm = w;
 
  } else if (!strcmp(client, "xstepLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xstepLabel = w;
 
  } else if (!strcmp(client, "xstepText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xstepText = w;
 
  } else if (!strcmp(client, "xstepOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xstepOKPBtn = w;
 
  } else if (!strcmp(client, "xstepCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->xstepCancelPBtn = w;
 
  } else if (!strcmp(client, "yminForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yminForm = w;
 
  } else if (!strcmp(client, "yminLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yminLabel = w;
 
  } else if (!strcmp(client, "yminText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yminText = w;
 
  } else if (!strcmp(client, "yminOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yminOKPBtn = w;
 
  } else if (!strcmp(client, "yminCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->yminCancelPBtn = w;
 
  } else if (!strcmp(client, "ymaxForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ymaxForm = w;
 
  } else if (!strcmp(client, "ymaxLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ymaxLabel = w;
 
  } else if (!strcmp(client, "ymaxText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ymaxText = w;
 
  } else if (!strcmp(client, "ymaxOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ymaxOKPBtn = w;
 
  } else if (!strcmp(client, "ymaxCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ymaxCancelPBtn = w;
 
  } else if (!strcmp(client, "ystepForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ystepForm = w;
 
  } else if (!strcmp(client, "ystepLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ystepLabel = w;
 
  } else if (!strcmp(client, "ystepText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ystepText = w;
 
  } else if (!strcmp(client, "ystepOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ystepOKPBtn = w;
 
  } else if (!strcmp(client, "ystepCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->ystepCancelPBtn = w;
 
  } else if (!strcmp(client, "noNormToggle")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->noNormToggle = w;
 
  } else if (!strcmp(client, "scaleLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->scaleLabel = w;
 
  } else if (!strcmp(client, "colorToggle")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->colorToggle = w;
 
  } else if (!strcmp(client, "scatterFrame")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->scatterFrame = w;
 
  } else if (!strcmp(client, "scatterForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->scatterForm = w;
 
  } else if (!strcmp(client, "showMissesToggle")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->showMissesToggle = w;
 
  } else if (!strcmp(client, "showAllToggle")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->showAllToggle = w;
 
  } else if (!strcmp(client, "distLimForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->distLimForm = w;
 
  } else if (!strcmp(client, "distLimLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->distLimLabel = w;
 
  } else if (!strcmp(client, "distLimText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->distLimText = w;
 
  } else if (!strcmp(client, "distLimOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->distLimOKPBtn = w;
 
  } else if (!strcmp(client, "distLimCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->distLimCancelPBtn = w;
 
  } else if (!strcmp(client, "scatterLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->scatterLabel = w;
 
  } else if (!strcmp(client, "internalsFrame")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsFrame = w;
 
  } else if (!strcmp(client, "internalsForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsForm = w;

  } else if (!strcmp(client, "internalsLevelForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsLevelForm = w;
 
  } else if (!strcmp(client, "internalsLevelLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsLevelLabel = w;
 
  } else if (!strcmp(client, "internalsLevelText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsLevelText = w;
 
  } else if (!strcmp(client, "internalsLevelOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsLevelOKPBtn = w;
 
  } else if (!strcmp(client, "internalsLevelCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsLevelCancelPBtn = w;
 
  } else if (!strcmp(client, "internalsScaleForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsScaleForm = w;
 
  } else if (!strcmp(client, "internalsScaleLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsScaleLabel = w;
 
  } else if (!strcmp(client, "internalsScaleText")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsScaleText = w;
 
  } else if (!strcmp(client, "internalsScaleOKPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsScaleOKPBtn = w;
 
  } else if (!strcmp(client, "internalsScaleCancelPBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsScaleCancelPBtn = w;
 
  } else if (!strcmp(client, "internalsLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->internalsLabel = w;
 
   } else if (!strcmp(client, "plotLabelLabel1")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->plotLabelLabel1 = w;
	
  } else if (!strcmp(client, "plotLabelLabel")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->plotLabelLabel = w;

  } else if (!strcmp(client, "buttonForm")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->buttonForm = w;
 
  } else if (!strcmp(client, "separator")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->separator = w;
 
  } else if (!strcmp(client, "closePBtn")) {
    /*fprintf (stderr, "region_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, RegionClone, NULL);
    RegionClone->closePBtn = w;
 
  } else {
    fprintf(stderr, "region_create: unknown client: %s\n", (char *)client);
  }
}
