/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef reports_H
#define reports_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/reports/reports.h,v 1.5 2001/08/23 20:17:54 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            REPORTS                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $REPORTSHOME/src/reports.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for reports
 * 
 * Calling Sequence:
 *   #include <reports.h>
 *
 * Modification History:
 *  22-Sep-1995     Linda C Kukolich         initial creation
 *  30-Nov-1995     Linda C Kukolich         added frames around things
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" reports.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget reportsDialogShell;
  Widget reportsForm;
  Widget wdirNameLabel1;
  Widget wdirNameLabel;
  Widget notebookFrame;
  Widget notebookForm;
  Widget notebookFileForm;
  Widget notebookFileLabel;
  Widget notebookFileText;
  Widget notebookFileOKPBtn;
  Widget notebookFileCancelPBtn;
  Widget notebookOnToggle;
  Widget notebookLabel;
  Widget experimentFrame;
  Widget experimentForm;
  Widget experimentPathForm;
  Widget experimentPathLabel;
  Widget experimentPathText;
  Widget experimentPathOKPBtn;
  Widget experimentPathCancelPBtn;
  Widget shellFileLabel1;
  Widget shellFileLabel;
  Widget logFileLabel1;
  Widget logFileLabel;
  Widget paramFileLabel1;
  Widget paramFileLabel;
  Widget errorFileLabel1;
  Widget errorFileLabel;
  Widget screenFileLabel1;
  Widget screenFileLabel;
  Widget experimentLabel;
  Widget verboseFrame;
  Widget verboseForm;
  Widget verbosityOptionMenu;
  Widget verbosityPulldownMenu;
  Widget verbosityOverallPBtn;
  Widget verbositySummaryPBtn;
  Widget verbosityConfusionPBtn;
  Widget verbosityFlagsPBtn;
  Widget verrorOptionMenu;
  Widget verrorPulldownMenu;
  Widget verrorNonePBtn;
  Widget verrorResultsPBtn;
  Widget verrorOutputsPBtn;
  Widget verrorInputsPBtn;
  Widget noTrainVerrorToggle;
  Widget verboseLabel;
  Widget buttonForm;
  Widget separator;
  Widget restoreScreenPBtn;
  Widget closePBtn;
} ReportsWidgets;
 
#endif
