/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef selectGen_H
#define selectGen_H
/**************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/select/selectGen.h,v 1.6 2001/08/23 20:17:57 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            SELECTGEN                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $SELECTGENHOME/src/selectGen.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for selectgen
 * 
 * Calling Sequence:
 *   #include <selectGen.h>
 *
 * Modification History:
 *  13-Oct-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" selectGen.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget selectGenDialogShell;
  Widget selectGenForm;
  Widget listFileLabel1;
  Widget listFileLabel;
  Widget scriptLabel1;
  Widget scriptLabel;
  Widget logLabel1;
  Widget logLabel;
  Widget searchAlgFrame;
  Widget searchAlgForm;
  Widget searchAlgRadioBox;
  Widget searchAlgNNToggle;
  Widget searchAlgAlgToggle;
  Widget algorithmForm;
  Widget algorithmLabel;
  Widget algorithmParamsPBtn;
  Widget nFoldsForm;
  Widget nFoldsLabel;
  Widget nFoldsText;
  Widget nFoldsOKPBtn;
  Widget nFoldsCancelPBtn;
  Widget searchAlgLabel;
  Widget directionLabel;
  Widget directionRadioBox;
  Widget directionForwardToggle;
  Widget directionBackwardToggle;
  Widget directionForBackToggle;
  Widget directionFloatingToggle;
  Widget stopEarlyRadioBox;
  Widget stopEarlyAllToggle;
  Widget stopEarlyStopToggle;
  Widget genSearchNForm;
  Widget genSearchNLabel;
  Widget genSearchNText;
  Widget genSearchNOKPBtn;
  Widget genSearchNCancelPBtn;
  Widget searchCriterionFrame;
  Widget searchCriterionForm;
  Widget searchCriterionLabel;
  Widget searchCriterionRadioBox;
  Widget perrToggle;
  Widget rocToggle;
  Widget rocTargetForm;
  Widget rocTargetLabel;
  Widget rocTargetText;
  Widget rocTargetOKPBtn;
  Widget rocTargetCancelPBtn;
  Widget plotSeparator;
  Widget genPlotToggle;
  Widget plotForm;
  Widget plotFnameLabel1;
  Widget plotFnameLabel;
  Widget scaleFrame;
  Widget scaleForm;
  Widget autoscaleToggle;
  Widget axesForm;
  Widget axesLimitsLabel;
  Widget xminForm;
  Widget xminLabel;
  Widget xminText;
  Widget xminOKPBtn;
  Widget xminCancelPBtn;
  Widget xmaxForm;
  Widget xmaxLabel;
  Widget xmaxText;
  Widget xmaxOKPBtn;
  Widget xmaxCancelPBtn;
  Widget xstepForm;
  Widget xstepLabel;
  Widget xstepText;
  Widget xstepOKPBtn;
  Widget xstepCancelPBtn;
  Widget yminForm;
  Widget yminLabel;
  Widget yminText;
  Widget yminOKPBtn;
  Widget yminCancelPBtn;
  Widget ymaxForm;
  Widget ymaxLabel;
  Widget ymaxText;
  Widget ymaxOKPBtn;
  Widget ymaxCancelPBtn;
  Widget ystepForm;
  Widget ystepLabel;
  Widget ystepText;
  Widget ystepOKPBtn;
  Widget ystepCancelPBtn;
  Widget scaleLabel;
  Widget plotLabelLabel1;
  Widget plotLabelLabel;
  Widget buttonForm;
  Widget separator;
  Widget runPBtn;
  Widget plotOnlyPBtn;
  Widget stopPBtn;
  Widget closePBtn;
} SelectGenWidgets;
 
#endif
