/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
 
/* $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/select/selectGen_create.c,v 11.6 2001/08/23 20:17:57 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            SELECTGEN                                 ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source $
 *
 * Language: C
 *
 * File Modification History:
 *  13-Oct-1995     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include <stdio.h>
#include <Xm/Xm.h>
#include "selectGen.h"
/*
 * External Functions
 */
 
/*
 * Externals
 */
extern SelectGenWidgets *SelectGenClone;
 
/******************************************************************************
 ******************************************************************************
 *
 * Module Name: selectGen_create
 *
 * Purpose: 
 * 
 * Calling Sequence:
 *   selectGen_create(w, client, call)
 *
 * Inputs:
 *   Widget w            widget calling this callback
 *   XtPointer client    client data attached to widget
 *   XtPointer call      pointer to callback structure
 *
 * Outputs:
 *   none
 *
 * Return Value:
 *   none
 *
 * Side Effects:
 *   none
 *
 * Restrictions:
 *   none
 *
 * Modification History:
 *  13-Oct-1995     Linda C Kukolich  initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
void
selectGen_create(Widget w, XtPointer client, XtPointer call)
{
  if (!strcmp(client, "selectGenDialogShell")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    /*
     * Allocate space for the structure
     */
    SelectGenClone = (SelectGenWidgets *)XtMalloc(sizeof(SelectGenWidgets));
    SelectGenClone->selectGenDialogShell = w;
 
  } else if (!strcmp(client, "selectGenForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->selectGenForm = w;
 
  } else if (!strcmp(client, "listFileLabel1")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->listFileLabel1 = w;
 
  } else if (!strcmp(client, "listFileLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->listFileLabel = w;
 
  } else if (!strcmp(client, "scriptLabel1")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->scriptLabel1 = w;
 
  } else if (!strcmp(client, "scriptLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->scriptLabel = w;
 
  } else if (!strcmp(client, "logLabel1")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->logLabel1 = w;
 
  } else if (!strcmp(client, "logLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->logLabel = w;
 
  } else if (!strcmp(client, "searchAlgFrame")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchAlgFrame = w;
 
  } else if (!strcmp(client, "searchAlgForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchAlgForm = w;
 
  } else if (!strcmp(client, "searchAlgRadioBox")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchAlgRadioBox = w;
 
  } else if (!strcmp(client, "searchAlgNNToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchAlgNNToggle = w;
 
  } else if (!strcmp(client, "searchAlgAlgToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchAlgAlgToggle = w;
 
  } else if (!strcmp(client, "algorithmForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->algorithmForm = w;
 
  } else if (!strcmp(client, "algorithmLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->algorithmLabel = w;
 
  } else if (!strcmp(client, "algorithmParamsPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->algorithmParamsPBtn = w;
 
  } else if (!strcmp(client, "nFoldsForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->nFoldsForm = w;
 
  } else if (!strcmp(client, "nFoldsLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->nFoldsLabel = w;
 
  } else if (!strcmp(client, "nFoldsText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->nFoldsText = w;
 
  } else if (!strcmp(client, "nFoldsOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->nFoldsOKPBtn = w;
 
  } else if (!strcmp(client, "nFoldsCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->nFoldsCancelPBtn = w;
 
  } else if (!strcmp(client, "searchAlgLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchAlgLabel = w;
 
  } else if (!strcmp(client, "directionLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->directionLabel = w;
 
  } else if (!strcmp(client, "directionRadioBox")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->directionRadioBox = w;
 
  } else if (!strcmp(client, "directionForwardToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->directionForwardToggle = w;
 
  } else if (!strcmp(client, "directionBackwardToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->directionBackwardToggle = w;
 
  } else if (!strcmp(client, "directionForBackToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->directionForBackToggle = w;
 
  } else if (!strcmp(client, "directionFloatingToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->directionFloatingToggle = w;
 
  } else if (!strcmp(client, "stopEarlyRadioBox")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->stopEarlyRadioBox = w;
 
  } else if (!strcmp(client, "stopEarlyAllToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->stopEarlyAllToggle = w;
 
  } else if (!strcmp(client, "stopEarlyStopToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->stopEarlyStopToggle = w;
 
  } else if (!strcmp(client, "genSearchNForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->genSearchNForm = w;
 
  } else if (!strcmp(client, "genSearchNLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->genSearchNLabel = w;
 
  } else if (!strcmp(client, "genSearchNText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->genSearchNText = w;
 
  } else if (!strcmp(client, "genSearchNOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->genSearchNOKPBtn = w;
 
  } else if (!strcmp(client, "genSearchNCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->genSearchNCancelPBtn = w;
 
  } else if (!strcmp(client, "searchCriterionFrame")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchCriterionFrame = w;
 
  } else if (!strcmp(client, "searchCriterionForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchCriterionForm = w;
 
  } else if (!strcmp(client, "searchCriterionRadioBox")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchCriterionRadioBox = w;
 
  } else if (!strcmp(client, "perrToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->perrToggle = w;
 
  } else if (!strcmp(client, "rocToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->rocToggle = w;
 
  } else if (!strcmp(client, "rocTargetForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->rocTargetForm = w;
 
  } else if (!strcmp(client, "rocTargetLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->rocTargetLabel = w;
 
  } else if (!strcmp(client, "rocTargetText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->rocTargetText = w;
 
  } else if (!strcmp(client, "rocTargetOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->rocTargetOKPBtn = w;
 
  } else if (!strcmp(client, "rocTargetCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->rocTargetCancelPBtn = w;
 
  } else if (!strcmp(client, "searchCriterionLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->searchCriterionLabel = w;
 
  } else if (!strcmp(client, "plotSeparator")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->plotSeparator = w;
 
  } else if (!strcmp(client, "genPlotToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->genPlotToggle = w;
 
  } else if (!strcmp(client, "plotForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->plotForm = w;
 
  } else if (!strcmp(client, "plotFnameLabel1")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->plotFnameLabel1 = w;
 
  } else if (!strcmp(client, "plotFnameLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->plotFnameLabel = w;
 
  } else if (!strcmp(client, "scaleFrame")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->scaleFrame = w;
 
  } else if (!strcmp(client, "scaleForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->scaleForm = w;
 
  } else if (!strcmp(client, "autoscaleToggle")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->autoscaleToggle = w;
 
  } else if (!strcmp(client, "axesForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->axesForm = w;
 
  } else if (!strcmp(client, "axesLimitsLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->axesLimitsLabel = w;
 
  } else if (!strcmp(client, "xminForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xminForm = w;
 
  } else if (!strcmp(client, "xminLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xminLabel = w;
 
  } else if (!strcmp(client, "xminText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xminText = w;
 
  } else if (!strcmp(client, "xminOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xminOKPBtn = w;
 
  } else if (!strcmp(client, "xminCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xminCancelPBtn = w;
 
  } else if (!strcmp(client, "xmaxForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xmaxForm = w;
 
  } else if (!strcmp(client, "xmaxLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xmaxLabel = w;
 
  } else if (!strcmp(client, "xmaxText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xmaxText = w;
 
  } else if (!strcmp(client, "xmaxOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xmaxOKPBtn = w;
 
  } else if (!strcmp(client, "xmaxCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xmaxCancelPBtn = w;
 
  } else if (!strcmp(client, "xstepForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xstepForm = w;
 
  } else if (!strcmp(client, "xstepLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xstepLabel = w;
 
  } else if (!strcmp(client, "xstepText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xstepText = w;
 
  } else if (!strcmp(client, "xstepOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xstepOKPBtn = w;
 
  } else if (!strcmp(client, "xstepCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->xstepCancelPBtn = w;
 
  } else if (!strcmp(client, "yminForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->yminForm = w;
 
  } else if (!strcmp(client, "yminLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->yminLabel = w;
 
  } else if (!strcmp(client, "yminText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->yminText = w;
 
  } else if (!strcmp(client, "yminOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->yminOKPBtn = w;
 
  } else if (!strcmp(client, "yminCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->yminCancelPBtn = w;
 
  } else if (!strcmp(client, "ymaxForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ymaxForm = w;
 
  } else if (!strcmp(client, "ymaxLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ymaxLabel = w;
 
  } else if (!strcmp(client, "ymaxText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ymaxText = w;
 
  } else if (!strcmp(client, "ymaxOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ymaxOKPBtn = w;
 
  } else if (!strcmp(client, "ymaxCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ymaxCancelPBtn = w;
 
  } else if (!strcmp(client, "ystepForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ystepForm = w;
 
  } else if (!strcmp(client, "ystepLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ystepLabel = w;
 
  } else if (!strcmp(client, "ystepText")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ystepText = w;
 
  } else if (!strcmp(client, "ystepOKPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ystepOKPBtn = w;
 
  } else if (!strcmp(client, "ystepCancelPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->ystepCancelPBtn = w;
 
  } else if (!strcmp(client, "scaleLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->scaleLabel = w;
 
  } else if (!strcmp(client, "plotLabelLabel1")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->plotLabelLabel1 = w;
 
  } else if (!strcmp(client, "plotLabelLabel")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->plotLabelLabel = w;
 
  } else if (!strcmp(client, "buttonForm")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->buttonForm = w;
 
  } else if (!strcmp(client, "separator")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->separator = w;
 
  } else if (!strcmp(client, "runPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->runPBtn = w;
 
  } else if (!strcmp(client, "plotOnlyPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->plotOnlyPBtn = w;
 
  } else if (!strcmp(client, "stopPBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->stopPBtn = w;
 
  } else if (!strcmp(client, "closePBtn")) {
    /*fprintf (stderr, "selectGen_create: %s\n", client );*/
    XtVaSetValues (w, XmNuserData, SelectGenClone, NULL);
    SelectGenClone->closePBtn = w;
 
  } else {
    fprintf(stderr, "selectGen_create: unknown client: %s\n", (char *)client);
  }
}
