/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
/***************************************************************************
                Copyright 1995 MIT Lincoln Laboratory.
This software is not for release and should neither be copied
nor distributed without explicit permission of MIT Lincoln Laboratory
**************************************************************************/
#ifndef select_params_H
#define select_params_H
/* rcsid_h "$Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/select/select_params.h,v 1.5 2001/08/23 20:17:57 craig Exp $" */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                       parameters on feature selection window                                 ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $Source: /data/speech/kukolich/cvsroot/lnknet/src/mclass/select/select_params.h,v $
 *
 * Language: C
 *
 * Purpose:
 * 
 * Calling Sequence:
 *   #include "select_params.h"
 *
 * Modification History:
 *  10-Oct-95     Linda C Kukolich   initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
typedef enum {ALL = 0, FIRST_N, MANUAL, READ_FILE} SELECT_TYPE;
typedef enum {NN = 0, CUR_ALG} SEARCH_ALG;
typedef enum {FORWARD = 0, BACKWARD, FOR_AND_BACK} SEARCH_DIRECTION;
typedef struct {
    /* for outside */
    int ninputs;
    int *features;
    /* select window */
    SELECT_TYPE selectType;
    int firstN;
    char *firstN_string;
    char *listFile;
    int *featureList;
    char *featureList_string;
    int searchN;
    char *searchN_string;
    int searchLimit;
    int bestN;
    int *searchFeatures;
    /* select gen window */
    int pid;
    char *scriptFname;
    char *logFname;
    char *plotFname;
    char *plotLabel;
    SEARCH_ALG searchAlg;
    int searchAlgActive;
    int nFolds;
    char *nFolds_string;
    int stopEarly;
    int genSearchN;
    char *genSearchN_string;
    SEARCH_DIRECTION searchDirection;
  int rocCost;
  int rocTarget;
  char *rocTarget_string;
    /* axes scales */
    int genPlot;
    int autoscale;
    float xmin;
    char *xmin_string;
    float xmax;
    char *xmax_string;
    float xstep;
    char *xstep_string;
    float ymin;
    char *ymin_string;
    float ymax;
    char *ymax_string;
    float ystep;
    char *ystep_string;
} SelectParams;
#endif
