/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef svm_H
#define svm_H
 
/* rcsid = $Header: /data/speech/kukolich/cvsroot/lnknet/src/mclass/svm/svm.h,v 1.3 2001/08/23 20:18:03 craig Exp $ */

 
/******************************************************************************
 ******************************************************************************
 ****                                                                      ****
 ****                       MIT Lincoln Laboratory                         ****
 ****                            SVM                              ****
 ****                          Window Interface                            ****
 ****                                                                      ****
 ******************************************************************************
 ******************************************************************************
 *
 * File Name: $SVMHOME/src/svm.h
 *
 * Language: C
 *
 * Purpose: Structure definitions for svm
 * 
 * Calling Sequence:
 *   #include <svm.h>
 *
 * Modification History:
 *  8-Nov-1995     Linda C Kukolich         initial creation
 *
 ******************************************************************************
 ******************************************************************************
 */
 
/*
 * Structures created by command "gawk -f uil.awk ansi="yes" rcs="yes" svm.uil"
 * Structures for the TopLevelShells or DialogShells
 *  and their widgets.
 */
typedef struct {
  Widget svmDialogShell;
  Widget svmForm;
  Widget kktTolForm;
  Widget kktTolLabel;
  Widget kktTolText;
  Widget kktTolOKPBtn;
  Widget kktTolCancelPBtn;
  Widget alphaTolForm;
  Widget alphaTolLabel;
  Widget alphaTolText;
  Widget alphaTolOKPBtn;
  Widget alphaTolCancelPBtn;
  Widget kernelFrame;
  Widget kernelLabel;
  Widget kernelForm;
  Widget kernelTypeRadioBox;
  Widget kernelLinearToggle;
  Widget kernelGaussianToggle;
  Widget kernelPolynomialToggle;
  Widget kernelInhomPolyToggle;
  Widget kernelExtraToggle;
  Widget kernelSigmaForm;
  Widget kernelSigmaLabel;
  Widget kernelSigmaText;
  Widget kernelSigmaOKPBtn;
  Widget kernelSigmaCancelPBtn;
  Widget kernelOrderForm;
  Widget kernelOrderLabel;
  Widget kernelOrderText;
  Widget kernelOrderOKPBtn;
  Widget kernelOrderCancelPBtn;
  Widget kernelPolyForm;
  Widget kernelPolyLabel;
  Widget kernelPolyText;
  Widget kernelPolyOKPBtn;
  Widget kernelPolyCancelPBtn;
  Widget n_sigmoid_fitLabel;
  Widget n_sigmoid_fitRadioBox;
  Widget sigmoidFitToggle;
  Widget rawOutToggle;
  Widget mclassTypeLabel;
  Widget mclassTypeRadioBox;
  Widget meVsWorldToggle;
  Widget meVsEachToggle;
  Widget totalNclassLabel;
  Widget cboundForm;
  Widget cboundLabel;
  Widget cboundText;
  Widget cboundOKPBtn;
  Widget cboundCancelPBtn;
  Widget buttonForm;
  Widget separator;
  Widget closePBtn;
} SvmWidgets;
 
#endif
