/* (c) Copyright 1999 M.I.T. Lincoln Laboratory


Permission is hereby granted, without written agreement or royalty fee,
to use, copy, modify, and distribute this software and its
documentation for any purpose, provided that the above copyright notic
and the following three paragraphs appear in all copies of this software.

IN NO EVENT SHALL M.I.T. LINCOLN LABORATORY BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF
THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF M.I.T. LINCOLN
LABORATORY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. M.I.T. LINCOLN
LABORATORY SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
AND NON-INFRINGEMENT.

THE SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND M.I.T. LINCOLN
LABORATORY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. */
#ifndef ABS
#define ABS(x) (((x) > 0)? (x) : -(x))
#endif

/* config.h must go first */
#if HAVE_CONFIG_H
#include <config.h>
#endif
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#endif
#include "xlippic.h"

void
uvbeam_outline(int u1, int v1, int u2, int v2, int line_width)
{
    int x1, y1, x2, y2, delta;
    delta = line_width/2;
    if(ABS(u1 - u2) >= ABS(v1 - v2)){
	x1 = u1;
	x2 = u2;
	y1 = v1 + delta;
	y2 = v2 + delta;
	uvline(x1, y1, x2, y2);
	y1 = v1 - delta;
	y2 = v2 - delta;
	uvline(x1, y1, x2, y2);
    } else {
	y1 = v1;
	y2 = v2;
	x1 = u1 + delta;
	x2 = u2 + delta;
	uvline(x1, y1, x2, y2);
	x1 = u1 - delta;
	x2 = u2 - delta;
	uvline(x1, y1, x2, y2);
    }
}
